/* A Bison parser, made by GNU Bison 3.7.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2020 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30704

/* Bison version string.  */
#define YYBISON_VERSION "3.7.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         nft_parse
#define yylex           nft_lex
#define yyerror         nft_error
#define yydebug         nft_debug
#define yynerrs         nft_nerrs

/* First part of user prologue.  */
#line 11 "parser_bison.y"


#include <ctype.h>
#include <stddef.h>
#include <stdio.h>
#include <inttypes.h>
#include <syslog.h>
#include <netinet/ip.h>
#include <netinet/tcp.h>
#include <netinet/if_ether.h>
#include <linux/netfilter.h>
#include <linux/netfilter/nf_tables.h>
#include <linux/netfilter/nf_conntrack_tuple_common.h>
#include <linux/netfilter/nf_nat.h>
#include <linux/netfilter/nf_log.h>
#include <linux/netfilter/nfnetlink_osf.h>
#include <linux/netfilter/nf_synproxy.h>
#include <linux/xfrm.h>
#include <netinet/ip_icmp.h>
#include <netinet/icmp6.h>
#include <libnftnl/common.h>
#include <libnftnl/set.h>
#include <libnftnl/udata.h>

#include <rule.h>
#include <statement.h>
#include <expression.h>
#include <headers.h>
#include <utils.h>
#include <parser.h>
#include <erec.h>

#include "parser_bison.h"

void parser_init(struct nft_ctx *nft, struct parser_state *state,
		 struct list_head *msgs, struct list_head *cmds,
		 struct scope *top_scope)
{
	memset(state, 0, sizeof(*state));
	state->msgs = msgs;
	state->cmds = cmds;
	state->scopes[0] = scope_init(top_scope, NULL);
	init_list_head(&state->indesc_list);
}

static void yyerror(struct location *loc, struct nft_ctx *nft, void *scanner,
		    struct parser_state *state, const char *s)
{
	erec_queue(error(loc, "%s", s), state->msgs);
}

static struct scope *current_scope(const struct parser_state *state)
{
	return state->scopes[state->scope];
}

static void open_scope(struct parser_state *state, struct scope *scope)
{
	assert(state->scope < array_size(state->scopes) - 1);
	scope_init(scope, current_scope(state));
	state->scopes[++state->scope] = scope;
}

static void close_scope(struct parser_state *state)
{
	assert(state->scope > 0);
	state->scope--;
}

static void location_init(void *scanner, struct parser_state *state,
			  struct location *loc)
{
	memset(loc, 0, sizeof(*loc));
	loc->indesc = state->indesc;
}

static void location_update(struct location *loc, struct location *rhs, int n)
{
	if (n) {
		loc->indesc       = rhs[n].indesc;
		loc->token_offset = rhs[1].token_offset;
		loc->line_offset  = rhs[1].line_offset;
		loc->first_line   = rhs[1].first_line;
		loc->first_column = rhs[1].first_column;
		loc->last_line    = rhs[n].last_line;
		loc->last_column  = rhs[n].last_column;
	} else {
		loc->indesc       = rhs[0].indesc;
		loc->token_offset = rhs[0].token_offset;
		loc->line_offset  = rhs[0].line_offset;
		loc->first_line   = loc->last_line   = rhs[0].last_line;
		loc->first_column = loc->last_column = rhs[0].last_column;
	}
}

static struct expr *handle_concat_expr(const struct location *loc,
					 struct expr *expr,
					 struct expr *expr_l, struct expr *expr_r,
					 struct location loc_rhs[3])
{
	if (expr->etype != EXPR_CONCAT) {
		expr = concat_expr_alloc(loc);
		compound_expr_add(expr, expr_l);
	} else {
		location_update(&expr_r->location, loc_rhs, 2);

		expr = expr_l;
		expr->location = *loc;
	}

	compound_expr_add(expr, expr_r);
	return expr;
}

static bool already_set(const void *attr, const struct location *loc,
			struct parser_state *state)
{
	if (!attr)
		return false;

	erec_queue(error(loc, "You can only specify this once. This statement is duplicated."),
		   state->msgs);
	return true;
}

#define YYLLOC_DEFAULT(Current, Rhs, N)	location_update(&Current, Rhs, N)

#define symbol_value(loc, str) \
	symbol_expr_alloc(loc, SYMBOL_VALUE, current_scope(state), str)

/* Declare those here to avoid compiler warnings */
void nft_set_debug(int, void *);
int nft_lex(void *, void *, void *);

#line 211 "parser_bison.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Use api.header.include to #include this header
   instead of duplicating it here.  */
#ifndef YY_NFT_PARSER_BISON_H_INCLUDED
# define YY_NFT_PARSER_BISON_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif
#if YYDEBUG
extern int nft_debug;
#endif

/* Token kinds.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    YYEMPTY = -2,
    TOKEN_EOF = 0,                 /* "end of file"  */
    YYerror = 256,                 /* error  */
    YYUNDEF = 257,                 /* "invalid token"  */
    JUNK = 258,                    /* "junk"  */
    NEWLINE = 259,                 /* "newline"  */
    COLON = 260,                   /* "colon"  */
    SEMICOLON = 261,               /* "semicolon"  */
    COMMA = 262,                   /* "comma"  */
    DOT = 263,                     /* "."  */
    EQ = 264,                      /* "=="  */
    NEQ = 265,                     /* "!="  */
    LT = 266,                      /* "<"  */
    GT = 267,                      /* ">"  */
    GTE = 268,                     /* ">="  */
    LTE = 269,                     /* "<="  */
    LSHIFT = 270,                  /* "<<"  */
    RSHIFT = 271,                  /* ">>"  */
    AMPERSAND = 272,               /* "&"  */
    CARET = 273,                   /* "^"  */
    NOT = 274,                     /* "!"  */
    SLASH = 275,                   /* "/"  */
    ASTERISK = 276,                /* "*"  */
    DASH = 277,                    /* "-"  */
    AT = 278,                      /* "@"  */
    VMAP = 279,                    /* "vmap"  */
    PLUS = 280,                    /* "+"  */
    INCLUDE = 281,                 /* "include"  */
    DEFINE = 282,                  /* "define"  */
    REDEFINE = 283,                /* "redefine"  */
    UNDEFINE = 284,                /* "undefine"  */
    FIB = 285,                     /* "fib"  */
    SOCKET = 286,                  /* "socket"  */
    TRANSPARENT = 287,             /* "transparent"  */
    WILDCARD = 288,                /* "wildcard"  */
    TPROXY = 289,                  /* "tproxy"  */
    OSF = 290,                     /* "osf"  */
    SYNPROXY = 291,                /* "synproxy"  */
    MSS = 292,                     /* "mss"  */
    WSCALE = 293,                  /* "wscale"  */
    TYPEOF = 294,                  /* "typeof"  */
    HOOK = 295,                    /* "hook"  */
    DEVICE = 296,                  /* "device"  */
    DEVICES = 297,                 /* "devices"  */
    TABLE = 298,                   /* "table"  */
    TABLES = 299,                  /* "tables"  */
    CHAIN = 300,                   /* "chain"  */
    CHAINS = 301,                  /* "chains"  */
    RULE = 302,                    /* "rule"  */
    RULES = 303,                   /* "rules"  */
    SETS = 304,                    /* "sets"  */
    SET = 305,                     /* "set"  */
    ELEMENT = 306,                 /* "element"  */
    MAP = 307,                     /* "map"  */
    MAPS = 308,                    /* "maps"  */
    FLOWTABLE = 309,               /* "flowtable"  */
    HANDLE = 310,                  /* "handle"  */
    RULESET = 311,                 /* "ruleset"  */
    TRACE = 312,                   /* "trace"  */
    INET = 313,                    /* "inet"  */
    NETDEV = 314,                  /* "netdev"  */
    ADD = 315,                     /* "add"  */
    UPDATE = 316,                  /* "update"  */
    REPLACE = 317,                 /* "replace"  */
    CREATE = 318,                  /* "create"  */
    INSERT = 319,                  /* "insert"  */
    DELETE = 320,                  /* "delete"  */
    GET = 321,                     /* "get"  */
    LIST = 322,                    /* "list"  */
    RESET = 323,                   /* "reset"  */
    FLUSH = 324,                   /* "flush"  */
    RENAME = 325,                  /* "rename"  */
    DESCRIBE = 326,                /* "describe"  */
    IMPORT = 327,                  /* "import"  */
    EXPORT = 328,                  /* "export"  */
    MONITOR = 329,                 /* "monitor"  */
    ALL = 330,                     /* "all"  */
    ACCEPT = 331,                  /* "accept"  */
    DROP = 332,                    /* "drop"  */
    CONTINUE = 333,                /* "continue"  */
    JUMP = 334,                    /* "jump"  */
    GOTO = 335,                    /* "goto"  */
    RETURN = 336,                  /* "return"  */
    TO = 337,                      /* "to"  */
    CONSTANT = 338,                /* "constant"  */
    INTERVAL = 339,                /* "interval"  */
    DYNAMIC = 340,                 /* "dynamic"  */
    AUTOMERGE = 341,               /* "auto-merge"  */
    TIMEOUT = 342,                 /* "timeout"  */
    GC_INTERVAL = 343,             /* "gc-interval"  */
    ELEMENTS = 344,                /* "elements"  */
    EXPIRES = 345,                 /* "expires"  */
    POLICY = 346,                  /* "policy"  */
    MEMORY = 347,                  /* "memory"  */
    PERFORMANCE = 348,             /* "performance"  */
    SIZE = 349,                    /* "size"  */
    FLOW = 350,                    /* "flow"  */
    OFFLOAD = 351,                 /* "offload"  */
    METER = 352,                   /* "meter"  */
    METERS = 353,                  /* "meters"  */
    FLOWTABLES = 354,              /* "flowtables"  */
    NUM = 355,                     /* "number"  */
    STRING = 356,                  /* "string"  */
    QUOTED_STRING = 357,           /* "quoted string"  */
    ASTERISK_STRING = 358,         /* "string with a trailing asterisk"  */
    LL_HDR = 359,                  /* "ll"  */
    NETWORK_HDR = 360,             /* "nh"  */
    TRANSPORT_HDR = 361,           /* "th"  */
    BRIDGE = 362,                  /* "bridge"  */
    ETHER = 363,                   /* "ether"  */
    SADDR = 364,                   /* "saddr"  */
    DADDR = 365,                   /* "daddr"  */
    TYPE = 366,                    /* "type"  */
    VLAN = 367,                    /* "vlan"  */
    ID = 368,                      /* "id"  */
    CFI = 369,                     /* "cfi"  */
    PCP = 370,                     /* "pcp"  */
    ARP = 371,                     /* "arp"  */
    HTYPE = 372,                   /* "htype"  */
    PTYPE = 373,                   /* "ptype"  */
    HLEN = 374,                    /* "hlen"  */
    PLEN = 375,                    /* "plen"  */
    OPERATION = 376,               /* "operation"  */
    IP = 377,                      /* "ip"  */
    HDRVERSION = 378,              /* "version"  */
    HDRLENGTH = 379,               /* "hdrlength"  */
    DSCP = 380,                    /* "dscp"  */
    ECN = 381,                     /* "ecn"  */
    LENGTH = 382,                  /* "length"  */
    FRAG_OFF = 383,                /* "frag-off"  */
    TTL = 384,                     /* "ttl"  */
    PROTOCOL = 385,                /* "protocol"  */
    CHECKSUM = 386,                /* "checksum"  */
    PTR = 387,                     /* "ptr"  */
    VALUE = 388,                   /* "value"  */
    LSRR = 389,                    /* "lsrr"  */
    RR = 390,                      /* "rr"  */
    SSRR = 391,                    /* "ssrr"  */
    RA = 392,                      /* "ra"  */
    ICMP = 393,                    /* "icmp"  */
    CODE = 394,                    /* "code"  */
    SEQUENCE = 395,                /* "seq"  */
    GATEWAY = 396,                 /* "gateway"  */
    MTU = 397,                     /* "mtu"  */
    IGMP = 398,                    /* "igmp"  */
    MRT = 399,                     /* "mrt"  */
    OPTIONS = 400,                 /* "options"  */
    IP6 = 401,                     /* "ip6"  */
    PRIORITY = 402,                /* "priority"  */
    FLOWLABEL = 403,               /* "flowlabel"  */
    NEXTHDR = 404,                 /* "nexthdr"  */
    HOPLIMIT = 405,                /* "hoplimit"  */
    ICMP6 = 406,                   /* "icmpv6"  */
    PPTR = 407,                    /* "param-problem"  */
    MAXDELAY = 408,                /* "max-delay"  */
    AH = 409,                      /* "ah"  */
    RESERVED = 410,                /* "reserved"  */
    SPI = 411,                     /* "spi"  */
    ESP = 412,                     /* "esp"  */
    COMP = 413,                    /* "comp"  */
    FLAGS = 414,                   /* "flags"  */
    CPI = 415,                     /* "cpi"  */
    PORT = 416,                    /* "port"  */
    UDP = 417,                     /* "udp"  */
    SPORT = 418,                   /* "sport"  */
    DPORT = 419,                   /* "dport"  */
    UDPLITE = 420,                 /* "udplite"  */
    CSUMCOV = 421,                 /* "csumcov"  */
    TCP = 422,                     /* "tcp"  */
    ACKSEQ = 423,                  /* "ackseq"  */
    DOFF = 424,                    /* "doff"  */
    WINDOW = 425,                  /* "window"  */
    URGPTR = 426,                  /* "urgptr"  */
    OPTION = 427,                  /* "option"  */
    ECHO = 428,                    /* "echo"  */
    EOL = 429,                     /* "eol"  */
    NOP = 430,                     /* "nop"  */
    SACK = 431,                    /* "sack"  */
    SACK0 = 432,                   /* "sack0"  */
    SACK1 = 433,                   /* "sack1"  */
    SACK2 = 434,                   /* "sack2"  */
    SACK3 = 435,                   /* "sack3"  */
    SACK_PERM = 436,               /* "sack-permitted"  */
    TIMESTAMP = 437,               /* "timestamp"  */
    KIND = 438,                    /* "kind"  */
    COUNT = 439,                   /* "count"  */
    LEFT = 440,                    /* "left"  */
    RIGHT = 441,                   /* "right"  */
    TSVAL = 442,                   /* "tsval"  */
    TSECR = 443,                   /* "tsecr"  */
    DCCP = 444,                    /* "dccp"  */
    SCTP = 445,                    /* "sctp"  */
    VTAG = 446,                    /* "vtag"  */
    RT = 447,                      /* "rt"  */
    RT0 = 448,                     /* "rt0"  */
    RT2 = 449,                     /* "rt2"  */
    RT4 = 450,                     /* "srh"  */
    SEG_LEFT = 451,                /* "seg-left"  */
    ADDR = 452,                    /* "addr"  */
    LAST_ENT = 453,                /* "last-entry"  */
    TAG = 454,                     /* "tag"  */
    SID = 455,                     /* "sid"  */
    HBH = 456,                     /* "hbh"  */
    FRAG = 457,                    /* "frag"  */
    RESERVED2 = 458,               /* "reserved2"  */
    MORE_FRAGMENTS = 459,          /* "more-fragments"  */
    DST = 460,                     /* "dst"  */
    MH = 461,                      /* "mh"  */
    META = 462,                    /* "meta"  */
    MARK = 463,                    /* "mark"  */
    IIF = 464,                     /* "iif"  */
    IIFNAME = 465,                 /* "iifname"  */
    IIFTYPE = 466,                 /* "iiftype"  */
    OIF = 467,                     /* "oif"  */
    OIFNAME = 468,                 /* "oifname"  */
    OIFTYPE = 469,                 /* "oiftype"  */
    SKUID = 470,                   /* "skuid"  */
    SKGID = 471,                   /* "skgid"  */
    NFTRACE = 472,                 /* "nftrace"  */
    RTCLASSID = 473,               /* "rtclassid"  */
    IBRIPORT = 474,                /* "ibriport"  */
    OBRIPORT = 475,                /* "obriport"  */
    IBRIDGENAME = 476,             /* "ibrname"  */
    OBRIDGENAME = 477,             /* "obrname"  */
    PKTTYPE = 478,                 /* "pkttype"  */
    CPU = 479,                     /* "cpu"  */
    IIFGROUP = 480,                /* "iifgroup"  */
    OIFGROUP = 481,                /* "oifgroup"  */
    CGROUP = 482,                  /* "cgroup"  */
    TIME = 483,                    /* "time"  */
    CLASSID = 484,                 /* "classid"  */
    NEXTHOP = 485,                 /* "nexthop"  */
    CT = 486,                      /* "ct"  */
    L3PROTOCOL = 487,              /* "l3proto"  */
    PROTO_SRC = 488,               /* "proto-src"  */
    PROTO_DST = 489,               /* "proto-dst"  */
    ZONE = 490,                    /* "zone"  */
    DIRECTION = 491,               /* "direction"  */
    EVENT = 492,                   /* "event"  */
    EXPECTATION = 493,             /* "expectation"  */
    EXPIRATION = 494,              /* "expiration"  */
    HELPER = 495,                  /* "helper"  */
    LABEL = 496,                   /* "label"  */
    STATE = 497,                   /* "state"  */
    STATUS = 498,                  /* "status"  */
    ORIGINAL = 499,                /* "original"  */
    REPLY = 500,                   /* "reply"  */
    COUNTER = 501,                 /* "counter"  */
    NAME = 502,                    /* "name"  */
    PACKETS = 503,                 /* "packets"  */
    BYTES = 504,                   /* "bytes"  */
    AVGPKT = 505,                  /* "avgpkt"  */
    COUNTERS = 506,                /* "counters"  */
    QUOTAS = 507,                  /* "quotas"  */
    LIMITS = 508,                  /* "limits"  */
    SYNPROXYS = 509,               /* "synproxys"  */
    HELPERS = 510,                 /* "helpers"  */
    LOG = 511,                     /* "log"  */
    PREFIX = 512,                  /* "prefix"  */
    GROUP = 513,                   /* "group"  */
    SNAPLEN = 514,                 /* "snaplen"  */
    QUEUE_THRESHOLD = 515,         /* "queue-threshold"  */
    LEVEL = 516,                   /* "level"  */
    LIMIT = 517,                   /* "limit"  */
    RATE = 518,                    /* "rate"  */
    BURST = 519,                   /* "burst"  */
    OVER = 520,                    /* "over"  */
    UNTIL = 521,                   /* "until"  */
    QUOTA = 522,                   /* "quota"  */
    USED = 523,                    /* "used"  */
    SECMARK = 524,                 /* "secmark"  */
    SECMARKS = 525,                /* "secmarks"  */
    NANOSECOND = 526,              /* "nanosecond"  */
    MICROSECOND = 527,             /* "microsecond"  */
    MILLISECOND = 528,             /* "millisecond"  */
    SECOND = 529,                  /* "second"  */
    MINUTE = 530,                  /* "minute"  */
    HOUR = 531,                    /* "hour"  */
    DAY = 532,                     /* "day"  */
    WEEK = 533,                    /* "week"  */
    _REJECT = 534,                 /* "reject"  */
    WITH = 535,                    /* "with"  */
    ICMPX = 536,                   /* "icmpx"  */
    SNAT = 537,                    /* "snat"  */
    DNAT = 538,                    /* "dnat"  */
    MASQUERADE = 539,              /* "masquerade"  */
    REDIRECT = 540,                /* "redirect"  */
    RANDOM = 541,                  /* "random"  */
    FULLY_RANDOM = 542,            /* "fully-random"  */
    PERSISTENT = 543,              /* "persistent"  */
    QUEUE = 544,                   /* "queue"  */
    QUEUENUM = 545,                /* "num"  */
    BYPASS = 546,                  /* "bypass"  */
    FANOUT = 547,                  /* "fanout"  */
    DUP = 548,                     /* "dup"  */
    FWD = 549,                     /* "fwd"  */
    NUMGEN = 550,                  /* "numgen"  */
    INC = 551,                     /* "inc"  */
    MOD = 552,                     /* "mod"  */
    OFFSET = 553,                  /* "offset"  */
    JHASH = 554,                   /* "jhash"  */
    SYMHASH = 555,                 /* "symhash"  */
    SEED = 556,                    /* "seed"  */
    POSITION = 557,                /* "position"  */
    INDEX = 558,                   /* "index"  */
    COMMENT = 559,                 /* "comment"  */
    XML = 560,                     /* "xml"  */
    JSON = 561,                    /* "json"  */
    VM = 562,                      /* "vm"  */
    NOTRACK = 563,                 /* "notrack"  */
    EXISTS = 564,                  /* "exists"  */
    MISSING = 565,                 /* "missing"  */
    EXTHDR = 566,                  /* "exthdr"  */
    IPSEC = 567,                   /* "ipsec"  */
    MODE = 568,                    /* "mode"  */
    REQID = 569,                   /* "reqid"  */
    SPNUM = 570,                   /* "spnum"  */
    TRANSPORT = 571,               /* "transport"  */
    TUNNEL = 572,                  /* "tunnel"  */
    IN = 573,                      /* "in"  */
    OUT = 574                      /* "out"  */
  };
  typedef enum yytokentype yytoken_kind_t;
#endif
/* Token kinds.  */
#define YYEMPTY -2
#define TOKEN_EOF 0
#define YYerror 256
#define YYUNDEF 257
#define JUNK 258
#define NEWLINE 259
#define COLON 260
#define SEMICOLON 261
#define COMMA 262
#define DOT 263
#define EQ 264
#define NEQ 265
#define LT 266
#define GT 267
#define GTE 268
#define LTE 269
#define LSHIFT 270
#define RSHIFT 271
#define AMPERSAND 272
#define CARET 273
#define NOT 274
#define SLASH 275
#define ASTERISK 276
#define DASH 277
#define AT 278
#define VMAP 279
#define PLUS 280
#define INCLUDE 281
#define DEFINE 282
#define REDEFINE 283
#define UNDEFINE 284
#define FIB 285
#define SOCKET 286
#define TRANSPARENT 287
#define WILDCARD 288
#define TPROXY 289
#define OSF 290
#define SYNPROXY 291
#define MSS 292
#define WSCALE 293
#define TYPEOF 294
#define HOOK 295
#define DEVICE 296
#define DEVICES 297
#define TABLE 298
#define TABLES 299
#define CHAIN 300
#define CHAINS 301
#define RULE 302
#define RULES 303
#define SETS 304
#define SET 305
#define ELEMENT 306
#define MAP 307
#define MAPS 308
#define FLOWTABLE 309
#define HANDLE 310
#define RULESET 311
#define TRACE 312
#define INET 313
#define NETDEV 314
#define ADD 315
#define UPDATE 316
#define REPLACE 317
#define CREATE 318
#define INSERT 319
#define DELETE 320
#define GET 321
#define LIST 322
#define RESET 323
#define FLUSH 324
#define RENAME 325
#define DESCRIBE 326
#define IMPORT 327
#define EXPORT 328
#define MONITOR 329
#define ALL 330
#define ACCEPT 331
#define DROP 332
#define CONTINUE 333
#define JUMP 334
#define GOTO 335
#define RETURN 336
#define TO 337
#define CONSTANT 338
#define INTERVAL 339
#define DYNAMIC 340
#define AUTOMERGE 341
#define TIMEOUT 342
#define GC_INTERVAL 343
#define ELEMENTS 344
#define EXPIRES 345
#define POLICY 346
#define MEMORY 347
#define PERFORMANCE 348
#define SIZE 349
#define FLOW 350
#define OFFLOAD 351
#define METER 352
#define METERS 353
#define FLOWTABLES 354
#define NUM 355
#define STRING 356
#define QUOTED_STRING 357
#define ASTERISK_STRING 358
#define LL_HDR 359
#define NETWORK_HDR 360
#define TRANSPORT_HDR 361
#define BRIDGE 362
#define ETHER 363
#define SADDR 364
#define DADDR 365
#define TYPE 366
#define VLAN 367
#define ID 368
#define CFI 369
#define PCP 370
#define ARP 371
#define HTYPE 372
#define PTYPE 373
#define HLEN 374
#define PLEN 375
#define OPERATION 376
#define IP 377
#define HDRVERSION 378
#define HDRLENGTH 379
#define DSCP 380
#define ECN 381
#define LENGTH 382
#define FRAG_OFF 383
#define TTL 384
#define PROTOCOL 385
#define CHECKSUM 386
#define PTR 387
#define VALUE 388
#define LSRR 389
#define RR 390
#define SSRR 391
#define RA 392
#define ICMP 393
#define CODE 394
#define SEQUENCE 395
#define GATEWAY 396
#define MTU 397
#define IGMP 398
#define MRT 399
#define OPTIONS 400
#define IP6 401
#define PRIORITY 402
#define FLOWLABEL 403
#define NEXTHDR 404
#define HOPLIMIT 405
#define ICMP6 406
#define PPTR 407
#define MAXDELAY 408
#define AH 409
#define RESERVED 410
#define SPI 411
#define ESP 412
#define COMP 413
#define FLAGS 414
#define CPI 415
#define PORT 416
#define UDP 417
#define SPORT 418
#define DPORT 419
#define UDPLITE 420
#define CSUMCOV 421
#define TCP 422
#define ACKSEQ 423
#define DOFF 424
#define WINDOW 425
#define URGPTR 426
#define OPTION 427
#define ECHO 428
#define EOL 429
#define NOP 430
#define SACK 431
#define SACK0 432
#define SACK1 433
#define SACK2 434
#define SACK3 435
#define SACK_PERM 436
#define TIMESTAMP 437
#define KIND 438
#define COUNT 439
#define LEFT 440
#define RIGHT 441
#define TSVAL 442
#define TSECR 443
#define DCCP 444
#define SCTP 445
#define VTAG 446
#define RT 447
#define RT0 448
#define RT2 449
#define RT4 450
#define SEG_LEFT 451
#define ADDR 452
#define LAST_ENT 453
#define TAG 454
#define SID 455
#define HBH 456
#define FRAG 457
#define RESERVED2 458
#define MORE_FRAGMENTS 459
#define DST 460
#define MH 461
#define META 462
#define MARK 463
#define IIF 464
#define IIFNAME 465
#define IIFTYPE 466
#define OIF 467
#define OIFNAME 468
#define OIFTYPE 469
#define SKUID 470
#define SKGID 471
#define NFTRACE 472
#define RTCLASSID 473
#define IBRIPORT 474
#define OBRIPORT 475
#define IBRIDGENAME 476
#define OBRIDGENAME 477
#define PKTTYPE 478
#define CPU 479
#define IIFGROUP 480
#define OIFGROUP 481
#define CGROUP 482
#define TIME 483
#define CLASSID 484
#define NEXTHOP 485
#define CT 486
#define L3PROTOCOL 487
#define PROTO_SRC 488
#define PROTO_DST 489
#define ZONE 490
#define DIRECTION 491
#define EVENT 492
#define EXPECTATION 493
#define EXPIRATION 494
#define HELPER 495
#define LABEL 496
#define STATE 497
#define STATUS 498
#define ORIGINAL 499
#define REPLY 500
#define COUNTER 501
#define NAME 502
#define PACKETS 503
#define BYTES 504
#define AVGPKT 505
#define COUNTERS 506
#define QUOTAS 507
#define LIMITS 508
#define SYNPROXYS 509
#define HELPERS 510
#define LOG 511
#define PREFIX 512
#define GROUP 513
#define SNAPLEN 514
#define QUEUE_THRESHOLD 515
#define LEVEL 516
#define LIMIT 517
#define RATE 518
#define BURST 519
#define OVER 520
#define UNTIL 521
#define QUOTA 522
#define USED 523
#define SECMARK 524
#define SECMARKS 525
#define NANOSECOND 526
#define MICROSECOND 527
#define MILLISECOND 528
#define SECOND 529
#define MINUTE 530
#define HOUR 531
#define DAY 532
#define WEEK 533
#define _REJECT 534
#define WITH 535
#define ICMPX 536
#define SNAT 537
#define DNAT 538
#define MASQUERADE 539
#define REDIRECT 540
#define RANDOM 541
#define FULLY_RANDOM 542
#define PERSISTENT 543
#define QUEUE 544
#define QUEUENUM 545
#define BYPASS 546
#define FANOUT 547
#define DUP 548
#define FWD 549
#define NUMGEN 550
#define INC 551
#define MOD 552
#define OFFSET 553
#define JHASH 554
#define SYMHASH 555
#define SEED 556
#define POSITION 557
#define INDEX 558
#define COMMENT 559
#define XML 560
#define JSON 561
#define VM 562
#define NOTRACK 563
#define EXISTS 564
#define MISSING 565
#define EXTHDR 566
#define IPSEC 567
#define MODE 568
#define REQID 569
#define SPNUM 570
#define TRANSPORT 571
#define TUNNEL 572
#define IN 573
#define OUT 574

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
union YYSTYPE
{
#line 166 "parser_bison.y"

	uint64_t		val;
	uint32_t		val32;
	uint8_t			val8;
	const char *		string;

	struct list_head	*list;
	struct cmd		*cmd;
	struct handle		handle;
	struct table		*table;
	struct chain		*chain;
	struct rule		*rule;
	struct stmt		*stmt;
	struct expr		*expr;
	struct set		*set;
	struct obj		*obj;
	struct flowtable	*flowtable;
	struct ct		*ct;
	const struct datatype	*datatype;
	struct handle_spec	handle_spec;
	struct position_spec	position_spec;
	struct prio_spec	prio_spec;

#line 926 "parser_bison.c"

};
typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif

/* Location type.  */
#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE YYLTYPE;
struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
};
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif



int nft_parse (struct nft_ctx *nft, void *scanner, struct parser_state *state);

#endif /* !YY_NFT_PARSER_BISON_H_INCLUDED  */
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_JUNK = 3,                       /* "junk"  */
  YYSYMBOL_NEWLINE = 4,                    /* "newline"  */
  YYSYMBOL_COLON = 5,                      /* "colon"  */
  YYSYMBOL_SEMICOLON = 6,                  /* "semicolon"  */
  YYSYMBOL_COMMA = 7,                      /* "comma"  */
  YYSYMBOL_DOT = 8,                        /* "."  */
  YYSYMBOL_EQ = 9,                         /* "=="  */
  YYSYMBOL_NEQ = 10,                       /* "!="  */
  YYSYMBOL_LT = 11,                        /* "<"  */
  YYSYMBOL_GT = 12,                        /* ">"  */
  YYSYMBOL_GTE = 13,                       /* ">="  */
  YYSYMBOL_LTE = 14,                       /* "<="  */
  YYSYMBOL_LSHIFT = 15,                    /* "<<"  */
  YYSYMBOL_RSHIFT = 16,                    /* ">>"  */
  YYSYMBOL_AMPERSAND = 17,                 /* "&"  */
  YYSYMBOL_CARET = 18,                     /* "^"  */
  YYSYMBOL_NOT = 19,                       /* "!"  */
  YYSYMBOL_SLASH = 20,                     /* "/"  */
  YYSYMBOL_ASTERISK = 21,                  /* "*"  */
  YYSYMBOL_DASH = 22,                      /* "-"  */
  YYSYMBOL_AT = 23,                        /* "@"  */
  YYSYMBOL_VMAP = 24,                      /* "vmap"  */
  YYSYMBOL_PLUS = 25,                      /* "+"  */
  YYSYMBOL_INCLUDE = 26,                   /* "include"  */
  YYSYMBOL_DEFINE = 27,                    /* "define"  */
  YYSYMBOL_REDEFINE = 28,                  /* "redefine"  */
  YYSYMBOL_UNDEFINE = 29,                  /* "undefine"  */
  YYSYMBOL_FIB = 30,                       /* "fib"  */
  YYSYMBOL_SOCKET = 31,                    /* "socket"  */
  YYSYMBOL_TRANSPARENT = 32,               /* "transparent"  */
  YYSYMBOL_WILDCARD = 33,                  /* "wildcard"  */
  YYSYMBOL_TPROXY = 34,                    /* "tproxy"  */
  YYSYMBOL_OSF = 35,                       /* "osf"  */
  YYSYMBOL_SYNPROXY = 36,                  /* "synproxy"  */
  YYSYMBOL_MSS = 37,                       /* "mss"  */
  YYSYMBOL_WSCALE = 38,                    /* "wscale"  */
  YYSYMBOL_TYPEOF = 39,                    /* "typeof"  */
  YYSYMBOL_HOOK = 40,                      /* "hook"  */
  YYSYMBOL_DEVICE = 41,                    /* "device"  */
  YYSYMBOL_DEVICES = 42,                   /* "devices"  */
  YYSYMBOL_TABLE = 43,                     /* "table"  */
  YYSYMBOL_TABLES = 44,                    /* "tables"  */
  YYSYMBOL_CHAIN = 45,                     /* "chain"  */
  YYSYMBOL_CHAINS = 46,                    /* "chains"  */
  YYSYMBOL_RULE = 47,                      /* "rule"  */
  YYSYMBOL_RULES = 48,                     /* "rules"  */
  YYSYMBOL_SETS = 49,                      /* "sets"  */
  YYSYMBOL_SET = 50,                       /* "set"  */
  YYSYMBOL_ELEMENT = 51,                   /* "element"  */
  YYSYMBOL_MAP = 52,                       /* "map"  */
  YYSYMBOL_MAPS = 53,                      /* "maps"  */
  YYSYMBOL_FLOWTABLE = 54,                 /* "flowtable"  */
  YYSYMBOL_HANDLE = 55,                    /* "handle"  */
  YYSYMBOL_RULESET = 56,                   /* "ruleset"  */
  YYSYMBOL_TRACE = 57,                     /* "trace"  */
  YYSYMBOL_INET = 58,                      /* "inet"  */
  YYSYMBOL_NETDEV = 59,                    /* "netdev"  */
  YYSYMBOL_ADD = 60,                       /* "add"  */
  YYSYMBOL_UPDATE = 61,                    /* "update"  */
  YYSYMBOL_REPLACE = 62,                   /* "replace"  */
  YYSYMBOL_CREATE = 63,                    /* "create"  */
  YYSYMBOL_INSERT = 64,                    /* "insert"  */
  YYSYMBOL_DELETE = 65,                    /* "delete"  */
  YYSYMBOL_GET = 66,                       /* "get"  */
  YYSYMBOL_LIST = 67,                      /* "list"  */
  YYSYMBOL_RESET = 68,                     /* "reset"  */
  YYSYMBOL_FLUSH = 69,                     /* "flush"  */
  YYSYMBOL_RENAME = 70,                    /* "rename"  */
  YYSYMBOL_DESCRIBE = 71,                  /* "describe"  */
  YYSYMBOL_IMPORT = 72,                    /* "import"  */
  YYSYMBOL_EXPORT = 73,                    /* "export"  */
  YYSYMBOL_MONITOR = 74,                   /* "monitor"  */
  YYSYMBOL_ALL = 75,                       /* "all"  */
  YYSYMBOL_ACCEPT = 76,                    /* "accept"  */
  YYSYMBOL_DROP = 77,                      /* "drop"  */
  YYSYMBOL_CONTINUE = 78,                  /* "continue"  */
  YYSYMBOL_JUMP = 79,                      /* "jump"  */
  YYSYMBOL_GOTO = 80,                      /* "goto"  */
  YYSYMBOL_RETURN = 81,                    /* "return"  */
  YYSYMBOL_TO = 82,                        /* "to"  */
  YYSYMBOL_CONSTANT = 83,                  /* "constant"  */
  YYSYMBOL_INTERVAL = 84,                  /* "interval"  */
  YYSYMBOL_DYNAMIC = 85,                   /* "dynamic"  */
  YYSYMBOL_AUTOMERGE = 86,                 /* "auto-merge"  */
  YYSYMBOL_TIMEOUT = 87,                   /* "timeout"  */
  YYSYMBOL_GC_INTERVAL = 88,               /* "gc-interval"  */
  YYSYMBOL_ELEMENTS = 89,                  /* "elements"  */
  YYSYMBOL_EXPIRES = 90,                   /* "expires"  */
  YYSYMBOL_POLICY = 91,                    /* "policy"  */
  YYSYMBOL_MEMORY = 92,                    /* "memory"  */
  YYSYMBOL_PERFORMANCE = 93,               /* "performance"  */
  YYSYMBOL_SIZE = 94,                      /* "size"  */
  YYSYMBOL_FLOW = 95,                      /* "flow"  */
  YYSYMBOL_OFFLOAD = 96,                   /* "offload"  */
  YYSYMBOL_METER = 97,                     /* "meter"  */
  YYSYMBOL_METERS = 98,                    /* "meters"  */
  YYSYMBOL_FLOWTABLES = 99,                /* "flowtables"  */
  YYSYMBOL_NUM = 100,                      /* "number"  */
  YYSYMBOL_STRING = 101,                   /* "string"  */
  YYSYMBOL_QUOTED_STRING = 102,            /* "quoted string"  */
  YYSYMBOL_ASTERISK_STRING = 103,          /* "string with a trailing asterisk"  */
  YYSYMBOL_LL_HDR = 104,                   /* "ll"  */
  YYSYMBOL_NETWORK_HDR = 105,              /* "nh"  */
  YYSYMBOL_TRANSPORT_HDR = 106,            /* "th"  */
  YYSYMBOL_BRIDGE = 107,                   /* "bridge"  */
  YYSYMBOL_ETHER = 108,                    /* "ether"  */
  YYSYMBOL_SADDR = 109,                    /* "saddr"  */
  YYSYMBOL_DADDR = 110,                    /* "daddr"  */
  YYSYMBOL_TYPE = 111,                     /* "type"  */
  YYSYMBOL_VLAN = 112,                     /* "vlan"  */
  YYSYMBOL_ID = 113,                       /* "id"  */
  YYSYMBOL_CFI = 114,                      /* "cfi"  */
  YYSYMBOL_PCP = 115,                      /* "pcp"  */
  YYSYMBOL_ARP = 116,                      /* "arp"  */
  YYSYMBOL_HTYPE = 117,                    /* "htype"  */
  YYSYMBOL_PTYPE = 118,                    /* "ptype"  */
  YYSYMBOL_HLEN = 119,                     /* "hlen"  */
  YYSYMBOL_PLEN = 120,                     /* "plen"  */
  YYSYMBOL_OPERATION = 121,                /* "operation"  */
  YYSYMBOL_IP = 122,                       /* "ip"  */
  YYSYMBOL_HDRVERSION = 123,               /* "version"  */
  YYSYMBOL_HDRLENGTH = 124,                /* "hdrlength"  */
  YYSYMBOL_DSCP = 125,                     /* "dscp"  */
  YYSYMBOL_ECN = 126,                      /* "ecn"  */
  YYSYMBOL_LENGTH = 127,                   /* "length"  */
  YYSYMBOL_FRAG_OFF = 128,                 /* "frag-off"  */
  YYSYMBOL_TTL = 129,                      /* "ttl"  */
  YYSYMBOL_PROTOCOL = 130,                 /* "protocol"  */
  YYSYMBOL_CHECKSUM = 131,                 /* "checksum"  */
  YYSYMBOL_PTR = 132,                      /* "ptr"  */
  YYSYMBOL_VALUE = 133,                    /* "value"  */
  YYSYMBOL_LSRR = 134,                     /* "lsrr"  */
  YYSYMBOL_RR = 135,                       /* "rr"  */
  YYSYMBOL_SSRR = 136,                     /* "ssrr"  */
  YYSYMBOL_RA = 137,                       /* "ra"  */
  YYSYMBOL_ICMP = 138,                     /* "icmp"  */
  YYSYMBOL_CODE = 139,                     /* "code"  */
  YYSYMBOL_SEQUENCE = 140,                 /* "seq"  */
  YYSYMBOL_GATEWAY = 141,                  /* "gateway"  */
  YYSYMBOL_MTU = 142,                      /* "mtu"  */
  YYSYMBOL_IGMP = 143,                     /* "igmp"  */
  YYSYMBOL_MRT = 144,                      /* "mrt"  */
  YYSYMBOL_OPTIONS = 145,                  /* "options"  */
  YYSYMBOL_IP6 = 146,                      /* "ip6"  */
  YYSYMBOL_PRIORITY = 147,                 /* "priority"  */
  YYSYMBOL_FLOWLABEL = 148,                /* "flowlabel"  */
  YYSYMBOL_NEXTHDR = 149,                  /* "nexthdr"  */
  YYSYMBOL_HOPLIMIT = 150,                 /* "hoplimit"  */
  YYSYMBOL_ICMP6 = 151,                    /* "icmpv6"  */
  YYSYMBOL_PPTR = 152,                     /* "param-problem"  */
  YYSYMBOL_MAXDELAY = 153,                 /* "max-delay"  */
  YYSYMBOL_AH = 154,                       /* "ah"  */
  YYSYMBOL_RESERVED = 155,                 /* "reserved"  */
  YYSYMBOL_SPI = 156,                      /* "spi"  */
  YYSYMBOL_ESP = 157,                      /* "esp"  */
  YYSYMBOL_COMP = 158,                     /* "comp"  */
  YYSYMBOL_FLAGS = 159,                    /* "flags"  */
  YYSYMBOL_CPI = 160,                      /* "cpi"  */
  YYSYMBOL_PORT = 161,                     /* "port"  */
  YYSYMBOL_UDP = 162,                      /* "udp"  */
  YYSYMBOL_SPORT = 163,                    /* "sport"  */
  YYSYMBOL_DPORT = 164,                    /* "dport"  */
  YYSYMBOL_UDPLITE = 165,                  /* "udplite"  */
  YYSYMBOL_CSUMCOV = 166,                  /* "csumcov"  */
  YYSYMBOL_TCP = 167,                      /* "tcp"  */
  YYSYMBOL_ACKSEQ = 168,                   /* "ackseq"  */
  YYSYMBOL_DOFF = 169,                     /* "doff"  */
  YYSYMBOL_WINDOW = 170,                   /* "window"  */
  YYSYMBOL_URGPTR = 171,                   /* "urgptr"  */
  YYSYMBOL_OPTION = 172,                   /* "option"  */
  YYSYMBOL_ECHO = 173,                     /* "echo"  */
  YYSYMBOL_EOL = 174,                      /* "eol"  */
  YYSYMBOL_NOP = 175,                      /* "nop"  */
  YYSYMBOL_SACK = 176,                     /* "sack"  */
  YYSYMBOL_SACK0 = 177,                    /* "sack0"  */
  YYSYMBOL_SACK1 = 178,                    /* "sack1"  */
  YYSYMBOL_SACK2 = 179,                    /* "sack2"  */
  YYSYMBOL_SACK3 = 180,                    /* "sack3"  */
  YYSYMBOL_SACK_PERM = 181,                /* "sack-permitted"  */
  YYSYMBOL_TIMESTAMP = 182,                /* "timestamp"  */
  YYSYMBOL_KIND = 183,                     /* "kind"  */
  YYSYMBOL_COUNT = 184,                    /* "count"  */
  YYSYMBOL_LEFT = 185,                     /* "left"  */
  YYSYMBOL_RIGHT = 186,                    /* "right"  */
  YYSYMBOL_TSVAL = 187,                    /* "tsval"  */
  YYSYMBOL_TSECR = 188,                    /* "tsecr"  */
  YYSYMBOL_DCCP = 189,                     /* "dccp"  */
  YYSYMBOL_SCTP = 190,                     /* "sctp"  */
  YYSYMBOL_VTAG = 191,                     /* "vtag"  */
  YYSYMBOL_RT = 192,                       /* "rt"  */
  YYSYMBOL_RT0 = 193,                      /* "rt0"  */
  YYSYMBOL_RT2 = 194,                      /* "rt2"  */
  YYSYMBOL_RT4 = 195,                      /* "srh"  */
  YYSYMBOL_SEG_LEFT = 196,                 /* "seg-left"  */
  YYSYMBOL_ADDR = 197,                     /* "addr"  */
  YYSYMBOL_LAST_ENT = 198,                 /* "last-entry"  */
  YYSYMBOL_TAG = 199,                      /* "tag"  */
  YYSYMBOL_SID = 200,                      /* "sid"  */
  YYSYMBOL_HBH = 201,                      /* "hbh"  */
  YYSYMBOL_FRAG = 202,                     /* "frag"  */
  YYSYMBOL_RESERVED2 = 203,                /* "reserved2"  */
  YYSYMBOL_MORE_FRAGMENTS = 204,           /* "more-fragments"  */
  YYSYMBOL_DST = 205,                      /* "dst"  */
  YYSYMBOL_MH = 206,                       /* "mh"  */
  YYSYMBOL_META = 207,                     /* "meta"  */
  YYSYMBOL_MARK = 208,                     /* "mark"  */
  YYSYMBOL_IIF = 209,                      /* "iif"  */
  YYSYMBOL_IIFNAME = 210,                  /* "iifname"  */
  YYSYMBOL_IIFTYPE = 211,                  /* "iiftype"  */
  YYSYMBOL_OIF = 212,                      /* "oif"  */
  YYSYMBOL_OIFNAME = 213,                  /* "oifname"  */
  YYSYMBOL_OIFTYPE = 214,                  /* "oiftype"  */
  YYSYMBOL_SKUID = 215,                    /* "skuid"  */
  YYSYMBOL_SKGID = 216,                    /* "skgid"  */
  YYSYMBOL_NFTRACE = 217,                  /* "nftrace"  */
  YYSYMBOL_RTCLASSID = 218,                /* "rtclassid"  */
  YYSYMBOL_IBRIPORT = 219,                 /* "ibriport"  */
  YYSYMBOL_OBRIPORT = 220,                 /* "obriport"  */
  YYSYMBOL_IBRIDGENAME = 221,              /* "ibrname"  */
  YYSYMBOL_OBRIDGENAME = 222,              /* "obrname"  */
  YYSYMBOL_PKTTYPE = 223,                  /* "pkttype"  */
  YYSYMBOL_CPU = 224,                      /* "cpu"  */
  YYSYMBOL_IIFGROUP = 225,                 /* "iifgroup"  */
  YYSYMBOL_OIFGROUP = 226,                 /* "oifgroup"  */
  YYSYMBOL_CGROUP = 227,                   /* "cgroup"  */
  YYSYMBOL_TIME = 228,                     /* "time"  */
  YYSYMBOL_CLASSID = 229,                  /* "classid"  */
  YYSYMBOL_NEXTHOP = 230,                  /* "nexthop"  */
  YYSYMBOL_CT = 231,                       /* "ct"  */
  YYSYMBOL_L3PROTOCOL = 232,               /* "l3proto"  */
  YYSYMBOL_PROTO_SRC = 233,                /* "proto-src"  */
  YYSYMBOL_PROTO_DST = 234,                /* "proto-dst"  */
  YYSYMBOL_ZONE = 235,                     /* "zone"  */
  YYSYMBOL_DIRECTION = 236,                /* "direction"  */
  YYSYMBOL_EVENT = 237,                    /* "event"  */
  YYSYMBOL_EXPECTATION = 238,              /* "expectation"  */
  YYSYMBOL_EXPIRATION = 239,               /* "expiration"  */
  YYSYMBOL_HELPER = 240,                   /* "helper"  */
  YYSYMBOL_LABEL = 241,                    /* "label"  */
  YYSYMBOL_STATE = 242,                    /* "state"  */
  YYSYMBOL_STATUS = 243,                   /* "status"  */
  YYSYMBOL_ORIGINAL = 244,                 /* "original"  */
  YYSYMBOL_REPLY = 245,                    /* "reply"  */
  YYSYMBOL_COUNTER = 246,                  /* "counter"  */
  YYSYMBOL_NAME = 247,                     /* "name"  */
  YYSYMBOL_PACKETS = 248,                  /* "packets"  */
  YYSYMBOL_BYTES = 249,                    /* "bytes"  */
  YYSYMBOL_AVGPKT = 250,                   /* "avgpkt"  */
  YYSYMBOL_COUNTERS = 251,                 /* "counters"  */
  YYSYMBOL_QUOTAS = 252,                   /* "quotas"  */
  YYSYMBOL_LIMITS = 253,                   /* "limits"  */
  YYSYMBOL_SYNPROXYS = 254,                /* "synproxys"  */
  YYSYMBOL_HELPERS = 255,                  /* "helpers"  */
  YYSYMBOL_LOG = 256,                      /* "log"  */
  YYSYMBOL_PREFIX = 257,                   /* "prefix"  */
  YYSYMBOL_GROUP = 258,                    /* "group"  */
  YYSYMBOL_SNAPLEN = 259,                  /* "snaplen"  */
  YYSYMBOL_QUEUE_THRESHOLD = 260,          /* "queue-threshold"  */
  YYSYMBOL_LEVEL = 261,                    /* "level"  */
  YYSYMBOL_LIMIT = 262,                    /* "limit"  */
  YYSYMBOL_RATE = 263,                     /* "rate"  */
  YYSYMBOL_BURST = 264,                    /* "burst"  */
  YYSYMBOL_OVER = 265,                     /* "over"  */
  YYSYMBOL_UNTIL = 266,                    /* "until"  */
  YYSYMBOL_QUOTA = 267,                    /* "quota"  */
  YYSYMBOL_USED = 268,                     /* "used"  */
  YYSYMBOL_SECMARK = 269,                  /* "secmark"  */
  YYSYMBOL_SECMARKS = 270,                 /* "secmarks"  */
  YYSYMBOL_NANOSECOND = 271,               /* "nanosecond"  */
  YYSYMBOL_MICROSECOND = 272,              /* "microsecond"  */
  YYSYMBOL_MILLISECOND = 273,              /* "millisecond"  */
  YYSYMBOL_SECOND = 274,                   /* "second"  */
  YYSYMBOL_MINUTE = 275,                   /* "minute"  */
  YYSYMBOL_HOUR = 276,                     /* "hour"  */
  YYSYMBOL_DAY = 277,                      /* "day"  */
  YYSYMBOL_WEEK = 278,                     /* "week"  */
  YYSYMBOL__REJECT = 279,                  /* "reject"  */
  YYSYMBOL_WITH = 280,                     /* "with"  */
  YYSYMBOL_ICMPX = 281,                    /* "icmpx"  */
  YYSYMBOL_SNAT = 282,                     /* "snat"  */
  YYSYMBOL_DNAT = 283,                     /* "dnat"  */
  YYSYMBOL_MASQUERADE = 284,               /* "masquerade"  */
  YYSYMBOL_REDIRECT = 285,                 /* "redirect"  */
  YYSYMBOL_RANDOM = 286,                   /* "random"  */
  YYSYMBOL_FULLY_RANDOM = 287,             /* "fully-random"  */
  YYSYMBOL_PERSISTENT = 288,               /* "persistent"  */
  YYSYMBOL_QUEUE = 289,                    /* "queue"  */
  YYSYMBOL_QUEUENUM = 290,                 /* "num"  */
  YYSYMBOL_BYPASS = 291,                   /* "bypass"  */
  YYSYMBOL_FANOUT = 292,                   /* "fanout"  */
  YYSYMBOL_DUP = 293,                      /* "dup"  */
  YYSYMBOL_FWD = 294,                      /* "fwd"  */
  YYSYMBOL_NUMGEN = 295,                   /* "numgen"  */
  YYSYMBOL_INC = 296,                      /* "inc"  */
  YYSYMBOL_MOD = 297,                      /* "mod"  */
  YYSYMBOL_OFFSET = 298,                   /* "offset"  */
  YYSYMBOL_JHASH = 299,                    /* "jhash"  */
  YYSYMBOL_SYMHASH = 300,                  /* "symhash"  */
  YYSYMBOL_SEED = 301,                     /* "seed"  */
  YYSYMBOL_POSITION = 302,                 /* "position"  */
  YYSYMBOL_INDEX = 303,                    /* "index"  */
  YYSYMBOL_COMMENT = 304,                  /* "comment"  */
  YYSYMBOL_XML = 305,                      /* "xml"  */
  YYSYMBOL_JSON = 306,                     /* "json"  */
  YYSYMBOL_VM = 307,                       /* "vm"  */
  YYSYMBOL_NOTRACK = 308,                  /* "notrack"  */
  YYSYMBOL_EXISTS = 309,                   /* "exists"  */
  YYSYMBOL_MISSING = 310,                  /* "missing"  */
  YYSYMBOL_EXTHDR = 311,                   /* "exthdr"  */
  YYSYMBOL_IPSEC = 312,                    /* "ipsec"  */
  YYSYMBOL_MODE = 313,                     /* "mode"  */
  YYSYMBOL_REQID = 314,                    /* "reqid"  */
  YYSYMBOL_SPNUM = 315,                    /* "spnum"  */
  YYSYMBOL_TRANSPORT = 316,                /* "transport"  */
  YYSYMBOL_TUNNEL = 317,                   /* "tunnel"  */
  YYSYMBOL_IN = 318,                       /* "in"  */
  YYSYMBOL_OUT = 319,                      /* "out"  */
  YYSYMBOL_320_ = 320,                     /* '='  */
  YYSYMBOL_321_ = 321,                     /* '{'  */
  YYSYMBOL_322_ = 322,                     /* '}'  */
  YYSYMBOL_323_ = 323,                     /* '('  */
  YYSYMBOL_324_ = 324,                     /* ')'  */
  YYSYMBOL_325_ = 325,                     /* '|'  */
  YYSYMBOL_326_ = 326,                     /* '$'  */
  YYSYMBOL_327_ = 327,                     /* '['  */
  YYSYMBOL_328_ = 328,                     /* ']'  */
  YYSYMBOL_YYACCEPT = 329,                 /* $accept  */
  YYSYMBOL_input = 330,                    /* input  */
  YYSYMBOL_stmt_separator = 331,           /* stmt_separator  */
  YYSYMBOL_opt_newline = 332,              /* opt_newline  */
  YYSYMBOL_common_block = 333,             /* common_block  */
  YYSYMBOL_line = 334,                     /* line  */
  YYSYMBOL_base_cmd = 335,                 /* base_cmd  */
  YYSYMBOL_add_cmd = 336,                  /* add_cmd  */
  YYSYMBOL_replace_cmd = 337,              /* replace_cmd  */
  YYSYMBOL_create_cmd = 338,               /* create_cmd  */
  YYSYMBOL_insert_cmd = 339,               /* insert_cmd  */
  YYSYMBOL_delete_cmd = 340,               /* delete_cmd  */
  YYSYMBOL_get_cmd = 341,                  /* get_cmd  */
  YYSYMBOL_list_cmd = 342,                 /* list_cmd  */
  YYSYMBOL_reset_cmd = 343,                /* reset_cmd  */
  YYSYMBOL_flush_cmd = 344,                /* flush_cmd  */
  YYSYMBOL_rename_cmd = 345,               /* rename_cmd  */
  YYSYMBOL_import_cmd = 346,               /* import_cmd  */
  YYSYMBOL_export_cmd = 347,               /* export_cmd  */
  YYSYMBOL_monitor_cmd = 348,              /* monitor_cmd  */
  YYSYMBOL_monitor_event = 349,            /* monitor_event  */
  YYSYMBOL_monitor_object = 350,           /* monitor_object  */
  YYSYMBOL_monitor_format = 351,           /* monitor_format  */
  YYSYMBOL_markup_format = 352,            /* markup_format  */
  YYSYMBOL_describe_cmd = 353,             /* describe_cmd  */
  YYSYMBOL_table_block_alloc = 354,        /* table_block_alloc  */
  YYSYMBOL_table_options = 355,            /* table_options  */
  YYSYMBOL_table_block = 356,              /* table_block  */
  YYSYMBOL_chain_block_alloc = 357,        /* chain_block_alloc  */
  YYSYMBOL_chain_block = 358,              /* chain_block  */
  YYSYMBOL_subchain_block = 359,           /* subchain_block  */
  YYSYMBOL_typeof_expr = 360,              /* typeof_expr  */
  YYSYMBOL_set_block_alloc = 361,          /* set_block_alloc  */
  YYSYMBOL_set_block = 362,                /* set_block  */
  YYSYMBOL_set_block_expr = 363,           /* set_block_expr  */
  YYSYMBOL_set_flag_list = 364,            /* set_flag_list  */
  YYSYMBOL_set_flag = 365,                 /* set_flag  */
  YYSYMBOL_map_block_alloc = 366,          /* map_block_alloc  */
  YYSYMBOL_map_block = 367,                /* map_block  */
  YYSYMBOL_set_mechanism = 368,            /* set_mechanism  */
  YYSYMBOL_set_policy_spec = 369,          /* set_policy_spec  */
  YYSYMBOL_flowtable_block_alloc = 370,    /* flowtable_block_alloc  */
  YYSYMBOL_flowtable_block = 371,          /* flowtable_block  */
  YYSYMBOL_flowtable_expr = 372,           /* flowtable_expr  */
  YYSYMBOL_flowtable_list_expr = 373,      /* flowtable_list_expr  */
  YYSYMBOL_flowtable_expr_member = 374,    /* flowtable_expr_member  */
  YYSYMBOL_data_type_atom_expr = 375,      /* data_type_atom_expr  */
  YYSYMBOL_data_type_expr = 376,           /* data_type_expr  */
  YYSYMBOL_obj_block_alloc = 377,          /* obj_block_alloc  */
  YYSYMBOL_counter_block = 378,            /* counter_block  */
  YYSYMBOL_quota_block = 379,              /* quota_block  */
  YYSYMBOL_ct_helper_block = 380,          /* ct_helper_block  */
  YYSYMBOL_ct_timeout_block = 381,         /* ct_timeout_block  */
  YYSYMBOL_ct_expect_block = 382,          /* ct_expect_block  */
  YYSYMBOL_limit_block = 383,              /* limit_block  */
  YYSYMBOL_secmark_block = 384,            /* secmark_block  */
  YYSYMBOL_synproxy_block = 385,           /* synproxy_block  */
  YYSYMBOL_type_identifier = 386,          /* type_identifier  */
  YYSYMBOL_hook_spec = 387,                /* hook_spec  */
  YYSYMBOL_prio_spec = 388,                /* prio_spec  */
  YYSYMBOL_extended_prio_name = 389,       /* extended_prio_name  */
  YYSYMBOL_extended_prio_spec = 390,       /* extended_prio_spec  */
  YYSYMBOL_int_num = 391,                  /* int_num  */
  YYSYMBOL_dev_spec = 392,                 /* dev_spec  */
  YYSYMBOL_flags_spec = 393,               /* flags_spec  */
  YYSYMBOL_policy_spec = 394,              /* policy_spec  */
  YYSYMBOL_policy_expr = 395,              /* policy_expr  */
  YYSYMBOL_chain_policy = 396,             /* chain_policy  */
  YYSYMBOL_identifier = 397,               /* identifier  */
  YYSYMBOL_string = 398,                   /* string  */
  YYSYMBOL_time_spec = 399,                /* time_spec  */
  YYSYMBOL_family_spec = 400,              /* family_spec  */
  YYSYMBOL_family_spec_explicit = 401,     /* family_spec_explicit  */
  YYSYMBOL_table_spec = 402,               /* table_spec  */
  YYSYMBOL_tableid_spec = 403,             /* tableid_spec  */
  YYSYMBOL_chain_spec = 404,               /* chain_spec  */
  YYSYMBOL_chainid_spec = 405,             /* chainid_spec  */
  YYSYMBOL_chain_identifier = 406,         /* chain_identifier  */
  YYSYMBOL_set_spec = 407,                 /* set_spec  */
  YYSYMBOL_setid_spec = 408,               /* setid_spec  */
  YYSYMBOL_set_identifier = 409,           /* set_identifier  */
  YYSYMBOL_flowtable_spec = 410,           /* flowtable_spec  */
  YYSYMBOL_flowtableid_spec = 411,         /* flowtableid_spec  */
  YYSYMBOL_flowtable_identifier = 412,     /* flowtable_identifier  */
  YYSYMBOL_obj_spec = 413,                 /* obj_spec  */
  YYSYMBOL_objid_spec = 414,               /* objid_spec  */
  YYSYMBOL_obj_identifier = 415,           /* obj_identifier  */
  YYSYMBOL_handle_spec = 416,              /* handle_spec  */
  YYSYMBOL_position_spec = 417,            /* position_spec  */
  YYSYMBOL_index_spec = 418,               /* index_spec  */
  YYSYMBOL_rule_position = 419,            /* rule_position  */
  YYSYMBOL_ruleid_spec = 420,              /* ruleid_spec  */
  YYSYMBOL_comment_spec = 421,             /* comment_spec  */
  YYSYMBOL_ruleset_spec = 422,             /* ruleset_spec  */
  YYSYMBOL_rule = 423,                     /* rule  */
  YYSYMBOL_rule_alloc = 424,               /* rule_alloc  */
  YYSYMBOL_stmt_list = 425,                /* stmt_list  */
  YYSYMBOL_stateful_stmt_list = 426,       /* stateful_stmt_list  */
  YYSYMBOL_stateful_stmt = 427,            /* stateful_stmt  */
  YYSYMBOL_stmt = 428,                     /* stmt  */
  YYSYMBOL_chain_stmt_type = 429,          /* chain_stmt_type  */
  YYSYMBOL_chain_stmt = 430,               /* chain_stmt  */
  YYSYMBOL_verdict_stmt = 431,             /* verdict_stmt  */
  YYSYMBOL_verdict_map_stmt = 432,         /* verdict_map_stmt  */
  YYSYMBOL_verdict_map_expr = 433,         /* verdict_map_expr  */
  YYSYMBOL_verdict_map_list_expr = 434,    /* verdict_map_list_expr  */
  YYSYMBOL_verdict_map_list_member_expr = 435, /* verdict_map_list_member_expr  */
  YYSYMBOL_connlimit_stmt = 436,           /* connlimit_stmt  */
  YYSYMBOL_counter_stmt = 437,             /* counter_stmt  */
  YYSYMBOL_counter_stmt_alloc = 438,       /* counter_stmt_alloc  */
  YYSYMBOL_counter_args = 439,             /* counter_args  */
  YYSYMBOL_counter_arg = 440,              /* counter_arg  */
  YYSYMBOL_log_stmt = 441,                 /* log_stmt  */
  YYSYMBOL_log_stmt_alloc = 442,           /* log_stmt_alloc  */
  YYSYMBOL_log_args = 443,                 /* log_args  */
  YYSYMBOL_log_arg = 444,                  /* log_arg  */
  YYSYMBOL_level_type = 445,               /* level_type  */
  YYSYMBOL_log_flags = 446,                /* log_flags  */
  YYSYMBOL_log_flags_tcp = 447,            /* log_flags_tcp  */
  YYSYMBOL_log_flag_tcp = 448,             /* log_flag_tcp  */
  YYSYMBOL_limit_stmt = 449,               /* limit_stmt  */
  YYSYMBOL_quota_mode = 450,               /* quota_mode  */
  YYSYMBOL_quota_unit = 451,               /* quota_unit  */
  YYSYMBOL_quota_used = 452,               /* quota_used  */
  YYSYMBOL_quota_stmt = 453,               /* quota_stmt  */
  YYSYMBOL_limit_mode = 454,               /* limit_mode  */
  YYSYMBOL_limit_burst_pkts = 455,         /* limit_burst_pkts  */
  YYSYMBOL_limit_burst_bytes = 456,        /* limit_burst_bytes  */
  YYSYMBOL_time_unit = 457,                /* time_unit  */
  YYSYMBOL_reject_stmt = 458,              /* reject_stmt  */
  YYSYMBOL_reject_stmt_alloc = 459,        /* reject_stmt_alloc  */
  YYSYMBOL_reject_opts = 460,              /* reject_opts  */
  YYSYMBOL_nat_stmt = 461,                 /* nat_stmt  */
  YYSYMBOL_nat_stmt_alloc = 462,           /* nat_stmt_alloc  */
  YYSYMBOL_tproxy_stmt = 463,              /* tproxy_stmt  */
  YYSYMBOL_synproxy_stmt = 464,            /* synproxy_stmt  */
  YYSYMBOL_synproxy_stmt_alloc = 465,      /* synproxy_stmt_alloc  */
  YYSYMBOL_synproxy_args = 466,            /* synproxy_args  */
  YYSYMBOL_synproxy_arg = 467,             /* synproxy_arg  */
  YYSYMBOL_synproxy_config = 468,          /* synproxy_config  */
  YYSYMBOL_synproxy_obj = 469,             /* synproxy_obj  */
  YYSYMBOL_synproxy_ts = 470,              /* synproxy_ts  */
  YYSYMBOL_synproxy_sack = 471,            /* synproxy_sack  */
  YYSYMBOL_primary_stmt_expr = 472,        /* primary_stmt_expr  */
  YYSYMBOL_shift_stmt_expr = 473,          /* shift_stmt_expr  */
  YYSYMBOL_and_stmt_expr = 474,            /* and_stmt_expr  */
  YYSYMBOL_exclusive_or_stmt_expr = 475,   /* exclusive_or_stmt_expr  */
  YYSYMBOL_inclusive_or_stmt_expr = 476,   /* inclusive_or_stmt_expr  */
  YYSYMBOL_basic_stmt_expr = 477,          /* basic_stmt_expr  */
  YYSYMBOL_concat_stmt_expr = 478,         /* concat_stmt_expr  */
  YYSYMBOL_map_stmt_expr_set = 479,        /* map_stmt_expr_set  */
  YYSYMBOL_map_stmt_expr = 480,            /* map_stmt_expr  */
  YYSYMBOL_prefix_stmt_expr = 481,         /* prefix_stmt_expr  */
  YYSYMBOL_range_stmt_expr = 482,          /* range_stmt_expr  */
  YYSYMBOL_wildcard_expr = 483,            /* wildcard_expr  */
  YYSYMBOL_multiton_stmt_expr = 484,       /* multiton_stmt_expr  */
  YYSYMBOL_stmt_expr = 485,                /* stmt_expr  */
  YYSYMBOL_nat_stmt_args = 486,            /* nat_stmt_args  */
  YYSYMBOL_masq_stmt = 487,                /* masq_stmt  */
  YYSYMBOL_masq_stmt_alloc = 488,          /* masq_stmt_alloc  */
  YYSYMBOL_masq_stmt_args = 489,           /* masq_stmt_args  */
  YYSYMBOL_redir_stmt = 490,               /* redir_stmt  */
  YYSYMBOL_redir_stmt_alloc = 491,         /* redir_stmt_alloc  */
  YYSYMBOL_redir_stmt_arg = 492,           /* redir_stmt_arg  */
  YYSYMBOL_dup_stmt = 493,                 /* dup_stmt  */
  YYSYMBOL_fwd_stmt = 494,                 /* fwd_stmt  */
  YYSYMBOL_nf_nat_flags = 495,             /* nf_nat_flags  */
  YYSYMBOL_nf_nat_flag = 496,              /* nf_nat_flag  */
  YYSYMBOL_queue_stmt = 497,               /* queue_stmt  */
  YYSYMBOL_queue_stmt_alloc = 498,         /* queue_stmt_alloc  */
  YYSYMBOL_queue_stmt_args = 499,          /* queue_stmt_args  */
  YYSYMBOL_queue_stmt_arg = 500,           /* queue_stmt_arg  */
  YYSYMBOL_queue_stmt_flags = 501,         /* queue_stmt_flags  */
  YYSYMBOL_queue_stmt_flag = 502,          /* queue_stmt_flag  */
  YYSYMBOL_set_elem_expr_stmt = 503,       /* set_elem_expr_stmt  */
  YYSYMBOL_set_elem_expr_stmt_alloc = 504, /* set_elem_expr_stmt_alloc  */
  YYSYMBOL_set_stmt = 505,                 /* set_stmt  */
  YYSYMBOL_set_stmt_op = 506,              /* set_stmt_op  */
  YYSYMBOL_map_stmt = 507,                 /* map_stmt  */
  YYSYMBOL_meter_stmt = 508,               /* meter_stmt  */
  YYSYMBOL_flow_stmt_legacy_alloc = 509,   /* flow_stmt_legacy_alloc  */
  YYSYMBOL_flow_stmt_opts = 510,           /* flow_stmt_opts  */
  YYSYMBOL_flow_stmt_opt = 511,            /* flow_stmt_opt  */
  YYSYMBOL_meter_stmt_alloc = 512,         /* meter_stmt_alloc  */
  YYSYMBOL_match_stmt = 513,               /* match_stmt  */
  YYSYMBOL_variable_expr = 514,            /* variable_expr  */
  YYSYMBOL_symbol_expr = 515,              /* symbol_expr  */
  YYSYMBOL_set_ref_expr = 516,             /* set_ref_expr  */
  YYSYMBOL_set_ref_symbol_expr = 517,      /* set_ref_symbol_expr  */
  YYSYMBOL_integer_expr = 518,             /* integer_expr  */
  YYSYMBOL_primary_expr = 519,             /* primary_expr  */
  YYSYMBOL_fib_expr = 520,                 /* fib_expr  */
  YYSYMBOL_fib_result = 521,               /* fib_result  */
  YYSYMBOL_fib_flag = 522,                 /* fib_flag  */
  YYSYMBOL_fib_tuple = 523,                /* fib_tuple  */
  YYSYMBOL_osf_expr = 524,                 /* osf_expr  */
  YYSYMBOL_osf_ttl = 525,                  /* osf_ttl  */
  YYSYMBOL_shift_expr = 526,               /* shift_expr  */
  YYSYMBOL_and_expr = 527,                 /* and_expr  */
  YYSYMBOL_exclusive_or_expr = 528,        /* exclusive_or_expr  */
  YYSYMBOL_inclusive_or_expr = 529,        /* inclusive_or_expr  */
  YYSYMBOL_basic_expr = 530,               /* basic_expr  */
  YYSYMBOL_concat_expr = 531,              /* concat_expr  */
  YYSYMBOL_prefix_rhs_expr = 532,          /* prefix_rhs_expr  */
  YYSYMBOL_range_rhs_expr = 533,           /* range_rhs_expr  */
  YYSYMBOL_multiton_rhs_expr = 534,        /* multiton_rhs_expr  */
  YYSYMBOL_map_expr = 535,                 /* map_expr  */
  YYSYMBOL_expr = 536,                     /* expr  */
  YYSYMBOL_set_expr = 537,                 /* set_expr  */
  YYSYMBOL_set_list_expr = 538,            /* set_list_expr  */
  YYSYMBOL_set_list_member_expr = 539,     /* set_list_member_expr  */
  YYSYMBOL_meter_key_expr = 540,           /* meter_key_expr  */
  YYSYMBOL_meter_key_expr_alloc = 541,     /* meter_key_expr_alloc  */
  YYSYMBOL_set_elem_expr = 542,            /* set_elem_expr  */
  YYSYMBOL_set_elem_expr_alloc = 543,      /* set_elem_expr_alloc  */
  YYSYMBOL_set_elem_options = 544,         /* set_elem_options  */
  YYSYMBOL_set_elem_option = 545,          /* set_elem_option  */
  YYSYMBOL_set_elem_expr_options = 546,    /* set_elem_expr_options  */
  YYSYMBOL_set_elem_stmt_list = 547,       /* set_elem_stmt_list  */
  YYSYMBOL_set_elem_stmt = 548,            /* set_elem_stmt  */
  YYSYMBOL_set_elem_expr_option = 549,     /* set_elem_expr_option  */
  YYSYMBOL_set_lhs_expr = 550,             /* set_lhs_expr  */
  YYSYMBOL_set_rhs_expr = 551,             /* set_rhs_expr  */
  YYSYMBOL_initializer_expr = 552,         /* initializer_expr  */
  YYSYMBOL_counter_config = 553,           /* counter_config  */
  YYSYMBOL_counter_obj = 554,              /* counter_obj  */
  YYSYMBOL_quota_config = 555,             /* quota_config  */
  YYSYMBOL_quota_obj = 556,                /* quota_obj  */
  YYSYMBOL_secmark_config = 557,           /* secmark_config  */
  YYSYMBOL_secmark_obj = 558,              /* secmark_obj  */
  YYSYMBOL_ct_obj_type = 559,              /* ct_obj_type  */
  YYSYMBOL_ct_l4protoname = 560,           /* ct_l4protoname  */
  YYSYMBOL_ct_helper_config = 561,         /* ct_helper_config  */
  YYSYMBOL_timeout_states = 562,           /* timeout_states  */
  YYSYMBOL_timeout_state = 563,            /* timeout_state  */
  YYSYMBOL_ct_timeout_config = 564,        /* ct_timeout_config  */
  YYSYMBOL_ct_expect_config = 565,         /* ct_expect_config  */
  YYSYMBOL_ct_obj_alloc = 566,             /* ct_obj_alloc  */
  YYSYMBOL_limit_config = 567,             /* limit_config  */
  YYSYMBOL_limit_obj = 568,                /* limit_obj  */
  YYSYMBOL_relational_expr = 569,          /* relational_expr  */
  YYSYMBOL_list_rhs_expr = 570,            /* list_rhs_expr  */
  YYSYMBOL_rhs_expr = 571,                 /* rhs_expr  */
  YYSYMBOL_shift_rhs_expr = 572,           /* shift_rhs_expr  */
  YYSYMBOL_and_rhs_expr = 573,             /* and_rhs_expr  */
  YYSYMBOL_exclusive_or_rhs_expr = 574,    /* exclusive_or_rhs_expr  */
  YYSYMBOL_inclusive_or_rhs_expr = 575,    /* inclusive_or_rhs_expr  */
  YYSYMBOL_basic_rhs_expr = 576,           /* basic_rhs_expr  */
  YYSYMBOL_concat_rhs_expr = 577,          /* concat_rhs_expr  */
  YYSYMBOL_boolean_keys = 578,             /* boolean_keys  */
  YYSYMBOL_boolean_expr = 579,             /* boolean_expr  */
  YYSYMBOL_keyword_expr = 580,             /* keyword_expr  */
  YYSYMBOL_primary_rhs_expr = 581,         /* primary_rhs_expr  */
  YYSYMBOL_relational_op = 582,            /* relational_op  */
  YYSYMBOL_verdict_expr = 583,             /* verdict_expr  */
  YYSYMBOL_chain_expr = 584,               /* chain_expr  */
  YYSYMBOL_meta_expr = 585,                /* meta_expr  */
  YYSYMBOL_meta_key = 586,                 /* meta_key  */
  YYSYMBOL_meta_key_qualified = 587,       /* meta_key_qualified  */
  YYSYMBOL_meta_key_unqualified = 588,     /* meta_key_unqualified  */
  YYSYMBOL_meta_stmt = 589,                /* meta_stmt  */
  YYSYMBOL_socket_expr = 590,              /* socket_expr  */
  YYSYMBOL_socket_key = 591,               /* socket_key  */
  YYSYMBOL_offset_opt = 592,               /* offset_opt  */
  YYSYMBOL_numgen_type = 593,              /* numgen_type  */
  YYSYMBOL_numgen_expr = 594,              /* numgen_expr  */
  YYSYMBOL_xfrm_spnum = 595,               /* xfrm_spnum  */
  YYSYMBOL_xfrm_dir = 596,                 /* xfrm_dir  */
  YYSYMBOL_xfrm_state_key = 597,           /* xfrm_state_key  */
  YYSYMBOL_xfrm_state_proto_key = 598,     /* xfrm_state_proto_key  */
  YYSYMBOL_xfrm_expr = 599,                /* xfrm_expr  */
  YYSYMBOL_hash_expr = 600,                /* hash_expr  */
  YYSYMBOL_nf_key_proto = 601,             /* nf_key_proto  */
  YYSYMBOL_rt_expr = 602,                  /* rt_expr  */
  YYSYMBOL_rt_key = 603,                   /* rt_key  */
  YYSYMBOL_ct_expr = 604,                  /* ct_expr  */
  YYSYMBOL_ct_dir = 605,                   /* ct_dir  */
  YYSYMBOL_ct_key = 606,                   /* ct_key  */
  YYSYMBOL_ct_key_dir = 607,               /* ct_key_dir  */
  YYSYMBOL_ct_key_proto_field = 608,       /* ct_key_proto_field  */
  YYSYMBOL_ct_key_dir_optional = 609,      /* ct_key_dir_optional  */
  YYSYMBOL_symbol_stmt_expr = 610,         /* symbol_stmt_expr  */
  YYSYMBOL_list_stmt_expr = 611,           /* list_stmt_expr  */
  YYSYMBOL_ct_stmt = 612,                  /* ct_stmt  */
  YYSYMBOL_payload_stmt = 613,             /* payload_stmt  */
  YYSYMBOL_payload_expr = 614,             /* payload_expr  */
  YYSYMBOL_payload_raw_expr = 615,         /* payload_raw_expr  */
  YYSYMBOL_payload_base_spec = 616,        /* payload_base_spec  */
  YYSYMBOL_eth_hdr_expr = 617,             /* eth_hdr_expr  */
  YYSYMBOL_eth_hdr_field = 618,            /* eth_hdr_field  */
  YYSYMBOL_vlan_hdr_expr = 619,            /* vlan_hdr_expr  */
  YYSYMBOL_vlan_hdr_field = 620,           /* vlan_hdr_field  */
  YYSYMBOL_arp_hdr_expr = 621,             /* arp_hdr_expr  */
  YYSYMBOL_arp_hdr_field = 622,            /* arp_hdr_field  */
  YYSYMBOL_ip_hdr_expr = 623,              /* ip_hdr_expr  */
  YYSYMBOL_ip_hdr_field = 624,             /* ip_hdr_field  */
  YYSYMBOL_ip_option_type = 625,           /* ip_option_type  */
  YYSYMBOL_ip_option_field = 626,          /* ip_option_field  */
  YYSYMBOL_icmp_hdr_expr = 627,            /* icmp_hdr_expr  */
  YYSYMBOL_icmp_hdr_field = 628,           /* icmp_hdr_field  */
  YYSYMBOL_igmp_hdr_expr = 629,            /* igmp_hdr_expr  */
  YYSYMBOL_igmp_hdr_field = 630,           /* igmp_hdr_field  */
  YYSYMBOL_ip6_hdr_expr = 631,             /* ip6_hdr_expr  */
  YYSYMBOL_ip6_hdr_field = 632,            /* ip6_hdr_field  */
  YYSYMBOL_icmp6_hdr_expr = 633,           /* icmp6_hdr_expr  */
  YYSYMBOL_icmp6_hdr_field = 634,          /* icmp6_hdr_field  */
  YYSYMBOL_auth_hdr_expr = 635,            /* auth_hdr_expr  */
  YYSYMBOL_auth_hdr_field = 636,           /* auth_hdr_field  */
  YYSYMBOL_esp_hdr_expr = 637,             /* esp_hdr_expr  */
  YYSYMBOL_esp_hdr_field = 638,            /* esp_hdr_field  */
  YYSYMBOL_comp_hdr_expr = 639,            /* comp_hdr_expr  */
  YYSYMBOL_comp_hdr_field = 640,           /* comp_hdr_field  */
  YYSYMBOL_udp_hdr_expr = 641,             /* udp_hdr_expr  */
  YYSYMBOL_udp_hdr_field = 642,            /* udp_hdr_field  */
  YYSYMBOL_udplite_hdr_expr = 643,         /* udplite_hdr_expr  */
  YYSYMBOL_udplite_hdr_field = 644,        /* udplite_hdr_field  */
  YYSYMBOL_tcp_hdr_expr = 645,             /* tcp_hdr_expr  */
  YYSYMBOL_tcp_hdr_field = 646,            /* tcp_hdr_field  */
  YYSYMBOL_tcp_hdr_option_type = 647,      /* tcp_hdr_option_type  */
  YYSYMBOL_tcp_hdr_option_field = 648,     /* tcp_hdr_option_field  */
  YYSYMBOL_dccp_hdr_expr = 649,            /* dccp_hdr_expr  */
  YYSYMBOL_dccp_hdr_field = 650,           /* dccp_hdr_field  */
  YYSYMBOL_sctp_hdr_expr = 651,            /* sctp_hdr_expr  */
  YYSYMBOL_sctp_hdr_field = 652,           /* sctp_hdr_field  */
  YYSYMBOL_th_hdr_expr = 653,              /* th_hdr_expr  */
  YYSYMBOL_th_hdr_field = 654,             /* th_hdr_field  */
  YYSYMBOL_exthdr_expr = 655,              /* exthdr_expr  */
  YYSYMBOL_hbh_hdr_expr = 656,             /* hbh_hdr_expr  */
  YYSYMBOL_hbh_hdr_field = 657,            /* hbh_hdr_field  */
  YYSYMBOL_rt_hdr_expr = 658,              /* rt_hdr_expr  */
  YYSYMBOL_rt_hdr_field = 659,             /* rt_hdr_field  */
  YYSYMBOL_rt0_hdr_expr = 660,             /* rt0_hdr_expr  */
  YYSYMBOL_rt0_hdr_field = 661,            /* rt0_hdr_field  */
  YYSYMBOL_rt2_hdr_expr = 662,             /* rt2_hdr_expr  */
  YYSYMBOL_rt2_hdr_field = 663,            /* rt2_hdr_field  */
  YYSYMBOL_rt4_hdr_expr = 664,             /* rt4_hdr_expr  */
  YYSYMBOL_rt4_hdr_field = 665,            /* rt4_hdr_field  */
  YYSYMBOL_frag_hdr_expr = 666,            /* frag_hdr_expr  */
  YYSYMBOL_frag_hdr_field = 667,           /* frag_hdr_field  */
  YYSYMBOL_dst_hdr_expr = 668,             /* dst_hdr_expr  */
  YYSYMBOL_dst_hdr_field = 669,            /* dst_hdr_field  */
  YYSYMBOL_mh_hdr_expr = 670,              /* mh_hdr_expr  */
  YYSYMBOL_mh_hdr_field = 671,             /* mh_hdr_field  */
  YYSYMBOL_exthdr_exists_expr = 672,       /* exthdr_exists_expr  */
  YYSYMBOL_exthdr_key = 673                /* exthdr_key  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if 1

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* 1 */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE) \
             + YYSIZEOF (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   7523

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  329
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  345
/* YYNRULES -- Number of rules.  */
#define YYNRULES  1127
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1848

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   574


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,   326,     2,     2,     2,
     323,   324,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   320,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   327,     2,   328,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   321,   325,   322,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   842,   842,   843,   852,   853,   856,   857,   860,   868,
     883,   890,   901,   909,   910,   911,   912,   932,   933,   934,
     935,   936,   937,   938,   939,   940,   941,   942,   943,   944,
     945,   946,   949,   953,   960,   964,   972,   976,   980,   987,
     994,   998,  1005,  1014,  1018,  1022,  1026,  1030,  1034,  1038,
    1042,  1046,  1050,  1054,  1058,  1062,  1068,  1074,  1078,  1085,
    1089,  1097,  1104,  1111,  1115,  1122,  1131,  1135,  1139,  1143,
    1147,  1151,  1155,  1159,  1165,  1171,  1175,  1179,  1183,  1187,
    1191,  1195,  1199,  1203,  1207,  1211,  1215,  1222,  1226,  1230,
    1234,  1238,  1242,  1246,  1250,  1254,  1258,  1262,  1268,  1274,
    1278,  1282,  1286,  1290,  1294,  1298,  1302,  1306,  1310,  1314,
    1318,  1322,  1326,  1330,  1334,  1338,  1342,  1346,  1350,  1354,
    1358,  1362,  1366,  1370,  1374,  1378,  1382,  1386,  1390,  1394,
    1398,  1402,  1406,  1410,  1416,  1420,  1424,  1428,  1432,  1436,
    1442,  1446,  1450,  1454,  1458,  1462,  1466,  1472,  1479,  1485,
    1493,  1499,  1507,  1516,  1517,  1520,  1521,  1522,  1523,  1524,
    1525,  1526,  1527,  1530,  1531,  1534,  1535,  1536,  1539,  1548,
    1554,  1566,  1576,  1577,  1578,  1579,  1580,  1591,  1601,  1612,
    1622,  1633,  1644,  1653,  1662,  1671,  1682,  1693,  1707,  1713,
    1714,  1715,  1716,  1717,  1718,  1719,  1724,  1734,  1735,  1736,
    1743,  1754,  1767,  1772,  1773,  1774,  1775,  1780,  1786,  1791,
    1796,  1801,  1807,  1812,  1817,  1818,  1829,  1830,  1833,  1837,
    1840,  1841,  1842,  1843,  1847,  1852,  1853,  1854,  1855,  1860,
    1870,  1881,  1892,  1904,  1913,  1922,  1931,  1940,  1945,  1950,
    1959,  1962,  1966,  1972,  1973,  1977,  1982,  1983,  1984,  1985,
    1999,  2003,  2009,  2014,  2021,  2026,  2031,  2034,  2041,  2048,
    2060,  2067,  2068,  2080,  2085,  2086,  2087,  2088,  2092,  2102,
    2103,  2104,  2105,  2109,  2119,  2120,  2121,  2122,  2126,  2137,
    2141,  2142,  2143,  2147,  2157,  2158,  2159,  2160,  2164,  2174,
    2175,  2176,  2177,  2181,  2191,  2192,  2193,  2194,  2198,  2208,
    2209,  2210,  2211,  2215,  2225,  2226,  2227,  2228,  2229,  2232,
    2262,  2269,  2273,  2276,  2286,  2293,  2304,  2317,  2332,  2333,
    2336,  2348,  2354,  2358,  2361,  2367,  2380,  2385,  2394,  2395,
    2398,  2401,  2402,  2403,  2406,  2421,  2422,  2425,  2426,  2427,
    2428,  2429,  2430,  2433,  2442,  2451,  2459,  2467,  2475,  2483,
    2491,  2499,  2507,  2515,  2523,  2531,  2539,  2547,  2555,  2563,
    2571,  2575,  2580,  2588,  2595,  2602,  2615,  2619,  2626,  2630,
    2636,  2648,  2654,  2661,  2667,  2674,  2675,  2676,  2677,  2680,
    2681,  2682,  2683,  2684,  2685,  2686,  2687,  2688,  2689,  2690,
    2691,  2692,  2693,  2694,  2695,  2696,  2697,  2698,  2699,  2702,
    2703,  2706,  2715,  2719,  2725,  2731,  2736,  2739,  2744,  2749,
    2752,  2758,  2763,  2771,  2772,  2774,  2778,  2786,  2790,  2793,
    2797,  2803,  2804,  2807,  2813,  2817,  2820,  2945,  2950,  2955,
    2960,  2965,  2971,  3001,  3005,  3009,  3013,  3017,  3023,  3027,
    3030,  3034,  3040,  3054,  3079,  3087,  3088,  3089,  3092,  3093,
    3096,  3097,  3112,  3128,  3136,  3137,  3138,  3141,  3142,  3145,
    3146,  3147,  3162,  3163,  3164,  3165,  3166,  3169,  3172,  3179,
    3183,  3194,  3205,  3215,  3221,  3224,  3225,  3228,  3234,  3240,
    3246,  3253,  3260,  3268,  3269,  3272,  3276,  3284,  3288,  3291,
    3296,  3301,  3305,  3311,  3327,  3346,  3352,  3353,  3359,  3360,
    3366,  3367,  3368,  3369,  3370,  3371,  3372,  3373,  3374,  3375,
    3376,  3377,  3378,  3381,  3382,  3386,  3392,  3393,  3399,  3400,
    3406,  3407,  3413,  3416,  3417,  3428,  3429,  3432,  3436,  3439,
    3445,  3451,  3462,  3463,  3464,  3467,  3468,  3469,  3472,  3476,
    3480,  3485,  3490,  3495,  3501,  3505,  3509,  3513,  3519,  3525,
    3530,  3539,  3549,  3550,  3553,  3556,  3560,  3565,  3571,  3572,
    3575,  3578,  3582,  3586,  3590,  3595,  3602,  3607,  3615,  3620,
    3629,  3630,  3636,  3637,  3638,  3641,  3642,  3645,  3651,  3655,
    3658,  3663,  3669,  3670,  3676,  3677,  3680,  3681,  3684,  3690,
    3697,  3704,  3715,  3716,  3717,  3720,  3728,  3740,  3747,  3750,
    3756,  3760,  3763,  3769,  3778,  3789,  3795,  3821,  3822,  3831,
    3832,  3835,  3844,  3855,  3856,  3857,  3858,  3859,  3860,  3861,
    3862,  3863,  3864,  3865,  3866,  3867,  3868,  3869,  3872,  3895,
    3896,  3897,  3900,  3901,  3902,  3903,  3904,  3907,  3911,  3914,
    3918,  3925,  3928,  3942,  3943,  3947,  3953,  3954,  3960,  3961,
    3967,  3968,  3974,  3977,  3978,  3989,  3995,  4001,  4002,  4005,
    4011,  4012,  4013,  4016,  4023,  4028,  4033,  4036,  4040,  4044,
    4050,  4051,  4058,  4064,  4065,  4068,  4074,  4080,  4084,  4087,
    4091,  4095,  4105,  4109,  4112,  4118,  4125,  4129,  4135,  4149,
    4175,  4179,  4183,  4193,  4194,  4197,  4198,  4201,  4202,  4203,
    4204,  4215,  4226,  4232,  4253,  4259,  4276,  4282,  4283,  4284,
    4287,  4288,  4291,  4307,  4313,  4319,  4326,  4340,  4348,  4356,
    4362,  4366,  4370,  4374,  4378,  4385,  4390,  4401,  4423,  4429,
    4433,  4437,  4443,  4449,  4457,  4458,  4459,  4460,  4463,  4464,
    4468,  4474,  4475,  4481,  4482,  4488,  4489,  4495,  4498,  4499,
    4500,  4509,  4520,  4521,  4524,  4532,  4533,  4534,  4535,  4536,
    4537,  4538,  4539,  4540,  4541,  4542,  4543,  4546,  4547,  4548,
    4549,  4550,  4557,  4564,  4571,  4578,  4585,  4592,  4599,  4606,
    4613,  4620,  4627,  4634,  4637,  4638,  4639,  4640,  4641,  4642,
    4645,  4649,  4653,  4657,  4661,  4665,  4671,  4672,  4682,  4686,
    4690,  4706,  4707,  4710,  4711,  4712,  4713,  4714,  4717,  4718,
    4719,  4720,  4721,  4722,  4723,  4724,  4725,  4726,  4727,  4728,
    4729,  4730,  4731,  4732,  4733,  4734,  4735,  4736,  4737,  4738,
    4739,  4740,  4743,  4763,  4767,  4781,  4785,  4789,  4795,  4801,
    4802,  4803,  4806,  4807,  4810,  4811,  4814,  4820,  4821,  4824,
    4825,  4828,  4829,  4832,  4833,  4836,  4844,  4871,  4876,  4881,
    4887,  4888,  4891,  4895,  4915,  4916,  4917,  4918,  4921,  4925,
    4929,  4935,  4936,  4939,  4940,  4941,  4942,  4943,  4944,  4945,
    4946,  4947,  4948,  4949,  4950,  4951,  4952,  4953,  4954,  4955,
    4958,  4959,  4960,  4961,  4962,  4963,  4964,  4967,  4968,  4969,
    4970,  4973,  4974,  4975,  4976,  4979,  4980,  4983,  4989,  4997,
    5010,  5017,  5023,  5029,  5038,  5039,  5040,  5041,  5042,  5043,
    5044,  5045,  5046,  5047,  5048,  5049,  5050,  5051,  5052,  5053,
    5054,  5055,  5058,  5067,  5068,  5069,  5072,  5078,  5079,  5080,
    5083,  5089,  5090,  5091,  5092,  5095,  5101,  5102,  5103,  5104,
    5105,  5106,  5107,  5108,  5109,  5112,  5116,  5120,  5127,  5128,
    5129,  5130,  5131,  5132,  5133,  5134,  5135,  5136,  5137,  5138,
    5141,  5142,  5143,  5144,  5147,  5148,  5149,  5150,  5151,  5154,
    5160,  5161,  5162,  5163,  5164,  5165,  5166,  5169,  5175,  5176,
    5177,  5178,  5181,  5187,  5188,  5189,  5190,  5191,  5192,  5193,
    5194,  5195,  5197,  5203,  5204,  5205,  5206,  5207,  5208,  5209,
    5210,  5213,  5219,  5220,  5221,  5222,  5223,  5226,  5232,  5233,
    5236,  5242,  5243,  5244,  5247,  5253,  5254,  5255,  5256,  5259,
    5265,  5266,  5267,  5268,  5271,  5275,  5279,  5284,  5291,  5292,
    5293,  5294,  5295,  5296,  5297,  5298,  5299,  5300,  5303,  5304,
    5305,  5306,  5307,  5308,  5309,  5310,  5311,  5312,  5313,  5314,
    5315,  5324,  5325,  5326,  5327,  5328,  5329,  5330,  5331,  5334,
    5340,  5341,  5342,  5345,  5351,  5352,  5353,  5354,  5357,  5365,
    5366,  5369,  5370,  5371,  5372,  5373,  5374,  5375,  5376,  5379,
    5385,  5386,  5389,  5395,  5396,  5397,  5398,  5401,  5407,  5413,
    5419,  5422,  5428,  5429,  5430,  5431,  5437,  5443,  5444,  5445,
    5446,  5447,  5448,  5451,  5457,  5458,  5461,  5467,  5468,  5469,
    5470,  5471,  5474,  5488,  5489,  5490,  5491,  5492
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if 1
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "\"junk\"",
  "\"newline\"", "\"colon\"", "\"semicolon\"", "\"comma\"", "\".\"",
  "\"==\"", "\"!=\"", "\"<\"", "\">\"", "\">=\"", "\"<=\"", "\"<<\"",
  "\">>\"", "\"&\"", "\"^\"", "\"!\"", "\"/\"", "\"*\"", "\"-\"", "\"@\"",
  "\"vmap\"", "\"+\"", "\"include\"", "\"define\"", "\"redefine\"",
  "\"undefine\"", "\"fib\"", "\"socket\"", "\"transparent\"",
  "\"wildcard\"", "\"tproxy\"", "\"osf\"", "\"synproxy\"", "\"mss\"",
  "\"wscale\"", "\"typeof\"", "\"hook\"", "\"device\"", "\"devices\"",
  "\"table\"", "\"tables\"", "\"chain\"", "\"chains\"", "\"rule\"",
  "\"rules\"", "\"sets\"", "\"set\"", "\"element\"", "\"map\"", "\"maps\"",
  "\"flowtable\"", "\"handle\"", "\"ruleset\"", "\"trace\"", "\"inet\"",
  "\"netdev\"", "\"add\"", "\"update\"", "\"replace\"", "\"create\"",
  "\"insert\"", "\"delete\"", "\"get\"", "\"list\"", "\"reset\"",
  "\"flush\"", "\"rename\"", "\"describe\"", "\"import\"", "\"export\"",
  "\"monitor\"", "\"all\"", "\"accept\"", "\"drop\"", "\"continue\"",
  "\"jump\"", "\"goto\"", "\"return\"", "\"to\"", "\"constant\"",
  "\"interval\"", "\"dynamic\"", "\"auto-merge\"", "\"timeout\"",
  "\"gc-interval\"", "\"elements\"", "\"expires\"", "\"policy\"",
  "\"memory\"", "\"performance\"", "\"size\"", "\"flow\"", "\"offload\"",
  "\"meter\"", "\"meters\"", "\"flowtables\"", "\"number\"", "\"string\"",
  "\"quoted string\"", "\"string with a trailing asterisk\"", "\"ll\"",
  "\"nh\"", "\"th\"", "\"bridge\"", "\"ether\"", "\"saddr\"", "\"daddr\"",
  "\"type\"", "\"vlan\"", "\"id\"", "\"cfi\"", "\"pcp\"", "\"arp\"",
  "\"htype\"", "\"ptype\"", "\"hlen\"", "\"plen\"", "\"operation\"",
  "\"ip\"", "\"version\"", "\"hdrlength\"", "\"dscp\"", "\"ecn\"",
  "\"length\"", "\"frag-off\"", "\"ttl\"", "\"protocol\"", "\"checksum\"",
  "\"ptr\"", "\"value\"", "\"lsrr\"", "\"rr\"", "\"ssrr\"", "\"ra\"",
  "\"icmp\"", "\"code\"", "\"seq\"", "\"gateway\"", "\"mtu\"", "\"igmp\"",
  "\"mrt\"", "\"options\"", "\"ip6\"", "\"priority\"", "\"flowlabel\"",
  "\"nexthdr\"", "\"hoplimit\"", "\"icmpv6\"", "\"param-problem\"",
  "\"max-delay\"", "\"ah\"", "\"reserved\"", "\"spi\"", "\"esp\"",
  "\"comp\"", "\"flags\"", "\"cpi\"", "\"port\"", "\"udp\"", "\"sport\"",
  "\"dport\"", "\"udplite\"", "\"csumcov\"", "\"tcp\"", "\"ackseq\"",
  "\"doff\"", "\"window\"", "\"urgptr\"", "\"option\"", "\"echo\"",
  "\"eol\"", "\"nop\"", "\"sack\"", "\"sack0\"", "\"sack1\"", "\"sack2\"",
  "\"sack3\"", "\"sack-permitted\"", "\"timestamp\"", "\"kind\"",
  "\"count\"", "\"left\"", "\"right\"", "\"tsval\"", "\"tsecr\"",
  "\"dccp\"", "\"sctp\"", "\"vtag\"", "\"rt\"", "\"rt0\"", "\"rt2\"",
  "\"srh\"", "\"seg-left\"", "\"addr\"", "\"last-entry\"", "\"tag\"",
  "\"sid\"", "\"hbh\"", "\"frag\"", "\"reserved2\"", "\"more-fragments\"",
  "\"dst\"", "\"mh\"", "\"meta\"", "\"mark\"", "\"iif\"", "\"iifname\"",
  "\"iiftype\"", "\"oif\"", "\"oifname\"", "\"oiftype\"", "\"skuid\"",
  "\"skgid\"", "\"nftrace\"", "\"rtclassid\"", "\"ibriport\"",
  "\"obriport\"", "\"ibrname\"", "\"obrname\"", "\"pkttype\"", "\"cpu\"",
  "\"iifgroup\"", "\"oifgroup\"", "\"cgroup\"", "\"time\"", "\"classid\"",
  "\"nexthop\"", "\"ct\"", "\"l3proto\"", "\"proto-src\"", "\"proto-dst\"",
  "\"zone\"", "\"direction\"", "\"event\"", "\"expectation\"",
  "\"expiration\"", "\"helper\"", "\"label\"", "\"state\"", "\"status\"",
  "\"original\"", "\"reply\"", "\"counter\"", "\"name\"", "\"packets\"",
  "\"bytes\"", "\"avgpkt\"", "\"counters\"", "\"quotas\"", "\"limits\"",
  "\"synproxys\"", "\"helpers\"", "\"log\"", "\"prefix\"", "\"group\"",
  "\"snaplen\"", "\"queue-threshold\"", "\"level\"", "\"limit\"",
  "\"rate\"", "\"burst\"", "\"over\"", "\"until\"", "\"quota\"",
  "\"used\"", "\"secmark\"", "\"secmarks\"", "\"nanosecond\"",
  "\"microsecond\"", "\"millisecond\"", "\"second\"", "\"minute\"",
  "\"hour\"", "\"day\"", "\"week\"", "\"reject\"", "\"with\"", "\"icmpx\"",
  "\"snat\"", "\"dnat\"", "\"masquerade\"", "\"redirect\"", "\"random\"",
  "\"fully-random\"", "\"persistent\"", "\"queue\"", "\"num\"",
  "\"bypass\"", "\"fanout\"", "\"dup\"", "\"fwd\"", "\"numgen\"",
  "\"inc\"", "\"mod\"", "\"offset\"", "\"jhash\"", "\"symhash\"",
  "\"seed\"", "\"position\"", "\"index\"", "\"comment\"", "\"xml\"",
  "\"json\"", "\"vm\"", "\"notrack\"", "\"exists\"", "\"missing\"",
  "\"exthdr\"", "\"ipsec\"", "\"mode\"", "\"reqid\"", "\"spnum\"",
  "\"transport\"", "\"tunnel\"", "\"in\"", "\"out\"", "'='", "'{'", "'}'",
  "'('", "')'", "'|'", "'$'", "'['", "']'", "$accept", "input",
  "stmt_separator", "opt_newline", "common_block", "line", "base_cmd",
  "add_cmd", "replace_cmd", "create_cmd", "insert_cmd", "delete_cmd",
  "get_cmd", "list_cmd", "reset_cmd", "flush_cmd", "rename_cmd",
  "import_cmd", "export_cmd", "monitor_cmd", "monitor_event",
  "monitor_object", "monitor_format", "markup_format", "describe_cmd",
  "table_block_alloc", "table_options", "table_block", "chain_block_alloc",
  "chain_block", "subchain_block", "typeof_expr", "set_block_alloc",
  "set_block", "set_block_expr", "set_flag_list", "set_flag",
  "map_block_alloc", "map_block", "set_mechanism", "set_policy_spec",
  "flowtable_block_alloc", "flowtable_block", "flowtable_expr",
  "flowtable_list_expr", "flowtable_expr_member", "data_type_atom_expr",
  "data_type_expr", "obj_block_alloc", "counter_block", "quota_block",
  "ct_helper_block", "ct_timeout_block", "ct_expect_block", "limit_block",
  "secmark_block", "synproxy_block", "type_identifier", "hook_spec",
  "prio_spec", "extended_prio_name", "extended_prio_spec", "int_num",
  "dev_spec", "flags_spec", "policy_spec", "policy_expr", "chain_policy",
  "identifier", "string", "time_spec", "family_spec",
  "family_spec_explicit", "table_spec", "tableid_spec", "chain_spec",
  "chainid_spec", "chain_identifier", "set_spec", "setid_spec",
  "set_identifier", "flowtable_spec", "flowtableid_spec",
  "flowtable_identifier", "obj_spec", "objid_spec", "obj_identifier",
  "handle_spec", "position_spec", "index_spec", "rule_position",
  "ruleid_spec", "comment_spec", "ruleset_spec", "rule", "rule_alloc",
  "stmt_list", "stateful_stmt_list", "stateful_stmt", "stmt",
  "chain_stmt_type", "chain_stmt", "verdict_stmt", "verdict_map_stmt",
  "verdict_map_expr", "verdict_map_list_expr",
  "verdict_map_list_member_expr", "connlimit_stmt", "counter_stmt",
  "counter_stmt_alloc", "counter_args", "counter_arg", "log_stmt",
  "log_stmt_alloc", "log_args", "log_arg", "level_type", "log_flags",
  "log_flags_tcp", "log_flag_tcp", "limit_stmt", "quota_mode",
  "quota_unit", "quota_used", "quota_stmt", "limit_mode",
  "limit_burst_pkts", "limit_burst_bytes", "time_unit", "reject_stmt",
  "reject_stmt_alloc", "reject_opts", "nat_stmt", "nat_stmt_alloc",
  "tproxy_stmt", "synproxy_stmt", "synproxy_stmt_alloc", "synproxy_args",
  "synproxy_arg", "synproxy_config", "synproxy_obj", "synproxy_ts",
  "synproxy_sack", "primary_stmt_expr", "shift_stmt_expr", "and_stmt_expr",
  "exclusive_or_stmt_expr", "inclusive_or_stmt_expr", "basic_stmt_expr",
  "concat_stmt_expr", "map_stmt_expr_set", "map_stmt_expr",
  "prefix_stmt_expr", "range_stmt_expr", "wildcard_expr",
  "multiton_stmt_expr", "stmt_expr", "nat_stmt_args", "masq_stmt",
  "masq_stmt_alloc", "masq_stmt_args", "redir_stmt", "redir_stmt_alloc",
  "redir_stmt_arg", "dup_stmt", "fwd_stmt", "nf_nat_flags", "nf_nat_flag",
  "queue_stmt", "queue_stmt_alloc", "queue_stmt_args", "queue_stmt_arg",
  "queue_stmt_flags", "queue_stmt_flag", "set_elem_expr_stmt",
  "set_elem_expr_stmt_alloc", "set_stmt", "set_stmt_op", "map_stmt",
  "meter_stmt", "flow_stmt_legacy_alloc", "flow_stmt_opts",
  "flow_stmt_opt", "meter_stmt_alloc", "match_stmt", "variable_expr",
  "symbol_expr", "set_ref_expr", "set_ref_symbol_expr", "integer_expr",
  "primary_expr", "fib_expr", "fib_result", "fib_flag", "fib_tuple",
  "osf_expr", "osf_ttl", "shift_expr", "and_expr", "exclusive_or_expr",
  "inclusive_or_expr", "basic_expr", "concat_expr", "prefix_rhs_expr",
  "range_rhs_expr", "multiton_rhs_expr", "map_expr", "expr", "set_expr",
  "set_list_expr", "set_list_member_expr", "meter_key_expr",
  "meter_key_expr_alloc", "set_elem_expr", "set_elem_expr_alloc",
  "set_elem_options", "set_elem_option", "set_elem_expr_options",
  "set_elem_stmt_list", "set_elem_stmt", "set_elem_expr_option",
  "set_lhs_expr", "set_rhs_expr", "initializer_expr", "counter_config",
  "counter_obj", "quota_config", "quota_obj", "secmark_config",
  "secmark_obj", "ct_obj_type", "ct_l4protoname", "ct_helper_config",
  "timeout_states", "timeout_state", "ct_timeout_config",
  "ct_expect_config", "ct_obj_alloc", "limit_config", "limit_obj",
  "relational_expr", "list_rhs_expr", "rhs_expr", "shift_rhs_expr",
  "and_rhs_expr", "exclusive_or_rhs_expr", "inclusive_or_rhs_expr",
  "basic_rhs_expr", "concat_rhs_expr", "boolean_keys", "boolean_expr",
  "keyword_expr", "primary_rhs_expr", "relational_op", "verdict_expr",
  "chain_expr", "meta_expr", "meta_key", "meta_key_qualified",
  "meta_key_unqualified", "meta_stmt", "socket_expr", "socket_key",
  "offset_opt", "numgen_type", "numgen_expr", "xfrm_spnum", "xfrm_dir",
  "xfrm_state_key", "xfrm_state_proto_key", "xfrm_expr", "hash_expr",
  "nf_key_proto", "rt_expr", "rt_key", "ct_expr", "ct_dir", "ct_key",
  "ct_key_dir", "ct_key_proto_field", "ct_key_dir_optional",
  "symbol_stmt_expr", "list_stmt_expr", "ct_stmt", "payload_stmt",
  "payload_expr", "payload_raw_expr", "payload_base_spec", "eth_hdr_expr",
  "eth_hdr_field", "vlan_hdr_expr", "vlan_hdr_field", "arp_hdr_expr",
  "arp_hdr_field", "ip_hdr_expr", "ip_hdr_field", "ip_option_type",
  "ip_option_field", "icmp_hdr_expr", "icmp_hdr_field", "igmp_hdr_expr",
  "igmp_hdr_field", "ip6_hdr_expr", "ip6_hdr_field", "icmp6_hdr_expr",
  "icmp6_hdr_field", "auth_hdr_expr", "auth_hdr_field", "esp_hdr_expr",
  "esp_hdr_field", "comp_hdr_expr", "comp_hdr_field", "udp_hdr_expr",
  "udp_hdr_field", "udplite_hdr_expr", "udplite_hdr_field", "tcp_hdr_expr",
  "tcp_hdr_field", "tcp_hdr_option_type", "tcp_hdr_option_field",
  "dccp_hdr_expr", "dccp_hdr_field", "sctp_hdr_expr", "sctp_hdr_field",
  "th_hdr_expr", "th_hdr_field", "exthdr_expr", "hbh_hdr_expr",
  "hbh_hdr_field", "rt_hdr_expr", "rt_hdr_field", "rt0_hdr_expr",
  "rt0_hdr_field", "rt2_hdr_expr", "rt2_hdr_field", "rt4_hdr_expr",
  "rt4_hdr_field", "frag_hdr_expr", "frag_hdr_field", "dst_hdr_expr",
  "dst_hdr_field", "mh_hdr_expr", "mh_hdr_field", "exthdr_exists_expr",
  "exthdr_key", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
      61,   123,   125,    40,    41,   124,    36,    91,    93
};
#endif

#define YYPACT_NINF (-1553)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-907)

#define yytable_value_is_error(Yyn) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
   -1553,  6982, -1553,   351, -1553, -1553,    86,   122,   122,   122,
     876,   876,   876,   876,   876,   876,   876,   876, -1553, -1553,
    3376,   188,  2201,   191,  2085,   193,  7253,   344,   906,   219,
    6481,   140,   176,   165, -1553, -1553, -1553, -1553,   260,   876,
     876,   876,   876, -1553, -1553, -1553,   562, -1553,   122, -1553,
     122,   137,  5951, -1553,   351, -1553,   -48,   -15,   351,   122,
   -1553,     1,    19,  5951,   122, -1553,   315, -1553,   122, -1553,
   -1553,   876, -1553,   876,   876,   876,   876,   876,   876,   876,
     370,   876,   876,   876,   876, -1553,   876, -1553,   876,   876,
     876,   876,   876,   876,   876,   876,   410,   876,   876,   876,
     876, -1553,   876, -1553,   876,   876,   876,   876,   876,   496,
     876,   876,   876,   876,   876,   779,   876,   876,   876,   421,
     876,  1094,  1330,  1514,  1613,   876,   876,   876,  1672, -1553,
     876,  1935,  2046,   876, -1553,   876,   876,   876,   876,   876,
     301,   876, -1553,   876, -1553,   748,   523,   230,   252, -1553,
   -1553, -1553, -1553,   738,   769,   770,  1373,  3207,  1108,    76,
    1718,  1391,   824,   443,   599,   555,   564,  2945,   422,   652,
    1194,   238,   306,   545,   345,   701,   368,   716,  4238, -1553,
   -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553,
   -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553,
    5370, -1553, -1553,   279,  6179,   159,   861,   492,  6481,   122,
   -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553,
   -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553,
   -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553,
   -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553,
   -1553, -1553, -1553, -1553, -1553,   626, -1553, -1553,   215, -1553,
   -1553,   626, -1553, -1553, -1553, -1553,  1273,   876,   876,   876,
     -71, -1553, -1553, -1553, -1553, -1553, -1553, -1553,   480,   554,
     572, -1553, -1553, -1553,   170,   360,   727, -1553, -1553, -1553,
   -1553, -1553, -1553,    -2,    -2, -1553,   114,   122,  4466,  5160,
     433, -1553,   446,   423, -1553, -1553, -1553, -1553, -1553, -1553,
     602,   425, -1553,   709, -1553,   416,  5951, -1553, -1553, -1553,
   -1553, -1553, -1553, -1553, -1553,   688, -1553,   708, -1553, -1553,
   -1553,   454, -1553,  4050, -1553, -1553,   447, -1553,    31, -1553,
     333, -1553, -1553, -1553,   686, -1553,   111, -1553, -1553,   695,
   -1553, -1553, -1553,   925,   735,   754,   449, -1553,   565, -1553,
    5199, -1553, -1553, -1553,   749, -1553, -1553, -1553,   755, -1553,
    5561,  5561, -1553, -1553,    61,   521,   525, -1553, -1553,   528,
   -1553, -1553, -1553,   547, -1553,   577,   762,  5951, -1553,     1,
      19, -1553,   315, -1553, -1553,   876,   876,   876,   615, -1553,
   -1553, -1553,  5951,   259, -1553, -1553,   411, -1553, -1553,   436,
   -1553, -1553, -1553,   455, -1553, -1553,   315, -1553,   497,   592,
   -1553, -1553, -1553, -1553,   876, -1553, -1553, -1553, -1553, -1553,
   -1553, -1553, -1553,   315, -1553, -1553, -1553, -1553, -1553, -1553,
     876, -1553, -1553, -1553, -1553, -1553, -1553,   876,   876, -1553,
   -1553, -1553,   850,   872,   883,   876, -1553,   876, -1553,   876,
   -1553,   876, -1553,   876, -1553, -1553, -1553, -1553,   876, -1553,
   -1553,   876, -1553,   876, -1553, -1553, -1553, -1553, -1553, -1553,
   -1553,   876, -1553,   122, -1553, -1553, -1553,   938, -1553, -1553,
   -1553, -1553, -1553,   973,    45, -1553, -1553, -1553, -1553,   858,
      59, -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553,
   -1553, -1553, -1553,   529,   583, -1553, -1553, -1553, -1553, -1553,
   -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553,
   -1553, -1553, -1553,  1041, -1553, -1553, -1553, -1553, -1553, -1553,
   -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553,
   -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553,
   -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553,
   -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553,
   -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553,
   -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553,
    2891, -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553,
   -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553,
   -1553,   409, -1553, -1553,   666, -1553, -1553, -1553, -1553, -1553,
   -1553,   670, -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553,
   -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553,
   -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553,
   -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553,
   -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553,
   -1553, -1553, -1553, -1553,  3056, -1553, -1553, -1553, -1553,   702,
     189,   710,   912, -1553, -1553, -1553, -1553, -1553, -1553, -1553,
   -1553,   700,   693, -1553, -1553, -1553, -1553, -1553, -1553, -1553,
   -1553, -1553, -1553, -1553,   626, -1553, -1553, -1553,   -46,   -85,
     261,    47, -1553, -1553, -1553,  4278,   968,  5348,  6481, -1553,
   -1553, -1553, -1553,  1052,  1063,    10,  1040,  1066,  1068,    28,
    1073,  3056,  1081,  5348,  5348,   687,  5348, -1553, -1553,  1034,
    5348,  5348,  1061, -1553,  2577,    66, -1553,   918, -1553, -1553,
     829,  1057,  1058,   688, -1553,   681,   918,  1062,  1084,  1089,
     918,   708, -1553,   394, -1553,  5348, -1553, -1553,  4506,  1079,
     769,   770,  1373,  2823, -1553,  1456,    71, -1553, -1553, -1553,
    1099, -1553, -1553, -1553, -1553,  6694, -1553,   994,  1146,  1177,
     871,   808,   312, -1553, -1553, -1553, -1553, -1553,  1193,   792,
    1195, -1553, -1553, -1553, -1553,  1210, -1553, -1553, -1553, -1553,
     458, -1553, -1553,  1213,  1224, -1553,  1136,  1138, -1553, -1553,
     447, -1553,  1236, -1553, -1553, -1553, -1553,  1239, -1553,  4734,
   -1553,  1239,  5348, -1553, -1553,   686, -1553,  1244, -1553,   122,
   -1553,   931, -1553,   122,    42, -1553,  7096,  7096,  7096,  7096,
    7096,  6481,   106,  5632, -1553, -1553, -1553, -1553, -1553, -1553,
   -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553,
   -1553, -1553, -1553, -1553, -1553, -1553, -1553,  7096, -1553, -1553,
   -1553, -1553, -1553, -1553, -1553, -1553,  1247, -1553,  1027,  1243,
    1245,   937,   640,  1263, -1553, -1553, -1553,  5632,  5348,  5348,
    1172,    89,   351,  1247, -1553,   351,  1178, -1553, -1553, -1553,
   -1553, -1553, -1553, -1553, -1553, -1553,  1242,   962,   963,   967,
   -1553,   970,   975, -1553, -1553, -1553,  1042,  1031,   719,   918,
   -1553,  1200,  1201,  1203,  1204, -1553,  1206,   990, -1553, -1553,
   -1553, -1553, -1553,   876,   876,   876, -1553, -1553, -1553, -1553,
   -1553, -1553, -1553, -1553, -1553, -1553,  1212,   523, -1553, -1553,
   -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553,
   -1553, -1553, -1553,    79,  2393, -1553, -1553, -1553, -1553, -1553,
   -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553,  1021, -1553,
    1223,  1225, -1553, -1553,   936, -1553,   951, -1553, -1553, -1553,
   -1553, -1553, -1553,  1226,  1235,  1015,  1237,   109, -1553, -1553,
   -1553,  1003,  1017,  1018,  1241, -1553, -1553,   687, -1553, -1553,
   -1553,  1249, -1553, -1553, -1553, -1553,  5348,  3207,  1718,  1337,
    4962, -1553,   111,   150,  1336,   918,   918,  1250,  6481,  5348,
    5348,  5348, -1553,  1252,  5348,  1295,  5348, -1553, -1553, -1553,
   -1553,  1253, -1553,    24,  1314, -1553,  5348, -1553,   709,  1060,
     164,   507,   969,  1263,   709, -1553, -1553, -1553, -1553, -1553,
   -1553, -1553, -1553,  1211,   561, -1553, -1553, -1553, -1553, -1553,
   -1553, -1553, -1553, -1553,  1246,  1255,  1290,  1268, -1553,  5348,
    1356,  5348,  5348,  1050, -1553, -1553,  6694,  6694,  6694,  6694,
    6694,  1264,  6694,  6694,   132,  5348,  1239,  5348,  1311,  1386,
    1313,  2780,  2780, -1553, -1553, -1553,  5348,   792,  5348,   792,
   -1553, -1553,   802, -1553,  6481, -1553,  6481, -1553, -1553, -1553,
    1027,  1243,  1245, -1553,   709, -1553, -1553, -1553,  1072,  7096,
    7096,  7096,  7096,  7096,  7096,  7096,  1300,  7096,  7096, -1553,
   -1553, -1553, -1553, -1553, -1553, -1553,   743,   138,  1845,  2936,
    1857,   596,   255, -1553, -1553, -1553, -1553, -1553, -1553,  1091,
    1093,  1098, -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553,
   -1553, -1553, -1553, -1553, -1553, -1553,  1395, -1553, -1553, -1553,
   -1553, -1553, -1553, -1553,  1408, -1553, -1553, -1553, -1553, -1553,
   -1553, -1553, -1553, -1553,  1092,  1100, -1553, -1553, -1553, -1553,
    1015,  -125,  1321, -1553, -1553, -1553, -1553, -1553,   997, -1553,
   -1553, -1553,  1173,   322,  1338,   390,   104,    24,   639, -1553,
    5348,  5348,  1431, -1553,  1343,  1343, -1553,   150, -1553, -1553,
   -1553,  1118,  1336,  5951,   150, -1553, -1553, -1553, -1553, -1553,
    5348, -1553,   152, -1553, -1553,  1179,  5348,  1404, -1553,  6991,
   -1553,  1343,  1343, -1553,   164, -1553,  1207,  1185,   507, -1553,
    2577, -1553,  3816, -1553, -1553, -1553,  1447, -1553,  1361,  1363,
   -1553,  1364, -1553,  5348, -1553, -1553, -1553, -1553, -1553,   994,
    1146,  1177, -1553, -1553, -1553, -1553, -1553, -1553, -1553,  1461,
    5348,  1307,  5348, -1553, -1553, -1553, -1553,   792, -1553,   792,
    1239, -1553,   112,  5951,  5794,    85, -1553, -1553, -1553, -1553,
   -1553,  1027,  1243,  1245, -1553, -1553, -1553, -1553,   969,  1371,
    1434, -1553, -1553, -1553, -1553, -1553,   122,   122,   122,   122,
     122,  1372,   431,   122,   122,   122,   122, -1553, -1553, -1553,
     351, -1553,    35,  1377,  1383, -1553, -1553, -1553,   351,   351,
     351,   351,   351,  6481, -1553,  1343,  1343,  1160,  1020,  1384,
     699,  1182,  1301, -1553, -1553, -1553,   351,   351,   274, -1553,
    6481,  1343,  1166,   699,  1182, -1553, -1553, -1553,   351,   351,
    1387,  1169, -1553, -1553, -1553, -1553,  2494,  3248,  1958,  2506,
     767, -1553, -1553, -1553,  1145,  1396,  1398, -1553, -1553, -1553,
    1399, -1553, -1553, -1553, -1553, -1553,   242,   587,  1913,  1410,
   -1553, -1553, -1553, -1553, -1553,   202, -1553, -1553, -1553, -1553,
   -1553, -1553, -1553, -1553, -1553, -1553,  1179, -1553, -1553, -1553,
   -1553, -1553, -1553, -1553,  5348, -1553, -1553, -1553, -1553,  6481,
    1189,   150, -1553,   826,  1231,  1412, -1553, -1553,  5348,    -2,
      -2,   709,  1263, -1553, -1553, -1553, -1553,  1414,   687, -1553,
   -1553, -1553,   351,   561, -1553, -1553, -1553, -1553,  5348, -1553,
    1443, -1553,  1239,  1239,  6481, -1553,   213,  1205,  1523,   709,
   -1553,  1354,  1437, -1553, -1553, -1553, -1553, -1553, -1553, -1553,
   -1553, -1553, -1553,   122,   122,   122, -1553, -1553, -1553, -1553,
   -1553, -1553, -1553, -1553, -1553, -1553,  1499, -1553, -1553, -1553,
   -1553, -1553, -1553,   833, -1553,   351,   351,   315, -1553, -1553,
   -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553,   904,
   -1553, -1553, -1553, -1553, -1553,   853, -1553, -1553, -1553, -1553,
   -1553,   471,   351,   315,   752,   853, -1553, -1553,  1394,   441,
   -1553, -1553, -1553, -1553, -1553,   374,   860,  1999, -1553, -1553,
    1538,  1015,  1227,   549,   876, -1553, -1553, -1553, -1553, -1553,
    1343,  1446,   549,  1449,   876, -1553, -1553, -1553, -1553, -1553,
    1448,   876, -1553, -1553, -1553, -1553, -1553, -1553,   826,  1231,
   -1553, -1553,  5951, -1553, -1553, -1553, -1553, -1553, -1553,  1287,
    1453, -1553,    24, -1553, -1553,  1320,  1460, -1553, -1553, -1553,
    5348,  1234,  6481, -1553, -1553,  1515,  5794, -1553, -1553,  1397,
     351,  1259,  1265,  1267,  1276,  1280, -1553, -1553, -1553,  1288,
    1291,  1292,  1293,  1476,  6481, -1553, -1553, -1553, -1553,   699,
   -1553,  1182, -1553,  6330, -1553, -1553,  2604, -1553,   124,   351,
      26,   351, -1553, -1553, -1553, -1553,  1484, -1553,  1297, -1553,
   -1553,   351,   351,   351,   351,   351,   351,   351,  1459,   351,
    1287, -1553,  1294,  1502, -1553,    39, -1553,  1519,   210, -1553,
   -1553,  1302,   709, -1553, -1553,  1354, -1553, -1553, -1553, -1553,
   -1553,  1304,  1305,  1306, -1553, -1553, -1553, -1553,  1080, -1553,
   -1553, -1553,  6481,   833,   699,   351,   351,   351,   351,   904,
    1522, -1553, -1553, -1553,   579, -1553, -1553, -1553, -1553, -1553,
      87, -1553, -1553, -1553, -1553,  1527, -1553, -1553, -1553, -1553,
   -1553, -1553, -1553,   549, -1553, -1553, -1553,  1385, -1553, -1553,
   -1553,   826,  1231, -1553, -1553,  1397,   696,  3549,  2154,  2525,
    2334, -1553, -1553, -1553,  1029,  1113,  1010,   893,    13,  1312,
    1394,   833, -1553,   904, -1553, -1553, -1553, -1553, -1553, -1553,
    1531,  1540,    67, -1553,  1637,   102, -1553,   351, -1553,  1287,
   -1553, -1553,   351,   351,   351,   351,   351,  1281,  1954,  2595,
     351,   351,   351,   351, -1553, -1553,   441, -1553, -1553, -1553,
   -1553, -1553, -1553, -1553,  1544,  1527,   351, -1553, -1553, -1553,
   -1553, -1553, -1553, -1553,   351,   351,   351, -1553, -1553, -1553,
   -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       2,     0,     1,     0,     4,     5,     0,     0,     0,     0,
     335,   335,   335,   335,   335,   335,   335,   335,   339,   342,
     335,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   153,   341,   340,   337,   338,     0,   335,
     335,   335,   335,    14,    13,     3,     0,    17,     0,   336,
       0,   360,     0,    12,     0,   330,     0,     0,     0,     0,
     495,    32,    34,     0,     0,   202,     0,   224,     0,   245,
      18,   335,    19,   335,   335,   335,   335,   335,   335,   335,
       0,   335,   335,   335,   335,    20,   335,    21,   335,   335,
     335,   335,   335,   335,   335,   335,     0,   335,   335,   335,
     335,    22,   335,    23,   335,   335,   366,   335,   366,   366,
     335,   335,   366,   335,   366,     0,   335,   366,   366,     0,
     335,   366,   366,   366,   366,   335,   335,   335,   366,    24,
     335,   366,   366,   335,    25,   335,   335,   335,   335,   366,
       0,   335,    26,   335,    27,     0,     0,     0,   641,   612,
     331,   332,   333,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   808,
     809,   810,   811,   812,   813,   814,   815,   816,   817,   818,
     819,   820,   821,   822,   823,   824,   825,   826,   827,   829,
       0,   831,   830,     0,     0,     0,     0,   828,     0,     0,
      31,   608,   607,   613,   614,   168,   624,   625,   618,   799,
     619,   622,   626,   623,   620,   621,   615,   914,   915,   916,
     917,   918,   919,   920,   921,   922,   923,   924,   925,   926,
     927,   928,   929,   930,   931,   616,  1081,  1082,  1083,  1084,
    1085,  1086,  1087,  1088,   617,     0,   165,   166,     0,    28,
     149,     0,    29,   151,   154,    30,   155,   335,   335,   335,
      42,   728,   704,   706,    16,    15,   343,   345,     0,     0,
       0,   362,   361,   363,     0,   485,     0,   592,   593,   594,
     790,   791,   792,   399,   400,   795,   599,     0,     0,     0,
     415,   423,     0,   447,   468,   475,   476,   554,   560,   577,
       0,     0,   835,     7,    37,   368,   370,   383,   371,   188,
     398,   379,   403,   378,   375,   413,   385,   421,   376,   377,
     386,   469,   387,     0,   388,   397,   483,   391,   553,   392,
     559,   393,   394,   389,   575,   395,     0,   396,   381,     0,
     598,   380,   643,   646,   648,   650,   652,   653,   660,   662,
       0,   661,   605,   402,   799,   384,   390,   382,   615,     8,
       0,     0,    11,   354,     0,     0,     0,    36,   348,     0,
      40,   217,   216,     0,   351,     0,     0,     0,   495,    57,
      59,   202,     0,   224,   245,   335,   335,   335,    65,   728,
     704,   706,     0,     0,    96,    97,     0,    75,    76,     0,
      77,    78,    79,     0,    80,    81,     0,    82,     0,    84,
      85,   708,   709,   707,   335,    87,    88,    92,    93,    89,
      90,    94,    95,     0,   120,    99,   367,   100,   101,   102,
     335,   103,   105,   129,   128,   127,   121,   335,   366,   125,
     124,   126,   708,   709,     0,   335,   108,   335,   106,   335,
     109,   335,   112,   335,   118,   114,   111,   117,   335,   115,
     136,   335,   134,   335,   137,   139,   140,   141,   142,   143,
     146,   335,   145,     0,   933,   934,   935,     0,   632,   633,
     634,   635,   636,   638,     0,   839,   841,   840,   838,     0,
       0,  1079,  1080,  1078,   937,   938,   939,   936,   944,   941,
     942,   943,   940,     0,     0,   946,   947,   948,   949,   950,
     945,   968,   969,   963,   958,   959,   960,   961,   962,   964,
     965,   966,   967,     0,   955,   980,   983,   982,   981,   984,
     985,   986,   979,   988,   989,   990,   991,   987,  1000,  1001,
     993,   994,   995,   997,   996,   998,   999,   992,  1003,  1008,
    1005,  1004,  1009,  1007,  1006,  1010,  1002,  1013,  1016,  1012,
    1014,  1015,  1011,  1019,  1018,  1017,  1021,  1022,  1023,  1020,
    1027,  1028,  1025,  1026,  1024,  1033,  1030,  1031,  1032,  1029,
    1046,  1040,  1043,  1044,  1038,  1039,  1041,  1042,  1045,  1047,
       0,  1034,  1072,  1070,  1071,  1069,  1077,  1074,  1075,  1076,
    1073,  1095,   860,  1094,   866,   861,  1093,  1096,   864,   865,
     867,     0,   862,  1092,     0,  1097,  1100,  1099,  1103,  1102,
    1104,     0,  1101,  1091,  1090,  1089,  1112,  1109,  1107,  1108,
    1110,  1111,  1106,  1115,  1114,  1113,  1119,  1118,  1121,  1117,
    1120,  1116,   800,   803,   804,   805,   807,   806,   828,   798,
     801,   802,   881,   882,   888,   874,   875,   873,   883,   884,
     904,   877,   886,   879,   880,   885,   876,   878,   871,   872,
     902,   901,   903,   887,     0,   868,   889,   845,   844,     0,
     660,     0,     0,  1124,  1123,  1125,  1126,  1127,  1122,   849,
     850,   848,     0,   606,   148,   167,   150,   156,   157,   159,
     158,   161,   162,   160,   163,   725,   725,   725,     0,     0,
     447,     0,   357,   358,   359,     0,     0,     0,     0,   797,
     796,   793,   794,     0,     0,     0,   800,   798,     0,     0,
       0,     0,   868,     0,     0,   456,     0,   445,   446,     0,
       0,     0,     0,     6,     0,     0,   664,     0,   369,   372,
       0,     0,     0,   414,   417,     0,     0,     0,     0,     0,
       0,   422,   424,     0,   467,     0,   531,   763,     0,     0,
     755,   758,   759,   756,   762,   757,     0,   766,   764,   765,
       0,   761,   760,   752,   753,     0,   513,   516,   518,   520,
     522,   523,   528,   535,   532,   533,   534,   536,   538,   474,
     500,   501,   511,   754,   502,   509,   503,   510,   506,   507,
       0,   504,   505,     0,   537,   508,     0,     0,   492,   491,
     484,   487,     0,   572,   573,   574,   552,   557,   570,     0,
     558,   563,     0,   584,   585,   576,   578,   581,   582,     0,
     610,     0,   609,     0,     0,   600,     0,     0,     0,     0,
       0,     0,     0,     0,   784,   785,   786,   787,   788,   789,
     755,   758,   759,   756,   776,   777,   757,   778,   775,   774,
     779,   772,   773,   771,   780,   781,   782,     0,   735,   767,
     737,   768,   657,   658,   749,   736,   730,   729,   741,   743,
     745,   747,   748,   734,   769,   770,   738,     0,     0,     0,
       0,     7,     0,   698,   697,     0,     0,   299,    54,   172,
     189,   203,   225,   246,   364,    56,     0,     0,     0,     0,
      63,     0,     0,   725,   725,   725,     0,     0,   447,     0,
      74,     0,     0,     0,     0,    83,     0,     0,   725,    98,
     104,   123,   122,   335,   335,   335,   130,   107,   110,   113,
     119,   116,   135,   138,   144,   147,     0,     0,   631,   629,
     630,   628,   642,   639,   640,   951,   953,   952,   954,   970,
     971,   972,   973,   957,     0,  1050,  1060,  1051,  1058,  1048,
    1049,  1053,  1054,  1055,  1056,  1057,  1052,  1059,  1036,   863,
       0,     0,   890,   891,     0,   893,     0,   892,   894,   895,
     869,   870,   896,     0,     0,   842,     0,     0,   627,   152,
     164,     0,     0,     0,     0,   264,    43,   456,   289,    50,
     269,     0,    45,   294,   705,    52,     0,   756,   757,   477,
       0,   486,     0,   586,   588,     0,     0,     0,     0,     0,
       0,     0,   411,     0,     0,   896,     0,   416,   444,   454,
     455,     0,   453,     0,   566,   568,     0,   694,     7,     7,
     673,   676,   748,   693,     7,   663,   365,   197,   419,   420,
     418,   437,   436,     0,     0,   435,   431,   426,   427,   428,
     429,   432,   430,   425,     0,     0,     0,     0,   544,     0,
     539,     0,     0,     0,   500,   509,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   546,     0,     0,     0,
       0,     0,     0,   489,   490,   488,     0,     0,     0,   561,
     580,   579,     0,   611,     0,   602,     0,   601,   644,   645,
     647,   649,   651,   654,     7,   404,   406,   659,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   731,
     833,   913,   700,   699,     9,    10,     0,     0,     0,     0,
       0,     0,     0,    73,   172,   189,   203,   225,   246,     0,
       0,     0,    66,    71,    67,    72,   355,   344,   346,   349,
     352,   246,    91,   132,   133,   131,     0,   637,   974,   975,
     977,   976,   978,   956,     0,  1063,  1062,  1061,  1064,  1065,
    1066,  1067,  1068,  1035,     0,     0,   897,   898,   899,   900,
     842,   842,     0,   859,   847,   851,   852,   855,     0,   279,
     284,   274,     0,     0,     0,     0,     0,     0,     0,   479,
       0,     0,   478,   589,     0,     0,   681,   587,   677,   837,
     836,     0,   672,     0,   670,   834,   832,   910,   412,   911,
       0,   909,     0,   449,   448,   450,     0,     0,   667,     0,
     668,     0,     0,   692,   674,   682,   686,     0,   675,   684,
     666,   665,     0,   434,   440,   441,   433,   439,     0,     0,
     473,     0,   545,     0,   549,   551,   512,   514,   515,   517,
     519,   521,   529,   530,   524,   527,   526,   525,   541,   540,
       0,     0,     0,   905,   906,   907,   908,   555,   571,   562,
     564,   583,     0,     0,     0,     0,   407,   783,   733,   739,
     740,   742,   744,   746,   732,   655,   656,   750,   751,     0,
       0,    55,   301,   300,   303,   302,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    33,   174,   173,
       0,   171,     0,     0,     0,    35,   191,   190,     0,     0,
       0,     0,     0,     0,   213,     0,     0,     0,     0,     0,
       0,     0,     0,    38,   205,   204,     0,     0,     0,   373,
       0,     0,     0,     0,     0,    39,   227,   226,     0,     0,
       0,     0,   251,    41,   248,   247,     0,     0,     0,     0,
       0,   279,   284,   274,     0,     0,     0,  1098,  1105,   846,
       0,   858,   843,   854,   853,   856,     0,     0,     0,     0,
      44,   266,   265,   268,   267,     0,    51,   291,   290,   293,
     292,    46,   271,   270,   273,   272,   450,    53,   296,   295,
     298,   297,   480,   482,     0,   334,   679,   680,   678,     0,
       0,   671,   912,     0,   459,     0,   452,   567,     0,     0,
       0,     7,   695,   696,   690,   691,   683,     0,   456,   685,
     401,   198,     0,     0,   470,   471,   472,   542,     0,   548,
       0,   550,   556,   565,     0,   590,     0,     0,     0,     7,
     405,   496,     0,   356,   263,   347,   188,   350,   202,   224,
     353,   245,   170,     0,     0,     0,   263,   263,   263,   263,
     175,   328,   329,   325,   327,   326,     0,   324,   192,   194,
     193,   196,   195,     0,   200,     0,     0,     0,   244,   243,
     241,   242,   304,   306,   307,   305,   260,   308,   261,     0,
     259,   220,   221,   223,   222,     0,   219,   214,   215,   211,
     374,     0,     0,     0,     0,     0,   240,   239,     0,     0,
      58,    60,    61,    62,    64,     0,     0,     0,    86,   932,
       0,   842,     0,     0,     0,    48,   281,   280,   283,   282,
       0,     0,     0,     0,     0,    49,   286,   285,   288,   287,
       0,     0,    47,   276,   275,   278,   277,   701,     0,   459,
     703,   481,     0,   603,   462,   463,   464,   465,   466,   457,
       0,   443,     0,   569,   669,     0,     0,   199,   438,   543,
       0,     0,     0,   591,   597,     0,   409,   408,   497,   498,
       0,     0,     0,     0,     0,     0,   263,   263,   263,     0,
       0,     0,     0,     0,     0,   207,   209,   210,   212,     0,
     206,     0,   208,     0,   228,   238,     0,   237,     0,     0,
       0,     0,   253,    69,    70,    68,     0,   857,     0,   711,
     710,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     457,   727,     0,     0,   442,     0,   451,     0,     0,   547,
     595,     0,     7,   499,   493,   496,   299,   189,   203,   225,
     246,     0,     0,     0,   264,   289,   269,   294,   323,   201,
     262,   218,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   318,   312,   311,   315,   310,   313,   314,   249,   257,
       0,   254,   258,   250,  1037,     0,   717,   719,   722,   723,
     720,   721,   724,     0,   713,   726,   604,     0,   461,   460,
     687,     0,   459,   596,   410,   498,     0,     0,     0,     0,
       0,   279,   284,   274,     0,     0,     0,     0,     0,     0,
       0,     0,   231,     0,   233,   235,   234,   236,   229,   319,
       0,     0,     7,   252,     0,     0,   714,     0,   458,   457,
     689,   494,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   320,   321,     0,   309,   232,   230,
     317,   316,   256,   255,     0,     0,     0,   712,   688,   187,
     176,   177,   178,   179,     0,     0,     0,   180,   185,   181,
     186,   322,   716,   715,   718,   183,   184,   182
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1553, -1553,    -1, -1038,    23, -1553, -1553,  1625, -1553, -1553,
   -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553,
   -1553, -1553, -1553,   -16, -1553,  1258, -1553,   475,  -306, -1138,
   -1553, -1338,  -372, -1129,  -377,   258,    -6,  -371, -1128, -1142,
   -1553,  -376, -1143,  -159, -1553,  -134,     0, -1325,  -642,   -53,
     -54, -1359, -1349, -1347,   -52,   -51,   -39, -1553, -1553,  -116,
   -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553,    93,  -679,
   -1149,  1580,   -42,  2313, -1553,  1256, -1553, -1553,    43, -1553,
     324,   479, -1553, -1553,   389,  1114,  -590,  1289, -1553, -1553,
     208,  1586,   864,    77,   -49, -1553, -1553,   357, -1159,  -315,
   -1553, -1553, -1553, -1553, -1553, -1553,   190, -1553, -1553, -1553,
   -1553,   924, -1553, -1553, -1553,   920, -1553, -1553, -1553,   209,
   -1553,  1390, -1186,   248, -1553,  -983, -1552, -1458, -1446, -1553,
   -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553,   866,  -342,
    1310,    -5,   -66,  -316,   594,   598,   595, -1553,  -707, -1553,
   -1553, -1553, -1553, -1553,  -350, -1553,  1739, -1553, -1553, -1553,
   -1553, -1553, -1553, -1553, -1553, -1553,  -331,   581, -1553, -1553,
   -1553,   865, -1553,   580, -1084, -1553, -1553,  1428, -1553, -1553,
   -1553, -1553,   862, -1553, -1553,   -60,   -25,  -755,  -334,   600,
     -13, -1553, -1553, -1553,   750,    11, -1553, -1553, -1553, -1553,
   -1553,  -182,  -179, -1553, -1553,   563, -1553,  1533,   -62, -1553,
     645, -1067, -1553, -1241, -1553,   469, -1076, -1553, -1553,   461,
     466, -1553, -1553,  1374,  -600,  1345,  -596,  1344,  -574,  1346,
    1627, -1432, -1553, -1553,   -65, -1553, -1553,  -404,  -561,  1362,
   -1553,  1402,  -320,  -763,  -756,  -734, -1553,  -337,  -746, -1553,
     366,   -81,  -687, -1553, -1223,  -287,   244,  1466, -1553,   151,
   -1553,   247, -1553, -1160, -1553,   542, -1553, -1553, -1553, -1553,
   -1553,   647,  -256,   840,  1149,   843,  1472,  1473, -1553, -1553,
    -456,    33, -1553, -1553, -1553,   887, -1553, -1553, -1553, -1553,
   -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553,
   -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553,
   -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553,   793, -1553,
   -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553,
   -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553, -1553,
   -1553, -1553, -1553, -1553, -1553
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,  1404,   754,  1405,    45,    46,    47,    72,    85,
      87,   101,   103,   129,   134,   142,   144,   259,   262,   265,
     266,   714,  1019,   260,   210,   375,  1360,  1168,   376,  1169,
    1282,  1533,   379,  1170,   380,  1555,  1556,   383,  1171,  1386,
    1540,   385,  1172,  1671,  1740,  1741,  1548,  1549,  1641,  1233,
    1236,  1428,  1426,  1427,  1235,  1238,  1167,  1550,  1368,  1669,
    1734,  1735,  1736,  1780,  1369,  1370,  1523,  1524,  1503,   211,
    1456,    48,    49,    59,   408,    51,   411,  1506,    65,   415,
    1508,    69,   420,  1511,    60,   405,  1504,   281,   282,   283,
      52,   387,  1246,   437,  1372,   315,   316,  1388,   317,   318,
     319,   320,   321,   322,  1145,  1325,  1326,   323,   324,   325,
     763,   764,   326,   327,   771,   772,  1092,  1086,  1286,  1287,
     328,  1031,  1265,  1466,   329,  1061,  1694,  1621,  1619,   330,
     331,   774,   332,   333,   334,   335,   336,   830,   831,  1345,
     374,  1639,  1704,   796,   797,   798,   799,   800,   801,   802,
    1305,   803,   804,   805,   806,   807,   808,   809,   337,   338,
     836,   339,   340,   840,   341,   342,   837,   838,   343,   344,
     845,   846,   847,   848,  1042,  1043,   345,   346,   347,   348,
     349,   854,   855,   350,   351,   212,   810,   851,   890,   811,
     352,   216,   971,   493,   494,   812,   500,   353,   354,   355,
     356,   357,   358,   892,   893,   894,   359,   360,   361,   755,
     756,  1253,  1254,  1069,  1070,  1247,  1248,  1274,  1278,  1279,
    1275,  1071,  1471,   912,  1434,   718,  1445,   720,  1451,   721,
     424,  1681,  1606,  1795,  1796,  1589,  1599,  1021,  1440,   719,
     362,   913,   914,   898,   899,   900,   901,  1072,   903,   813,
     814,   815,   906,   907,   363,   731,   816,   659,   660,   219,
     365,   817,   498,  1223,   689,   818,  1017,   701,  1227,  1425,
     222,   819,   621,   821,   622,   822,   684,   685,  1010,  1011,
     686,   823,   824,   366,   367,   825,   227,   487,   228,   507,
     229,   512,   230,   520,   231,   534,   983,  1203,   232,   542,
     233,   547,   234,   557,   235,   566,   236,   572,   237,   575,
     238,   579,   239,   584,   240,   589,   241,   601,   998,  1213,
     242,   605,   243,   610,   244,   503,   245,   246,   635,   247,
     623,   248,   625,   249,   627,   250,   632,   251,   642,   252,
     645,   253,   651,   254,   698
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      43,   759,    53,   314,   382,   213,   381,   732,  1073,   841,
     888,  1389,   852,   760,   377,   930,   263,   215,   932,   929,
     888,   888,   931,   902,    44,   690,   702,   213,   726,  1398,
    1268,  1270,   918,   902,   902,  1410,  1280,  1407,   213,   945,
     897,   217,  1034,   947,  1234,   275,  1473,  1408,  1414,  1409,
    1322,  1446,  1561,   369,  1577,   752,   949,   372,    66,    67,
    1419,  1421,  1575,   217,   436,  1576,   436,   436,  1564,  1323,
     436,   753,   436,  1074,   217,   436,   436,   820,  1076,   436,
     436,   436,   436,  1498,   928,   853,   436,  1087,  1103,   436,
     436,  1091,  1499,   753,  1792,  1140,  1457,   436,   916,    55,
      56,    57,    58,  1141,  1047,     3,  1324,  1146,     4,  1825,
       5,  1521,  1522,   832,   150,   151,   152,  1494,  1026,   391,
     392,   393,  1474,  1475,  1032,  1263,  1142,  1739,  1052,   849,
       6,     7,     8,     9,   849,   414,   416,   417,  1755,     3,
    1758,   276,     4,   277,     5,   433,  1730,  1035,   150,   151,
     152,  1691,   373,   442,   443,   849,   968,   378,  1029,   449,
    1685,   384,  1690,  1389,     6,     7,     8,     9,  1739,  1138,
    1139,  1458,  1463,  1222,   733,   916,  1420,  -702,  1027,   213,
     478,   479,   973,   213,   482,   439,   441,   543,    54,   444,
    1198,   446,   278,   612,   450,   451,   255,   861,   458,   460,
     462,   464,  1024,   364,  -447,   469,  1199,   544,   472,   474,
     734,  1200,  1201,   614,   364,   217,   480,   615,  1632,   217,
     545,    63,  1608,    55,  1731,  1732,  1535,  1536,  1012,  1560,
    1761,   612,   261,   730,   730,    71,  1028,  1244,    86,   704,
    1245,   863,  1562,     3,   102,   706,     4,  1828,     5,  1389,
    -702,  1271,   725,  1464,  1272,   615,     3,   969,   970,     4,
    1034,     5,   495,   496,   143,  1225,   264,  1398,     6,     7,
       8,     9,   370,  1264,   218,  1025,  1202,   220,     4,   905,
       5,     6,     7,     8,     9,  1055,   850,  1243,  1759,   905,
     905,   213,   612,  1053,   402,  1400,   218,  1401,   895,   220,
     618,   619,   703,  1609,  1800,   371,   974,   218,   895,   895,
     220,  1762,  1022,  1023,   941,  1799,   615,   833,   834,   835,
    1113,  1797,  -169,     3,   209,  1723,     4,   217,     5,   661,
     382,  1048,   381,  1582,   546,   889,  1182,  1560,   925,   209,
    -188,  1729,  1184,  1382,   481,   889,   889,   267,     6,     7,
       8,     9,   209,   940,   382,     4,   381,     5,   300,  1306,
      55,   209,   213,  1136,  1114,  1185,  1249,  1250,  1033,   747,
     748,   382,  1583,   381,   302,     3,  1183,   213,     4,   303,
       5,   499,   917,   620,  1781,  1458,   729,   729,  1075,  1331,
     735,     3,  1612,   209,     4,  1498,     5,  1332,   217,  1783,
       6,     7,     8,     9,  1067,  1303,   436,  1500,   757,  1793,
    1631,  1163,  1702,   217,  1809,   839,     6,     7,     8,     9,
    1333,  1677,  1807,  1226,  1826,  1808,  1441,  1144,   270,   271,
     272,   273,   209,  1624,  1495,   624,  1696,   209,   497,   279,
     280,  1683,   757,  1733,  1382,   256,   257,   258,   218,   661,
     209,   220,   218,   313,   757,   220,   692,   395,   209,   300,
    1341,  1636,   388,  1329,  1330,  1582,   942,   364,   757,   633,
     398,   399,   400,   401,  1584,   302,  1663,   404,  1116,  1654,
     303,   256,   257,   258,   826,   827,   425,   427,   429,   431,
     951,   943,   643,   434,   634,  1626,   373,   421,   268,   276,
     269,  1402,   277,   626,  1583,  1382,   378,   751,   452,   456,
     944,   384,    55,   888,   465,   466,   467,   644,  1513,   470,
     300,   705,   475,  1472,   964,   952,   747,   748,   852,  1179,
    1180,  1181,  1094,   602,  1073,  1633,   302,    55,   364,   440,
    1117,   303,  1118,  1147,  1192,  1095,   757,   612,  1701,  1044,
    1148,   614,   946,   364,    18,    19,    55,   888,   394,  1034,
     218,  1096,   274,   220,  1585,   687,     4,  1770,     5,  1767,
    1024,   615,   221,   861,   419,   688,   965,  1403,  1073,  1768,
     722,  1769,  1030,   573,  1173,   603,   604,  1159,     3,   862,
     130,     4,   445,     5,   221,   131,   132,     3,    55,   574,
       4,  1790,     5,    34,  1791,   221,  1584,   727,   396,  1389,
     397,   133,    35,     6,     7,     8,     9,   863,    36,   833,
     834,   835,     6,     7,     8,     9,   757,  1398,   828,   829,
     214,   218,   488,   489,   220,  1390,   313,   975,   618,   619,
       3,   209,    37,     4,  1430,     5,   218,  1155,   422,   220,
     423,   976,   214,  1027,   723,  1119,   715,   716,   717,   453,
    1156,   423,  1157,   214,  1764,     6,     7,     8,     9,  1514,
     746,  1515,   724,   905,  1590,  1097,   454,   223,   757,  1143,
     743,  1591,   580,  1391,   750,  1392,   581,  1378,   747,   748,
    1379,   977,  1068,   744,   757,   585,  1673,     3,  1020,   223,
       4,  1284,     5,   213,   628,   978,  1285,  1393,   852,   745,
     223,  1679,  1436,   753,  1105,  1120,  1680,  1592,   582,   583,
     757,   620,     6,     7,     8,     9,   904,   586,   587,   889,
     588,   490,   491,   916,   773,   492,   904,   904,   853,   217,
     150,   151,   152,   629,   630,   631,   221,     4,   576,     5,
     221,  1593,   858,  1276,  1822,  1394,  1081,  1666,   577,   578,
    1659,  1228,  1670,  1516,  1517,  1518,  1519,   209,     3,  1277,
    1104,     4,   859,     5,   860,   905,   905,   905,   905,   905,
     852,  1339,   905,   606,   933,   934,   935,   287,   288,  1082,
    1297,  1298,   289,     6,     7,     8,     9,  1304,  1320,   908,
    1542,   895,   850,  1083,   214,   909,   905,  1400,   214,  1401,
     699,   700,  1328,   948,   636,   607,   608,   278,  1334,  1594,
    1336,  1338,   447,   448,  1543,  1544,   905,   646,  1111,   637,
    1112,   889,   889,   889,   889,   889,   213,     4,   889,     5,
     647,  1654,   919,   609,   956,   895,   920,   648,  1084,   921,
     638,   223,   484,   485,   486,   223,   639,     4,   221,     5,
    1661,     3,   889,  -702,     4,   649,     5,   765,   922,  1252,
     224,   650,   217,   225,  1649,  1650,  1651,  1652,   504,   505,
     506,   508,   889,   509,   510,   511,     6,     7,     8,     9,
    1073,   757,   224,   953,     3,   225,  1085,     4,   923,     5,
     757,   501,   502,   224,   640,   641,   225,  1545,     4,  1595,
       5,  1164,  1659,  -245,  1165,   954,   214,   226,  1395,     6,
       7,     8,     9,  1646,  1647,  1648,   955,  1546,  1547,   221,
    1067,   256,   257,   258,    18,    19,   761,   762,  1460,   368,
     856,   857,  1133,   757,   221,   966,  1135,  1590,   567,   135,
     368,   136,  1059,  1060,  1591,  1044,   137,  1252,   138,   972,
     891,  1447,   139,   223,   568,   766,   767,   768,   769,   770,
     891,   891,   218,   569,  1067,   220,   842,   843,   844,   570,
     571,   967,   850,    34,   747,   748,  1492,   214,  1493,  1156,
    1592,  1157,    35,  1000,   150,   151,   152,  1001,    36,  1013,
     757,   140,   214,   141,  1711,  1712,  1713,  1014,  1497,  1106,
    1107,     3,  1015,  1402,     4,  1016,     5,  1018,  1802,   150,
     151,   152,    37,   213,  1593,  1105,  1105,  1105,  1105,  1105,
       3,  1105,  1105,     4,   223,     5,     6,     7,     8,     9,
    1314,  1314,  1150,  1151,   224,  1216,  1217,   225,   224,   223,
    1040,   225,  1307,   693,   850,     6,     7,     8,     9,   217,
    1218,  1219,   694,   695,   753,  1269,   696,   697,   905,   905,
     905,   905,   905,   905,   905,  1045,   905,   905,   833,   834,
     835,  1104,  1104,  1104,  1104,  1104,  1046,  1104,  1104,  1574,
    1049,   226,  1594,   843,   844,   226,  1313,  1313,  1034,  1814,
    1614,  1615,  1616,  1617,  1618,   218,  1423,  1424,   220,   213,
    -447,   213,  1538,  1539,     3,  1205,  1050,     4,  1051,     5,
     904,  1778,  1779,  1054,   889,   889,   889,   889,   889,   889,
     889,  1056,   889,   889,  1063,  1645,  1643,   457,  1644,     6,
       7,     8,     9,  1066,   213,   217,     3,   217,  1206,     4,
    1077,     5,    18,    19,  1315,  1316,   224,  1078,  1079,   225,
    1658,  1101,  1088,  1108,   757,  1340,  1342,  1358,  1366,  1384,
    1396,     6,     7,     8,     9,   979,   980,   981,   982,   758,
     217,  1102,  1674,   732,  1089,  1400,  1665,  1401,   905,  1090,
    1343,  1359,  1367,  1385,  1397,  1109,  1110,   757,  1115,   905,
    1642,    34,  -905,   368,  1207,  1208,  1209,  1210,  1211,  1212,
      35,   426,   428,   430,   432,  1813,    36,  -906,  1068,   535,
    1121,   536,   904,   904,   904,   904,   904,   224,   213,   904,
     225,  1122,  1431,  1482,  1437,  1442,  1123,  1448,  1124,   537,
      37,  1126,   224,   905,   889,   225,  1127,   538,   539,   540,
     541,  1132,  1134,   904,  1149,   889,  1432,   213,  1438,  1443,
    1152,  1449,  1154,  1153,   217,  1551,  1552,  1553,    62,  1554,
     221,  1158,  1162,   904,   368,   747,   748,  1024,  1166,   916,
    1252,  1481,     3,  1174,  1175,     4,  1067,     5,  1176,   368,
    1024,  1177,   218,   217,  1027,   220,  1178,  1692,   213,   889,
    1186,  1187,  1525,  1188,  1189,   611,  1190,     6,     7,     8,
       9,  1191,  1196,  1222,   757,  1044,   612,   707,   613,   708,
     364,   709,   710,  1214,  1229,  1215,  1220,   386,   214,   711,
     712,   390,  1812,   757,   217,  1221,   614,  1224,  1230,  1231,
     615,  1232,  1240,   616,   861,  1260,   410,   386,   213,  1237,
    1251,  1810,  1258,  1262,   891,  1266,  1283,  1288,  1290,  1520,
    1534,  1293,   713,   438,  1302,   213,  1289,  1528,  1529,  1530,
    1531,  1532,  1582,   459,  1296,   223,  1027,  1534,   218,  1291,
     218,   220,   213,   220,   217,  1557,  1558,  1559,    18,    19,
     617,  1402,   477,  1310,  1311,  1312,  1327,  1566,  1567,   483,
    1335,   217,  1415,   221,   364,  1358,  1366,  1384,  1396,   730,
     730,  1583,  1411,   218,  1412,  1416,   220,   757,   217,  1413,
    1417,  1422,  1429,   618,   619,  1586,  1596,  1603,  1418,  1359,
    1367,  1385,  1397,   364,   213,  1811,  1454,    34,  1435,  1459,
    1505,  1507,  1507,  1510,  1455,  1468,    35,  1465,  1478,  1587,
    1597,  1604,    36,  1044,  1483,  1477,   891,   891,   891,   891,
     891,   214,  1484,   891,  1485,  1486,  1488,  1578,  1490,   213,
     217,  1501,  1502,  1512,   364,   382,    37,   381,  1526,  1527,
    1537,  1627,   513,   514,  1541,   739,  1563,   891,  1568,  1569,
     515,   516,   517,   518,   519,  1620,  1579,   218,  1580,  1581,
     220,   382,   558,   381,   559,   217,   620,   891,   223,  1672,
    1607,  1613,  1622,  1584,  1625,   904,   904,   904,   904,   904,
     904,   904,   560,   904,   904,  1630,   218,  1634,  1635,   220,
     561,   562,  1655,   563,  1656,  1657,  1638,  1640,  -861,  1653,
    -861,  1668,  1682,   564,   565,  1676,  1684,  1678,  1660,  1686,
    1688,  1693,  1687,  1695,  1662,   905,  1700,   461,   364,  1689,
    1698,  1664,   729,   729,  1667,   548,   549,   218,   224,  1697,
     220,   225,    18,    19,  1586,  1596,  1603,  1718,  1703,   550,
    1706,   551,   552,   553,  1744,   757,  1707,   213,  1708,  1753,
     221,   290,   291,   292,  1469,  1470,   295,  1709,  1587,  1597,
    1604,  1710,  1757,  1834,   554,   555,   556,   213,  1737,  1714,
    1742,   889,  1715,  1716,  1717,   226,  1756,   218,  1745,  1760,
     220,    34,  1789,   217,  1763,  1771,  1772,  1773,  1794,   213,
      35,  1820,  1816,  1798,   218,   904,    36,   220,   213,  1705,
    1821,  1719,  1824,   217,  1842,    70,   904,   927,   214,  1406,
    1534,   218,  1565,  -861,   220,  1721,   463,  1841,  1823,  1720,
      37,  1774,  1776,  1775,  1817,   217,  1777,  1766,  1738,   406,
    1743,    18,    19,  1509,   217,   924,   221,   412,   221,  1496,
    1746,  1747,  1748,  1749,  1750,  1751,  1752,  1080,  1754,  1637,
     904,  1093,  1628,   749,  1610,   223,  1125,   213,   926,  1801,
    1765,   224,  1299,   218,   225,  1301,   220,  1300,  1318,  1534,
    1131,   221,  1321,  -861,   728,   468,  1137,  1197,  1815,  1281,
      34,  1337,  1782,  1461,  1784,  1785,  1786,  1787,  1788,    35,
      18,    19,  1742,   217,   214,    36,   214,   691,   218,  1479,
    1476,   220,   213,   936,   938,   915,   455,   939,   226,   891,
     891,   891,   891,   891,   891,   891,  1672,   891,   891,    37,
    1843,   937,   896,   364,   737,  1342,  1366,  1384,  1396,   214,
     999,   741,   742,  1431,  1437,  1442,  1448,  1204,   217,    34,
    1818,   223,  1819,   223,     0,     0,     0,     0,    35,  1343,
    1367,  1385,  1397,     0,    36,   221,  1827,  1432,  1438,  1443,
    1449,  1829,  1830,  1831,  1832,  1833,  1586,  1596,  1603,  1837,
    1838,  1839,  1840,     0,     0,     0,   223,     0,    37,     0,
       0,     0,     0,     0,   221,  1844,     0,   548,   549,     0,
    1587,  1597,  1604,  1845,  1846,  1847,     0,     0,     0,     0,
       0,   550,     0,   551,   552,   553,     3,     0,     0,     4,
       0,     5,     0,   214,     0,     0,   218,     0,     3,   220,
       0,     4,     0,     5,     0,   221,   554,   555,   556,   891,
       0,     6,     7,     8,     9,     0,   218,     0,     0,   220,
     891,  1346,   214,     6,     7,     8,     9,     0,   224,     0,
    1347,   225,     0,     0,     0,  1348,  1373,  1349,   218,  1350,
     223,   220,     0,     0,     0,     0,     0,   218,     0,     0,
     220,     0,     0,     0,     3,   221,     0,     4,   364,     5,
       0,     0,     0,   214,   891,     0,     0,     0,     0,   223,
       0,     0,   221,     0,  1273,   226,     0,     0,     0,     6,
       7,     8,     9,  1374,  1375,  1376,  1377,     0,  1378,   221,
       0,  1379,     0,     0,     0,     3,     0,     0,     4,     3,
       5,     0,     4,     0,     5,     0,   218,     0,  1380,   220,
     223,     0,     0,   214,   224,     0,   224,   225,   471,   225,
       6,     7,     8,     9,     6,     7,     8,     9,     0,     0,
     214,     0,     0,    18,    19,     0,     0,  1373,     0,     0,
       3,   221,   904,     4,  1351,     5,     0,   214,     0,   224,
       0,   218,   225,     0,   220,     0,  1381,     0,     0,     0,
     223,   226,     0,   226,  1600,     6,     7,     8,     9,     0,
       0,  1344,  1361,  1371,  1387,  1399,   221,   223,     0,     0,
       0,  1590,    34,     0,  1374,  1375,  1376,  1377,  1591,  1378,
       0,    35,  1379,     0,   223,     0,   368,    36,     0,   214,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1380,
       0,     0,     0,     0,     0,     0,  1352,     0,     0,     0,
       0,    37,     0,     0,  1592,     0,     0,     0,  1382,   473,
       0,  1353,     0,   224,   214,     0,   225,  1433,     0,  1439,
    1444,     0,  1450,   300,    18,    19,   223,  1354,     0,     0,
    1600,     0,  1355,     0,  1356,     0,     0,  1381,  1593,   302,
       0,    88,   224,     0,   303,   225,     0,     0,    89,     0,
      90,     0,    91,     0,     0,    92,    93,    94,  1273,    95,
     368,   223,     0,     0,     0,  1601,     0,     0,     0,   757,
       0,     0,     0,    34,   221,     3,     0,     0,     4,     0,
       5,   757,    35,   224,     0,     0,   225,  1357,    36,   368,
       0,     0,     0,     0,   221,     0,     0,     0,     0,  1383,
       6,     7,     8,     9,     0,     0,  1594,     0,     0,  1382,
       0,     0,    37,  1373,     0,     0,   221,     0,     0,     0,
       0,     0,     0,     0,   300,   221,     0,     0,     0,     0,
     368,     0,   214,   224,     0,     0,   225,   757,     0,     0,
     302,     0,     0,     0,     0,   303,     0,     0,     0,     0,
     224,  1601,   214,   225,     0,  1602,   891,    73,     0,     0,
    1374,  1375,  1376,  1377,    74,  1378,    75,   224,  1379,     0,
     225,    76,    77,    78,   214,    79,     0,     0,   757,   223,
     226,     0,   757,   214,   221,  1380,     0,     0,     0,     0,
    1361,  1371,  1387,  1399,     0,     0,  1835,   226,     0,   223,
    1572,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1588,  1598,  1605,     0,   368,     0,     0,     0,     0,   224,
       0,   223,   225,   757,     0,     0,     0,     0,     0,   221,
     223,     0,     0,  1381,    50,     0,    96,     0,     0,     0,
       0,  1675,   214,     0,    61,    50,    50,    64,    64,    64,
      68,    97,     0,    50,   224,     3,     0,   225,     4,     0,
       5,     0,     0,     0,     0,     0,   226,    98,     0,     0,
       0,     0,    99,     0,   100,     0,     0,     0,     0,     0,
       6,     7,     8,     9,     0,     0,     0,   214,     0,   223,
       0,     0,     0,     0,  1400,     0,  1401,     0,     0,     0,
       0,   226,     0,     0,    50,  1382,     0,   389,    50,    64,
      64,    64,    68,     0,     0,     0,     0,     0,     0,    50,
     300,   403,   407,   409,    50,   413,    64,    64,   418,     0,
     403,   403,   403,   403,   223,    64,   302,     0,   435,     0,
      50,   303,     0,    64,    64,     0,    68,     0,     0,    64,
     985,     0,    80,     0,     0,     0,     0,     0,     0,  1588,
    1598,  1605,     0,     0,     0,     0,     0,    81,   476,    50,
      64,    64,   224,     0,    64,   225,    50,     0,   757,     0,
       0,     0,     0,    82,  1039,     0,  1041,     0,    83,     0,
      84,     0,   224,     0,     0,   225,  1804,     0,     0,     0,
       0,     0,  1057,  1058,     0,  1062,     0,     0,     0,  1064,
    1065,     0,     0,   986,   224,     3,     0,   225,     4,   368,
       5,     0,     0,   224,     0,     0,   225,     3,     0,     0,
       4,     0,     5,     0,  1098,     0,     0,  1100,     0,   226,
       6,     7,     8,     9,     0,     0,     3,     0,     0,     4,
    1346,     5,     6,     7,     8,     9,     0,     0,     0,  1347,
       0,   226,     0,     0,  1348,  1390,  1349,     0,  1350,     0,
     226,     6,     7,     8,     9,     0,     0,     0,     0,     0,
       0,     0,   224,   987,  1390,   225,   988,   989,   990,   991,
     992,   993,   994,   995,   996,   997,     0,     0,  1129,     0,
    1402,  1130,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1391,     0,  1392,     3,  1378,   776,     4,
    1379,     5,     0,     0,     0,     0,     0,   224,     0,   226,
     225,     0,  1391,     0,  1392,     0,  1378,  1393,     0,  1379,
       0,     6,     7,     8,     9,     0,     0,     0,     0,     0,
    1344,  1371,  1387,  1399,     0,     0,  1393,     0,  1433,  1439,
    1444,  1450,     0,     0,     0,   777,     0,  1160,  1161,     0,
       0,     0,     0,  1351,   368,     0,  1806,     0,     0,     0,
       0,     0,     0,     0,     0,  1394,     0,     0,     0,     0,
       0,  1588,  1598,  1605,     0,     0,     0,   149,   150,   151,
     152,     0,     0,     0,  1394,   870,     0,     0,  1724,   871,
       0,     0,     0,   872,     0,     0,     0,     0,     0,   873,
       0,     0,     0,   784,     0,  1542,  1600,     0,     0,     0,
       0,     0,     0,     0,     0,   874,     0,     0,     0,     0,
     875,     0,     0,   876,     0,  1352,     0,     0,   877,  1543,
    1544,   878,     0,     0,   879,   880,     0,     0,     0,   881,
    1353,     0,   882,     0,   883,     0,     0,     0,     0,     0,
       0,     0,     0,   950,     0,     0,  1354,     0,     0,     0,
      64,  1355,     0,  1356,     0,     0,   884,   885,     0,     0,
     957,     0,   958,     0,   959,  1239,   960,     0,     0,  1242,
       0,   961,     0,     0,   962,     0,   963,     0,  1255,  1256,
    1257,     0,     0,  1259,    64,  1261,     0,     0,   757,     0,
       0,     0,     0,     0,     0,  1267,     0,     0,     0,     0,
     757,     0,  1545,     0,     0,     0,  1570,     0,   787,     0,
       0,   788,   789,     0,     0,     0,     0,  1601,  1573,   757,
       0,     0,  1546,  1547,     0,     0,     0,     0,  1292,     0,
    1294,  1295,     0,     0,     0,     0,     0,  1805,   777,     0,
    1725,     0,     0,     0,  1308,     0,  1309,     0,     0,   791,
     792,     0,   886,     0,     0,  1317,  1726,  1319,     0,     0,
       0,  1727,     0,  1728,     0,     0,     0,     0,     0,     0,
       0,   150,   151,   152,     0,     0,   793,   794,   870,     0,
       0,     0,   871,     0,     0,     0,   872,     0,   313,   757,
     887,     0,   873,   209,     0,  -860,   784,  -860,     0,     0,
       0,     0,     0,     0,   984,     0,     0,  1836,     0,     0,
       0,     0,     0,     0,     0,     0,   876,     0,   985,     0,
       0,     0,   521,   522,     0,     0,   523,     3,     0,     0,
       4,     0,     5,     0,     0,     0,   524,   525,   526,   527,
     528,   529,   530,   531,   532,     0,     0,     0,     0,   145,
       0,     0,     6,     7,     8,     9,   146,   147,     0,     0,
     284,   148,   285,     0,     0,     0,     0,     0,     0,  1452,
    1453,     0,     0,     0,     0,     0,   286,     0,     0,     0,
       0,   986,     0,     0,     0,   533,   287,   288,     0,  1462,
       0,   289,     0,     0,     0,  1467,     0,     0,     0,     0,
       0,     0,   290,   291,   292,   293,   294,   295,     0,     0,
    -860,   787,     0,     0,   788,   789,     0,  1362,     0,     0,
       0,   296,  1487,   297,     0,     0,   149,   150,   151,   152,
       0,     0,   153,     0,   154,     0,     0,  1363,   155,  1489,
       0,  1491,   156,     0,     0,     0,     0,     0,   157,     0,
       0,   987,   791,   792,   988,   989,   990,   991,   992,   993,
     994,   995,   996,   997,   158,     0,   590,     0,     0,   159,
    -860,     0,   160,     0,     0,   591,     0,   161,     0,     0,
     162,     0,     0,   163,   164,  1364,     0,     0,   165,     0,
     592,   166,     0,   167,   593,     0,   209,     0,   594,   595,
       0,     0,     0,   596,   597,   598,   599,   600,     0,     0,
       0,     0,     0,     0,     0,   168,   169,     0,   170,   171,
     172,   173,     0,     0,     0,     0,     0,   174,   175,     0,
       0,   176,   177,   298,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,  1002,  1003,   299,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1004,     0,
       0,     0,   300,     0,     0,     0,  1005,     0,     0,     0,
       0,     0,   301,  1611,     0,     0,     0,     0,   302,     0,
       0,     0,  1006,   303,     0,     0,     0,  1623,     0,     0,
       0,     0,   201,   202,     0,   304,     0,     0,   305,   306,
     307,   308,     0,     0,     0,   309,     0,  1629,     0,   310,
     311,   203,     0,     0,     0,   204,   205,     0,     0,     0,
     757,     0,     0,     0,   312,     0,     0,   206,   207,     3,
       0,     0,     4,     0,     5,     0,     0,   313,  1365,   208,
       0,     0,   209,     0,     0,     0,  1193,  1194,  1195,     0,
       0,   145,     0,     0,     6,     7,     8,     9,   146,   147,
       0,     0,   284,   148,   285,     0,     0,     0,  1007,  1008,
    1009,   670,     0,     0,     0,     0,     0,     0,   286,     0,
       0,     0,     0,     0,   680,   681,   682,     0,   287,   288,
       0,     0,     0,   289,     0,     0,   521,   522,     0,     0,
     523,     0,     0,     0,   290,   291,   292,   293,   294,   295,
     524,   525,   526,   527,   528,   529,   530,   531,   532,  1362,
       0,     0,     0,   296,     0,   297,     0,     0,   149,   150,
     151,   152,     0,     0,   153,     0,   154,     0,     0,  1363,
     155,     0,     0,     0,   156,     0,     0,     0,     0,  1699,
     157,     0,     0,     0,     0,     0,     0,     0,     0,   533,
       0,     0,     0,     0,     0,     0,   158,     0,     0,     0,
       0,   159,     0,     0,   160,     0,     0,     0,     0,   161,
       0,     0,   162,     0,     0,   163,   164,  1364,     0,     0,
     165,     0,    10,   166,     0,   167,     0,     0,     0,    11,
       0,    12,     0,    13,     0,     0,    14,    15,    16,     0,
      17,     0,     0,     0,    18,    19,     0,   168,   169,     0,
     170,   171,   172,   173,     0,     0,     0,     0,     0,   174,
     175,     0,     0,   176,   177,   298,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,     0,     0,   299,
       0,     0,     0,    34,     0,     0,     0,     0,     0,     0,
       0,     0,    35,     0,   300,     0,     0,     0,    36,     0,
       0,     0,     0,     0,   301,     0,     0,     0,     0,     0,
     302,     0,     0,     0,     0,   303,     0,     0,     0,     0,
       0,     0,    37,     0,   201,   202,     0,   304,     0,     0,
     305,   306,   307,   308,     0,     0,     0,   309,     0,     0,
       0,   310,   311,   203,     0,     0,     0,   204,   205,     0,
       3,     0,   757,     4,     0,     5,   312,     0,     0,   206,
     207,     0,     0,     0,     0,     0,     0,     0,     0,   313,
    1571,   208,   145,     0,   209,     6,     7,     8,     9,   146,
     147,     0,     0,   284,   148,   285,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   286,
       0,     0,     0,     0,     0,     0,     0,    38,     0,   287,
     288,     0,     0,     0,   289,     0,     0,     0,     0,     0,
       0,     0,    39,     0,     0,   290,   291,   292,   293,   294,
     295,     0,     0,     0,     0,     0,     0,     0,    40,     0,
    1362,     0,     0,    41,   296,    42,   297,     0,     0,   149,
     150,   151,   152,     0,     0,   153,     0,   154,     0,     0,
    1363,   155,     0,     0,     0,   156,     0,     0,     0,     0,
       0,   157,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   158,     0,     0,
       0,     0,   159,     0,     0,   160,     0,     0,     0,     0,
     161,     0,     0,   162,     0,     0,   163,   164,  1364,     0,
       0,   165,     0,     0,   166,     0,   167,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   168,   169,
       0,   170,   171,   172,   173,     0,     0,     0,     0,     0,
     174,   175,     0,     0,   176,   177,   298,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,     0,     0,
     299,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   300,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   301,     0,     0,     0,     0,
       0,   302,     0,     0,     0,     0,   303,     0,     0,     0,
       4,     0,     5,     0,     0,   201,   202,     0,   304,     0,
       0,   305,   306,   307,   308,     0,     0,     0,   309,   145,
       0,     0,   310,   311,   203,     0,   146,   147,   204,   205,
     284,   148,   285,   757,     0,     0,     0,   312,     0,     0,
     206,   207,     0,     0,     0,     0,   286,     0,     0,     0,
     313,  1803,   208,     0,     0,   209,   287,   288,     0,     0,
       0,   289,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   290,   291,   292,   293,   294,   295,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   296,     0,   297,     0,     0,   149,   150,   151,   152,
       0,     0,   153,     0,   154,     0,     0,     0,   155,     0,
       0,     0,   156,     0,     0,     0,     0,     0,   157,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   158,     0,     0,     0,     0,   159,
       0,     0,   160,     0,     0,     0,     0,   161,     0,     0,
     162,     0,     0,   163,   164,     0,     0,     0,   165,     0,
       0,   166,     0,   167,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   168,   169,     0,   170,   171,
     172,   173,     0,     0,     0,     0,     0,   174,   175,     0,
       0,   176,   177,   298,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,     0,     0,   299,     0,     0,
       0,     0,     0,     0,     0,   775,     0,     0,     0,     0,
       0,     0,   300,     0,     0,     0,     0,     0,     0,     0,
       0,   776,   301,   145,     0,     0,     0,     0,   302,     0,
       0,   147,     0,   303,     0,   148,     0,     0,     0,     0,
       0,     0,   201,   202,     0,   304,     0,     0,   305,   306,
     307,   308,     0,     0,     0,   309,     0,     0,     0,   310,
     311,   203,     0,     0,     0,   204,   205,     0,   777,     0,
       0,     0,     0,     0,   312,     0,     0,   206,   207,     0,
       0,     0,   778,     0,   779,     0,     0,   313,  1480,   208,
       0,     0,   209,     0,     0,     0,     0,     0,     0,     0,
     149,   150,   151,   152,     0,     0,   153,     0,   780,     0,
       0,     0,   781,     0,     0,     0,   782,     0,     0,     0,
       0,     0,   783,     0,     0,     0,   784,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   158,     0,
       0,     0,     0,   159,     0,     0,   785,     0,     0,     0,
       0,   161,     0,     0,   162,     0,     0,   163,   164,     0,
       0,     0,   165,     0,     0,   166,     0,   167,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   168,
     169,     0,   786,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,     0,
       0,   200,     0,  1036,     0,     0,     0,     0,     0,     0,
       0,   787,     0,     0,   788,   789,     0,     0,     0,   776,
       0,   145,     0,     0,     0,     0,     0,   790,     0,   147,
       0,     0,     0,   148,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   201,   202,     0,     0,
       0,     0,   791,   792,     0,     0,     0,     0,     0,   652,
       0,     0,     0,     0,     0,   203,   777,     0,     0,   204,
     205,     0,     0,     0,     0,     0,     0,     0,     0,   793,
     794,     0,   658,     0,     0,   653,     0,     0,   654,     0,
       0,     0,     0,   795,     0,     0,   209,     0,   149,   150,
     151,   152,     0,     0,   153,   655,   780,     0,     0,     0,
     781,     0,     0,     0,   782,     0,     0,     0,     0,     0,
    1037,     0,     0,     0,   784,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   158,     0,     0,     0,
       0,   159,     0,     0,  1038,     0,     0,     0,     0,   161,
       0,     0,   162,     0,     0,   163,   164,     0,     0,     0,
     165,     0,     0,   166,     0,   167,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   168,   169,     0,
     786,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   656,     0,   200,
       0,  1099,     0,     0,   201,   202,     0,     0,     0,   787,
       0,     0,   788,   789,   657,     0,     0,   776,     0,   145,
       0,     0,     0,     0,     0,     0,     0,   147,     0,     0,
       0,   148,     0,     0,     0,     0,     0,     0,     0,     0,
     658,     0,     0,     0,   201,   202,     0,     0,     0,     0,
     791,   792,     0,     0,     0,     0,     0,   736,     0,     0,
       0,     0,     0,   203,   777,     0,     0,   204,   205,     0,
       0,     0,     0,     0,     0,     0,     0,   793,   794,     0,
     658,     0,     0,   653,     0,     0,   654,     0,     0,     0,
       0,   795,     0,     0,   209,     0,   149,   150,   151,   152,
       0,     0,   153,   655,   780,     0,     0,     0,   781,     0,
       0,     0,   782,     0,     0,     0,     0,     0,  1037,     0,
       0,     0,   784,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   158,     0,     0,     0,     0,   159,
       0,     0,  1038,     0,     0,     0,     0,   161,     0,     0,
     162,     0,     0,   163,   164,     0,     0,     0,   165,     0,
       0,   166,     0,   167,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   168,   169,     0,   786,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   656,     0,   200,     0,  1128,
       0,     0,   201,   202,     0,     0,     0,   787,     0,     0,
     788,   789,   657,     0,     0,   776,     0,   145,     0,     0,
       0,     0,     0,     0,     0,   147,     0,     0,     0,   148,
       0,     0,     0,     0,     0,     0,     0,     0,   658,     0,
       0,     0,   201,   202,     0,     0,     0,     0,   791,   792,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   203,   777,     0,     0,   204,   205,     0,     0,     0,
       0,     0,     0,     0,     0,   793,   794,     0,   658,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   795,
       0,     0,   209,     0,   149,   150,   151,   152,     0,     0,
     153,     0,   780,     0,     0,     0,   781,     0,     0,     0,
     782,     0,     0,     0,     0,     0,  1037,     0,     0,     0,
     784,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   158,     0,     0,     0,     0,   159,     0,     0,
    1038,     0,     0,     0,     0,   161,     0,     0,   162,     0,
       0,   163,   164,     0,     0,     0,   165,     0,     0,   166,
       0,   167,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   168,   169,     0,   786,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   178,   179,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,     0,     0,   200,     0,  1241,     0,     0,
       0,     0,     0,     0,     0,   787,     0,     0,   788,   789,
       0,     0,     0,   776,     0,   145,     0,     0,     0,     0,
       0,     0,     0,   147,     0,     0,     0,   148,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     201,   202,     0,     0,     0,     0,   791,   792,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   203,
     777,     0,     0,   204,   205,     0,     0,     0,     0,     0,
       0,     0,     0,   793,   794,     0,   658,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   795,     0,     0,
     209,     0,   149,   150,   151,   152,     0,     0,   153,     0,
     780,     0,     0,     0,   781,     0,     0,     0,   782,     0,
       0,     0,     0,     0,  1037,     0,     0,     0,   784,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     158,     0,     0,     0,     0,   159,     0,     0,  1038,     0,
       0,     0,     0,   161,     0,     0,   162,     0,     0,   163,
     164,     0,     0,     0,   165,     0,     0,   166,     0,   167,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   168,   169,     0,   786,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,     0,     0,   200,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   787,     0,     0,   788,   789,   864,   865,
     866,   867,   868,   869,     0,     0,     0,     0,     0,     0,
     776,     0,   849,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   201,   202,
       0,     0,     0,     0,   791,   792,     0,   738,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   203,     0,     0,
       0,   204,   205,     0,     0,     0,     0,   777,     0,   662,
     663,   793,   794,   664,   658,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   795,     0,     0,   209,     0,
     665,     0,     0,     0,     0,     0,     0,     0,     0,   149,
     150,   151,   152,     0,     0,     0,     0,   870,     0,     0,
       0,   871,     0,     0,     0,   872,     0,     0,     0,     0,
       0,   873,     0,     0,     0,   784,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   874,     0,     0,
       0,     0,   875,     0,   739,   876,     0,     0,     0,     0,
     877,     0,     0,   878,     0,     0,   879,   880,     0,     0,
       0,   881,     0,     0,   882,     0,   883,     0,   666,   776,
       0,   145,     0,     0,     0,     0,     0,     0,     0,   147,
       0,     0,     0,   148,     0,     0,     0,     0,   884,   885,
       0,     0,   667,   668,   669,   670,   671,   672,   740,   673,
     674,   675,   676,   677,   678,   679,     0,     0,   680,   681,
     682,     0,     0,     0,     0,     0,   777,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   683,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     787,     0,     0,   788,   789,     0,     0,     0,   149,   150,
     151,   152,     0,     0,   153,     0,   780,     0,     0,     0,
     781,     0,     0,     0,   782,     0,     0,     0,     0,     0,
    1037,     0,     0,     0,   784,     0,     0,     0,     0,   662,
     663,   791,   792,   664,   886,     0,   158,     0,     0,     0,
       0,   159,     0,     0,  1038,     0,     0,     0,     0,   161,
     665,     0,   162,     0,     0,   163,   164,     0,   793,   794,
     165,     0,     0,   166,     0,   167,     0,     0,     0,     0,
     313,     0,   887,     0,     0,   209,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   168,   169,     0,
     786,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,     0,   666,   200,
       0,     0,   776,   910,   849,     0,     0,     0,     0,   787,
       0,     0,   788,   789,     0,     0,     0,     0,     0,     0,
       0,     0,   667,   668,   669,   670,   671,   672,     0,   673,
     674,   675,   676,   677,   678,   679,     0,     0,   680,   681,
     682,     0,     0,     0,   201,   202,     0,     0,     0,   777,
     791,   792,     0,     0,     0,     0,     0,     0,     0,   683,
       0,     0,     0,   203,     0,     0,     0,   204,   205,     0,
       0,     0,     0,   776,     0,   849,     0,   793,   794,     0,
     658,   149,   150,   151,   152,     0,     0,     0,     0,   870,
       0,   795,     0,   871,   209,     0,     0,   872,     0,     0,
       0,     0,     0,   873,     0,     0,     0,   784,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   874,
     777,     0,     0,     0,   875,     0,     0,   876,     0,     0,
       0,     0,   877,     0,     0,   878,     0,     0,   879,   880,
       0,     0,     0,   881,     0,     0,   882,     0,   883,     0,
       0,     0,   149,   150,   151,   152,     0,     0,     0,     0,
     870,     0,     0,     0,   871,     0,     0,     0,   872,     0,
     884,   885,     0,     0,   873,     0,     0,     0,   784,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     874,     0,     0,     0,     0,   875,     0,     0,   876,     0,
       0,     0,     0,   877,     0,     0,   878,     0,     0,   879,
     880,     0,     0,     0,   881,     0,     0,   882,     0,   883,
       0,     0,   787,     0,     0,   788,   789,     0,     0,     0,
       0,     0,     0,     0,     0,   776,     0,     0,     0,     0,
       0,   884,   885,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   791,   792,     0,   886,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   777,     0,     0,     0,     0,     0,     0,     0,
     793,   794,     0,   787,     0,     0,   788,   789,     0,     0,
       0,     0,   911,     0,   887,     0,     0,   209,     0,     0,
       0,     0,     0,     0,   149,   150,   151,   152,     0,     0,
       0,     0,   870,     0,     0,     0,   871,     0,     0,     0,
     872,     0,     0,     0,   791,   792,   873,   886,     0,     0,
     784,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   874,     0,     0,     0,     0,   875,     0,     0,
     876,   793,   794,     0,     0,   877,     0,     0,   878,     0,
       0,   879,   880,   313,     0,   887,   881,     0,   209,   882,
       0,   883,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   145,     0,     0,     0,     0,     0,
       0,   146,   147,   884,   885,   284,   148,   285,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   286,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   287,   288,     0,     0,     0,   289,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   290,   291,   292,
     293,   294,   295,     0,     0,   787,     0,     0,   788,   789,
       0,     0,     0,     0,     0,     0,   296,     0,   297,     0,
       0,   149,   150,   151,   152,     0,     0,   153,     0,   154,
       0,     0,     0,   155,     0,     0,     0,   156,     0,     0,
       0,     0,     0,   157,     0,     0,   791,   792,     0,   886,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   158,
       0,     0,     0,     0,   159,     0,     0,   160,     0,     0,
       0,     0,   161,   793,   794,   162,     0,     0,   163,   164,
       0,     0,     0,   165,     0,     0,   166,   887,   167,     0,
     209,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     168,   169,     0,   170,   171,   172,   173,     0,     0,     0,
       0,     0,   174,   175,     0,     0,   176,   177,   298,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
       0,     0,   299,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   300,     0,     0,
       0,     0,   145,     0,     0,     0,     0,   301,     0,   146,
     147,     0,     0,   302,   148,     0,     0,     0,   303,     0,
       0,     0,     0,     0,     0,     0,     0,   201,   202,     0,
     304,     0,     0,   305,   306,   307,   308,     0,     0,     0,
     309,     0,     0,     0,   310,   311,   203,     0,     0,     0,
     204,   205,     0,     0,     0,     0,     0,     0,     0,   312,
       0,     0,   206,   207,     0,     0,     0,     0,     0,     0,
       0,     0,   313,     0,   208,     0,     0,   209,     0,   149,
     150,   151,   152,     0,     0,   153,     0,   154,     0,     0,
       0,   155,     0,     0,     0,   156,     0,     0,     0,     0,
       0,   157,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   158,     0,     0,
       0,     0,   159,     0,     0,   160,     0,     0,     0,     0,
     161,     0,     0,   162,     0,     0,   163,   164,     0,     0,
       0,   165,     0,     0,   166,     0,   167,     0,     0,     0,
       0,     0,     0,   145,     0,     0,     0,     0,     0,     0,
     146,   147,     0,     0,     0,   148,     0,     0,   168,   169,
       0,   170,   171,   172,   173,     0,     0,     0,     0,     0,
     174,   175,     0,     0,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,     0,     0,
     200,     0,     0,     0,  1722,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     149,   150,   151,   152,     0,     0,   153,     0,   154,     0,
       0,     0,   155,     0,     0,     0,   156,     0,     0,     0,
       0,     0,   157,     0,     0,   201,   202,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   158,     0,
       0,     0,     0,   159,   203,     0,   160,     0,   204,   205,
       0,   161,     0,     0,   162,     0,     0,   163,   164,     0,
     206,   207,   165,     0,     0,   166,     0,   167,     0,     0,
     313,     0,   208,     0,   145,   209,     0,     0,     0,     0,
       0,   146,   147,     0,     0,     0,   148,     0,     0,   168,
     169,     0,   170,   171,   172,   173,     0,     0,     0,     0,
       0,   174,   175,     0,     0,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,     0,
       0,   200,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   149,   150,   151,   152,     0,     0,   153,     0,   154,
       0,     0,     0,   155,     0,     0,     0,   156,     0,     0,
       0,     0,     0,   157,     0,     0,   201,   202,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   158,
       0,     0,     0,     0,   159,   203,     0,   160,     0,   204,
     205,     0,   161,     0,     0,   162,     0,     0,   163,   164,
       0,   206,   207,   165,     0,     0,   166,     0,   167,     0,
       0,     0,     0,   208,     0,     0,   209,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     168,   169,     0,   170,   171,   172,   173,     0,     0,     0,
       0,     0,   174,   175,     0,     0,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
       0,     0,   200,     0,     0,     0,     0,   145,     0,     0,
       0,     0,     0,     0,     0,   147,     0,     0,     0,   148,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   201,   202,     0,
       0,     0,   777,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   203,     0,     0,     0,
     204,   205,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   206,   207,   149,   150,   151,   152,     0,     0,
     153,     0,   780,     0,   208,     0,   781,   209,     0,     0,
     782,     0,     0,     0,     0,     0,  1037,     0,     0,     0,
     784,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   158,     0,     0,     0,     0,   159,     0,     0,
    1038,     0,     0,     0,     0,   161,     0,     0,   162,     0,
       0,   163,   164,     0,     0,     0,   165,     0,     0,   166,
       0,   167,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   168,   169,     0,   786,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   178,   179,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,     0,     0,   200,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   787,     0,     0,   788,   789,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     201,   202,     0,     0,     0,     0,   791,   792,     0,     0,
       0,     0,     2,     3,     0,     0,     4,     0,     5,   203,
       0,     0,     0,   204,   205,     0,     0,     0,     0,     0,
       0,     0,     0,   793,   794,     0,   658,     0,     6,     7,
       8,     9,     0,     0,     0,     0,     0,   795,    10,     0,
     209,     0,     0,     0,     0,    11,     0,    12,     0,    13,
       0,     0,    14,    15,    16,     0,    17,     0,     0,     0,
      18,    19,    20,     0,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,     0,     0,   777,
       0,     0,     0,     0,     0,     0,     0,   290,   291,   292,
    1469,  1470,   295,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  -335,     0,     0,     0,     0,     0,    34,
       0,   149,   150,   151,   152,     0,     0,     0,    35,   870,
       0,     0,     0,   871,    36,     0,     0,   872,     0,     0,
       0,     0,     0,   873,     0,     0,     0,   784,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    37,   874,
       0,     0,     0,     0,   875,     0,     0,   876,     0,     0,
       0,     0,   877,     0,     0,   878,     0,     0,   879,   880,
       0,     0,     0,   881,     0,     0,   882,     0,   883,     0,
       0,     0,     0,     0,   777,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     884,   885,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   149,   150,   151,   152,
       0,     0,     0,     0,   870,     0,     0,     0,   871,     0,
       0,     0,   872,    38,     0,     0,     0,     0,   873,     0,
       0,     0,   784,     0,     0,     0,     0,     0,    39,     0,
       0,     0,   787,     0,   874,   788,   789,     0,     0,   875,
       0,     0,   876,     0,    40,     0,     0,   877,     0,    41,
     878,    42,     0,   879,   880,     0,     0,     0,   881,     0,
       0,   882,     0,   883,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   791,   792,     0,   886,     0,     0,     0,
       0,     0,     0,     0,     0,   884,   885,     0,     0,   104,
       0,     0,     0,     0,     0,     0,   105,   106,   107,   108,
     793,   794,   109,   110,     0,   111,   112,   113,     0,   114,
       0,     0,     0,     0,   887,     0,     0,   209,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   787,     0,     0,
     788,   789,     0,     0,     0,     0,     0,     0,   115,     0,
     116,   117,   118,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   791,   792,
       0,   886,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   793,   794,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   887,
       0,     0,   209,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   119,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   120,
       0,     0,     0,     0,   121,   122,   123,   124,     0,     0,
       0,     0,     0,     0,     0,   125,     0,     0,     0,     0,
     126,     0,   127,   128
};

static const yytype_int16 yycheck[] =
{
       1,   316,     3,    52,    66,    30,    66,   294,   754,   340,
     360,  1170,   346,   319,    63,   392,    32,    30,   394,   391,
     370,   371,   393,   360,     1,   204,   208,    52,   284,  1171,
    1068,  1069,   374,   370,   371,  1178,  1074,  1175,    63,   416,
     360,    30,   721,   419,  1027,    46,  1269,  1176,  1191,  1177,
    1134,  1237,  1390,    54,  1413,   311,   433,    58,    15,    16,
    1220,  1221,  1411,    52,   106,  1412,   108,   109,  1393,  1136,
     112,     4,   114,     7,    63,   117,   118,   333,   757,   121,
     122,   123,   124,  1324,   390,    43,   128,   766,   795,   131,
     132,   770,     7,     4,     7,   858,  1245,   139,    37,   101,
       7,     8,     9,   859,    94,     1,  1144,   862,     4,     7,
       6,    76,    77,    82,   101,   102,   103,     5,   718,    76,
      77,    78,  1271,  1272,   720,   101,   860,   101,   100,    23,
      26,    27,    28,    29,    23,    92,    93,    94,  1690,     1,
     101,    48,     4,    50,     6,   102,    22,   721,   101,   102,
     103,  1609,    59,   110,   111,    23,   111,    64,   719,   116,
    1592,    68,  1608,  1322,    26,    27,    28,    29,   101,   856,
     857,  1247,    20,   298,    60,    37,   301,   248,   263,   204,
     137,   138,   123,   208,   141,   108,   109,   111,   102,   112,
     111,   114,    55,   122,   117,   118,    56,     8,   121,   122,
     123,   124,   248,    52,   100,   128,   127,   131,   131,   132,
      96,   132,   133,   142,    63,   204,   139,   146,     5,   208,
     144,    13,    20,   101,   100,   101,  1375,  1376,   684,  1388,
      20,   122,    56,   293,   294,    47,   321,    87,    47,   255,
      90,    52,  1391,     1,    51,   261,     4,  1799,     6,  1408,
     321,    87,    82,   101,    90,   146,     1,   212,   213,     4,
     939,     6,    32,    33,    45,   156,   101,  1409,    26,    27,
      28,    29,   320,   249,    30,   321,   197,    30,     4,   360,
       6,    26,    27,    28,    29,   741,   346,  1042,   249,   370,
     371,   316,   122,   265,    86,    40,    52,    42,   360,    52,
     229,   230,   209,   101,  1762,   320,   247,    63,   370,   371,
      63,   101,   716,   717,    55,  1761,   146,   286,   287,   288,
       8,  1753,   321,     1,   326,  1663,     4,   316,     6,   178,
     392,   321,   392,    91,   258,   360,   936,  1496,   387,   326,
     321,  1666,   938,   231,    43,   370,   371,    87,    26,    27,
      28,    29,   326,   402,   416,     4,   416,     6,   246,  1114,
     101,   326,   387,   321,    52,   939,  1045,  1046,   321,   265,
     266,   433,   130,   433,   262,     1,   937,   402,     4,   267,
       6,   129,   321,   312,  1722,  1461,   293,   294,   322,  1152,
     297,     1,  1459,   326,     4,  1636,     6,  1153,   387,  1724,
      26,    27,    28,    29,   754,  1112,   448,   322,   304,   322,
    1494,   322,  1635,   402,  1773,    82,    26,    27,    28,    29,
    1154,  1581,  1771,   314,   322,  1772,   322,   321,    39,    40,
      41,    42,   326,  1471,   322,   197,  1622,   326,   208,   302,
     303,  1590,   304,   319,   231,   305,   306,   307,   204,   298,
     326,   204,   208,   321,   304,   208,   297,    87,   326,   246,
     322,  1499,    73,  1150,  1151,    91,    55,   316,   304,   124,
      81,    82,    83,    84,   232,   262,     5,    88,   809,     8,
     267,   305,   306,   307,    37,    38,    97,    98,    99,   100,
     447,    55,   124,   104,   149,  1478,   403,    87,   238,   406,
     240,   246,   409,   197,   130,   231,   413,    82,    87,   120,
      55,   418,   101,   863,   125,   126,   127,   149,    87,   130,
     246,   306,   133,  1269,   481,   448,   265,   266,   862,   933,
     934,   935,   138,   111,  1280,   322,   262,   101,   387,    43,
      82,   267,    84,   863,   948,   151,   304,   122,  1632,   728,
     887,   142,    55,   402,    58,    59,   101,   907,    79,  1238,
     316,   167,     0,   316,   322,   286,     4,  1710,     6,  1707,
     248,   146,    30,     8,    95,   296,   483,   322,  1324,  1708,
     100,  1709,   321,   140,   926,   163,   164,   907,     1,    24,
     246,     4,   113,     6,    52,   251,   252,     1,   101,   156,
       4,    22,     6,   107,    25,    63,   232,   247,   238,  1768,
     240,   267,   116,    26,    27,    28,    29,    52,   122,   286,
     287,   288,    26,    27,    28,    29,   304,  1769,   181,   182,
      30,   387,   109,   110,   387,    39,   321,   108,   229,   230,
       1,   326,   146,     4,   322,     6,   402,     7,   238,   402,
     240,   122,    52,   263,   100,   197,   267,   268,   269,   238,
      20,   240,    22,    63,  1702,    26,    27,    28,    29,   238,
     247,   240,   100,   754,    87,   281,   255,    30,   304,   861,
     247,    94,   127,    87,    82,    89,   131,    91,   265,   266,
      94,   108,   754,   247,   304,   131,   322,     1,   714,    52,
       4,   140,     6,   728,   159,   122,   145,   111,  1042,   263,
      63,   162,   322,     4,   795,   257,   167,   130,   163,   164,
     304,   312,    26,    27,    28,    29,   360,   163,   164,   754,
     166,   208,   209,    37,   280,   212,   370,   371,    43,   728,
     101,   102,   103,   198,   199,   200,   204,     4,   149,     6,
     208,   164,    17,   246,  1792,   159,    75,     5,   159,   160,
       8,  1017,   321,  1353,  1354,  1355,  1356,   326,     1,   262,
     795,     4,    18,     6,   325,   856,   857,   858,   859,   860,
    1114,    38,   863,   131,   395,   396,   397,    60,    61,   108,
    1106,  1107,    65,    26,    27,    28,    29,  1113,  1129,    50,
     101,   863,   862,   122,   204,    50,   887,    40,   208,    42,
     318,   319,  1149,   424,   113,   163,   164,    55,  1155,   232,
    1157,  1158,    43,    44,   125,   126,   907,   111,    20,   128,
      22,   856,   857,   858,   859,   860,   861,     4,   863,     6,
     124,     8,   321,   191,   455,   907,   321,   131,   167,   321,
     149,   204,   104,   105,   106,   208,   155,     4,   316,     6,
       7,     1,   887,   248,     4,   149,     6,   159,   321,  1048,
      30,   155,   861,    30,  1516,  1517,  1518,  1519,   109,   110,
     111,   111,   907,   113,   114,   115,    26,    27,    28,    29,
    1636,   304,    52,    43,     1,    52,   215,     4,   321,     6,
     304,   163,   164,    63,   203,   204,    63,   208,     4,   322,
       6,   912,     8,   321,   915,    43,   316,    30,   322,    26,
      27,    28,    29,  1513,  1514,  1515,    43,   228,   229,   387,
    1280,   305,   306,   307,    58,    59,   248,   249,  1253,    52,
      15,    16,   849,   304,   402,     7,   853,    87,   124,    43,
      63,    45,   265,   266,    94,  1134,    50,  1136,    52,   101,
     360,   322,    56,   316,   140,   257,   258,   259,   260,   261,
     370,   371,   728,   149,  1324,   728,   290,   291,   292,   155,
     156,     8,  1042,   107,   265,   266,  1317,   387,  1319,    20,
     130,    22,   116,   327,   101,   102,   103,   327,   122,   297,
     304,    95,   402,    97,  1646,  1647,  1648,   297,  1323,    15,
      16,     1,   100,   246,     4,   315,     6,   324,   322,   101,
     102,   103,   146,  1048,   164,  1106,  1107,  1108,  1109,  1110,
       1,  1112,  1113,     4,   387,     6,    26,    27,    28,    29,
    1121,  1122,    15,    16,   204,   109,   110,   204,   208,   402,
      82,   208,  1114,   192,  1114,    26,    27,    28,    29,  1048,
     109,   110,   201,   202,     4,     5,   205,   206,  1149,  1150,
    1151,  1152,  1153,  1154,  1155,    23,  1157,  1158,   286,   287,
     288,  1106,  1107,  1108,  1109,  1110,    23,  1112,  1113,   322,
      50,   204,   232,   291,   292,   208,  1121,  1122,  1777,  1778,
     274,   275,   276,   277,   278,   861,   109,   110,   861,  1134,
     100,  1136,    92,    93,     1,    94,    50,     4,    50,     6,
     754,    41,    42,    50,  1149,  1150,  1151,  1152,  1153,  1154,
    1155,    50,  1157,  1158,   100,  1511,  1508,    43,  1509,    26,
      27,    28,    29,    82,  1169,  1134,     1,  1136,   127,     4,
     321,     6,    58,    59,  1121,  1122,   316,   100,   100,   316,
    1537,    82,   100,    17,   304,  1166,  1167,  1168,  1169,  1170,
    1171,    26,    27,    28,    29,   134,   135,   136,   137,   315,
    1169,    82,   322,  1470,   100,    40,  1563,    42,  1269,   100,
    1167,  1168,  1169,  1170,  1171,    18,   325,   304,     5,  1280,
    1506,   107,     7,   316,   183,   184,   185,   186,   187,   188,
     116,    97,    98,    99,   100,   322,   122,     7,  1280,   111,
       7,   113,   856,   857,   858,   859,   860,   387,  1253,   863,
     387,     7,  1233,  1282,  1235,  1236,   100,  1238,   100,   131,
     146,     5,   402,  1324,  1269,   402,     7,   139,   140,   141,
     142,     7,   321,   887,     7,  1280,  1233,  1282,  1235,  1236,
      17,  1238,   325,    18,  1253,    83,    84,    85,    12,    87,
     728,     8,   100,   907,   387,   265,   266,   248,   100,    37,
    1459,  1282,     1,   321,   321,     4,  1636,     6,   321,   402,
     248,   321,  1048,  1282,   263,  1048,   321,  1612,  1323,  1324,
     100,   100,  1362,   100,   100,   111,   100,    26,    27,    28,
      29,   321,   100,   298,   304,  1494,   122,    44,   124,    46,
    1169,    48,    49,   100,   321,   100,   100,    71,   728,    56,
      57,    75,   322,   304,  1323,   100,   142,   100,   321,   321,
     146,   100,     5,   149,     8,    50,    90,    91,  1373,   100,
     100,   322,   100,   100,   754,    41,   145,   111,    68,  1360,
    1373,     5,    89,   107,   100,  1390,   111,  1368,  1369,  1370,
    1371,  1372,    91,    43,   324,   728,   263,  1390,  1134,   111,
    1136,  1134,  1407,  1136,  1373,  1386,  1387,  1388,    58,    59,
     196,   246,   136,    82,     8,    82,   324,  1398,  1399,   143,
     100,  1390,     7,   861,  1253,  1406,  1407,  1408,  1409,  1469,
    1470,   130,   321,  1169,   321,     7,  1169,   304,  1407,   321,
     328,   100,   249,   229,   230,  1426,  1427,  1428,   328,  1406,
    1407,  1408,  1409,  1282,  1459,   322,     5,   107,   100,   321,
    1347,  1348,  1349,  1350,   101,    41,   116,   268,   263,  1426,
    1427,  1428,   122,  1632,     7,   248,   856,   857,   858,   859,
     860,   861,   101,   863,   101,   101,     5,   322,   161,  1494,
    1459,   100,    38,   101,  1323,  1537,   146,  1537,   101,    96,
     320,  1482,   109,   110,   100,   184,   320,   887,   101,   320,
     117,   118,   119,   120,   121,   264,   100,  1253,   100,   100,
    1253,  1563,   111,  1563,   113,  1494,   312,   907,   861,  1569,
     100,   322,   100,   232,   100,  1149,  1150,  1151,  1152,  1153,
    1154,  1155,   131,  1157,  1158,    82,  1282,   322,     5,  1282,
     139,   140,  1533,   142,  1535,  1536,   182,   100,    82,    40,
      84,   147,  1584,   152,   153,     7,   100,   320,  1549,   100,
     102,   264,  1594,   100,  1555,  1636,   322,    43,  1407,  1601,
     100,  1562,  1469,  1470,  1565,   109,   110,  1323,   728,   249,
    1323,   728,    58,    59,  1575,  1576,  1577,   101,   181,   123,
     321,   125,   126,   127,   100,   304,   321,  1612,   321,   130,
    1048,    76,    77,    78,    79,    80,    81,   321,  1575,  1576,
    1577,   321,   100,   322,   148,   149,   150,  1632,  1668,   321,
    1670,  1636,   321,   321,   321,   728,   322,  1373,   321,   100,
    1373,   107,   100,  1612,   322,   321,   321,   321,   101,  1654,
     116,   100,   320,   248,  1390,  1269,   122,  1390,  1663,  1640,
     100,  1654,     5,  1632,   100,    20,  1280,   389,  1048,  1174,
    1663,  1407,  1394,   197,  1407,  1661,    43,  1816,  1792,  1659,
     146,  1714,  1716,  1715,  1780,  1654,  1717,  1706,  1669,    89,
    1671,    58,    59,  1349,  1663,   386,  1134,    91,  1136,  1322,
    1681,  1682,  1683,  1684,  1685,  1686,  1687,   763,  1689,  1499,
    1324,   771,  1483,   303,  1446,  1048,   830,  1722,   388,  1765,
    1705,   861,  1108,  1459,   861,  1110,  1459,  1109,  1127,  1722,
     845,  1169,  1132,   257,   286,    43,   854,   967,  1778,  1074,
     107,  1158,  1723,  1254,  1725,  1726,  1727,  1728,  1729,   116,
      58,    59,  1792,  1722,  1134,   122,  1136,   204,  1494,  1278,
    1274,  1494,  1767,   398,   400,   371,   119,   401,   861,  1149,
    1150,  1151,  1152,  1153,  1154,  1155,  1816,  1157,  1158,   146,
    1825,   399,   360,  1612,   298,  1766,  1767,  1768,  1769,  1169,
     621,   299,   299,  1774,  1775,  1776,  1777,   984,  1767,   107,
    1781,  1134,  1783,  1136,    -1,    -1,    -1,    -1,   116,  1766,
    1767,  1768,  1769,    -1,   122,  1253,  1797,  1774,  1775,  1776,
    1777,  1802,  1803,  1804,  1805,  1806,  1807,  1808,  1809,  1810,
    1811,  1812,  1813,    -1,    -1,    -1,  1169,    -1,   146,    -1,
      -1,    -1,    -1,    -1,  1282,  1826,    -1,   109,   110,    -1,
    1807,  1808,  1809,  1834,  1835,  1836,    -1,    -1,    -1,    -1,
      -1,   123,    -1,   125,   126,   127,     1,    -1,    -1,     4,
      -1,     6,    -1,  1253,    -1,    -1,  1612,    -1,     1,  1612,
      -1,     4,    -1,     6,    -1,  1323,   148,   149,   150,  1269,
      -1,    26,    27,    28,    29,    -1,  1632,    -1,    -1,  1632,
    1280,    36,  1282,    26,    27,    28,    29,    -1,  1048,    -1,
      45,  1048,    -1,    -1,    -1,    50,    39,    52,  1654,    54,
    1253,  1654,    -1,    -1,    -1,    -1,    -1,  1663,    -1,    -1,
    1663,    -1,    -1,    -1,     1,  1373,    -1,     4,  1767,     6,
      -1,    -1,    -1,  1323,  1324,    -1,    -1,    -1,    -1,  1282,
      -1,    -1,  1390,    -1,  1070,  1048,    -1,    -1,    -1,    26,
      27,    28,    29,    86,    87,    88,    89,    -1,    91,  1407,
      -1,    94,    -1,    -1,    -1,     1,    -1,    -1,     4,     1,
       6,    -1,     4,    -1,     6,    -1,  1722,    -1,   111,  1722,
    1323,    -1,    -1,  1373,  1134,    -1,  1136,  1134,    43,  1136,
      26,    27,    28,    29,    26,    27,    28,    29,    -1,    -1,
    1390,    -1,    -1,    58,    59,    -1,    -1,    39,    -1,    -1,
       1,  1459,  1636,     4,   159,     6,    -1,  1407,    -1,  1169,
      -1,  1767,  1169,    -1,  1767,    -1,   159,    -1,    -1,    -1,
    1373,  1134,    -1,  1136,   111,    26,    27,    28,    29,    -1,
      -1,  1167,  1168,  1169,  1170,  1171,  1494,  1390,    -1,    -1,
      -1,    87,   107,    -1,    86,    87,    88,    89,    94,    91,
      -1,   116,    94,    -1,  1407,    -1,  1169,   122,    -1,  1459,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   111,
      -1,    -1,    -1,    -1,    -1,    -1,   231,    -1,    -1,    -1,
      -1,   146,    -1,    -1,   130,    -1,    -1,    -1,   231,    43,
      -1,   246,    -1,  1253,  1494,    -1,  1253,  1233,    -1,  1235,
    1236,    -1,  1238,   246,    58,    59,  1459,   262,    -1,    -1,
     111,    -1,   267,    -1,   269,    -1,    -1,   159,   164,   262,
      -1,    36,  1282,    -1,   267,  1282,    -1,    -1,    43,    -1,
      45,    -1,    47,    -1,    -1,    50,    51,    52,  1274,    54,
    1253,  1494,    -1,    -1,    -1,   232,    -1,    -1,    -1,   304,
      -1,    -1,    -1,   107,  1612,     1,    -1,    -1,     4,    -1,
       6,   304,   116,  1323,    -1,    -1,  1323,   322,   122,  1282,
      -1,    -1,    -1,    -1,  1632,    -1,    -1,    -1,    -1,   322,
      26,    27,    28,    29,    -1,    -1,   232,    -1,    -1,   231,
      -1,    -1,   146,    39,    -1,    -1,  1654,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   246,  1663,    -1,    -1,    -1,    -1,
    1323,    -1,  1612,  1373,    -1,    -1,  1373,   304,    -1,    -1,
     262,    -1,    -1,    -1,    -1,   267,    -1,    -1,    -1,    -1,
    1390,   232,  1632,  1390,    -1,   322,  1636,    36,    -1,    -1,
      86,    87,    88,    89,    43,    91,    45,  1407,    94,    -1,
    1407,    50,    51,    52,  1654,    54,    -1,    -1,   304,  1612,
    1373,    -1,   304,  1663,  1722,   111,    -1,    -1,    -1,    -1,
    1406,  1407,  1408,  1409,    -1,    -1,   322,  1390,    -1,  1632,
     322,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1426,  1427,  1428,    -1,  1407,    -1,    -1,    -1,    -1,  1459,
      -1,  1654,  1459,   304,    -1,    -1,    -1,    -1,    -1,  1767,
    1663,    -1,    -1,   159,     1,    -1,   231,    -1,    -1,    -1,
      -1,   322,  1722,    -1,    11,    12,    13,    14,    15,    16,
      17,   246,    -1,    20,  1494,     1,    -1,  1494,     4,    -1,
       6,    -1,    -1,    -1,    -1,    -1,  1459,   262,    -1,    -1,
      -1,    -1,   267,    -1,   269,    -1,    -1,    -1,    -1,    -1,
      26,    27,    28,    29,    -1,    -1,    -1,  1767,    -1,  1722,
      -1,    -1,    -1,    -1,    40,    -1,    42,    -1,    -1,    -1,
      -1,  1494,    -1,    -1,    71,   231,    -1,    74,    75,    76,
      77,    78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    86,
     246,    88,    89,    90,    91,    92,    93,    94,    95,    -1,
      97,    98,    99,   100,  1767,   102,   262,    -1,   105,    -1,
     107,   267,    -1,   110,   111,    -1,   113,    -1,    -1,   116,
      37,    -1,   231,    -1,    -1,    -1,    -1,    -1,    -1,  1575,
    1576,  1577,    -1,    -1,    -1,    -1,    -1,   246,   135,   136,
     137,   138,  1612,    -1,   141,  1612,   143,    -1,   304,    -1,
      -1,    -1,    -1,   262,   725,    -1,   727,    -1,   267,    -1,
     269,    -1,  1632,    -1,    -1,  1632,   322,    -1,    -1,    -1,
      -1,    -1,   743,   744,    -1,   746,    -1,    -1,    -1,   750,
     751,    -1,    -1,   100,  1654,     1,    -1,  1654,     4,  1612,
       6,    -1,    -1,  1663,    -1,    -1,  1663,     1,    -1,    -1,
       4,    -1,     6,    -1,   775,    -1,    -1,   778,    -1,  1632,
      26,    27,    28,    29,    -1,    -1,     1,    -1,    -1,     4,
      36,     6,    26,    27,    28,    29,    -1,    -1,    -1,    45,
      -1,  1654,    -1,    -1,    50,    39,    52,    -1,    54,    -1,
    1663,    26,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1722,   170,    39,  1722,   173,   174,   175,   176,
     177,   178,   179,   180,   181,   182,    -1,    -1,   839,    -1,
     246,   842,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    87,    -1,    89,     1,    91,    21,     4,
      94,     6,    -1,    -1,    -1,    -1,    -1,  1767,    -1,  1722,
    1767,    -1,    87,    -1,    89,    -1,    91,   111,    -1,    94,
      -1,    26,    27,    28,    29,    -1,    -1,    -1,    -1,    -1,
    1766,  1767,  1768,  1769,    -1,    -1,   111,    -1,  1774,  1775,
    1776,  1777,    -1,    -1,    -1,    68,    -1,   908,   909,    -1,
      -1,    -1,    -1,   159,  1767,    -1,   322,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   159,    -1,    -1,    -1,    -1,
      -1,  1807,  1808,  1809,    -1,    -1,    -1,   100,   101,   102,
     103,    -1,    -1,    -1,   159,   108,    -1,    -1,    84,   112,
      -1,    -1,    -1,   116,    -1,    -1,    -1,    -1,    -1,   122,
      -1,    -1,    -1,   126,    -1,   101,   111,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   138,    -1,    -1,    -1,    -1,
     143,    -1,    -1,   146,    -1,   231,    -1,    -1,   151,   125,
     126,   154,    -1,    -1,   157,   158,    -1,    -1,    -1,   162,
     246,    -1,   165,    -1,   167,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   440,    -1,    -1,   262,    -1,    -1,    -1,
     447,   267,    -1,   269,    -1,    -1,   189,   190,    -1,    -1,
     457,    -1,   459,    -1,   461,  1036,   463,    -1,    -1,  1040,
      -1,   468,    -1,    -1,   471,    -1,   473,    -1,  1049,  1050,
    1051,    -1,    -1,  1054,   481,  1056,    -1,    -1,   304,    -1,
      -1,    -1,    -1,    -1,    -1,  1066,    -1,    -1,    -1,    -1,
     304,    -1,   208,    -1,    -1,    -1,   322,    -1,   241,    -1,
      -1,   244,   245,    -1,    -1,    -1,    -1,   232,   322,   304,
      -1,    -1,   228,   229,    -1,    -1,    -1,    -1,  1099,    -1,
    1101,  1102,    -1,    -1,    -1,    -1,    -1,   322,    68,    -1,
     246,    -1,    -1,    -1,  1115,    -1,  1117,    -1,    -1,   282,
     283,    -1,   285,    -1,    -1,  1126,   262,  1128,    -1,    -1,
      -1,   267,    -1,   269,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   101,   102,   103,    -1,    -1,   309,   310,   108,    -1,
      -1,    -1,   112,    -1,    -1,    -1,   116,    -1,   321,   304,
     323,    -1,   122,   326,    -1,    82,   126,    84,    -1,    -1,
      -1,    -1,    -1,    -1,    23,    -1,    -1,   322,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   146,    -1,    37,    -1,
      -1,    -1,   109,   110,    -1,    -1,   113,     1,    -1,    -1,
       4,    -1,     6,    -1,    -1,    -1,   123,   124,   125,   126,
     127,   128,   129,   130,   131,    -1,    -1,    -1,    -1,    23,
      -1,    -1,    26,    27,    28,    29,    30,    31,    -1,    -1,
      34,    35,    36,    -1,    -1,    -1,    -1,    -1,    -1,  1240,
    1241,    -1,    -1,    -1,    -1,    -1,    50,    -1,    -1,    -1,
      -1,   100,    -1,    -1,    -1,   172,    60,    61,    -1,  1260,
      -1,    65,    -1,    -1,    -1,  1266,    -1,    -1,    -1,    -1,
      -1,    -1,    76,    77,    78,    79,    80,    81,    -1,    -1,
     197,   241,    -1,    -1,   244,   245,    -1,    91,    -1,    -1,
      -1,    95,  1293,    97,    -1,    -1,   100,   101,   102,   103,
      -1,    -1,   106,    -1,   108,    -1,    -1,   111,   112,  1310,
      -1,  1312,   116,    -1,    -1,    -1,    -1,    -1,   122,    -1,
      -1,   170,   282,   283,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   138,    -1,   131,    -1,    -1,   143,
     257,    -1,   146,    -1,    -1,   140,    -1,   151,    -1,    -1,
     154,    -1,    -1,   157,   158,   159,    -1,    -1,   162,    -1,
     155,   165,    -1,   167,   159,    -1,   326,    -1,   163,   164,
      -1,    -1,    -1,   168,   169,   170,   171,   172,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   189,   190,    -1,   192,   193,
     194,   195,    -1,    -1,    -1,    -1,    -1,   201,   202,    -1,
      -1,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   109,   110,   231,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   122,    -1,
      -1,    -1,   246,    -1,    -1,    -1,   130,    -1,    -1,    -1,
      -1,    -1,   256,  1454,    -1,    -1,    -1,    -1,   262,    -1,
      -1,    -1,   146,   267,    -1,    -1,    -1,  1468,    -1,    -1,
      -1,    -1,   276,   277,    -1,   279,    -1,    -1,   282,   283,
     284,   285,    -1,    -1,    -1,   289,    -1,  1488,    -1,   293,
     294,   295,    -1,    -1,    -1,   299,   300,    -1,    -1,    -1,
     304,    -1,    -1,    -1,   308,    -1,    -1,   311,   312,     1,
      -1,    -1,     4,    -1,     6,    -1,    -1,   321,   322,   323,
      -1,    -1,   326,    -1,    -1,    -1,   953,   954,   955,    -1,
      -1,    23,    -1,    -1,    26,    27,    28,    29,    30,    31,
      -1,    -1,    34,    35,    36,    -1,    -1,    -1,   232,   233,
     234,   235,    -1,    -1,    -1,    -1,    -1,    -1,    50,    -1,
      -1,    -1,    -1,    -1,   248,   249,   250,    -1,    60,    61,
      -1,    -1,    -1,    65,    -1,    -1,   109,   110,    -1,    -1,
     113,    -1,    -1,    -1,    76,    77,    78,    79,    80,    81,
     123,   124,   125,   126,   127,   128,   129,   130,   131,    91,
      -1,    -1,    -1,    95,    -1,    97,    -1,    -1,   100,   101,
     102,   103,    -1,    -1,   106,    -1,   108,    -1,    -1,   111,
     112,    -1,    -1,    -1,   116,    -1,    -1,    -1,    -1,  1630,
     122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,
      -1,    -1,    -1,    -1,    -1,    -1,   138,    -1,    -1,    -1,
      -1,   143,    -1,    -1,   146,    -1,    -1,    -1,    -1,   151,
      -1,    -1,   154,    -1,    -1,   157,   158,   159,    -1,    -1,
     162,    -1,    36,   165,    -1,   167,    -1,    -1,    -1,    43,
      -1,    45,    -1,    47,    -1,    -1,    50,    51,    52,    -1,
      54,    -1,    -1,    -1,    58,    59,    -1,   189,   190,    -1,
     192,   193,   194,   195,    -1,    -1,    -1,    -1,    -1,   201,
     202,    -1,    -1,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,    -1,    -1,   231,
      -1,    -1,    -1,   107,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   116,    -1,   246,    -1,    -1,    -1,   122,    -1,
      -1,    -1,    -1,    -1,   256,    -1,    -1,    -1,    -1,    -1,
     262,    -1,    -1,    -1,    -1,   267,    -1,    -1,    -1,    -1,
      -1,    -1,   146,    -1,   276,   277,    -1,   279,    -1,    -1,
     282,   283,   284,   285,    -1,    -1,    -1,   289,    -1,    -1,
      -1,   293,   294,   295,    -1,    -1,    -1,   299,   300,    -1,
       1,    -1,   304,     4,    -1,     6,   308,    -1,    -1,   311,
     312,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   321,
     322,   323,    23,    -1,   326,    26,    27,    28,    29,    30,
      31,    -1,    -1,    34,    35,    36,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    50,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   231,    -1,    60,
      61,    -1,    -1,    -1,    65,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   246,    -1,    -1,    76,    77,    78,    79,    80,
      81,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   262,    -1,
      91,    -1,    -1,   267,    95,   269,    97,    -1,    -1,   100,
     101,   102,   103,    -1,    -1,   106,    -1,   108,    -1,    -1,
     111,   112,    -1,    -1,    -1,   116,    -1,    -1,    -1,    -1,
      -1,   122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   138,    -1,    -1,
      -1,    -1,   143,    -1,    -1,   146,    -1,    -1,    -1,    -1,
     151,    -1,    -1,   154,    -1,    -1,   157,   158,   159,    -1,
      -1,   162,    -1,    -1,   165,    -1,   167,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   189,   190,
      -1,   192,   193,   194,   195,    -1,    -1,    -1,    -1,    -1,
     201,   202,    -1,    -1,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,    -1,    -1,
     231,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   246,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   256,    -1,    -1,    -1,    -1,
      -1,   262,    -1,    -1,    -1,    -1,   267,    -1,    -1,    -1,
       4,    -1,     6,    -1,    -1,   276,   277,    -1,   279,    -1,
      -1,   282,   283,   284,   285,    -1,    -1,    -1,   289,    23,
      -1,    -1,   293,   294,   295,    -1,    30,    31,   299,   300,
      34,    35,    36,   304,    -1,    -1,    -1,   308,    -1,    -1,
     311,   312,    -1,    -1,    -1,    -1,    50,    -1,    -1,    -1,
     321,   322,   323,    -1,    -1,   326,    60,    61,    -1,    -1,
      -1,    65,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    76,    77,    78,    79,    80,    81,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    -1,    97,    -1,    -1,   100,   101,   102,   103,
      -1,    -1,   106,    -1,   108,    -1,    -1,    -1,   112,    -1,
      -1,    -1,   116,    -1,    -1,    -1,    -1,    -1,   122,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   138,    -1,    -1,    -1,    -1,   143,
      -1,    -1,   146,    -1,    -1,    -1,    -1,   151,    -1,    -1,
     154,    -1,    -1,   157,   158,    -1,    -1,    -1,   162,    -1,
      -1,   165,    -1,   167,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   189,   190,    -1,   192,   193,
     194,   195,    -1,    -1,    -1,    -1,    -1,   201,   202,    -1,
      -1,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,    -1,    -1,   231,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     5,    -1,    -1,    -1,    -1,
      -1,    -1,   246,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    21,   256,    23,    -1,    -1,    -1,    -1,   262,    -1,
      -1,    31,    -1,   267,    -1,    35,    -1,    -1,    -1,    -1,
      -1,    -1,   276,   277,    -1,   279,    -1,    -1,   282,   283,
     284,   285,    -1,    -1,    -1,   289,    -1,    -1,    -1,   293,
     294,   295,    -1,    -1,    -1,   299,   300,    -1,    68,    -1,
      -1,    -1,    -1,    -1,   308,    -1,    -1,   311,   312,    -1,
      -1,    -1,    82,    -1,    84,    -1,    -1,   321,   322,   323,
      -1,    -1,   326,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     100,   101,   102,   103,    -1,    -1,   106,    -1,   108,    -1,
      -1,    -1,   112,    -1,    -1,    -1,   116,    -1,    -1,    -1,
      -1,    -1,   122,    -1,    -1,    -1,   126,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   138,    -1,
      -1,    -1,    -1,   143,    -1,    -1,   146,    -1,    -1,    -1,
      -1,   151,    -1,    -1,   154,    -1,    -1,   157,   158,    -1,
      -1,    -1,   162,    -1,    -1,   165,    -1,   167,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   189,
     190,    -1,   192,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,    -1,
      -1,   231,    -1,     5,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   241,    -1,    -1,   244,   245,    -1,    -1,    -1,    21,
      -1,    23,    -1,    -1,    -1,    -1,    -1,   257,    -1,    31,
      -1,    -1,    -1,    35,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   276,   277,    -1,    -1,
      -1,    -1,   282,   283,    -1,    -1,    -1,    -1,    -1,   101,
      -1,    -1,    -1,    -1,    -1,   295,    68,    -1,    -1,   299,
     300,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   309,
     310,    -1,   312,    -1,    -1,   127,    -1,    -1,   130,    -1,
      -1,    -1,    -1,   323,    -1,    -1,   326,    -1,   100,   101,
     102,   103,    -1,    -1,   106,   147,   108,    -1,    -1,    -1,
     112,    -1,    -1,    -1,   116,    -1,    -1,    -1,    -1,    -1,
     122,    -1,    -1,    -1,   126,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   138,    -1,    -1,    -1,
      -1,   143,    -1,    -1,   146,    -1,    -1,    -1,    -1,   151,
      -1,    -1,   154,    -1,    -1,   157,   158,    -1,    -1,    -1,
     162,    -1,    -1,   165,    -1,   167,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   189,   190,    -1,
     192,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   269,    -1,   231,
      -1,     5,    -1,    -1,   276,   277,    -1,    -1,    -1,   241,
      -1,    -1,   244,   245,   286,    -1,    -1,    21,    -1,    23,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    31,    -1,    -1,
      -1,    35,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     312,    -1,    -1,    -1,   276,   277,    -1,    -1,    -1,    -1,
     282,   283,    -1,    -1,    -1,    -1,    -1,   101,    -1,    -1,
      -1,    -1,    -1,   295,    68,    -1,    -1,   299,   300,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   309,   310,    -1,
     312,    -1,    -1,   127,    -1,    -1,   130,    -1,    -1,    -1,
      -1,   323,    -1,    -1,   326,    -1,   100,   101,   102,   103,
      -1,    -1,   106,   147,   108,    -1,    -1,    -1,   112,    -1,
      -1,    -1,   116,    -1,    -1,    -1,    -1,    -1,   122,    -1,
      -1,    -1,   126,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   138,    -1,    -1,    -1,    -1,   143,
      -1,    -1,   146,    -1,    -1,    -1,    -1,   151,    -1,    -1,
     154,    -1,    -1,   157,   158,    -1,    -1,    -1,   162,    -1,
      -1,   165,    -1,   167,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   189,   190,    -1,   192,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   269,    -1,   231,    -1,     5,
      -1,    -1,   276,   277,    -1,    -1,    -1,   241,    -1,    -1,
     244,   245,   286,    -1,    -1,    21,    -1,    23,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    31,    -1,    -1,    -1,    35,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   312,    -1,
      -1,    -1,   276,   277,    -1,    -1,    -1,    -1,   282,   283,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   295,    68,    -1,    -1,   299,   300,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   309,   310,    -1,   312,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   323,
      -1,    -1,   326,    -1,   100,   101,   102,   103,    -1,    -1,
     106,    -1,   108,    -1,    -1,    -1,   112,    -1,    -1,    -1,
     116,    -1,    -1,    -1,    -1,    -1,   122,    -1,    -1,    -1,
     126,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   138,    -1,    -1,    -1,    -1,   143,    -1,    -1,
     146,    -1,    -1,    -1,    -1,   151,    -1,    -1,   154,    -1,
      -1,   157,   158,    -1,    -1,    -1,   162,    -1,    -1,   165,
      -1,   167,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   189,   190,    -1,   192,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,    -1,    -1,   231,    -1,     5,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   241,    -1,    -1,   244,   245,
      -1,    -1,    -1,    21,    -1,    23,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    31,    -1,    -1,    -1,    35,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     276,   277,    -1,    -1,    -1,    -1,   282,   283,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   295,
      68,    -1,    -1,   299,   300,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   309,   310,    -1,   312,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   323,    -1,    -1,
     326,    -1,   100,   101,   102,   103,    -1,    -1,   106,    -1,
     108,    -1,    -1,    -1,   112,    -1,    -1,    -1,   116,    -1,
      -1,    -1,    -1,    -1,   122,    -1,    -1,    -1,   126,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     138,    -1,    -1,    -1,    -1,   143,    -1,    -1,   146,    -1,
      -1,    -1,    -1,   151,    -1,    -1,   154,    -1,    -1,   157,
     158,    -1,    -1,    -1,   162,    -1,    -1,   165,    -1,   167,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   189,   190,    -1,   192,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,    -1,    -1,   231,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   241,    -1,    -1,   244,   245,     9,    10,
      11,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      21,    -1,    23,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   276,   277,
      -1,    -1,    -1,    -1,   282,   283,    -1,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   295,    -1,    -1,
      -1,   299,   300,    -1,    -1,    -1,    -1,    68,    -1,   109,
     110,   309,   310,   113,   312,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   323,    -1,    -1,   326,    -1,
     130,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,
     101,   102,   103,    -1,    -1,    -1,    -1,   108,    -1,    -1,
      -1,   112,    -1,    -1,    -1,   116,    -1,    -1,    -1,    -1,
      -1,   122,    -1,    -1,    -1,   126,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   138,    -1,    -1,
      -1,    -1,   143,    -1,   184,   146,    -1,    -1,    -1,    -1,
     151,    -1,    -1,   154,    -1,    -1,   157,   158,    -1,    -1,
      -1,   162,    -1,    -1,   165,    -1,   167,    -1,   208,    21,
      -1,    23,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    31,
      -1,    -1,    -1,    35,    -1,    -1,    -1,    -1,   189,   190,
      -1,    -1,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,    -1,    -1,   248,   249,
     250,    -1,    -1,    -1,    -1,    -1,    68,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   269,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     241,    -1,    -1,   244,   245,    -1,    -1,    -1,   100,   101,
     102,   103,    -1,    -1,   106,    -1,   108,    -1,    -1,    -1,
     112,    -1,    -1,    -1,   116,    -1,    -1,    -1,    -1,    -1,
     122,    -1,    -1,    -1,   126,    -1,    -1,    -1,    -1,   109,
     110,   282,   283,   113,   285,    -1,   138,    -1,    -1,    -1,
      -1,   143,    -1,    -1,   146,    -1,    -1,    -1,    -1,   151,
     130,    -1,   154,    -1,    -1,   157,   158,    -1,   309,   310,
     162,    -1,    -1,   165,    -1,   167,    -1,    -1,    -1,    -1,
     321,    -1,   323,    -1,    -1,   326,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   189,   190,    -1,
     192,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,    -1,   208,   231,
      -1,    -1,    21,    22,    23,    -1,    -1,    -1,    -1,   241,
      -1,    -1,   244,   245,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   232,   233,   234,   235,   236,   237,    -1,   239,
     240,   241,   242,   243,   244,   245,    -1,    -1,   248,   249,
     250,    -1,    -1,    -1,   276,   277,    -1,    -1,    -1,    68,
     282,   283,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   269,
      -1,    -1,    -1,   295,    -1,    -1,    -1,   299,   300,    -1,
      -1,    -1,    -1,    21,    -1,    23,    -1,   309,   310,    -1,
     312,   100,   101,   102,   103,    -1,    -1,    -1,    -1,   108,
      -1,   323,    -1,   112,   326,    -1,    -1,   116,    -1,    -1,
      -1,    -1,    -1,   122,    -1,    -1,    -1,   126,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   138,
      68,    -1,    -1,    -1,   143,    -1,    -1,   146,    -1,    -1,
      -1,    -1,   151,    -1,    -1,   154,    -1,    -1,   157,   158,
      -1,    -1,    -1,   162,    -1,    -1,   165,    -1,   167,    -1,
      -1,    -1,   100,   101,   102,   103,    -1,    -1,    -1,    -1,
     108,    -1,    -1,    -1,   112,    -1,    -1,    -1,   116,    -1,
     189,   190,    -1,    -1,   122,    -1,    -1,    -1,   126,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     138,    -1,    -1,    -1,    -1,   143,    -1,    -1,   146,    -1,
      -1,    -1,    -1,   151,    -1,    -1,   154,    -1,    -1,   157,
     158,    -1,    -1,    -1,   162,    -1,    -1,   165,    -1,   167,
      -1,    -1,   241,    -1,    -1,   244,   245,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    21,    -1,    -1,    -1,    -1,
      -1,   189,   190,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   282,   283,    -1,   285,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    68,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     309,   310,    -1,   241,    -1,    -1,   244,   245,    -1,    -1,
      -1,    -1,   321,    -1,   323,    -1,    -1,   326,    -1,    -1,
      -1,    -1,    -1,    -1,   100,   101,   102,   103,    -1,    -1,
      -1,    -1,   108,    -1,    -1,    -1,   112,    -1,    -1,    -1,
     116,    -1,    -1,    -1,   282,   283,   122,   285,    -1,    -1,
     126,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   138,    -1,    -1,    -1,    -1,   143,    -1,    -1,
     146,   309,   310,    -1,    -1,   151,    -1,    -1,   154,    -1,
      -1,   157,   158,   321,    -1,   323,   162,    -1,   326,   165,
      -1,   167,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    23,    -1,    -1,    -1,    -1,    -1,
      -1,    30,    31,   189,   190,    34,    35,    36,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    50,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    60,    61,    -1,    -1,    -1,    65,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    76,    77,    78,
      79,    80,    81,    -1,    -1,   241,    -1,    -1,   244,   245,
      -1,    -1,    -1,    -1,    -1,    -1,    95,    -1,    97,    -1,
      -1,   100,   101,   102,   103,    -1,    -1,   106,    -1,   108,
      -1,    -1,    -1,   112,    -1,    -1,    -1,   116,    -1,    -1,
      -1,    -1,    -1,   122,    -1,    -1,   282,   283,    -1,   285,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   138,
      -1,    -1,    -1,    -1,   143,    -1,    -1,   146,    -1,    -1,
      -1,    -1,   151,   309,   310,   154,    -1,    -1,   157,   158,
      -1,    -1,    -1,   162,    -1,    -1,   165,   323,   167,    -1,
     326,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     189,   190,    -1,   192,   193,   194,   195,    -1,    -1,    -1,
      -1,    -1,   201,   202,    -1,    -1,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
      -1,    -1,   231,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   246,    -1,    -1,
      -1,    -1,    23,    -1,    -1,    -1,    -1,   256,    -1,    30,
      31,    -1,    -1,   262,    35,    -1,    -1,    -1,   267,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   276,   277,    -1,
     279,    -1,    -1,   282,   283,   284,   285,    -1,    -1,    -1,
     289,    -1,    -1,    -1,   293,   294,   295,    -1,    -1,    -1,
     299,   300,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   308,
      -1,    -1,   311,   312,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   321,    -1,   323,    -1,    -1,   326,    -1,   100,
     101,   102,   103,    -1,    -1,   106,    -1,   108,    -1,    -1,
      -1,   112,    -1,    -1,    -1,   116,    -1,    -1,    -1,    -1,
      -1,   122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   138,    -1,    -1,
      -1,    -1,   143,    -1,    -1,   146,    -1,    -1,    -1,    -1,
     151,    -1,    -1,   154,    -1,    -1,   157,   158,    -1,    -1,
      -1,   162,    -1,    -1,   165,    -1,   167,    -1,    -1,    -1,
      -1,    -1,    -1,    23,    -1,    -1,    -1,    -1,    -1,    -1,
      30,    31,    -1,    -1,    -1,    35,    -1,    -1,   189,   190,
      -1,   192,   193,   194,   195,    -1,    -1,    -1,    -1,    -1,
     201,   202,    -1,    -1,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,    -1,    -1,
     231,    -1,    -1,    -1,    84,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     100,   101,   102,   103,    -1,    -1,   106,    -1,   108,    -1,
      -1,    -1,   112,    -1,    -1,    -1,   116,    -1,    -1,    -1,
      -1,    -1,   122,    -1,    -1,   276,   277,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   138,    -1,
      -1,    -1,    -1,   143,   295,    -1,   146,    -1,   299,   300,
      -1,   151,    -1,    -1,   154,    -1,    -1,   157,   158,    -1,
     311,   312,   162,    -1,    -1,   165,    -1,   167,    -1,    -1,
     321,    -1,   323,    -1,    23,   326,    -1,    -1,    -1,    -1,
      -1,    30,    31,    -1,    -1,    -1,    35,    -1,    -1,   189,
     190,    -1,   192,   193,   194,   195,    -1,    -1,    -1,    -1,
      -1,   201,   202,    -1,    -1,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,    -1,
      -1,   231,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   100,   101,   102,   103,    -1,    -1,   106,    -1,   108,
      -1,    -1,    -1,   112,    -1,    -1,    -1,   116,    -1,    -1,
      -1,    -1,    -1,   122,    -1,    -1,   276,   277,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   138,
      -1,    -1,    -1,    -1,   143,   295,    -1,   146,    -1,   299,
     300,    -1,   151,    -1,    -1,   154,    -1,    -1,   157,   158,
      -1,   311,   312,   162,    -1,    -1,   165,    -1,   167,    -1,
      -1,    -1,    -1,   323,    -1,    -1,   326,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     189,   190,    -1,   192,   193,   194,   195,    -1,    -1,    -1,
      -1,    -1,   201,   202,    -1,    -1,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
      -1,    -1,   231,    -1,    -1,    -1,    -1,    23,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    31,    -1,    -1,    -1,    35,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   276,   277,    -1,
      -1,    -1,    68,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   295,    -1,    -1,    -1,
     299,   300,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   311,   312,   100,   101,   102,   103,    -1,    -1,
     106,    -1,   108,    -1,   323,    -1,   112,   326,    -1,    -1,
     116,    -1,    -1,    -1,    -1,    -1,   122,    -1,    -1,    -1,
     126,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   138,    -1,    -1,    -1,    -1,   143,    -1,    -1,
     146,    -1,    -1,    -1,    -1,   151,    -1,    -1,   154,    -1,
      -1,   157,   158,    -1,    -1,    -1,   162,    -1,    -1,   165,
      -1,   167,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   189,   190,    -1,   192,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,    -1,    -1,   231,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   241,    -1,    -1,   244,   245,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     276,   277,    -1,    -1,    -1,    -1,   282,   283,    -1,    -1,
      -1,    -1,     0,     1,    -1,    -1,     4,    -1,     6,   295,
      -1,    -1,    -1,   299,   300,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   309,   310,    -1,   312,    -1,    26,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,   323,    36,    -1,
     326,    -1,    -1,    -1,    -1,    43,    -1,    45,    -1,    47,
      -1,    -1,    50,    51,    52,    -1,    54,    -1,    -1,    -1,
      58,    59,    60,    -1,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    -1,    -1,    68,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    76,    77,    78,
      79,    80,    81,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   101,    -1,    -1,    -1,    -1,    -1,   107,
      -1,   100,   101,   102,   103,    -1,    -1,    -1,   116,   108,
      -1,    -1,    -1,   112,   122,    -1,    -1,   116,    -1,    -1,
      -1,    -1,    -1,   122,    -1,    -1,    -1,   126,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   146,   138,
      -1,    -1,    -1,    -1,   143,    -1,    -1,   146,    -1,    -1,
      -1,    -1,   151,    -1,    -1,   154,    -1,    -1,   157,   158,
      -1,    -1,    -1,   162,    -1,    -1,   165,    -1,   167,    -1,
      -1,    -1,    -1,    -1,    68,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     189,   190,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   100,   101,   102,   103,
      -1,    -1,    -1,    -1,   108,    -1,    -1,    -1,   112,    -1,
      -1,    -1,   116,   231,    -1,    -1,    -1,    -1,   122,    -1,
      -1,    -1,   126,    -1,    -1,    -1,    -1,    -1,   246,    -1,
      -1,    -1,   241,    -1,   138,   244,   245,    -1,    -1,   143,
      -1,    -1,   146,    -1,   262,    -1,    -1,   151,    -1,   267,
     154,   269,    -1,   157,   158,    -1,    -1,    -1,   162,    -1,
      -1,   165,    -1,   167,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   282,   283,    -1,   285,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   189,   190,    -1,    -1,    36,
      -1,    -1,    -1,    -1,    -1,    -1,    43,    44,    45,    46,
     309,   310,    49,    50,    -1,    52,    53,    54,    -1,    56,
      -1,    -1,    -1,    -1,   323,    -1,    -1,   326,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   241,    -1,    -1,
     244,   245,    -1,    -1,    -1,    -1,    -1,    -1,    95,    -1,
      97,    98,    99,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   282,   283,
      -1,   285,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   309,   310,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   323,
      -1,    -1,   326,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   231,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   246,
      -1,    -1,    -1,    -1,   251,   252,   253,   254,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   262,    -1,    -1,    -1,    -1,
     267,    -1,   269,   270
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,   330,     0,     1,     4,     6,    26,    27,    28,    29,
      36,    43,    45,    47,    50,    51,    52,    54,    58,    59,
      60,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,   107,   116,   122,   146,   231,   246,
     262,   267,   269,   331,   333,   334,   335,   336,   400,   401,
     402,   404,   419,   331,   102,   101,   397,   397,   397,   402,
     413,   402,   404,   419,   402,   407,   407,   407,   402,   410,
     336,    47,   337,    36,    43,    45,    50,    51,    52,    54,
     231,   246,   262,   267,   269,   338,    47,   339,    36,    43,
      45,    47,    50,    51,    52,    54,   231,   246,   262,   267,
     269,   340,    51,   341,    36,    43,    44,    45,    46,    49,
      50,    52,    53,    54,    56,    95,    97,    98,    99,   231,
     246,   251,   252,   253,   254,   262,   267,   269,   270,   342,
     246,   251,   252,   267,   343,    43,    45,    50,    52,    56,
      95,    97,   344,    45,   345,    23,    30,    31,    35,   100,
     101,   102,   103,   106,   108,   112,   116,   122,   138,   143,
     146,   151,   154,   157,   158,   162,   165,   167,   189,   190,
     192,   193,   194,   195,   201,   202,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     231,   276,   277,   295,   299,   300,   311,   312,   323,   326,
     353,   398,   514,   515,   518,   519,   520,   524,   585,   588,
     590,   594,   599,   600,   602,   604,   614,   615,   617,   619,
     621,   623,   627,   629,   631,   633,   635,   637,   639,   641,
     643,   645,   649,   651,   653,   655,   656,   658,   660,   662,
     664,   666,   668,   670,   672,    56,   305,   306,   307,   346,
     352,    56,   347,   352,   101,   348,   349,    87,   238,   240,
     413,   413,   413,   413,     0,   331,   397,   397,    55,   302,
     303,   416,   417,   418,    34,    36,    50,    60,    61,    65,
      76,    77,    78,    79,    80,    81,    95,    97,   207,   231,
     246,   256,   262,   267,   279,   282,   283,   284,   285,   289,
     293,   294,   308,   321,   423,   424,   425,   427,   428,   429,
     430,   431,   432,   436,   437,   438,   441,   442,   449,   453,
     458,   459,   461,   462,   463,   464,   465,   487,   488,   490,
     491,   493,   494,   497,   498,   505,   506,   507,   508,   509,
     512,   513,   519,   526,   527,   528,   529,   530,   531,   535,
     536,   537,   569,   583,   588,   589,   612,   613,   614,   331,
     320,   320,   331,   397,   469,   354,   357,   423,   397,   361,
     363,   514,   537,   366,   397,   370,   404,   420,   413,   402,
     404,   407,   407,   407,   410,    87,   238,   240,   413,   413,
     413,   413,   419,   402,   413,   414,   400,   402,   403,   402,
     404,   405,   420,   402,   407,   408,   407,   407,   402,   410,
     411,    87,   238,   240,   559,   413,   414,   413,   414,   413,
     414,   413,   414,   407,   413,   402,   401,   422,   404,   422,
      43,   422,   407,   407,   422,   410,   422,    43,    44,   407,
     422,   422,    87,   238,   255,   559,   413,    43,   422,    43,
     422,    43,   422,    43,   422,   413,   413,   413,    43,   422,
     413,    43,   422,    43,   422,   413,   402,   404,   407,   407,
     422,    43,   407,   404,   104,   105,   106,   616,   109,   110,
     208,   209,   212,   522,   523,    32,    33,   208,   591,   129,
     525,   163,   164,   654,   109,   110,   111,   618,   111,   113,
     114,   115,   620,   109,   110,   117,   118,   119,   120,   121,
     622,   109,   110,   113,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   172,   624,   111,   113,   131,   139,   140,
     141,   142,   628,   111,   131,   144,   258,   630,   109,   110,
     123,   125,   126,   127,   148,   149,   150,   632,   111,   113,
     131,   139,   140,   142,   152,   153,   634,   124,   140,   149,
     155,   156,   636,   140,   156,   638,   149,   159,   160,   640,
     127,   131,   163,   164,   642,   131,   163,   164,   166,   644,
     131,   140,   155,   159,   163,   164,   168,   169,   170,   171,
     172,   646,   111,   163,   164,   650,   131,   163,   164,   191,
     652,   111,   122,   124,   142,   146,   149,   196,   229,   230,
     312,   601,   603,   659,   197,   661,   197,   663,   159,   198,
     199,   200,   665,   124,   149,   657,   113,   128,   149,   155,
     203,   204,   667,   124,   149,   669,   111,   124,   131,   149,
     155,   671,   101,   127,   130,   147,   269,   286,   312,   586,
     587,   588,   109,   110,   113,   130,   208,   232,   233,   234,
     235,   236,   237,   239,   240,   241,   242,   243,   244,   245,
     248,   249,   250,   269,   605,   606,   609,   286,   296,   593,
     531,   536,   297,   192,   201,   202,   205,   206,   673,   318,
     319,   596,   530,   397,   352,   306,   352,    44,    46,    48,
      49,    56,    57,    89,   350,   413,   413,   413,   554,   568,
     556,   558,   100,   100,   100,    82,   601,   247,   506,   397,
     514,   584,   584,    60,    96,   397,   101,   586,    87,   184,
     238,   605,   606,   247,   247,   263,   247,   265,   266,   450,
      82,    82,   601,     4,   332,   538,   539,   304,   421,   428,
     357,   248,   249,   439,   440,   159,   257,   258,   259,   260,
     261,   443,   444,   280,   460,     5,    21,    68,    82,    84,
     108,   112,   116,   122,   126,   146,   192,   241,   244,   245,
     257,   282,   283,   309,   310,   323,   472,   473,   474,   475,
     476,   477,   478,   480,   481,   482,   483,   484,   485,   486,
     515,   518,   524,   578,   579,   580,   585,   590,   594,   600,
     601,   602,   604,   610,   611,   614,    37,    38,   181,   182,
     466,   467,    82,   286,   287,   288,   489,   495,   496,    82,
     492,   495,   290,   291,   292,   499,   500,   501,   502,    23,
     514,   516,   517,    43,   510,   511,    15,    16,    17,    18,
     325,     8,    24,    52,     9,    10,    11,    12,    13,    14,
     108,   112,   116,   122,   138,   143,   146,   151,   154,   157,
     158,   162,   165,   167,   189,   190,   285,   323,   483,   515,
     517,   518,   532,   533,   534,   537,   570,   571,   572,   573,
     574,   575,   576,   577,   579,   580,   581,   582,    50,    50,
      22,   321,   552,   570,   571,   552,    37,   321,   468,   321,
     321,   321,   321,   321,   416,   423,   469,   354,   357,   361,
     363,   366,   370,   413,   413,   413,   554,   568,   556,   558,
     423,    55,    55,    55,    55,   363,    55,   370,   413,   363,
     402,   407,   422,    43,    43,    43,   413,   402,   402,   402,
     402,   402,   402,   402,   407,   397,     7,     8,   111,   212,
     213,   521,   101,   123,   247,   108,   122,   108,   122,   134,
     135,   136,   137,   625,    23,    37,   100,   170,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   647,   603,
     327,   327,   109,   110,   122,   130,   146,   232,   233,   234,
     607,   608,   609,   297,   297,   100,   315,   595,   324,   351,
     352,   566,   566,   566,   248,   321,   553,   263,   321,   567,
     321,   450,   555,   321,   398,   557,     5,   122,   146,   485,
      82,   485,   503,   504,   531,    23,    23,    94,   321,    50,
      50,    50,   100,   265,    50,   609,    50,   485,   485,   265,
     266,   454,   485,   100,   485,   485,    82,   483,   537,   542,
     543,   550,   576,   577,     7,   322,   398,   321,   100,   100,
     440,    75,   108,   122,   167,   215,   446,   398,   100,   100,
     100,   398,   445,   444,   138,   151,   167,   281,   485,     5,
     485,    82,    82,   477,   515,   580,    15,    16,    17,    18,
     325,    20,    22,     8,    52,     5,   495,    82,    84,   197,
     257,     7,     7,   100,   100,   467,     5,     7,     5,   485,
     485,   500,     7,   397,   321,   397,   321,   511,   581,   581,
     572,   573,   574,   530,   321,   433,   516,   571,   576,     7,
      15,    16,    17,    18,   325,     7,    20,    22,     8,   571,
     485,   485,   100,   322,   331,   331,   100,   385,   356,   358,
     362,   367,   371,   468,   321,   321,   321,   321,   321,   566,
     566,   566,   553,   567,   555,   557,   100,   100,   100,   100,
     100,   321,   566,   402,   402,   402,   100,   523,   111,   127,
     132,   133,   197,   626,   647,    94,   127,   183,   184,   185,
     186,   187,   188,   648,   100,   100,   109,   110,   109,   110,
     100,   100,   298,   592,   100,   156,   314,   597,   601,   321,
     321,   321,   100,   378,   454,   383,   379,   100,   384,   485,
       5,     5,   485,   516,    87,    90,   421,   544,   545,   398,
     398,   100,   531,   540,   541,   485,   485,   485,   100,   485,
      50,   485,   100,   101,   249,   451,    41,   485,   332,     5,
     332,    87,    90,   421,   546,   549,   246,   262,   547,   548,
     332,   539,   359,   145,   140,   145,   447,   448,   111,   111,
      68,   111,   485,     5,   485,   485,   324,   472,   472,   473,
     474,   475,   100,   477,   472,   479,   516,   537,   485,   485,
      82,     8,    82,   515,   580,   610,   610,   485,   496,   485,
     495,   502,   503,   540,   332,   434,   435,   324,   576,   581,
     581,   572,   573,   574,   576,   100,   576,   534,   576,    38,
     331,   322,   331,   333,   421,   468,    36,    45,    50,    52,
      54,   159,   231,   246,   262,   267,   269,   322,   331,   333,
     355,   421,    91,   111,   159,   322,   331,   333,   387,   393,
     394,   421,   423,    39,    86,    87,    88,    89,    91,    94,
     111,   159,   231,   322,   331,   333,   368,   421,   426,   427,
      39,    87,    89,   111,   159,   322,   331,   333,   368,   421,
      40,    42,   246,   322,   331,   333,   356,   358,   362,   367,
     371,   321,   321,   321,   371,     7,     7,   328,   328,   592,
     301,   592,   100,   109,   110,   598,   381,   382,   380,   249,
     322,   331,   333,   421,   553,   100,   322,   331,   333,   421,
     567,   322,   331,   333,   421,   555,   451,   322,   331,   333,
     421,   557,   485,   485,     5,   101,   399,   399,   545,   321,
     428,   544,   485,    20,   101,   268,   452,   485,    41,    79,
      80,   551,   577,   583,   399,   399,   549,   248,   263,   548,
     322,   331,   423,     7,   101,   101,   101,   485,     5,   485,
     161,   485,   495,   495,     5,   322,   426,   428,   542,     7,
     322,   100,    38,   397,   415,   397,   406,   397,   409,   409,
     397,   412,   101,    87,   238,   240,   415,   415,   415,   415,
     331,    76,    77,   395,   396,   514,   101,    96,   331,   331,
     331,   331,   331,   360,   519,   399,   399,   320,    92,    93,
     369,   100,   101,   125,   126,   208,   228,   229,   375,   376,
     386,    83,    84,    85,    87,   364,   365,   331,   331,   331,
     427,   360,   399,   320,   376,   364,   331,   331,   101,   320,
     322,   322,   322,   322,   322,   381,   382,   380,   322,   100,
     100,   100,    91,   130,   232,   322,   331,   333,   421,   564,
      87,    94,   130,   164,   232,   322,   331,   333,   421,   565,
     111,   232,   322,   331,   333,   421,   561,   100,    20,   101,
     452,   485,   540,   322,   274,   275,   276,   277,   278,   457,
     264,   456,   100,   485,   332,   100,   454,   331,   448,   485,
      82,   503,     5,   322,   322,     5,   332,   435,   182,   470,
     100,   377,   357,   361,   366,   370,   415,   415,   415,   377,
     377,   377,   377,    40,     8,   331,   331,   331,   363,     8,
     331,     7,   331,     5,   331,   363,     5,   331,   147,   388,
     321,   372,   514,   322,   322,   322,     7,   592,   320,   162,
     167,   560,   401,   399,   100,   560,   100,   401,   102,   401,
     457,   456,   428,   264,   455,   100,   451,   249,   100,   485,
     322,   503,   583,   181,   471,   331,   321,   321,   321,   321,
     321,   377,   377,   377,   321,   321,   321,   321,   101,   519,
     375,   365,    84,   360,    84,   246,   262,   267,   269,   376,
      22,   100,   101,   319,   389,   390,   391,   514,   331,   101,
     373,   374,   514,   331,   100,   321,   331,   331,   331,   331,
     331,   331,   331,   130,   331,   455,   322,   100,   101,   249,
     100,    20,   101,   322,   332,   470,   385,   358,   362,   367,
     371,   321,   321,   321,   378,   383,   379,   384,    41,    42,
     392,   360,   331,   376,   331,   331,   331,   331,   331,   100,
      22,    25,     7,   322,   101,   562,   563,   560,   248,   457,
     456,   471,   322,   322,   322,   322,   322,   381,   382,   380,
     322,   322,   322,   322,   398,   514,   320,   388,   331,   331,
     100,   100,   332,   374,     5,     7,   322,   331,   455,   331,
     331,   331,   331,   331,   322,   322,   322,   331,   331,   331,
     331,   372,   100,   563,   331,   331,   331,   331
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_int16 yyr1[] =
{
       0,   329,   330,   330,   331,   331,   332,   332,   333,   333,
     333,   333,   333,   334,   334,   334,   334,   335,   335,   335,
     335,   335,   335,   335,   335,   335,   335,   335,   335,   335,
     335,   335,   336,   336,   336,   336,   336,   336,   336,   336,
     336,   336,   336,   336,   336,   336,   336,   336,   336,   336,
     336,   336,   336,   336,   336,   336,   337,   338,   338,   338,
     338,   338,   338,   338,   338,   338,   338,   338,   338,   338,
     338,   338,   338,   338,   339,   340,   340,   340,   340,   340,
     340,   340,   340,   340,   340,   340,   340,   340,   340,   340,
     340,   340,   340,   340,   340,   340,   340,   340,   341,   342,
     342,   342,   342,   342,   342,   342,   342,   342,   342,   342,
     342,   342,   342,   342,   342,   342,   342,   342,   342,   342,
     342,   342,   342,   342,   342,   342,   342,   342,   342,   342,
     342,   342,   342,   342,   343,   343,   343,   343,   343,   343,
     344,   344,   344,   344,   344,   344,   344,   345,   346,   346,
     347,   347,   348,   349,   349,   350,   350,   350,   350,   350,
     350,   350,   350,   351,   351,   352,   352,   352,   353,   354,
     355,   355,   356,   356,   356,   356,   356,   356,   356,   356,
     356,   356,   356,   356,   356,   356,   356,   356,   357,   358,
     358,   358,   358,   358,   358,   358,   358,   359,   359,   359,
     360,   360,   361,   362,   362,   362,   362,   362,   362,   362,
     362,   362,   362,   362,   362,   362,   363,   363,   364,   364,
     365,   365,   365,   365,   366,   367,   367,   367,   367,   367,
     367,   367,   367,   367,   367,   367,   367,   367,   367,   367,
     367,   368,   368,   369,   369,   370,   371,   371,   371,   371,
     371,   371,   372,   372,   373,   373,   373,   374,   374,   375,
     375,   376,   376,   377,   378,   378,   378,   378,   378,   379,
     379,   379,   379,   379,   380,   380,   380,   380,   380,   381,
     381,   381,   381,   381,   382,   382,   382,   382,   382,   383,
     383,   383,   383,   383,   384,   384,   384,   384,   384,   385,
     385,   385,   385,   385,   386,   386,   386,   386,   386,   387,
     388,   389,   389,   390,   390,   390,   390,   390,   391,   391,
     392,   392,   392,   392,   393,   394,   395,   395,   396,   396,
     397,   398,   398,   398,   399,   400,   400,   401,   401,   401,
     401,   401,   401,   402,   403,   404,   405,   406,   407,   408,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   419,   419,   419,   420,   421,   422,   422,   423,   423,
     424,   425,   425,   426,   426,   427,   427,   427,   427,   428,
     428,   428,   428,   428,   428,   428,   428,   428,   428,   428,
     428,   428,   428,   428,   428,   428,   428,   428,   428,   429,
     429,   430,   431,   431,   432,   433,   433,   434,   434,   434,
     435,   436,   436,   437,   437,   438,   438,   439,   439,   440,
     440,   441,   441,   442,   443,   443,   444,   444,   444,   444,
     444,   444,   445,   446,   446,   446,   446,   446,   447,   447,
     448,   448,   449,   449,   449,   450,   450,   450,   451,   451,
     452,   452,   453,   453,   454,   454,   454,   455,   455,   456,
     456,   456,   457,   457,   457,   457,   457,   458,   459,   460,
     460,   460,   460,   460,   461,   462,   462,   463,   463,   463,
     463,   463,   463,   464,   464,   465,   465,   466,   466,   467,
     467,   467,   467,   468,   468,   469,   470,   470,   471,   471,
     472,   472,   472,   472,   472,   472,   472,   472,   472,   472,
     472,   472,   472,   473,   473,   473,   474,   474,   475,   475,
     476,   476,   477,   478,   478,   479,   479,   480,   480,   481,
     482,   483,   484,   484,   484,   485,   485,   485,   486,   486,
     486,   486,   486,   486,   486,   486,   486,   486,   486,   486,
     486,   486,   487,   487,   488,   489,   489,   489,   490,   490,
     491,   492,   492,   492,   492,   492,   493,   493,   494,   494,
     495,   495,   496,   496,   496,   497,   497,   498,   499,   499,
     500,   500,   501,   501,   502,   502,   503,   503,   504,   505,
     505,   505,   506,   506,   506,   507,   507,   508,   508,   509,
     510,   510,   511,   512,   512,   513,   514,   515,   515,   516,
     516,   517,   518,   519,   519,   519,   519,   519,   519,   519,
     519,   519,   519,   519,   519,   519,   519,   519,   520,   521,
     521,   521,   522,   522,   522,   522,   522,   523,   523,   524,
     524,   525,   525,   526,   526,   526,   527,   527,   528,   528,
     529,   529,   530,   531,   531,   532,   533,   534,   534,   535,
     536,   536,   536,   537,   538,   538,   538,   539,   539,   539,
     540,   540,   541,   542,   542,   543,   543,   544,   544,   545,
     545,   545,   546,   546,   547,   547,   548,   548,   548,   548,
     549,   549,   549,   550,   550,   551,   551,   552,   552,   552,
     552,   553,   554,   555,   556,   557,   558,   559,   559,   559,
     560,   560,   561,   561,   562,   562,   563,   564,   564,   564,
     565,   565,   565,   565,   565,   566,   567,   567,   568,   569,
     569,   569,   570,   570,   571,   571,   571,   571,   572,   572,
     572,   573,   573,   574,   574,   575,   575,   576,   577,   577,
     577,   577,   578,   578,   579,   580,   580,   580,   580,   580,
     580,   580,   580,   580,   580,   580,   580,   581,   581,   581,
     581,   581,   581,   581,   581,   581,   581,   581,   581,   581,
     581,   581,   581,   581,   582,   582,   582,   582,   582,   582,
     583,   583,   583,   583,   583,   583,   584,   584,   585,   585,
     585,   586,   586,   587,   587,   587,   587,   587,   588,   588,
     588,   588,   588,   588,   588,   588,   588,   588,   588,   588,
     588,   588,   588,   588,   588,   588,   588,   588,   588,   588,
     588,   588,   589,   589,   589,   589,   589,   589,   590,   591,
     591,   591,   592,   592,   593,   593,   594,   595,   595,   596,
     596,   597,   597,   598,   598,   599,   599,   600,   600,   600,
     601,   601,   602,   602,   603,   603,   603,   603,   604,   604,
     604,   605,   605,   606,   606,   606,   606,   606,   606,   606,
     606,   606,   606,   606,   606,   606,   606,   606,   606,   606,
     607,   607,   607,   607,   607,   607,   607,   608,   608,   608,
     608,   609,   609,   609,   609,   610,   610,   611,   611,   612,
     612,   612,   612,   613,   614,   614,   614,   614,   614,   614,
     614,   614,   614,   614,   614,   614,   614,   614,   614,   614,
     614,   614,   615,   616,   616,   616,   617,   618,   618,   618,
     619,   620,   620,   620,   620,   621,   622,   622,   622,   622,
     622,   622,   622,   622,   622,   623,   623,   623,   624,   624,
     624,   624,   624,   624,   624,   624,   624,   624,   624,   624,
     625,   625,   625,   625,   626,   626,   626,   626,   626,   627,
     628,   628,   628,   628,   628,   628,   628,   629,   630,   630,
     630,   630,   631,   632,   632,   632,   632,   632,   632,   632,
     632,   632,   633,   634,   634,   634,   634,   634,   634,   634,
     634,   635,   636,   636,   636,   636,   636,   637,   638,   638,
     639,   640,   640,   640,   641,   642,   642,   642,   642,   643,
     644,   644,   644,   644,   645,   645,   645,   645,   646,   646,
     646,   646,   646,   646,   646,   646,   646,   646,   647,   647,
     647,   647,   647,   647,   647,   647,   647,   647,   647,   647,
     647,   648,   648,   648,   648,   648,   648,   648,   648,   649,
     650,   650,   650,   651,   652,   652,   652,   652,   653,   654,
     654,   655,   655,   655,   655,   655,   655,   655,   655,   656,
     657,   657,   658,   659,   659,   659,   659,   660,   661,   662,
     663,   664,   665,   665,   665,   665,   666,   667,   667,   667,
     667,   667,   667,   668,   669,   669,   670,   671,   671,   671,
     671,   671,   672,   673,   673,   673,   673,   673
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     0,     2,     1,     1,     1,     0,     3,     5,
       5,     3,     2,     1,     1,     2,     2,     1,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     6,     2,     6,     3,     2,     6,     6,
       3,     6,     2,     4,     6,     4,     6,     7,     7,     7,
       4,     6,     4,     6,     4,     6,     3,     2,     6,     2,
       6,     6,     6,     3,     6,     2,     4,     4,     7,     7,
       7,     4,     4,     4,     3,     2,     2,     2,     2,     2,
       2,     2,     2,     3,     2,     2,     6,     2,     2,     2,
       2,     4,     2,     2,     2,     2,     2,     2,     3,     2,
       2,     2,     2,     2,     3,     2,     2,     3,     2,     2,
       3,     2,     2,     3,     2,     2,     3,     2,     2,     3,
       2,     2,     3,     3,     2,     2,     2,     2,     2,     2,
       3,     4,     4,     4,     2,     3,     2,     2,     3,     2,
       2,     2,     2,     2,     3,     2,     2,     3,     2,     1,
       2,     1,     3,     0,     1,     0,     1,     1,     1,     1,
       1,     1,     1,     0,     1,     1,     1,     2,     1,     0,
       2,     1,     0,     2,     2,     3,     8,     8,     8,     8,
       8,     8,     9,     9,     9,     8,     8,     8,     0,     0,
       2,     2,     3,     3,     3,     3,     3,     0,     2,     3,
       1,     3,     0,     0,     2,     2,     4,     4,     4,     4,
       4,     3,     4,     2,     3,     3,     1,     1,     3,     1,
       1,     1,     1,     1,     0,     0,     2,     2,     4,     6,
       7,     6,     7,     6,     6,     6,     6,     4,     4,     3,
       3,     2,     2,     1,     1,     0,     0,     2,     2,     5,
       5,     2,     3,     1,     1,     3,     3,     1,     1,     1,
       1,     1,     3,     0,     0,     2,     2,     2,     2,     0,
       2,     2,     2,     2,     0,     2,     2,     2,     2,     0,
       2,     2,     2,     2,     0,     2,     2,     2,     2,     0,
       2,     2,     2,     2,     0,     2,     2,     2,     2,     0,
       2,     2,     2,     2,     1,     1,     1,     1,     1,     6,
       2,     1,     1,     1,     1,     1,     3,     3,     1,     2,
       2,     2,     3,     0,     2,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     0,     1,     1,     1,     1,
       1,     1,     1,     2,     3,     2,     3,     1,     2,     3,
       1,     2,     3,     1,     2,     3,     1,     2,     2,     2,
       1,     2,     2,     2,     2,     2,     0,     1,     1,     2,
       1,     1,     2,     1,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     5,     1,     1,     3,     3,     1,     1,     3,     3,
       5,     3,     4,     1,     2,     1,     3,     1,     2,     2,
       2,     1,     2,     1,     1,     2,     2,     2,     2,     2,
       2,     2,     1,     2,     2,     1,     1,     1,     3,     1,
       1,     1,     7,     6,     3,     1,     1,     0,     1,     1,
       0,     3,     5,     3,     1,     1,     0,     0,     3,     0,
       3,     3,     1,     1,     1,     1,     1,     2,     1,     0,
       4,     4,     4,     3,     2,     1,     1,     3,     4,     4,
       5,     6,     5,     1,     2,     1,     3,     1,     2,     2,
       2,     1,     1,     6,     8,     0,     0,     1,     0,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     1,     3,     3,     1,     3,     1,     3,
       1,     3,     1,     1,     3,     1,     1,     3,     1,     3,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       3,     3,     4,     5,     2,     3,     2,     6,     4,     3,
       4,     3,     2,     1,     1,     3,     4,     1,     2,     1,
       1,     2,     3,     1,     3,     4,     3,     5,     3,     6,
       1,     3,     1,     1,     1,     1,     2,     1,     1,     2,
       2,     1,     1,     3,     1,     1,     1,     2,     1,     4,
       5,     6,     1,     1,     1,     7,     8,     6,     1,     1,
       1,     2,     2,     6,     8,     1,     2,     1,     1,     1,
       1,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     3,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     3,     1,     3,
       3,     0,     2,     1,     3,     3,     1,     3,     1,     3,
       1,     3,     1,     1,     3,     3,     3,     1,     1,     3,
       1,     1,     1,     3,     1,     3,     3,     3,     3,     5,
       1,     2,     1,     1,     2,     2,     1,     1,     2,     2,
       2,     1,     1,     2,     1,     2,     1,     5,     7,     6,
       2,     2,     1,     1,     1,     1,     1,     1,     1,     2,
       2,     4,     0,     4,     0,     1,     0,     1,     1,     1,
       1,     1,     5,     3,     1,     3,     3,     3,     6,     3,
       3,     3,     3,     3,     3,     0,     6,     5,     0,     2,
       2,     3,     3,     3,     1,     1,     1,     1,     1,     3,
       3,     1,     3,     1,     3,     1,     3,     1,     1,     1,
       3,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     2,     1,     1,     1,     2,     1,
       2,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     4,     3,     4,     1,     4,     4,     2,     1,
       1,     1,     0,     2,     1,     1,     5,     2,     0,     1,
       1,     1,     1,     1,     1,     4,     5,     7,     5,     4,
       1,     1,     2,     3,     1,     1,     1,     1,     2,     3,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     2,     2,     2,
       2,     1,     1,     1,     1,     1,     1,     3,     3,     4,
       4,     4,     5,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     6,     1,     1,     1,     2,     1,     1,     1,
       2,     1,     1,     1,     1,     2,     1,     1,     1,     1,
       1,     2,     2,     2,     2,     2,     4,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       1,     1,     1,     1,     1,     1,     1,     2,     1,     1,
       1,     1,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     1,     1,     1,     1,     1,     2,     1,     1,
       2,     1,     1,     1,     2,     1,     1,     1,     1,     2,
       1,     1,     1,     1,     2,     4,     3,     8,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       1,     1,     1,     2,     1,     1,     1,     1,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       1,     1,     2,     1,     1,     1,     1,     2,     4,     2,
       1,     2,     1,     1,     1,     4,     2,     1,     1,     1,
       1,     1,     1,     2,     1,     1,     2,     1,     1,     1,
       1,     1,     2,     1,     1,     1,     1,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (&yylloc, nft, scanner, state, YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF

/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

# ifndef YY_LOCATION_PRINT
#  if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static int
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  int res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#   define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

#  else
#   define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#  endif
# endif /* !defined YY_LOCATION_PRINT */


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, Location, nft, scanner, state); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, struct nft_ctx *nft, void *scanner, struct parser_state *state)
{
  FILE *yyoutput = yyo;
  YYUSE (yyoutput);
  YYUSE (yylocationp);
  YYUSE (nft);
  YYUSE (scanner);
  YYUSE (state);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yykind < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yykind], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, struct nft_ctx *nft, void *scanner, struct parser_state *state)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  YY_LOCATION_PRINT (yyo, *yylocationp);
  YYFPRINTF (yyo, ": ");
  yy_symbol_value_print (yyo, yykind, yyvaluep, yylocationp, nft, scanner, state);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp,
                 int yyrule, struct nft_ctx *nft, void *scanner, struct parser_state *state)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)],
                       &(yylsp[(yyi + 1) - (yynrhs)]), nft, scanner, state);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule, nft, scanner, state); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


/* Context of a parse error.  */
typedef struct
{
  yy_state_t *yyssp;
  yysymbol_kind_t yytoken;
  YYLTYPE *yylloc;
} yypcontext_t;

/* Put in YYARG at most YYARGN of the expected tokens given the
   current YYCTX, and return the number of tokens stored in YYARG.  If
   YYARG is null, return the number of expected tokens (guaranteed to
   be less than YYNTOKENS).  Return YYENOMEM on memory exhaustion.
   Return 0 if there are more than YYARGN expected tokens, yet fill
   YYARG up to YYARGN. */
static int
yypcontext_expected_tokens (const yypcontext_t *yyctx,
                            yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  int yyn = yypact[+*yyctx->yyssp];
  if (!yypact_value_is_default (yyn))
    {
      /* Start YYX at -YYN if negative to avoid negative indexes in
         YYCHECK.  In other words, skip the first -YYN actions for
         this state because they are default actions.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;
      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yyx;
      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
        if (yycheck[yyx + yyn] == yyx && yyx != YYSYMBOL_YYerror
            && !yytable_value_is_error (yytable[yyx + yyn]))
          {
            if (!yyarg)
              ++yycount;
            else if (yycount == yyargn)
              return 0;
            else
              yyarg[yycount++] = YY_CAST (yysymbol_kind_t, yyx);
          }
    }
  if (yyarg && yycount == 0 && 0 < yyargn)
    yyarg[0] = YYSYMBOL_YYEMPTY;
  return yycount;
}




#ifndef yystrlen
# if defined __GLIBC__ && defined _STRING_H
#  define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
# else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
# endif
#endif

#ifndef yystpcpy
# if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#  define yystpcpy stpcpy
# else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
# endif
#endif

#ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYPTRDIFF_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYPTRDIFF_T yyn = 0;
      char const *yyp = yystr;
      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (yyres)
    return yystpcpy (yyres, yystr) - yyres;
  else
    return yystrlen (yystr);
}
#endif


static int
yy_syntax_error_arguments (const yypcontext_t *yyctx,
                           yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yyctx->yytoken != YYSYMBOL_YYEMPTY)
    {
      int yyn;
      if (yyarg)
        yyarg[yycount] = yyctx->yytoken;
      ++yycount;
      yyn = yypcontext_expected_tokens (yyctx,
                                        yyarg ? yyarg + 1 : yyarg, yyargn - 1);
      if (yyn == YYENOMEM)
        return YYENOMEM;
      else
        yycount += yyn;
    }
  return yycount;
}

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return -1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return YYENOMEM if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                const yypcontext_t *yyctx)
{
  enum { YYARGS_MAX = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  yysymbol_kind_t yyarg[YYARGS_MAX];
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* Actual size of YYARG. */
  int yycount = yy_syntax_error_arguments (yyctx, yyarg, YYARGS_MAX);
  if (yycount == YYENOMEM)
    return YYENOMEM;

  switch (yycount)
    {
#define YYCASE_(N, S)                       \
      case N:                               \
        yyformat = S;                       \
        break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
    }

  /* Compute error message size.  Don't count the "%s"s, but reserve
     room for the terminator.  */
  yysize = yystrlen (yyformat) - 2 * yycount + 1;
  {
    int yyi;
    for (yyi = 0; yyi < yycount; ++yyi)
      {
        YYPTRDIFF_T yysize1
          = yysize + yytnamerr (YY_NULLPTR, yytname[yyarg[yyi]]);
        if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
          yysize = yysize1;
        else
          return YYENOMEM;
      }
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return -1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yytname[yyarg[yyi++]]);
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, YYLTYPE *yylocationp, struct nft_ctx *nft, void *scanner, struct parser_state *state)
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  YYUSE (nft);
  YYUSE (scanner);
  YYUSE (state);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  switch (yykind)
    {
    case YYSYMBOL_STRING: /* "string"  */
#line 312 "parser_bison.y"
            { xfree(((*yyvaluep).string)); }
#line 5334 "parser_bison.c"
        break;

    case YYSYMBOL_QUOTED_STRING: /* "quoted string"  */
#line 312 "parser_bison.y"
            { xfree(((*yyvaluep).string)); }
#line 5340 "parser_bison.c"
        break;

    case YYSYMBOL_ASTERISK_STRING: /* "string with a trailing asterisk"  */
#line 312 "parser_bison.y"
            { xfree(((*yyvaluep).string)); }
#line 5346 "parser_bison.c"
        break;

    case YYSYMBOL_line: /* line  */
#line 587 "parser_bison.y"
            { cmd_free(((*yyvaluep).cmd)); }
#line 5352 "parser_bison.c"
        break;

    case YYSYMBOL_base_cmd: /* base_cmd  */
#line 590 "parser_bison.y"
            { cmd_free(((*yyvaluep).cmd)); }
#line 5358 "parser_bison.c"
        break;

    case YYSYMBOL_add_cmd: /* add_cmd  */
#line 590 "parser_bison.y"
            { cmd_free(((*yyvaluep).cmd)); }
#line 5364 "parser_bison.c"
        break;

    case YYSYMBOL_replace_cmd: /* replace_cmd  */
#line 590 "parser_bison.y"
            { cmd_free(((*yyvaluep).cmd)); }
#line 5370 "parser_bison.c"
        break;

    case YYSYMBOL_create_cmd: /* create_cmd  */
#line 590 "parser_bison.y"
            { cmd_free(((*yyvaluep).cmd)); }
#line 5376 "parser_bison.c"
        break;

    case YYSYMBOL_insert_cmd: /* insert_cmd  */
#line 590 "parser_bison.y"
            { cmd_free(((*yyvaluep).cmd)); }
#line 5382 "parser_bison.c"
        break;

    case YYSYMBOL_delete_cmd: /* delete_cmd  */
#line 590 "parser_bison.y"
            { cmd_free(((*yyvaluep).cmd)); }
#line 5388 "parser_bison.c"
        break;

    case YYSYMBOL_get_cmd: /* get_cmd  */
#line 590 "parser_bison.y"
            { cmd_free(((*yyvaluep).cmd)); }
#line 5394 "parser_bison.c"
        break;

    case YYSYMBOL_list_cmd: /* list_cmd  */
#line 590 "parser_bison.y"
            { cmd_free(((*yyvaluep).cmd)); }
#line 5400 "parser_bison.c"
        break;

    case YYSYMBOL_reset_cmd: /* reset_cmd  */
#line 590 "parser_bison.y"
            { cmd_free(((*yyvaluep).cmd)); }
#line 5406 "parser_bison.c"
        break;

    case YYSYMBOL_flush_cmd: /* flush_cmd  */
#line 590 "parser_bison.y"
            { cmd_free(((*yyvaluep).cmd)); }
#line 5412 "parser_bison.c"
        break;

    case YYSYMBOL_rename_cmd: /* rename_cmd  */
#line 590 "parser_bison.y"
            { cmd_free(((*yyvaluep).cmd)); }
#line 5418 "parser_bison.c"
        break;

    case YYSYMBOL_import_cmd: /* import_cmd  */
#line 590 "parser_bison.y"
            { cmd_free(((*yyvaluep).cmd)); }
#line 5424 "parser_bison.c"
        break;

    case YYSYMBOL_export_cmd: /* export_cmd  */
#line 590 "parser_bison.y"
            { cmd_free(((*yyvaluep).cmd)); }
#line 5430 "parser_bison.c"
        break;

    case YYSYMBOL_monitor_cmd: /* monitor_cmd  */
#line 590 "parser_bison.y"
            { cmd_free(((*yyvaluep).cmd)); }
#line 5436 "parser_bison.c"
        break;

    case YYSYMBOL_monitor_event: /* monitor_event  */
#line 813 "parser_bison.y"
            { xfree(((*yyvaluep).string)); }
#line 5442 "parser_bison.c"
        break;

    case YYSYMBOL_describe_cmd: /* describe_cmd  */
#line 590 "parser_bison.y"
            { cmd_free(((*yyvaluep).cmd)); }
#line 5448 "parser_bison.c"
        break;

    case YYSYMBOL_table_block_alloc: /* table_block_alloc  */
#line 606 "parser_bison.y"
            { close_scope(state); table_free(((*yyvaluep).table)); }
#line 5454 "parser_bison.c"
        break;

    case YYSYMBOL_chain_block_alloc: /* chain_block_alloc  */
#line 608 "parser_bison.y"
            { close_scope(state); chain_free(((*yyvaluep).chain)); }
#line 5460 "parser_bison.c"
        break;

    case YYSYMBOL_typeof_expr: /* typeof_expr  */
#line 677 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 5466 "parser_bison.c"
        break;

    case YYSYMBOL_set_block_alloc: /* set_block_alloc  */
#line 617 "parser_bison.y"
            { set_free(((*yyvaluep).set)); }
#line 5472 "parser_bison.c"
        break;

    case YYSYMBOL_set_block_expr: /* set_block_expr  */
#line 718 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 5478 "parser_bison.c"
        break;

    case YYSYMBOL_map_block_alloc: /* map_block_alloc  */
#line 620 "parser_bison.y"
            { set_free(((*yyvaluep).set)); }
#line 5484 "parser_bison.c"
        break;

    case YYSYMBOL_flowtable_block_alloc: /* flowtable_block_alloc  */
#line 623 "parser_bison.y"
            { flowtable_free(((*yyvaluep).flowtable)); }
#line 5490 "parser_bison.c"
        break;

    case YYSYMBOL_flowtable_expr: /* flowtable_expr  */
#line 718 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 5496 "parser_bison.c"
        break;

    case YYSYMBOL_flowtable_list_expr: /* flowtable_list_expr  */
#line 718 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 5502 "parser_bison.c"
        break;

    case YYSYMBOL_flowtable_expr_member: /* flowtable_expr_member  */
#line 718 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 5508 "parser_bison.c"
        break;

    case YYSYMBOL_data_type_atom_expr: /* data_type_atom_expr  */
#line 584 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 5514 "parser_bison.c"
        break;

    case YYSYMBOL_data_type_expr: /* data_type_expr  */
#line 584 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 5520 "parser_bison.c"
        break;

    case YYSYMBOL_obj_block_alloc: /* obj_block_alloc  */
#line 626 "parser_bison.y"
            { obj_free(((*yyvaluep).obj)); }
#line 5526 "parser_bison.c"
        break;

    case YYSYMBOL_type_identifier: /* type_identifier  */
#line 579 "parser_bison.y"
            { xfree(((*yyvaluep).string)); }
#line 5532 "parser_bison.c"
        break;

    case YYSYMBOL_extended_prio_name: /* extended_prio_name  */
#line 600 "parser_bison.y"
            { xfree(((*yyvaluep).string)); }
#line 5538 "parser_bison.c"
        break;

    case YYSYMBOL_dev_spec: /* dev_spec  */
#line 603 "parser_bison.y"
            { xfree(((*yyvaluep).expr)); }
#line 5544 "parser_bison.c"
        break;

    case YYSYMBOL_policy_expr: /* policy_expr  */
#line 675 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 5550 "parser_bison.c"
        break;

    case YYSYMBOL_identifier: /* identifier  */
#line 579 "parser_bison.y"
            { xfree(((*yyvaluep).string)); }
#line 5556 "parser_bison.c"
        break;

    case YYSYMBOL_string: /* string  */
#line 579 "parser_bison.y"
            { xfree(((*yyvaluep).string)); }
#line 5562 "parser_bison.c"
        break;

    case YYSYMBOL_table_spec: /* table_spec  */
#line 593 "parser_bison.y"
            { handle_free(&((*yyvaluep).handle)); }
#line 5568 "parser_bison.c"
        break;

    case YYSYMBOL_tableid_spec: /* tableid_spec  */
#line 593 "parser_bison.y"
            { handle_free(&((*yyvaluep).handle)); }
#line 5574 "parser_bison.c"
        break;

    case YYSYMBOL_chain_spec: /* chain_spec  */
#line 593 "parser_bison.y"
            { handle_free(&((*yyvaluep).handle)); }
#line 5580 "parser_bison.c"
        break;

    case YYSYMBOL_chainid_spec: /* chainid_spec  */
#line 593 "parser_bison.y"
            { handle_free(&((*yyvaluep).handle)); }
#line 5586 "parser_bison.c"
        break;

    case YYSYMBOL_chain_identifier: /* chain_identifier  */
#line 593 "parser_bison.y"
            { handle_free(&((*yyvaluep).handle)); }
#line 5592 "parser_bison.c"
        break;

    case YYSYMBOL_set_spec: /* set_spec  */
#line 595 "parser_bison.y"
            { handle_free(&((*yyvaluep).handle)); }
#line 5598 "parser_bison.c"
        break;

    case YYSYMBOL_setid_spec: /* setid_spec  */
#line 595 "parser_bison.y"
            { handle_free(&((*yyvaluep).handle)); }
#line 5604 "parser_bison.c"
        break;

    case YYSYMBOL_set_identifier: /* set_identifier  */
#line 595 "parser_bison.y"
            { handle_free(&((*yyvaluep).handle)); }
#line 5610 "parser_bison.c"
        break;

    case YYSYMBOL_flowtable_spec: /* flowtable_spec  */
#line 593 "parser_bison.y"
            { handle_free(&((*yyvaluep).handle)); }
#line 5616 "parser_bison.c"
        break;

    case YYSYMBOL_flowtableid_spec: /* flowtableid_spec  */
#line 595 "parser_bison.y"
            { handle_free(&((*yyvaluep).handle)); }
#line 5622 "parser_bison.c"
        break;

    case YYSYMBOL_obj_spec: /* obj_spec  */
#line 595 "parser_bison.y"
            { handle_free(&((*yyvaluep).handle)); }
#line 5628 "parser_bison.c"
        break;

    case YYSYMBOL_objid_spec: /* objid_spec  */
#line 595 "parser_bison.y"
            { handle_free(&((*yyvaluep).handle)); }
#line 5634 "parser_bison.c"
        break;

    case YYSYMBOL_obj_identifier: /* obj_identifier  */
#line 595 "parser_bison.y"
            { handle_free(&((*yyvaluep).handle)); }
#line 5640 "parser_bison.c"
        break;

    case YYSYMBOL_handle_spec: /* handle_spec  */
#line 593 "parser_bison.y"
            { handle_free(&((*yyvaluep).handle)); }
#line 5646 "parser_bison.c"
        break;

    case YYSYMBOL_position_spec: /* position_spec  */
#line 593 "parser_bison.y"
            { handle_free(&((*yyvaluep).handle)); }
#line 5652 "parser_bison.c"
        break;

    case YYSYMBOL_index_spec: /* index_spec  */
#line 593 "parser_bison.y"
            { handle_free(&((*yyvaluep).handle)); }
#line 5658 "parser_bison.c"
        break;

    case YYSYMBOL_rule_position: /* rule_position  */
#line 593 "parser_bison.y"
            { handle_free(&((*yyvaluep).handle)); }
#line 5664 "parser_bison.c"
        break;

    case YYSYMBOL_ruleid_spec: /* ruleid_spec  */
#line 593 "parser_bison.y"
            { handle_free(&((*yyvaluep).handle)); }
#line 5670 "parser_bison.c"
        break;

    case YYSYMBOL_comment_spec: /* comment_spec  */
#line 579 "parser_bison.y"
            { xfree(((*yyvaluep).string)); }
#line 5676 "parser_bison.c"
        break;

    case YYSYMBOL_ruleset_spec: /* ruleset_spec  */
#line 593 "parser_bison.y"
            { handle_free(&((*yyvaluep).handle)); }
#line 5682 "parser_bison.c"
        break;

    case YYSYMBOL_rule: /* rule  */
#line 610 "parser_bison.y"
            { rule_free(((*yyvaluep).rule)); }
#line 5688 "parser_bison.c"
        break;

    case YYSYMBOL_stmt_list: /* stmt_list  */
#line 629 "parser_bison.y"
            { stmt_list_free(((*yyvaluep).list)); xfree(((*yyvaluep).list)); }
#line 5694 "parser_bison.c"
        break;

    case YYSYMBOL_stateful_stmt_list: /* stateful_stmt_list  */
#line 629 "parser_bison.y"
            { stmt_list_free(((*yyvaluep).list)); xfree(((*yyvaluep).list)); }
#line 5700 "parser_bison.c"
        break;

    case YYSYMBOL_stateful_stmt: /* stateful_stmt  */
#line 633 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 5706 "parser_bison.c"
        break;

    case YYSYMBOL_stmt: /* stmt  */
#line 631 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 5712 "parser_bison.c"
        break;

    case YYSYMBOL_chain_stmt: /* chain_stmt  */
#line 656 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 5718 "parser_bison.c"
        break;

    case YYSYMBOL_verdict_stmt: /* verdict_stmt  */
#line 631 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 5724 "parser_bison.c"
        break;

    case YYSYMBOL_verdict_map_stmt: /* verdict_map_stmt  */
#line 712 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 5730 "parser_bison.c"
        break;

    case YYSYMBOL_verdict_map_expr: /* verdict_map_expr  */
#line 715 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 5736 "parser_bison.c"
        break;

    case YYSYMBOL_verdict_map_list_expr: /* verdict_map_list_expr  */
#line 715 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 5742 "parser_bison.c"
        break;

    case YYSYMBOL_verdict_map_list_member_expr: /* verdict_map_list_member_expr  */
#line 715 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 5748 "parser_bison.c"
        break;

    case YYSYMBOL_connlimit_stmt: /* connlimit_stmt  */
#line 644 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 5754 "parser_bison.c"
        break;

    case YYSYMBOL_counter_stmt: /* counter_stmt  */
#line 633 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 5760 "parser_bison.c"
        break;

    case YYSYMBOL_counter_stmt_alloc: /* counter_stmt_alloc  */
#line 633 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 5766 "parser_bison.c"
        break;

    case YYSYMBOL_log_stmt: /* log_stmt  */
#line 641 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 5772 "parser_bison.c"
        break;

    case YYSYMBOL_log_stmt_alloc: /* log_stmt_alloc  */
#line 641 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 5778 "parser_bison.c"
        break;

    case YYSYMBOL_limit_stmt: /* limit_stmt  */
#line 644 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 5784 "parser_bison.c"
        break;

    case YYSYMBOL_quota_unit: /* quota_unit  */
#line 600 "parser_bison.y"
            { xfree(((*yyvaluep).string)); }
#line 5790 "parser_bison.c"
        break;

    case YYSYMBOL_quota_stmt: /* quota_stmt  */
#line 644 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 5796 "parser_bison.c"
        break;

    case YYSYMBOL_reject_stmt: /* reject_stmt  */
#line 647 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 5802 "parser_bison.c"
        break;

    case YYSYMBOL_reject_stmt_alloc: /* reject_stmt_alloc  */
#line 647 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 5808 "parser_bison.c"
        break;

    case YYSYMBOL_nat_stmt: /* nat_stmt  */
#line 649 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 5814 "parser_bison.c"
        break;

    case YYSYMBOL_nat_stmt_alloc: /* nat_stmt_alloc  */
#line 649 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 5820 "parser_bison.c"
        break;

    case YYSYMBOL_tproxy_stmt: /* tproxy_stmt  */
#line 652 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 5826 "parser_bison.c"
        break;

    case YYSYMBOL_synproxy_stmt: /* synproxy_stmt  */
#line 654 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 5832 "parser_bison.c"
        break;

    case YYSYMBOL_synproxy_stmt_alloc: /* synproxy_stmt_alloc  */
#line 654 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 5838 "parser_bison.c"
        break;

    case YYSYMBOL_synproxy_obj: /* synproxy_obj  */
#line 738 "parser_bison.y"
            { obj_free(((*yyvaluep).obj)); }
#line 5844 "parser_bison.c"
        break;

    case YYSYMBOL_primary_stmt_expr: /* primary_stmt_expr  */
#line 699 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 5850 "parser_bison.c"
        break;

    case YYSYMBOL_shift_stmt_expr: /* shift_stmt_expr  */
#line 701 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 5856 "parser_bison.c"
        break;

    case YYSYMBOL_and_stmt_expr: /* and_stmt_expr  */
#line 703 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 5862 "parser_bison.c"
        break;

    case YYSYMBOL_exclusive_or_stmt_expr: /* exclusive_or_stmt_expr  */
#line 703 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 5868 "parser_bison.c"
        break;

    case YYSYMBOL_inclusive_or_stmt_expr: /* inclusive_or_stmt_expr  */
#line 703 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 5874 "parser_bison.c"
        break;

    case YYSYMBOL_basic_stmt_expr: /* basic_stmt_expr  */
#line 699 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 5880 "parser_bison.c"
        break;

    case YYSYMBOL_concat_stmt_expr: /* concat_stmt_expr  */
#line 691 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 5886 "parser_bison.c"
        break;

    case YYSYMBOL_map_stmt_expr_set: /* map_stmt_expr_set  */
#line 691 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 5892 "parser_bison.c"
        break;

    case YYSYMBOL_map_stmt_expr: /* map_stmt_expr  */
#line 691 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 5898 "parser_bison.c"
        break;

    case YYSYMBOL_prefix_stmt_expr: /* prefix_stmt_expr  */
#line 696 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 5904 "parser_bison.c"
        break;

    case YYSYMBOL_range_stmt_expr: /* range_stmt_expr  */
#line 696 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 5910 "parser_bison.c"
        break;

    case YYSYMBOL_wildcard_expr: /* wildcard_expr  */
#line 696 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 5916 "parser_bison.c"
        break;

    case YYSYMBOL_multiton_stmt_expr: /* multiton_stmt_expr  */
#line 694 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 5922 "parser_bison.c"
        break;

    case YYSYMBOL_stmt_expr: /* stmt_expr  */
#line 691 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 5928 "parser_bison.c"
        break;

    case YYSYMBOL_masq_stmt: /* masq_stmt  */
#line 649 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 5934 "parser_bison.c"
        break;

    case YYSYMBOL_masq_stmt_alloc: /* masq_stmt_alloc  */
#line 649 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 5940 "parser_bison.c"
        break;

    case YYSYMBOL_redir_stmt: /* redir_stmt  */
#line 649 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 5946 "parser_bison.c"
        break;

    case YYSYMBOL_redir_stmt_alloc: /* redir_stmt_alloc  */
#line 649 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 5952 "parser_bison.c"
        break;

    case YYSYMBOL_dup_stmt: /* dup_stmt  */
#line 663 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 5958 "parser_bison.c"
        break;

    case YYSYMBOL_fwd_stmt: /* fwd_stmt  */
#line 665 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 5964 "parser_bison.c"
        break;

    case YYSYMBOL_queue_stmt: /* queue_stmt  */
#line 660 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 5970 "parser_bison.c"
        break;

    case YYSYMBOL_queue_stmt_alloc: /* queue_stmt_alloc  */
#line 660 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 5976 "parser_bison.c"
        break;

    case YYSYMBOL_set_elem_expr_stmt: /* set_elem_expr_stmt  */
#line 722 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 5982 "parser_bison.c"
        break;

    case YYSYMBOL_set_elem_expr_stmt_alloc: /* set_elem_expr_stmt_alloc  */
#line 722 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 5988 "parser_bison.c"
        break;

    case YYSYMBOL_set_stmt: /* set_stmt  */
#line 667 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 5994 "parser_bison.c"
        break;

    case YYSYMBOL_map_stmt: /* map_stmt  */
#line 670 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 6000 "parser_bison.c"
        break;

    case YYSYMBOL_meter_stmt: /* meter_stmt  */
#line 672 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 6006 "parser_bison.c"
        break;

    case YYSYMBOL_flow_stmt_legacy_alloc: /* flow_stmt_legacy_alloc  */
#line 672 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 6012 "parser_bison.c"
        break;

    case YYSYMBOL_meter_stmt_alloc: /* meter_stmt_alloc  */
#line 672 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 6018 "parser_bison.c"
        break;

    case YYSYMBOL_match_stmt: /* match_stmt  */
#line 631 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 6024 "parser_bison.c"
        break;

    case YYSYMBOL_variable_expr: /* variable_expr  */
#line 675 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6030 "parser_bison.c"
        break;

    case YYSYMBOL_symbol_expr: /* symbol_expr  */
#line 675 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6036 "parser_bison.c"
        break;

    case YYSYMBOL_set_ref_expr: /* set_ref_expr  */
#line 683 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6042 "parser_bison.c"
        break;

    case YYSYMBOL_set_ref_symbol_expr: /* set_ref_symbol_expr  */
#line 683 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6048 "parser_bison.c"
        break;

    case YYSYMBOL_integer_expr: /* integer_expr  */
#line 675 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6054 "parser_bison.c"
        break;

    case YYSYMBOL_primary_expr: /* primary_expr  */
#line 677 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6060 "parser_bison.c"
        break;

    case YYSYMBOL_fib_expr: /* fib_expr  */
#line 804 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6066 "parser_bison.c"
        break;

    case YYSYMBOL_osf_expr: /* osf_expr  */
#line 809 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6072 "parser_bison.c"
        break;

    case YYSYMBOL_shift_expr: /* shift_expr  */
#line 677 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6078 "parser_bison.c"
        break;

    case YYSYMBOL_and_expr: /* and_expr  */
#line 677 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6084 "parser_bison.c"
        break;

    case YYSYMBOL_exclusive_or_expr: /* exclusive_or_expr  */
#line 679 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6090 "parser_bison.c"
        break;

    case YYSYMBOL_inclusive_or_expr: /* inclusive_or_expr  */
#line 679 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6096 "parser_bison.c"
        break;

    case YYSYMBOL_basic_expr: /* basic_expr  */
#line 681 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6102 "parser_bison.c"
        break;

    case YYSYMBOL_concat_expr: /* concat_expr  */
#line 706 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6108 "parser_bison.c"
        break;

    case YYSYMBOL_prefix_rhs_expr: /* prefix_rhs_expr  */
#line 688 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6114 "parser_bison.c"
        break;

    case YYSYMBOL_range_rhs_expr: /* range_rhs_expr  */
#line 688 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6120 "parser_bison.c"
        break;

    case YYSYMBOL_multiton_rhs_expr: /* multiton_rhs_expr  */
#line 686 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6126 "parser_bison.c"
        break;

    case YYSYMBOL_map_expr: /* map_expr  */
#line 709 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6132 "parser_bison.c"
        break;

    case YYSYMBOL_expr: /* expr  */
#line 728 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6138 "parser_bison.c"
        break;

    case YYSYMBOL_set_expr: /* set_expr  */
#line 718 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6144 "parser_bison.c"
        break;

    case YYSYMBOL_set_list_expr: /* set_list_expr  */
#line 718 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6150 "parser_bison.c"
        break;

    case YYSYMBOL_set_list_member_expr: /* set_list_member_expr  */
#line 718 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6156 "parser_bison.c"
        break;

    case YYSYMBOL_meter_key_expr: /* meter_key_expr  */
#line 725 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6162 "parser_bison.c"
        break;

    case YYSYMBOL_meter_key_expr_alloc: /* meter_key_expr_alloc  */
#line 725 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6168 "parser_bison.c"
        break;

    case YYSYMBOL_set_elem_expr: /* set_elem_expr  */
#line 720 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6174 "parser_bison.c"
        break;

    case YYSYMBOL_set_elem_expr_alloc: /* set_elem_expr_alloc  */
#line 720 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6180 "parser_bison.c"
        break;

    case YYSYMBOL_set_elem_stmt_list: /* set_elem_stmt_list  */
#line 629 "parser_bison.y"
            { stmt_list_free(((*yyvaluep).list)); xfree(((*yyvaluep).list)); }
#line 6186 "parser_bison.c"
        break;

    case YYSYMBOL_set_elem_stmt: /* set_elem_stmt  */
#line 631 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 6192 "parser_bison.c"
        break;

    case YYSYMBOL_set_lhs_expr: /* set_lhs_expr  */
#line 720 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6198 "parser_bison.c"
        break;

    case YYSYMBOL_set_rhs_expr: /* set_rhs_expr  */
#line 720 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6204 "parser_bison.c"
        break;

    case YYSYMBOL_initializer_expr: /* initializer_expr  */
#line 728 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6210 "parser_bison.c"
        break;

    case YYSYMBOL_counter_obj: /* counter_obj  */
#line 738 "parser_bison.y"
            { obj_free(((*yyvaluep).obj)); }
#line 6216 "parser_bison.c"
        break;

    case YYSYMBOL_quota_obj: /* quota_obj  */
#line 738 "parser_bison.y"
            { obj_free(((*yyvaluep).obj)); }
#line 6222 "parser_bison.c"
        break;

    case YYSYMBOL_secmark_obj: /* secmark_obj  */
#line 738 "parser_bison.y"
            { obj_free(((*yyvaluep).obj)); }
#line 6228 "parser_bison.c"
        break;

    case YYSYMBOL_timeout_states: /* timeout_states  */
#line 834 "parser_bison.y"
            { xfree(((*yyvaluep).list)); }
#line 6234 "parser_bison.c"
        break;

    case YYSYMBOL_timeout_state: /* timeout_state  */
#line 834 "parser_bison.y"
            { xfree(((*yyvaluep).list)); }
#line 6240 "parser_bison.c"
        break;

    case YYSYMBOL_ct_obj_alloc: /* ct_obj_alloc  */
#line 738 "parser_bison.y"
            { obj_free(((*yyvaluep).obj)); }
#line 6246 "parser_bison.c"
        break;

    case YYSYMBOL_limit_obj: /* limit_obj  */
#line 738 "parser_bison.y"
            { obj_free(((*yyvaluep).obj)); }
#line 6252 "parser_bison.c"
        break;

    case YYSYMBOL_relational_expr: /* relational_expr  */
#line 741 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6258 "parser_bison.c"
        break;

    case YYSYMBOL_list_rhs_expr: /* list_rhs_expr  */
#line 733 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6264 "parser_bison.c"
        break;

    case YYSYMBOL_rhs_expr: /* rhs_expr  */
#line 731 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6270 "parser_bison.c"
        break;

    case YYSYMBOL_shift_rhs_expr: /* shift_rhs_expr  */
#line 733 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6276 "parser_bison.c"
        break;

    case YYSYMBOL_and_rhs_expr: /* and_rhs_expr  */
#line 735 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6282 "parser_bison.c"
        break;

    case YYSYMBOL_exclusive_or_rhs_expr: /* exclusive_or_rhs_expr  */
#line 735 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6288 "parser_bison.c"
        break;

    case YYSYMBOL_inclusive_or_rhs_expr: /* inclusive_or_rhs_expr  */
#line 735 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6294 "parser_bison.c"
        break;

    case YYSYMBOL_basic_rhs_expr: /* basic_rhs_expr  */
#line 731 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6300 "parser_bison.c"
        break;

    case YYSYMBOL_concat_rhs_expr: /* concat_rhs_expr  */
#line 731 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6306 "parser_bison.c"
        break;

    case YYSYMBOL_boolean_expr: /* boolean_expr  */
#line 824 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6312 "parser_bison.c"
        break;

    case YYSYMBOL_keyword_expr: /* keyword_expr  */
#line 728 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6318 "parser_bison.c"
        break;

    case YYSYMBOL_primary_rhs_expr: /* primary_rhs_expr  */
#line 733 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6324 "parser_bison.c"
        break;

    case YYSYMBOL_verdict_expr: /* verdict_expr  */
#line 675 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6330 "parser_bison.c"
        break;

    case YYSYMBOL_chain_expr: /* chain_expr  */
#line 675 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6336 "parser_bison.c"
        break;

    case YYSYMBOL_meta_expr: /* meta_expr  */
#line 786 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6342 "parser_bison.c"
        break;

    case YYSYMBOL_meta_stmt: /* meta_stmt  */
#line 639 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 6348 "parser_bison.c"
        break;

    case YYSYMBOL_socket_expr: /* socket_expr  */
#line 790 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6354 "parser_bison.c"
        break;

    case YYSYMBOL_numgen_expr: /* numgen_expr  */
#line 754 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6360 "parser_bison.c"
        break;

    case YYSYMBOL_xfrm_expr: /* xfrm_expr  */
#line 838 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6366 "parser_bison.c"
        break;

    case YYSYMBOL_hash_expr: /* hash_expr  */
#line 754 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6372 "parser_bison.c"
        break;

    case YYSYMBOL_rt_expr: /* rt_expr  */
#line 796 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6378 "parser_bison.c"
        break;

    case YYSYMBOL_ct_expr: /* ct_expr  */
#line 800 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6384 "parser_bison.c"
        break;

    case YYSYMBOL_symbol_stmt_expr: /* symbol_stmt_expr  */
#line 733 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6390 "parser_bison.c"
        break;

    case YYSYMBOL_list_stmt_expr: /* list_stmt_expr  */
#line 701 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6396 "parser_bison.c"
        break;

    case YYSYMBOL_ct_stmt: /* ct_stmt  */
#line 637 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 6402 "parser_bison.c"
        break;

    case YYSYMBOL_payload_stmt: /* payload_stmt  */
#line 635 "parser_bison.y"
            { stmt_free(((*yyvaluep).stmt)); }
#line 6408 "parser_bison.c"
        break;

    case YYSYMBOL_payload_expr: /* payload_expr  */
#line 745 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6414 "parser_bison.c"
        break;

    case YYSYMBOL_payload_raw_expr: /* payload_raw_expr  */
#line 745 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6420 "parser_bison.c"
        break;

    case YYSYMBOL_eth_hdr_expr: /* eth_hdr_expr  */
#line 748 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6426 "parser_bison.c"
        break;

    case YYSYMBOL_vlan_hdr_expr: /* vlan_hdr_expr  */
#line 748 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6432 "parser_bison.c"
        break;

    case YYSYMBOL_arp_hdr_expr: /* arp_hdr_expr  */
#line 751 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6438 "parser_bison.c"
        break;

    case YYSYMBOL_ip_hdr_expr: /* ip_hdr_expr  */
#line 754 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6444 "parser_bison.c"
        break;

    case YYSYMBOL_icmp_hdr_expr: /* icmp_hdr_expr  */
#line 754 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6450 "parser_bison.c"
        break;

    case YYSYMBOL_igmp_hdr_expr: /* igmp_hdr_expr  */
#line 754 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6456 "parser_bison.c"
        break;

    case YYSYMBOL_ip6_hdr_expr: /* ip6_hdr_expr  */
#line 758 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6462 "parser_bison.c"
        break;

    case YYSYMBOL_icmp6_hdr_expr: /* icmp6_hdr_expr  */
#line 758 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6468 "parser_bison.c"
        break;

    case YYSYMBOL_auth_hdr_expr: /* auth_hdr_expr  */
#line 761 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6474 "parser_bison.c"
        break;

    case YYSYMBOL_esp_hdr_expr: /* esp_hdr_expr  */
#line 761 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6480 "parser_bison.c"
        break;

    case YYSYMBOL_comp_hdr_expr: /* comp_hdr_expr  */
#line 761 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6486 "parser_bison.c"
        break;

    case YYSYMBOL_udp_hdr_expr: /* udp_hdr_expr  */
#line 764 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6492 "parser_bison.c"
        break;

    case YYSYMBOL_udplite_hdr_expr: /* udplite_hdr_expr  */
#line 764 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6498 "parser_bison.c"
        break;

    case YYSYMBOL_tcp_hdr_expr: /* tcp_hdr_expr  */
#line 819 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6504 "parser_bison.c"
        break;

    case YYSYMBOL_dccp_hdr_expr: /* dccp_hdr_expr  */
#line 767 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6510 "parser_bison.c"
        break;

    case YYSYMBOL_sctp_hdr_expr: /* sctp_hdr_expr  */
#line 767 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6516 "parser_bison.c"
        break;

    case YYSYMBOL_th_hdr_expr: /* th_hdr_expr  */
#line 770 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6522 "parser_bison.c"
        break;

    case YYSYMBOL_exthdr_expr: /* exthdr_expr  */
#line 774 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6528 "parser_bison.c"
        break;

    case YYSYMBOL_hbh_hdr_expr: /* hbh_hdr_expr  */
#line 776 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6534 "parser_bison.c"
        break;

    case YYSYMBOL_rt_hdr_expr: /* rt_hdr_expr  */
#line 779 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6540 "parser_bison.c"
        break;

    case YYSYMBOL_rt0_hdr_expr: /* rt0_hdr_expr  */
#line 779 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6546 "parser_bison.c"
        break;

    case YYSYMBOL_rt2_hdr_expr: /* rt2_hdr_expr  */
#line 779 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6552 "parser_bison.c"
        break;

    case YYSYMBOL_rt4_hdr_expr: /* rt4_hdr_expr  */
#line 779 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6558 "parser_bison.c"
        break;

    case YYSYMBOL_frag_hdr_expr: /* frag_hdr_expr  */
#line 776 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6564 "parser_bison.c"
        break;

    case YYSYMBOL_dst_hdr_expr: /* dst_hdr_expr  */
#line 776 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6570 "parser_bison.c"
        break;

    case YYSYMBOL_mh_hdr_expr: /* mh_hdr_expr  */
#line 782 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6576 "parser_bison.c"
        break;

    case YYSYMBOL_exthdr_exists_expr: /* exthdr_exists_expr  */
#line 828 "parser_bison.y"
            { expr_free(((*yyvaluep).expr)); }
#line 6582 "parser_bison.c"
        break;

      default:
        break;
    }
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}






/*----------.
| yyparse.  |
`----------*/

int
yyparse (struct nft_ctx *nft, void *scanner, struct parser_state *state)
{
/* Lookahead token kind.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

/* Location data for the lookahead symbol.  */
static YYLTYPE yyloc_default
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
YYLTYPE yylloc = yyloc_default;

    /* Number of syntax errors so far.  */
    int yynerrs = 0;

    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

    /* The location stack: array, bottom, top.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls = yylsa;
    YYLTYPE *yylsp = yyls;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

  /* The locations where the error started and ended.  */
  YYLTYPE yyerror_range[3];

  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

/* User initialization code.  */
#line 158 "parser_bison.y"
{
	location_init(scanner, state, &yylloc);
	if (nft->debug_mask & NFT_DEBUG_SCANNER)
		nft_set_debug(1, scanner);
	if (nft->debug_mask & NFT_DEBUG_PARSER)
		yydebug = 1;
}

#line 6687 "parser_bison.c"

  yylsp[0] = yylloc;
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yyls1, yysize * YYSIZEOF (*yylsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
        yyls = yyls1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex (&yylval, &yylloc, scanner);
    }

  if (yychar <= TOKEN_EOF)
    {
      yychar = TOKEN_EOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      yyerror_range[1] = yylloc;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location. */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  yyerror_range[1] = yyloc;
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 3: /* input: input line  */
#line 844 "parser_bison.y"
                        {
				if ((yyvsp[0].cmd) != NULL) {
					(yyvsp[0].cmd)->location = (yylsp[0]);
					list_add_tail(&(yyvsp[0].cmd)->list, state->cmds);
				}
			}
#line 6904 "parser_bison.c"
    break;

  case 8: /* common_block: "include" "quoted string" stmt_separator  */
#line 861 "parser_bison.y"
                        {
				if (scanner_include_file(nft, scanner, (yyvsp[-1].string), &(yyloc)) < 0) {
					xfree((yyvsp[-1].string));
					YYERROR;
				}
				xfree((yyvsp[-1].string));
			}
#line 6916 "parser_bison.c"
    break;

  case 9: /* common_block: "define" identifier '=' initializer_expr stmt_separator  */
#line 869 "parser_bison.y"
                        {
				struct scope *scope = current_scope(state);

				if (symbol_lookup(scope, (yyvsp[-3].string)) != NULL) {
					erec_queue(error(&(yylsp[-3]), "redefinition of symbol '%s'", (yyvsp[-3].string)),
						   state->msgs);
					expr_free((yyvsp[-1].expr));
					xfree((yyvsp[-3].string));
					YYERROR;
				}

				symbol_bind(scope, (yyvsp[-3].string), (yyvsp[-1].expr));
				xfree((yyvsp[-3].string));
			}
#line 6935 "parser_bison.c"
    break;

  case 10: /* common_block: "redefine" identifier '=' initializer_expr stmt_separator  */
#line 884 "parser_bison.y"
                        {
				struct scope *scope = current_scope(state);

				symbol_bind(scope, (yyvsp[-3].string), (yyvsp[-1].expr));
				xfree((yyvsp[-3].string));
			}
#line 6946 "parser_bison.c"
    break;

  case 11: /* common_block: "undefine" identifier stmt_separator  */
#line 891 "parser_bison.y"
                        {
				struct scope *scope = current_scope(state);

				if (symbol_unbind(scope, (yyvsp[-1].string)) < 0) {
					erec_queue(error(&(yylsp[-1]), "undefined symbol '%s'", (yyvsp[-1].string)),
						   state->msgs);
					YYERROR;
				}
				xfree((yyvsp[-1].string));
			}
#line 6961 "parser_bison.c"
    break;

  case 12: /* common_block: error stmt_separator  */
#line 902 "parser_bison.y"
                        {
				if (++state->nerrs == nft->parser_max_errors)
					YYABORT;
				yyerrok;
			}
#line 6971 "parser_bison.c"
    break;

  case 13: /* line: common_block  */
#line 909 "parser_bison.y"
                                                                { (yyval.cmd) = NULL; }
#line 6977 "parser_bison.c"
    break;

  case 14: /* line: stmt_separator  */
#line 910 "parser_bison.y"
                                                                { (yyval.cmd) = NULL; }
#line 6983 "parser_bison.c"
    break;

  case 15: /* line: base_cmd stmt_separator  */
#line 911 "parser_bison.y"
                                                                { (yyval.cmd) = (yyvsp[-1].cmd); }
#line 6989 "parser_bison.c"
    break;

  case 16: /* line: base_cmd "end of file"  */
#line 913 "parser_bison.y"
                        {
				/*
				 * Very hackish workaround for bison >= 2.4: previous versions
				 * terminated parsing after EOF, 2.4+ tries to get further input
				 * in 'input' and calls the scanner again, causing a crash when
				 * the final input buffer has been popped. Terminate manually to
				 * avoid this. The correct fix should be to adjust the grammar
				 * to accept EOF in input, but for unknown reasons it does not
				 * work.
				 */
				if ((yyvsp[-1].cmd) != NULL) {
					(yyvsp[-1].cmd)->location = (yylsp[-1]);
					list_add_tail(&(yyvsp[-1].cmd)->list, state->cmds);
				}
				(yyval.cmd) = NULL;
				YYACCEPT;
			}
#line 7011 "parser_bison.c"
    break;

  case 17: /* base_cmd: add_cmd  */
#line 932 "parser_bison.y"
                                                                { (yyval.cmd) = (yyvsp[0].cmd); }
#line 7017 "parser_bison.c"
    break;

  case 18: /* base_cmd: "add" add_cmd  */
#line 933 "parser_bison.y"
                                                                { (yyval.cmd) = (yyvsp[0].cmd); }
#line 7023 "parser_bison.c"
    break;

  case 19: /* base_cmd: "replace" replace_cmd  */
#line 934 "parser_bison.y"
                                                                { (yyval.cmd) = (yyvsp[0].cmd); }
#line 7029 "parser_bison.c"
    break;

  case 20: /* base_cmd: "create" create_cmd  */
#line 935 "parser_bison.y"
                                                                { (yyval.cmd) = (yyvsp[0].cmd); }
#line 7035 "parser_bison.c"
    break;

  case 21: /* base_cmd: "insert" insert_cmd  */
#line 936 "parser_bison.y"
                                                                { (yyval.cmd) = (yyvsp[0].cmd); }
#line 7041 "parser_bison.c"
    break;

  case 22: /* base_cmd: "delete" delete_cmd  */
#line 937 "parser_bison.y"
                                                                { (yyval.cmd) = (yyvsp[0].cmd); }
#line 7047 "parser_bison.c"
    break;

  case 23: /* base_cmd: "get" get_cmd  */
#line 938 "parser_bison.y"
                                                                { (yyval.cmd) = (yyvsp[0].cmd); }
#line 7053 "parser_bison.c"
    break;

  case 24: /* base_cmd: "list" list_cmd  */
#line 939 "parser_bison.y"
                                                                { (yyval.cmd) = (yyvsp[0].cmd); }
#line 7059 "parser_bison.c"
    break;

  case 25: /* base_cmd: "reset" reset_cmd  */
#line 940 "parser_bison.y"
                                                                { (yyval.cmd) = (yyvsp[0].cmd); }
#line 7065 "parser_bison.c"
    break;

  case 26: /* base_cmd: "flush" flush_cmd  */
#line 941 "parser_bison.y"
                                                                { (yyval.cmd) = (yyvsp[0].cmd); }
#line 7071 "parser_bison.c"
    break;

  case 27: /* base_cmd: "rename" rename_cmd  */
#line 942 "parser_bison.y"
                                                                { (yyval.cmd) = (yyvsp[0].cmd); }
#line 7077 "parser_bison.c"
    break;

  case 28: /* base_cmd: "import" import_cmd  */
#line 943 "parser_bison.y"
                                                                { (yyval.cmd) = (yyvsp[0].cmd); }
#line 7083 "parser_bison.c"
    break;

  case 29: /* base_cmd: "export" export_cmd  */
#line 944 "parser_bison.y"
                                                                { (yyval.cmd) = (yyvsp[0].cmd); }
#line 7089 "parser_bison.c"
    break;

  case 30: /* base_cmd: "monitor" monitor_cmd  */
#line 945 "parser_bison.y"
                                                                { (yyval.cmd) = (yyvsp[0].cmd); }
#line 7095 "parser_bison.c"
    break;

  case 31: /* base_cmd: "describe" describe_cmd  */
#line 946 "parser_bison.y"
                                                                { (yyval.cmd) = (yyvsp[0].cmd); }
#line 7101 "parser_bison.c"
    break;

  case 32: /* add_cmd: "table" table_spec  */
#line 950 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_TABLE, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7109 "parser_bison.c"
    break;

  case 33: /* add_cmd: "table" table_spec table_block_alloc '{' table_block '}'  */
#line 955 "parser_bison.y"
                        {
				handle_merge(&(yyvsp[-3].table)->handle, &(yyvsp[-4].handle));
				close_scope(state);
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_TABLE, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-1].table));
			}
#line 7119 "parser_bison.c"
    break;

  case 34: /* add_cmd: "chain" chain_spec  */
#line 961 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_CHAIN, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7127 "parser_bison.c"
    break;

  case 35: /* add_cmd: "chain" chain_spec chain_block_alloc '{' chain_block '}'  */
#line 966 "parser_bison.y"
                        {
				(yyvsp[-1].chain)->location = (yylsp[-1]);
				handle_merge(&(yyvsp[-3].chain)->handle, &(yyvsp[-4].handle));
				close_scope(state);
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_CHAIN, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-1].chain));
			}
#line 7138 "parser_bison.c"
    break;

  case 36: /* add_cmd: "rule" rule_position rule  */
#line 973 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_RULE, &(yyvsp[-1].handle), &(yyloc), (yyvsp[0].rule));
			}
#line 7146 "parser_bison.c"
    break;

  case 37: /* add_cmd: rule_position rule  */
#line 977 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_RULE, &(yyvsp[-1].handle), &(yyloc), (yyvsp[0].rule));
			}
#line 7154 "parser_bison.c"
    break;

  case 38: /* add_cmd: "set" set_spec set_block_alloc '{' set_block '}'  */
#line 982 "parser_bison.y"
                        {
				(yyvsp[-1].set)->location = (yylsp[-1]);
				handle_merge(&(yyvsp[-3].set)->handle, &(yyvsp[-4].handle));
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_SET, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-1].set));
			}
#line 7164 "parser_bison.c"
    break;

  case 39: /* add_cmd: "map" set_spec map_block_alloc '{' map_block '}'  */
#line 989 "parser_bison.y"
                        {
				(yyvsp[-1].set)->location = (yylsp[-1]);
				handle_merge(&(yyvsp[-3].set)->handle, &(yyvsp[-4].handle));
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_SET, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-1].set));
			}
#line 7174 "parser_bison.c"
    break;

  case 40: /* add_cmd: "element" set_spec set_block_expr  */
#line 995 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_ELEMENTS, &(yyvsp[-1].handle), &(yyloc), (yyvsp[0].expr));
			}
#line 7182 "parser_bison.c"
    break;

  case 41: /* add_cmd: "flowtable" flowtable_spec flowtable_block_alloc '{' flowtable_block '}'  */
#line 1000 "parser_bison.y"
                        {
				(yyvsp[-1].flowtable)->location = (yylsp[-1]);
				handle_merge(&(yyvsp[-3].flowtable)->handle, &(yyvsp[-4].handle));
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_FLOWTABLE, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-1].flowtable));
			}
#line 7192 "parser_bison.c"
    break;

  case 42: /* add_cmd: "counter" obj_spec  */
#line 1006 "parser_bison.y"
                        {
				struct obj *obj;

				obj = obj_alloc(&(yyloc));
				obj->type = NFT_OBJECT_COUNTER;
				handle_merge(&obj->handle, &(yyvsp[0].handle));
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_COUNTER, &(yyvsp[0].handle), &(yyloc), obj);
			}
#line 7205 "parser_bison.c"
    break;

  case 43: /* add_cmd: "counter" obj_spec counter_obj counter_config  */
#line 1015 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_COUNTER, &(yyvsp[-2].handle), &(yyloc), (yyvsp[-1].obj));
			}
#line 7213 "parser_bison.c"
    break;

  case 44: /* add_cmd: "counter" obj_spec counter_obj '{' counter_block '}'  */
#line 1019 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_COUNTER, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-3].obj));
			}
#line 7221 "parser_bison.c"
    break;

  case 45: /* add_cmd: "quota" obj_spec quota_obj quota_config  */
#line 1023 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_QUOTA, &(yyvsp[-2].handle), &(yyloc), (yyvsp[-1].obj));
			}
#line 7229 "parser_bison.c"
    break;

  case 46: /* add_cmd: "quota" obj_spec quota_obj '{' quota_block '}'  */
#line 1027 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_QUOTA, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-3].obj));
			}
#line 7237 "parser_bison.c"
    break;

  case 47: /* add_cmd: "ct" "helper" obj_spec ct_obj_alloc '{' ct_helper_block '}'  */
#line 1031 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc_obj_ct(CMD_ADD, NFT_OBJECT_CT_HELPER, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-3].obj));
			}
#line 7245 "parser_bison.c"
    break;

  case 48: /* add_cmd: "ct" "timeout" obj_spec ct_obj_alloc '{' ct_timeout_block '}'  */
#line 1035 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc_obj_ct(CMD_ADD, NFT_OBJECT_CT_TIMEOUT, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-3].obj));
			}
#line 7253 "parser_bison.c"
    break;

  case 49: /* add_cmd: "ct" "expectation" obj_spec ct_obj_alloc '{' ct_expect_block '}'  */
#line 1039 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc_obj_ct(CMD_ADD, NFT_OBJECT_CT_EXPECT, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-3].obj));
			}
#line 7261 "parser_bison.c"
    break;

  case 50: /* add_cmd: "limit" obj_spec limit_obj limit_config  */
#line 1043 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_LIMIT, &(yyvsp[-2].handle), &(yyloc), (yyvsp[-1].obj));
			}
#line 7269 "parser_bison.c"
    break;

  case 51: /* add_cmd: "limit" obj_spec limit_obj '{' limit_block '}'  */
#line 1047 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_LIMIT, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-3].obj));
			}
#line 7277 "parser_bison.c"
    break;

  case 52: /* add_cmd: "secmark" obj_spec secmark_obj secmark_config  */
#line 1051 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_SECMARK, &(yyvsp[-2].handle), &(yyloc), (yyvsp[-1].obj));
			}
#line 7285 "parser_bison.c"
    break;

  case 53: /* add_cmd: "secmark" obj_spec secmark_obj '{' secmark_block '}'  */
#line 1055 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_SECMARK, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-3].obj));
			}
#line 7293 "parser_bison.c"
    break;

  case 54: /* add_cmd: "synproxy" obj_spec synproxy_obj synproxy_config  */
#line 1059 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_SYNPROXY, &(yyvsp[-2].handle), &(yyloc), (yyvsp[-1].obj));
			}
#line 7301 "parser_bison.c"
    break;

  case 55: /* add_cmd: "synproxy" obj_spec synproxy_obj '{' synproxy_block '}'  */
#line 1063 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_ADD, CMD_OBJ_SYNPROXY, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-3].obj));
			}
#line 7309 "parser_bison.c"
    break;

  case 56: /* replace_cmd: "rule" ruleid_spec rule  */
#line 1069 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_REPLACE, CMD_OBJ_RULE, &(yyvsp[-1].handle), &(yyloc), (yyvsp[0].rule));
			}
#line 7317 "parser_bison.c"
    break;

  case 57: /* create_cmd: "table" table_spec  */
#line 1075 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_CREATE, CMD_OBJ_TABLE, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7325 "parser_bison.c"
    break;

  case 58: /* create_cmd: "table" table_spec table_block_alloc '{' table_block '}'  */
#line 1080 "parser_bison.y"
                        {
				handle_merge(&(yyvsp[-3].table)->handle, &(yyvsp[-4].handle));
				close_scope(state);
				(yyval.cmd) = cmd_alloc(CMD_CREATE, CMD_OBJ_TABLE, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-1].table));
			}
#line 7335 "parser_bison.c"
    break;

  case 59: /* create_cmd: "chain" chain_spec  */
#line 1086 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_CREATE, CMD_OBJ_CHAIN, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7343 "parser_bison.c"
    break;

  case 60: /* create_cmd: "chain" chain_spec chain_block_alloc '{' chain_block '}'  */
#line 1091 "parser_bison.y"
                        {
				(yyvsp[-1].chain)->location = (yylsp[-1]);
				handle_merge(&(yyvsp[-3].chain)->handle, &(yyvsp[-4].handle));
				close_scope(state);
				(yyval.cmd) = cmd_alloc(CMD_CREATE, CMD_OBJ_CHAIN, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-1].chain));
			}
#line 7354 "parser_bison.c"
    break;

  case 61: /* create_cmd: "set" set_spec set_block_alloc '{' set_block '}'  */
#line 1099 "parser_bison.y"
                        {
				(yyvsp[-1].set)->location = (yylsp[-1]);
				handle_merge(&(yyvsp[-3].set)->handle, &(yyvsp[-4].handle));
				(yyval.cmd) = cmd_alloc(CMD_CREATE, CMD_OBJ_SET, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-1].set));
			}
#line 7364 "parser_bison.c"
    break;

  case 62: /* create_cmd: "map" set_spec map_block_alloc '{' map_block '}'  */
#line 1106 "parser_bison.y"
                        {
				(yyvsp[-1].set)->location = (yylsp[-1]);
				handle_merge(&(yyvsp[-3].set)->handle, &(yyvsp[-4].handle));
				(yyval.cmd) = cmd_alloc(CMD_CREATE, CMD_OBJ_SET, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-1].set));
			}
#line 7374 "parser_bison.c"
    break;

  case 63: /* create_cmd: "element" set_spec set_block_expr  */
#line 1112 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_CREATE, CMD_OBJ_ELEMENTS, &(yyvsp[-1].handle), &(yyloc), (yyvsp[0].expr));
			}
#line 7382 "parser_bison.c"
    break;

  case 64: /* create_cmd: "flowtable" flowtable_spec flowtable_block_alloc '{' flowtable_block '}'  */
#line 1117 "parser_bison.y"
                        {
				(yyvsp[-1].flowtable)->location = (yylsp[-1]);
				handle_merge(&(yyvsp[-3].flowtable)->handle, &(yyvsp[-4].handle));
				(yyval.cmd) = cmd_alloc(CMD_CREATE, CMD_OBJ_FLOWTABLE, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-1].flowtable));
			}
#line 7392 "parser_bison.c"
    break;

  case 65: /* create_cmd: "counter" obj_spec  */
#line 1123 "parser_bison.y"
                        {
				struct obj *obj;

				obj = obj_alloc(&(yyloc));
				obj->type = NFT_OBJECT_COUNTER;
				handle_merge(&obj->handle, &(yyvsp[0].handle));
				(yyval.cmd) = cmd_alloc(CMD_CREATE, CMD_OBJ_COUNTER, &(yyvsp[0].handle), &(yyloc), obj);
			}
#line 7405 "parser_bison.c"
    break;

  case 66: /* create_cmd: "counter" obj_spec counter_obj counter_config  */
#line 1132 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_CREATE, CMD_OBJ_COUNTER, &(yyvsp[-2].handle), &(yyloc), (yyvsp[-1].obj));
			}
#line 7413 "parser_bison.c"
    break;

  case 67: /* create_cmd: "quota" obj_spec quota_obj quota_config  */
#line 1136 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_CREATE, CMD_OBJ_QUOTA, &(yyvsp[-2].handle), &(yyloc), (yyvsp[-1].obj));
			}
#line 7421 "parser_bison.c"
    break;

  case 68: /* create_cmd: "ct" "helper" obj_spec ct_obj_alloc '{' ct_helper_block '}'  */
#line 1140 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc_obj_ct(CMD_CREATE, NFT_OBJECT_CT_HELPER, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-3].obj));
			}
#line 7429 "parser_bison.c"
    break;

  case 69: /* create_cmd: "ct" "timeout" obj_spec ct_obj_alloc '{' ct_timeout_block '}'  */
#line 1144 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc_obj_ct(CMD_CREATE, NFT_OBJECT_CT_TIMEOUT, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-3].obj));
			}
#line 7437 "parser_bison.c"
    break;

  case 70: /* create_cmd: "ct" "expectation" obj_spec ct_obj_alloc '{' ct_expect_block '}'  */
#line 1148 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc_obj_ct(CMD_CREATE, NFT_OBJECT_CT_EXPECT, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-3].obj));
			}
#line 7445 "parser_bison.c"
    break;

  case 71: /* create_cmd: "limit" obj_spec limit_obj limit_config  */
#line 1152 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_CREATE, CMD_OBJ_LIMIT, &(yyvsp[-2].handle), &(yyloc), (yyvsp[-1].obj));
			}
#line 7453 "parser_bison.c"
    break;

  case 72: /* create_cmd: "secmark" obj_spec secmark_obj secmark_config  */
#line 1156 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_CREATE, CMD_OBJ_SECMARK, &(yyvsp[-2].handle), &(yyloc), (yyvsp[-1].obj));
			}
#line 7461 "parser_bison.c"
    break;

  case 73: /* create_cmd: "synproxy" obj_spec synproxy_obj synproxy_config  */
#line 1160 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_CREATE, CMD_OBJ_SYNPROXY, &(yyvsp[-2].handle), &(yyloc), (yyvsp[-1].obj));
			}
#line 7469 "parser_bison.c"
    break;

  case 74: /* insert_cmd: "rule" rule_position rule  */
#line 1166 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_INSERT, CMD_OBJ_RULE, &(yyvsp[-1].handle), &(yyloc), (yyvsp[0].rule));
			}
#line 7477 "parser_bison.c"
    break;

  case 75: /* delete_cmd: "table" table_spec  */
#line 1172 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_TABLE, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7485 "parser_bison.c"
    break;

  case 76: /* delete_cmd: "table" tableid_spec  */
#line 1176 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_TABLE, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7493 "parser_bison.c"
    break;

  case 77: /* delete_cmd: "chain" chain_spec  */
#line 1180 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_CHAIN, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7501 "parser_bison.c"
    break;

  case 78: /* delete_cmd: "chain" chainid_spec  */
#line 1184 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_CHAIN, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7509 "parser_bison.c"
    break;

  case 79: /* delete_cmd: "rule" ruleid_spec  */
#line 1188 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_RULE, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7517 "parser_bison.c"
    break;

  case 80: /* delete_cmd: "set" set_spec  */
#line 1192 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_SET, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7525 "parser_bison.c"
    break;

  case 81: /* delete_cmd: "set" setid_spec  */
#line 1196 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_SET, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7533 "parser_bison.c"
    break;

  case 82: /* delete_cmd: "map" set_spec  */
#line 1200 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_SET, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7541 "parser_bison.c"
    break;

  case 83: /* delete_cmd: "element" set_spec set_block_expr  */
#line 1204 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_ELEMENTS, &(yyvsp[-1].handle), &(yyloc), (yyvsp[0].expr));
			}
#line 7549 "parser_bison.c"
    break;

  case 84: /* delete_cmd: "flowtable" flowtable_spec  */
#line 1208 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_FLOWTABLE, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7557 "parser_bison.c"
    break;

  case 85: /* delete_cmd: "flowtable" flowtableid_spec  */
#line 1212 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_FLOWTABLE, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7565 "parser_bison.c"
    break;

  case 86: /* delete_cmd: "flowtable" flowtable_spec flowtable_block_alloc '{' flowtable_block '}'  */
#line 1217 "parser_bison.y"
                        {
				(yyvsp[-1].flowtable)->location = (yylsp[-1]);
				handle_merge(&(yyvsp[-3].flowtable)->handle, &(yyvsp[-4].handle));
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_FLOWTABLE, &(yyvsp[-4].handle), &(yyloc), (yyvsp[-1].flowtable));
			}
#line 7575 "parser_bison.c"
    break;

  case 87: /* delete_cmd: "counter" obj_spec  */
#line 1223 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_COUNTER, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7583 "parser_bison.c"
    break;

  case 88: /* delete_cmd: "counter" objid_spec  */
#line 1227 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_COUNTER, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7591 "parser_bison.c"
    break;

  case 89: /* delete_cmd: "quota" obj_spec  */
#line 1231 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_QUOTA, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7599 "parser_bison.c"
    break;

  case 90: /* delete_cmd: "quota" objid_spec  */
#line 1235 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_QUOTA, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7607 "parser_bison.c"
    break;

  case 91: /* delete_cmd: "ct" ct_obj_type obj_spec ct_obj_alloc  */
#line 1239 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc_obj_ct(CMD_DELETE, (yyvsp[-2].val), &(yyvsp[-1].handle), &(yyloc), (yyvsp[0].obj));
			}
#line 7615 "parser_bison.c"
    break;

  case 92: /* delete_cmd: "limit" obj_spec  */
#line 1243 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_LIMIT, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7623 "parser_bison.c"
    break;

  case 93: /* delete_cmd: "limit" objid_spec  */
#line 1247 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_LIMIT, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7631 "parser_bison.c"
    break;

  case 94: /* delete_cmd: "secmark" obj_spec  */
#line 1251 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_SECMARK, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7639 "parser_bison.c"
    break;

  case 95: /* delete_cmd: "secmark" objid_spec  */
#line 1255 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_SECMARK, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7647 "parser_bison.c"
    break;

  case 96: /* delete_cmd: "synproxy" obj_spec  */
#line 1259 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_SYNPROXY, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7655 "parser_bison.c"
    break;

  case 97: /* delete_cmd: "synproxy" objid_spec  */
#line 1263 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_DELETE, CMD_OBJ_SYNPROXY, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7663 "parser_bison.c"
    break;

  case 98: /* get_cmd: "element" set_spec set_block_expr  */
#line 1269 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_GET, CMD_OBJ_ELEMENTS, &(yyvsp[-1].handle), &(yyloc), (yyvsp[0].expr));
			}
#line 7671 "parser_bison.c"
    break;

  case 99: /* list_cmd: "table" table_spec  */
#line 1275 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_TABLE, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7679 "parser_bison.c"
    break;

  case 100: /* list_cmd: "tables" ruleset_spec  */
#line 1279 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_TABLE, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7687 "parser_bison.c"
    break;

  case 101: /* list_cmd: "chain" chain_spec  */
#line 1283 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_CHAIN, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7695 "parser_bison.c"
    break;

  case 102: /* list_cmd: "chains" ruleset_spec  */
#line 1287 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_CHAINS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7703 "parser_bison.c"
    break;

  case 103: /* list_cmd: "sets" ruleset_spec  */
#line 1291 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_SETS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7711 "parser_bison.c"
    break;

  case 104: /* list_cmd: "sets" "table" table_spec  */
#line 1295 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_SETS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7719 "parser_bison.c"
    break;

  case 105: /* list_cmd: "set" set_spec  */
#line 1299 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_SET, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7727 "parser_bison.c"
    break;

  case 106: /* list_cmd: "counters" ruleset_spec  */
#line 1303 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_COUNTERS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7735 "parser_bison.c"
    break;

  case 107: /* list_cmd: "counters" "table" table_spec  */
#line 1307 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_COUNTERS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7743 "parser_bison.c"
    break;

  case 108: /* list_cmd: "counter" obj_spec  */
#line 1311 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_COUNTER, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7751 "parser_bison.c"
    break;

  case 109: /* list_cmd: "quotas" ruleset_spec  */
#line 1315 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_QUOTAS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7759 "parser_bison.c"
    break;

  case 110: /* list_cmd: "quotas" "table" table_spec  */
#line 1319 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_QUOTAS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7767 "parser_bison.c"
    break;

  case 111: /* list_cmd: "quota" obj_spec  */
#line 1323 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_QUOTA, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7775 "parser_bison.c"
    break;

  case 112: /* list_cmd: "limits" ruleset_spec  */
#line 1327 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_LIMITS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7783 "parser_bison.c"
    break;

  case 113: /* list_cmd: "limits" "table" table_spec  */
#line 1331 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_LIMITS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7791 "parser_bison.c"
    break;

  case 114: /* list_cmd: "limit" obj_spec  */
#line 1335 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_LIMIT, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7799 "parser_bison.c"
    break;

  case 115: /* list_cmd: "secmarks" ruleset_spec  */
#line 1339 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_SECMARKS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7807 "parser_bison.c"
    break;

  case 116: /* list_cmd: "secmarks" "table" table_spec  */
#line 1343 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_SECMARKS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7815 "parser_bison.c"
    break;

  case 117: /* list_cmd: "secmark" obj_spec  */
#line 1347 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_SECMARK, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7823 "parser_bison.c"
    break;

  case 118: /* list_cmd: "synproxys" ruleset_spec  */
#line 1351 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_SYNPROXYS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7831 "parser_bison.c"
    break;

  case 119: /* list_cmd: "synproxys" "table" table_spec  */
#line 1355 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_SYNPROXYS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7839 "parser_bison.c"
    break;

  case 120: /* list_cmd: "synproxy" obj_spec  */
#line 1359 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_SYNPROXY, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7847 "parser_bison.c"
    break;

  case 121: /* list_cmd: "ruleset" ruleset_spec  */
#line 1363 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_RULESET, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7855 "parser_bison.c"
    break;

  case 122: /* list_cmd: "flow" "tables" ruleset_spec  */
#line 1367 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_METERS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7863 "parser_bison.c"
    break;

  case 123: /* list_cmd: "flow" "table" set_spec  */
#line 1371 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_METER, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7871 "parser_bison.c"
    break;

  case 124: /* list_cmd: "meters" ruleset_spec  */
#line 1375 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_METERS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7879 "parser_bison.c"
    break;

  case 125: /* list_cmd: "meter" set_spec  */
#line 1379 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_METER, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7887 "parser_bison.c"
    break;

  case 126: /* list_cmd: "flowtables" ruleset_spec  */
#line 1383 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_FLOWTABLES, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7895 "parser_bison.c"
    break;

  case 127: /* list_cmd: "flowtable" flowtable_spec  */
#line 1387 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_FLOWTABLE, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7903 "parser_bison.c"
    break;

  case 128: /* list_cmd: "maps" ruleset_spec  */
#line 1391 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_MAPS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7911 "parser_bison.c"
    break;

  case 129: /* list_cmd: "map" set_spec  */
#line 1395 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_MAP, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7919 "parser_bison.c"
    break;

  case 130: /* list_cmd: "ct" ct_obj_type obj_spec  */
#line 1399 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc_obj_ct(CMD_LIST, (yyvsp[-1].val), &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7927 "parser_bison.c"
    break;

  case 131: /* list_cmd: "ct" "helpers" "table" table_spec  */
#line 1403 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_CT_HELPERS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7935 "parser_bison.c"
    break;

  case 132: /* list_cmd: "ct" "timeout" "table" table_spec  */
#line 1407 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_CT_TIMEOUT, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7943 "parser_bison.c"
    break;

  case 133: /* list_cmd: "ct" "expectation" "table" table_spec  */
#line 1411 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_LIST, CMD_OBJ_CT_EXPECT, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7951 "parser_bison.c"
    break;

  case 134: /* reset_cmd: "counters" ruleset_spec  */
#line 1417 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_RESET, CMD_OBJ_COUNTERS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7959 "parser_bison.c"
    break;

  case 135: /* reset_cmd: "counters" "table" table_spec  */
#line 1421 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_RESET, CMD_OBJ_COUNTERS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7967 "parser_bison.c"
    break;

  case 136: /* reset_cmd: "counter" obj_spec  */
#line 1425 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_RESET, CMD_OBJ_COUNTER, &(yyvsp[0].handle),&(yyloc), NULL);
			}
#line 7975 "parser_bison.c"
    break;

  case 137: /* reset_cmd: "quotas" ruleset_spec  */
#line 1429 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_RESET, CMD_OBJ_QUOTAS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7983 "parser_bison.c"
    break;

  case 138: /* reset_cmd: "quotas" "table" table_spec  */
#line 1433 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_RESET, CMD_OBJ_QUOTAS, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7991 "parser_bison.c"
    break;

  case 139: /* reset_cmd: "quota" obj_spec  */
#line 1437 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_RESET, CMD_OBJ_QUOTA, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 7999 "parser_bison.c"
    break;

  case 140: /* flush_cmd: "table" table_spec  */
#line 1443 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_FLUSH, CMD_OBJ_TABLE, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8007 "parser_bison.c"
    break;

  case 141: /* flush_cmd: "chain" chain_spec  */
#line 1447 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_FLUSH, CMD_OBJ_CHAIN, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8015 "parser_bison.c"
    break;

  case 142: /* flush_cmd: "set" set_spec  */
#line 1451 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_FLUSH, CMD_OBJ_SET, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8023 "parser_bison.c"
    break;

  case 143: /* flush_cmd: "map" set_spec  */
#line 1455 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_FLUSH, CMD_OBJ_MAP, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8031 "parser_bison.c"
    break;

  case 144: /* flush_cmd: "flow" "table" set_spec  */
#line 1459 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_FLUSH, CMD_OBJ_METER, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8039 "parser_bison.c"
    break;

  case 145: /* flush_cmd: "meter" set_spec  */
#line 1463 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_FLUSH, CMD_OBJ_METER, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8047 "parser_bison.c"
    break;

  case 146: /* flush_cmd: "ruleset" ruleset_spec  */
#line 1467 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_FLUSH, CMD_OBJ_RULESET, &(yyvsp[0].handle), &(yyloc), NULL);
			}
#line 8055 "parser_bison.c"
    break;

  case 147: /* rename_cmd: "chain" chain_spec identifier  */
#line 1473 "parser_bison.y"
                        {
				(yyval.cmd) = cmd_alloc(CMD_RENAME, CMD_OBJ_CHAIN, &(yyvsp[-1].handle), &(yyloc), NULL);
				(yyval.cmd)->arg = (yyvsp[0].string);
			}
#line 8064 "parser_bison.c"
    break;

  case 148: /* import_cmd: "ruleset" markup_format  */
#line 1480 "parser_bison.y"
                        {
				struct handle h = { .family = NFPROTO_UNSPEC };
				struct markup *markup = markup_alloc((yyvsp[0].val));
				(yyval.cmd) = cmd_alloc(CMD_IMPORT, CMD_OBJ_MARKUP, &h, &(yyloc), markup);
			}
#line 8074 "parser_bison.c"
    break;

  case 149: /* import_cmd: markup_format  */
#line 1486 "parser_bison.y"
                        {
				struct handle h = { .family = NFPROTO_UNSPEC };
				struct markup *markup = markup_alloc((yyvsp[0].val));
				(yyval.cmd) = cmd_alloc(CMD_IMPORT, CMD_OBJ_MARKUP, &h, &(yyloc), markup);
			}
#line 8084 "parser_bison.c"
    break;

  case 150: /* export_cmd: "ruleset" markup_format  */
#line 1494 "parser_bison.y"
                        {
				struct handle h = { .family = NFPROTO_UNSPEC };
				struct markup *markup = markup_alloc((yyvsp[0].val));
				(yyval.cmd) = cmd_alloc(CMD_EXPORT, CMD_OBJ_MARKUP, &h, &(yyloc), markup);
			}
#line 8094 "parser_bison.c"
    break;

  case 151: /* export_cmd: markup_format  */
#line 1500 "parser_bison.y"
                        {
				struct handle h = { .family = NFPROTO_UNSPEC };
				struct markup *markup = markup_alloc((yyvsp[0].val));
				(yyval.cmd) = cmd_alloc(CMD_EXPORT, CMD_OBJ_MARKUP, &h, &(yyloc), markup);
			}
#line 8104 "parser_bison.c"
    break;

  case 152: /* monitor_cmd: monitor_event monitor_object monitor_format  */
#line 1508 "parser_bison.y"
                        {
				struct handle h = { .family = NFPROTO_UNSPEC };
				struct monitor *m = monitor_alloc((yyvsp[0].val), (yyvsp[-1].val), (yyvsp[-2].string));
				m->location = (yylsp[-2]);
				(yyval.cmd) = cmd_alloc(CMD_MONITOR, CMD_OBJ_MONITOR, &h, &(yyloc), m);
			}
#line 8115 "parser_bison.c"
    break;

  case 153: /* monitor_event: %empty  */
#line 1516 "parser_bison.y"
                                                { (yyval.string) = NULL; }
#line 8121 "parser_bison.c"
    break;

  case 154: /* monitor_event: "string"  */
#line 1517 "parser_bison.y"
                                                { (yyval.string) = (yyvsp[0].string); }
#line 8127 "parser_bison.c"
    break;

  case 155: /* monitor_object: %empty  */
#line 1520 "parser_bison.y"
                                                { (yyval.val) = CMD_MONITOR_OBJ_ANY; }
#line 8133 "parser_bison.c"
    break;

  case 156: /* monitor_object: "tables"  */
#line 1521 "parser_bison.y"
                                                { (yyval.val) = CMD_MONITOR_OBJ_TABLES; }
#line 8139 "parser_bison.c"
    break;

  case 157: /* monitor_object: "chains"  */
#line 1522 "parser_bison.y"
                                                { (yyval.val) = CMD_MONITOR_OBJ_CHAINS; }
#line 8145 "parser_bison.c"
    break;

  case 158: /* monitor_object: "sets"  */
#line 1523 "parser_bison.y"
                                                { (yyval.val) = CMD_MONITOR_OBJ_SETS; }
#line 8151 "parser_bison.c"
    break;

  case 159: /* monitor_object: "rules"  */
#line 1524 "parser_bison.y"
                                                { (yyval.val) = CMD_MONITOR_OBJ_RULES; }
#line 8157 "parser_bison.c"
    break;

  case 160: /* monitor_object: "elements"  */
#line 1525 "parser_bison.y"
                                                { (yyval.val) = CMD_MONITOR_OBJ_ELEMS; }
#line 8163 "parser_bison.c"
    break;

  case 161: /* monitor_object: "ruleset"  */
#line 1526 "parser_bison.y"
                                                { (yyval.val) = CMD_MONITOR_OBJ_RULESET; }
#line 8169 "parser_bison.c"
    break;

  case 162: /* monitor_object: "trace"  */
#line 1527 "parser_bison.y"
                                                { (yyval.val) = CMD_MONITOR_OBJ_TRACE; }
#line 8175 "parser_bison.c"
    break;

  case 163: /* monitor_format: %empty  */
#line 1530 "parser_bison.y"
                                                { (yyval.val) = NFTNL_OUTPUT_DEFAULT; }
#line 8181 "parser_bison.c"
    break;

  case 165: /* markup_format: "xml"  */
#line 1534 "parser_bison.y"
                                                { (yyval.val) = __NFT_OUTPUT_NOTSUPP; }
#line 8187 "parser_bison.c"
    break;

  case 166: /* markup_format: "json"  */
#line 1535 "parser_bison.y"
                                                { (yyval.val) = NFTNL_OUTPUT_JSON; }
#line 8193 "parser_bison.c"
    break;

  case 167: /* markup_format: "vm" "json"  */
#line 1536 "parser_bison.y"
                                                { (yyval.val) = NFTNL_OUTPUT_JSON; }
#line 8199 "parser_bison.c"
    break;

  case 168: /* describe_cmd: primary_expr  */
#line 1540 "parser_bison.y"
                        {
				struct handle h = { .family = NFPROTO_UNSPEC };
				(yyval.cmd) = cmd_alloc(CMD_DESCRIBE, CMD_OBJ_EXPR, &h, &(yyloc), NULL);
				(yyval.cmd)->expr = (yyvsp[0].expr);
			}
#line 8209 "parser_bison.c"
    break;

  case 169: /* table_block_alloc: %empty  */
#line 1548 "parser_bison.y"
                        {
				(yyval.table) = table_alloc();
				open_scope(state, &(yyval.table)->scope);
			}
#line 8218 "parser_bison.c"
    break;

  case 170: /* table_options: "flags" "string"  */
#line 1555 "parser_bison.y"
                        {
				if (strcmp((yyvsp[0].string), "dormant") == 0) {
					(yyvsp[-2].table)->flags = TABLE_F_DORMANT;
					xfree((yyvsp[0].string));
				} else {
					erec_queue(error(&(yylsp[0]), "unknown table option %s", (yyvsp[0].string)),
						   state->msgs);
					xfree((yyvsp[0].string));
					YYERROR;
				}
			}
#line 8234 "parser_bison.c"
    break;

  case 171: /* table_options: comment_spec  */
#line 1567 "parser_bison.y"
                        {
				if (already_set((yyvsp[-1].table)->comment, &(yyloc), state)) {
					xfree((yyvsp[0].string));
					YYERROR;
				}
				(yyvsp[-1].table)->comment = (yyvsp[0].string);
			}
#line 8246 "parser_bison.c"
    break;

  case 172: /* table_block: %empty  */
#line 1576 "parser_bison.y"
                                                { (yyval.table) = (yyvsp[(-1) - (0)].table); }
#line 8252 "parser_bison.c"
    break;

  case 176: /* table_block: table_block "chain" chain_identifier chain_block_alloc '{' chain_block '}' stmt_separator  */
#line 1583 "parser_bison.y"
                        {
				(yyvsp[-4].chain)->location = (yylsp[-5]);
				handle_merge(&(yyvsp[-4].chain)->handle, &(yyvsp[-5].handle));
				handle_free(&(yyvsp[-5].handle));
				close_scope(state);
				list_add_tail(&(yyvsp[-4].chain)->list, &(yyvsp[-7].table)->chains);
				(yyval.table) = (yyvsp[-7].table);
			}
#line 8265 "parser_bison.c"
    break;

  case 177: /* table_block: table_block "set" set_identifier set_block_alloc '{' set_block '}' stmt_separator  */
#line 1594 "parser_bison.y"
                        {
				(yyvsp[-4].set)->location = (yylsp[-5]);
				handle_merge(&(yyvsp[-4].set)->handle, &(yyvsp[-5].handle));
				handle_free(&(yyvsp[-5].handle));
				list_add_tail(&(yyvsp[-4].set)->list, &(yyvsp[-7].table)->sets);
				(yyval.table) = (yyvsp[-7].table);
			}
#line 8277 "parser_bison.c"
    break;

  case 178: /* table_block: table_block "map" set_identifier map_block_alloc '{' map_block '}' stmt_separator  */
#line 1604 "parser_bison.y"
                        {
				(yyvsp[-4].set)->location = (yylsp[-5]);
				handle_merge(&(yyvsp[-4].set)->handle, &(yyvsp[-5].handle));
				handle_free(&(yyvsp[-5].handle));
				list_add_tail(&(yyvsp[-4].set)->list, &(yyvsp[-7].table)->sets);
				(yyval.table) = (yyvsp[-7].table);
			}
#line 8289 "parser_bison.c"
    break;

  case 179: /* table_block: table_block "flowtable" flowtable_identifier flowtable_block_alloc '{' flowtable_block '}' stmt_separator  */
#line 1615 "parser_bison.y"
                        {
				(yyvsp[-4].flowtable)->location = (yylsp[-5]);
				handle_merge(&(yyvsp[-4].flowtable)->handle, &(yyvsp[-5].handle));
				handle_free(&(yyvsp[-5].handle));
				list_add_tail(&(yyvsp[-4].flowtable)->list, &(yyvsp[-7].table)->flowtables);
				(yyval.table) = (yyvsp[-7].table);
			}
#line 8301 "parser_bison.c"
    break;

  case 180: /* table_block: table_block "counter" obj_identifier obj_block_alloc '{' counter_block '}' stmt_separator  */
#line 1625 "parser_bison.y"
                        {
				(yyvsp[-4].obj)->location = (yylsp[-5]);
				(yyvsp[-4].obj)->type = NFT_OBJECT_COUNTER;
				handle_merge(&(yyvsp[-4].obj)->handle, &(yyvsp[-5].handle));
				handle_free(&(yyvsp[-5].handle));
				list_add_tail(&(yyvsp[-4].obj)->list, &(yyvsp[-7].table)->objs);
				(yyval.table) = (yyvsp[-7].table);
			}
#line 8314 "parser_bison.c"
    break;

  case 181: /* table_block: table_block "quota" obj_identifier obj_block_alloc '{' quota_block '}' stmt_separator  */
#line 1636 "parser_bison.y"
                        {
				(yyvsp[-4].obj)->location = (yylsp[-5]);
				(yyvsp[-4].obj)->type = NFT_OBJECT_QUOTA;
				handle_merge(&(yyvsp[-4].obj)->handle, &(yyvsp[-5].handle));
				handle_free(&(yyvsp[-5].handle));
				list_add_tail(&(yyvsp[-4].obj)->list, &(yyvsp[-7].table)->objs);
				(yyval.table) = (yyvsp[-7].table);
			}
#line 8327 "parser_bison.c"
    break;

  case 182: /* table_block: table_block "ct" "helper" obj_identifier obj_block_alloc '{' ct_helper_block '}' stmt_separator  */
#line 1645 "parser_bison.y"
                        {
				(yyvsp[-4].obj)->location = (yylsp[-5]);
				(yyvsp[-4].obj)->type = NFT_OBJECT_CT_HELPER;
				handle_merge(&(yyvsp[-4].obj)->handle, &(yyvsp[-5].handle));
				handle_free(&(yyvsp[-5].handle));
				list_add_tail(&(yyvsp[-4].obj)->list, &(yyvsp[-8].table)->objs);
				(yyval.table) = (yyvsp[-8].table);
			}
#line 8340 "parser_bison.c"
    break;

  case 183: /* table_block: table_block "ct" "timeout" obj_identifier obj_block_alloc '{' ct_timeout_block '}' stmt_separator  */
#line 1654 "parser_bison.y"
                        {
				(yyvsp[-4].obj)->location = (yylsp[-5]);
				(yyvsp[-4].obj)->type = NFT_OBJECT_CT_TIMEOUT;
				handle_merge(&(yyvsp[-4].obj)->handle, &(yyvsp[-5].handle));
				handle_free(&(yyvsp[-5].handle));
				list_add_tail(&(yyvsp[-4].obj)->list, &(yyvsp[-8].table)->objs);
				(yyval.table) = (yyvsp[-8].table);
			}
#line 8353 "parser_bison.c"
    break;

  case 184: /* table_block: table_block "ct" "expectation" obj_identifier obj_block_alloc '{' ct_expect_block '}' stmt_separator  */
#line 1663 "parser_bison.y"
                        {
				(yyvsp[-4].obj)->location = (yylsp[-5]);
				(yyvsp[-4].obj)->type = NFT_OBJECT_CT_EXPECT;
				handle_merge(&(yyvsp[-4].obj)->handle, &(yyvsp[-5].handle));
				handle_free(&(yyvsp[-5].handle));
				list_add_tail(&(yyvsp[-4].obj)->list, &(yyvsp[-8].table)->objs);
				(yyval.table) = (yyvsp[-8].table);
			}
#line 8366 "parser_bison.c"
    break;

  case 185: /* table_block: table_block "limit" obj_identifier obj_block_alloc '{' limit_block '}' stmt_separator  */
#line 1674 "parser_bison.y"
                        {
				(yyvsp[-4].obj)->location = (yylsp[-5]);
				(yyvsp[-4].obj)->type = NFT_OBJECT_LIMIT;
				handle_merge(&(yyvsp[-4].obj)->handle, &(yyvsp[-5].handle));
				handle_free(&(yyvsp[-5].handle));
				list_add_tail(&(yyvsp[-4].obj)->list, &(yyvsp[-7].table)->objs);
				(yyval.table) = (yyvsp[-7].table);
			}
#line 8379 "parser_bison.c"
    break;

  case 186: /* table_block: table_block "secmark" obj_identifier obj_block_alloc '{' secmark_block '}' stmt_separator  */
#line 1685 "parser_bison.y"
                        {
				(yyvsp[-4].obj)->location = (yylsp[-5]);
				(yyvsp[-4].obj)->type = NFT_OBJECT_SECMARK;
				handle_merge(&(yyvsp[-4].obj)->handle, &(yyvsp[-5].handle));
				handle_free(&(yyvsp[-5].handle));
				list_add_tail(&(yyvsp[-4].obj)->list, &(yyvsp[-7].table)->objs);
				(yyval.table) = (yyvsp[-7].table);
			}
#line 8392 "parser_bison.c"
    break;

  case 187: /* table_block: table_block "synproxy" obj_identifier obj_block_alloc '{' synproxy_block '}' stmt_separator  */
#line 1696 "parser_bison.y"
                        {
				(yyvsp[-4].obj)->location = (yylsp[-5]);
				(yyvsp[-4].obj)->type = NFT_OBJECT_SYNPROXY;
				handle_merge(&(yyvsp[-4].obj)->handle, &(yyvsp[-5].handle));
				handle_free(&(yyvsp[-5].handle));
				list_add_tail(&(yyvsp[-4].obj)->list, &(yyvsp[-7].table)->objs);
				(yyval.table) = (yyvsp[-7].table);
			}
#line 8405 "parser_bison.c"
    break;

  case 188: /* chain_block_alloc: %empty  */
#line 1707 "parser_bison.y"
                        {
				(yyval.chain) = chain_alloc(NULL);
				open_scope(state, &(yyval.chain)->scope);
			}
#line 8414 "parser_bison.c"
    break;

  case 189: /* chain_block: %empty  */
#line 1713 "parser_bison.y"
                                                { (yyval.chain) = (yyvsp[(-1) - (0)].chain); }
#line 8420 "parser_bison.c"
    break;

  case 195: /* chain_block: chain_block rule stmt_separator  */
#line 1720 "parser_bison.y"
                        {
				list_add_tail(&(yyvsp[-1].rule)->list, &(yyvsp[-2].chain)->rules);
				(yyval.chain) = (yyvsp[-2].chain);
			}
#line 8429 "parser_bison.c"
    break;

  case 196: /* chain_block: chain_block comment_spec stmt_separator  */
#line 1725 "parser_bison.y"
                        {
				if (already_set((yyvsp[-2].chain)->comment, &(yylsp[-1]), state)) {
					xfree((yyvsp[-1].string));
					YYERROR;
				}
				(yyvsp[-2].chain)->comment = (yyvsp[-1].string);
			}
#line 8441 "parser_bison.c"
    break;

  case 197: /* subchain_block: %empty  */
#line 1734 "parser_bison.y"
                                                { (yyval.chain) = (yyvsp[(-1) - (0)].chain); }
#line 8447 "parser_bison.c"
    break;

  case 199: /* subchain_block: subchain_block rule stmt_separator  */
#line 1737 "parser_bison.y"
                        {
				list_add_tail(&(yyvsp[-1].rule)->list, &(yyvsp[-2].chain)->rules);
				(yyval.chain) = (yyvsp[-2].chain);
			}
#line 8456 "parser_bison.c"
    break;

  case 200: /* typeof_expr: primary_expr  */
#line 1744 "parser_bison.y"
                        {
				if (expr_ops((yyvsp[0].expr))->build_udata == NULL) {
					erec_queue(error(&(yylsp[0]), "primary expression type '%s' lacks typeof serialization", expr_ops((yyvsp[0].expr))->name),
						   state->msgs);
					expr_free((yyvsp[0].expr));
					YYERROR;
				}

				(yyval.expr) = (yyvsp[0].expr);
			}
#line 8471 "parser_bison.c"
    break;

  case 201: /* typeof_expr: typeof_expr "." primary_expr  */
#line 1755 "parser_bison.y"
                        {
				struct location rhs[] = {
					[1]	= (yylsp[-1]),
					[2]	= (yylsp[0]),
				};

				(yyval.expr) = handle_concat_expr(&(yyloc), (yyval.expr), (yyvsp[-2].expr), (yyvsp[0].expr), rhs);
			}
#line 8484 "parser_bison.c"
    break;

  case 202: /* set_block_alloc: %empty  */
#line 1767 "parser_bison.y"
                        {
				(yyval.set) = set_alloc(NULL);
			}
#line 8492 "parser_bison.c"
    break;

  case 203: /* set_block: %empty  */
#line 1772 "parser_bison.y"
                                                { (yyval.set) = (yyvsp[(-1) - (0)].set); }
#line 8498 "parser_bison.c"
    break;

  case 206: /* set_block: set_block "type" data_type_expr stmt_separator  */
#line 1776 "parser_bison.y"
                        {
				(yyvsp[-3].set)->key = (yyvsp[-1].expr);
				(yyval.set) = (yyvsp[-3].set);
			}
#line 8507 "parser_bison.c"
    break;

  case 207: /* set_block: set_block "typeof" typeof_expr stmt_separator  */
#line 1781 "parser_bison.y"
                        {
				(yyvsp[-3].set)->key = (yyvsp[-1].expr);
				datatype_set((yyvsp[-3].set)->key, (yyvsp[-1].expr)->dtype);
				(yyval.set) = (yyvsp[-3].set);
			}
#line 8517 "parser_bison.c"
    break;

  case 208: /* set_block: set_block "flags" set_flag_list stmt_separator  */
#line 1787 "parser_bison.y"
                        {
				(yyvsp[-3].set)->flags = (yyvsp[-1].val);
				(yyval.set) = (yyvsp[-3].set);
			}
#line 8526 "parser_bison.c"
    break;

  case 209: /* set_block: set_block "timeout" time_spec stmt_separator  */
#line 1792 "parser_bison.y"
                        {
				(yyvsp[-3].set)->timeout = (yyvsp[-1].val);
				(yyval.set) = (yyvsp[-3].set);
			}
#line 8535 "parser_bison.c"
    break;

  case 210: /* set_block: set_block "gc-interval" time_spec stmt_separator  */
#line 1797 "parser_bison.y"
                        {
				(yyvsp[-3].set)->gc_int = (yyvsp[-1].val);
				(yyval.set) = (yyvsp[-3].set);
			}
#line 8544 "parser_bison.c"
    break;

  case 211: /* set_block: set_block stateful_stmt_list stmt_separator  */
#line 1802 "parser_bison.y"
                        {
				list_splice_tail((yyvsp[-1].list), &(yyvsp[-2].set)->stmt_list);
				(yyval.set) = (yyvsp[-2].set);
				free((yyvsp[-1].list));
			}
#line 8554 "parser_bison.c"
    break;

  case 212: /* set_block: set_block "elements" '=' set_block_expr  */
#line 1808 "parser_bison.y"
                        {
				(yyvsp[-3].set)->init = (yyvsp[0].expr);
				(yyval.set) = (yyvsp[-3].set);
			}
#line 8563 "parser_bison.c"
    break;

  case 213: /* set_block: set_block "auto-merge"  */
#line 1813 "parser_bison.y"
                        {
				(yyvsp[-1].set)->automerge = true;
				(yyval.set) = (yyvsp[-1].set);
			}
#line 8572 "parser_bison.c"
    break;

  case 215: /* set_block: set_block comment_spec stmt_separator  */
#line 1819 "parser_bison.y"
                        {
				if (already_set((yyvsp[-2].set)->comment, &(yylsp[-1]), state)) {
					xfree((yyvsp[-1].string));
					YYERROR;
				}
				(yyvsp[-2].set)->comment = (yyvsp[-1].string);
				(yyval.set) = (yyvsp[-2].set);
			}
#line 8585 "parser_bison.c"
    break;

  case 218: /* set_flag_list: set_flag_list "comma" set_flag  */
#line 1834 "parser_bison.y"
                        {
				(yyval.val) = (yyvsp[-2].val) | (yyvsp[0].val);
			}
#line 8593 "parser_bison.c"
    break;

  case 220: /* set_flag: "constant"  */
#line 1840 "parser_bison.y"
                                                { (yyval.val) = NFT_SET_CONSTANT; }
#line 8599 "parser_bison.c"
    break;

  case 221: /* set_flag: "interval"  */
#line 1841 "parser_bison.y"
                                                { (yyval.val) = NFT_SET_INTERVAL; }
#line 8605 "parser_bison.c"
    break;

  case 222: /* set_flag: "timeout"  */
#line 1842 "parser_bison.y"
                                                { (yyval.val) = NFT_SET_TIMEOUT; }
#line 8611 "parser_bison.c"
    break;

  case 223: /* set_flag: "dynamic"  */
#line 1843 "parser_bison.y"
                                                { (yyval.val) = NFT_SET_EVAL; }
#line 8617 "parser_bison.c"
    break;

  case 224: /* map_block_alloc: %empty  */
#line 1847 "parser_bison.y"
                        {
				(yyval.set) = set_alloc(NULL);
			}
#line 8625 "parser_bison.c"
    break;

  case 225: /* map_block: %empty  */
#line 1852 "parser_bison.y"
                                                { (yyval.set) = (yyvsp[(-1) - (0)].set); }
#line 8631 "parser_bison.c"
    break;

  case 228: /* map_block: map_block "timeout" time_spec stmt_separator  */
#line 1856 "parser_bison.y"
                        {
				(yyvsp[-3].set)->timeout = (yyvsp[-1].val);
				(yyval.set) = (yyvsp[-3].set);
			}
#line 8640 "parser_bison.c"
    break;

  case 229: /* map_block: map_block "type" data_type_expr "colon" data_type_expr stmt_separator  */
#line 1863 "parser_bison.y"
                        {
				(yyvsp[-5].set)->key = (yyvsp[-3].expr);
				(yyvsp[-5].set)->data = (yyvsp[-1].expr);

				(yyvsp[-5].set)->flags |= NFT_SET_MAP;
				(yyval.set) = (yyvsp[-5].set);
			}
#line 8652 "parser_bison.c"
    break;

  case 230: /* map_block: map_block "type" data_type_expr "colon" "interval" data_type_expr stmt_separator  */
#line 1873 "parser_bison.y"
                        {
				(yyvsp[-6].set)->key = (yyvsp[-4].expr);
				(yyvsp[-6].set)->data = (yyvsp[-1].expr);
				(yyvsp[-6].set)->data->flags |= EXPR_F_INTERVAL;

				(yyvsp[-6].set)->flags |= NFT_SET_MAP;
				(yyval.set) = (yyvsp[-6].set);
			}
#line 8665 "parser_bison.c"
    break;

  case 231: /* map_block: map_block "typeof" typeof_expr "colon" typeof_expr stmt_separator  */
#line 1884 "parser_bison.y"
                        {
				(yyvsp[-5].set)->key = (yyvsp[-3].expr);
				datatype_set((yyvsp[-5].set)->key, (yyvsp[-3].expr)->dtype);
				(yyvsp[-5].set)->data = (yyvsp[-1].expr);

				(yyvsp[-5].set)->flags |= NFT_SET_MAP;
				(yyval.set) = (yyvsp[-5].set);
			}
#line 8678 "parser_bison.c"
    break;

  case 232: /* map_block: map_block "typeof" typeof_expr "colon" "interval" typeof_expr stmt_separator  */
#line 1895 "parser_bison.y"
                        {
				(yyvsp[-6].set)->key = (yyvsp[-4].expr);
				datatype_set((yyvsp[-6].set)->key, (yyvsp[-4].expr)->dtype);
				(yyvsp[-6].set)->data = (yyvsp[-1].expr);
				(yyvsp[-6].set)->data->flags |= EXPR_F_INTERVAL;

				(yyvsp[-6].set)->flags |= NFT_SET_MAP;
				(yyval.set) = (yyvsp[-6].set);
			}
#line 8692 "parser_bison.c"
    break;

  case 233: /* map_block: map_block "type" data_type_expr "colon" "counter" stmt_separator  */
#line 1907 "parser_bison.y"
                        {
				(yyvsp[-5].set)->key = (yyvsp[-3].expr);
				(yyvsp[-5].set)->objtype = NFT_OBJECT_COUNTER;
				(yyvsp[-5].set)->flags  |= NFT_SET_OBJECT;
				(yyval.set) = (yyvsp[-5].set);
			}
#line 8703 "parser_bison.c"
    break;

  case 234: /* map_block: map_block "type" data_type_expr "colon" "quota" stmt_separator  */
#line 1916 "parser_bison.y"
                        {
				(yyvsp[-5].set)->key = (yyvsp[-3].expr);
				(yyvsp[-5].set)->objtype = NFT_OBJECT_QUOTA;
				(yyvsp[-5].set)->flags  |= NFT_SET_OBJECT;
				(yyval.set) = (yyvsp[-5].set);
			}
#line 8714 "parser_bison.c"
    break;

  case 235: /* map_block: map_block "type" data_type_expr "colon" "limit" stmt_separator  */
#line 1925 "parser_bison.y"
                        {
				(yyvsp[-5].set)->key = (yyvsp[-3].expr);
				(yyvsp[-5].set)->objtype = NFT_OBJECT_LIMIT;
				(yyvsp[-5].set)->flags  |= NFT_SET_OBJECT;
				(yyval.set) = (yyvsp[-5].set);
			}
#line 8725 "parser_bison.c"
    break;

  case 236: /* map_block: map_block "type" data_type_expr "colon" "secmark" stmt_separator  */
#line 1934 "parser_bison.y"
                        {
				(yyvsp[-5].set)->key = (yyvsp[-3].expr);
				(yyvsp[-5].set)->objtype = NFT_OBJECT_SECMARK;
				(yyvsp[-5].set)->flags  |= NFT_SET_OBJECT;
				(yyval.set) = (yyvsp[-5].set);
			}
#line 8736 "parser_bison.c"
    break;

  case 237: /* map_block: map_block "flags" set_flag_list stmt_separator  */
#line 1941 "parser_bison.y"
                        {
				(yyvsp[-3].set)->flags |= (yyvsp[-1].val);
				(yyval.set) = (yyvsp[-3].set);
			}
#line 8745 "parser_bison.c"
    break;

  case 238: /* map_block: map_block "elements" '=' set_block_expr  */
#line 1946 "parser_bison.y"
                        {
				(yyvsp[-3].set)->init = (yyvsp[0].expr);
				(yyval.set) = (yyvsp[-3].set);
			}
#line 8754 "parser_bison.c"
    break;

  case 239: /* map_block: map_block comment_spec stmt_separator  */
#line 1951 "parser_bison.y"
                        {
				if (already_set((yyvsp[-2].set)->comment, &(yylsp[-1]), state)) {
					xfree((yyvsp[-1].string));
					YYERROR;
				}
				(yyvsp[-2].set)->comment = (yyvsp[-1].string);
				(yyval.set) = (yyvsp[-2].set);
			}
#line 8767 "parser_bison.c"
    break;

  case 241: /* set_mechanism: "policy" set_policy_spec  */
#line 1963 "parser_bison.y"
                        {
				(yyvsp[-2].set)->policy = (yyvsp[0].val);
			}
#line 8775 "parser_bison.c"
    break;

  case 242: /* set_mechanism: "size" "number"  */
#line 1967 "parser_bison.y"
                        {
				(yyvsp[-2].set)->desc.size = (yyvsp[0].val);
			}
#line 8783 "parser_bison.c"
    break;

  case 243: /* set_policy_spec: "performance"  */
#line 1972 "parser_bison.y"
                                                { (yyval.val) = NFT_SET_POL_PERFORMANCE; }
#line 8789 "parser_bison.c"
    break;

  case 244: /* set_policy_spec: "memory"  */
#line 1973 "parser_bison.y"
                                                { (yyval.val) = NFT_SET_POL_MEMORY; }
#line 8795 "parser_bison.c"
    break;

  case 245: /* flowtable_block_alloc: %empty  */
#line 1977 "parser_bison.y"
                        {
				(yyval.flowtable) = flowtable_alloc(NULL);
			}
#line 8803 "parser_bison.c"
    break;

  case 246: /* flowtable_block: %empty  */
#line 1982 "parser_bison.y"
                                                { (yyval.flowtable) = (yyvsp[(-1) - (0)].flowtable); }
#line 8809 "parser_bison.c"
    break;

  case 249: /* flowtable_block: flowtable_block "hook" "string" prio_spec stmt_separator  */
#line 1986 "parser_bison.y"
                        {
				(yyval.flowtable)->hook.loc = (yylsp[-2]);
				(yyval.flowtable)->hook.name = chain_hookname_lookup((yyvsp[-2].string));
				if ((yyval.flowtable)->hook.name == NULL) {
					erec_queue(error(&(yylsp[-2]), "unknown chain hook"),
						   state->msgs);
					xfree((yyvsp[-2].string));
					YYERROR;
				}
				xfree((yyvsp[-2].string));

				(yyval.flowtable)->priority = (yyvsp[-1].prio_spec);
			}
#line 8827 "parser_bison.c"
    break;

  case 250: /* flowtable_block: flowtable_block "devices" '=' flowtable_expr stmt_separator  */
#line 2000 "parser_bison.y"
                        {
				(yyval.flowtable)->dev_expr = (yyvsp[-1].expr);
			}
#line 8835 "parser_bison.c"
    break;

  case 251: /* flowtable_block: flowtable_block "counter"  */
#line 2004 "parser_bison.y"
                        {
				(yyval.flowtable)->flags |= NFT_FLOWTABLE_COUNTER;
			}
#line 8843 "parser_bison.c"
    break;

  case 252: /* flowtable_expr: '{' flowtable_list_expr '}'  */
#line 2010 "parser_bison.y"
                        {
				(yyvsp[-1].expr)->location = (yyloc);
				(yyval.expr) = (yyvsp[-1].expr);
			}
#line 8852 "parser_bison.c"
    break;

  case 253: /* flowtable_expr: variable_expr  */
#line 2015 "parser_bison.y"
                        {
				(yyvsp[0].expr)->location = (yyloc);
				(yyval.expr) = (yyvsp[0].expr);
			}
#line 8861 "parser_bison.c"
    break;

  case 254: /* flowtable_list_expr: flowtable_expr_member  */
#line 2022 "parser_bison.y"
                        {
				(yyval.expr) = compound_expr_alloc(&(yyloc), EXPR_LIST);
				compound_expr_add((yyval.expr), (yyvsp[0].expr));
			}
#line 8870 "parser_bison.c"
    break;

  case 255: /* flowtable_list_expr: flowtable_list_expr "comma" flowtable_expr_member  */
#line 2027 "parser_bison.y"
                        {
				compound_expr_add((yyvsp[-2].expr), (yyvsp[0].expr));
				(yyval.expr) = (yyvsp[-2].expr);
			}
#line 8879 "parser_bison.c"
    break;

  case 257: /* flowtable_expr_member: "string"  */
#line 2035 "parser_bison.y"
                        {
				(yyval.expr) = constant_expr_alloc(&(yyloc), &string_type,
							 BYTEORDER_HOST_ENDIAN,
							 strlen((yyvsp[0].string)) * BITS_PER_BYTE, (yyvsp[0].string));
				xfree((yyvsp[0].string));
			}
#line 8890 "parser_bison.c"
    break;

  case 258: /* flowtable_expr_member: variable_expr  */
#line 2042 "parser_bison.y"
                        {
				datatype_set((yyvsp[0].expr)->sym->expr, &ifname_type);
				(yyval.expr) = (yyvsp[0].expr);
			}
#line 8899 "parser_bison.c"
    break;

  case 259: /* data_type_atom_expr: type_identifier  */
#line 2049 "parser_bison.y"
                        {
				const struct datatype *dtype = datatype_lookup_byname((yyvsp[0].string));
				if (dtype == NULL) {
					erec_queue(error(&(yylsp[0]), "unknown datatype %s", (yyvsp[0].string)),
						   state->msgs);
					YYERROR;
				}
				(yyval.expr) = constant_expr_alloc(&(yylsp[0]), dtype, dtype->byteorder,
							 dtype->size, NULL);
				xfree((yyvsp[0].string));
			}
#line 8915 "parser_bison.c"
    break;

  case 260: /* data_type_atom_expr: "time"  */
#line 2061 "parser_bison.y"
                        {
				(yyval.expr) = constant_expr_alloc(&(yylsp[0]), &time_type, time_type.byteorder,
							 time_type.size, NULL);
			}
#line 8924 "parser_bison.c"
    break;

  case 262: /* data_type_expr: data_type_expr "." data_type_atom_expr  */
#line 2069 "parser_bison.y"
                        {
				struct location rhs[] = {
					[1]	= (yylsp[-1]),
					[2]	= (yylsp[0]),
				};

				(yyval.expr) = handle_concat_expr(&(yyloc), (yyval.expr), (yyvsp[-2].expr), (yyvsp[0].expr), rhs);
			}
#line 8937 "parser_bison.c"
    break;

  case 263: /* obj_block_alloc: %empty  */
#line 2080 "parser_bison.y"
                        {
				(yyval.obj) = obj_alloc(NULL);
			}
#line 8945 "parser_bison.c"
    break;

  case 264: /* counter_block: %empty  */
#line 2085 "parser_bison.y"
                                                { (yyval.obj) = (yyvsp[(-1) - (0)].obj); }
#line 8951 "parser_bison.c"
    break;

  case 267: /* counter_block: counter_block counter_config  */
#line 2089 "parser_bison.y"
                        {
				(yyval.obj) = (yyvsp[-1].obj);
			}
#line 8959 "parser_bison.c"
    break;

  case 268: /* counter_block: counter_block comment_spec  */
#line 2093 "parser_bison.y"
                        {
				if (already_set((yyvsp[-1].obj)->comment, &(yylsp[0]), state)) {
					xfree((yyvsp[0].string));
					YYERROR;
				}
				(yyvsp[-1].obj)->comment = (yyvsp[0].string);
			}
#line 8971 "parser_bison.c"
    break;

  case 269: /* quota_block: %empty  */
#line 2102 "parser_bison.y"
                                                { (yyval.obj) = (yyvsp[(-1) - (0)].obj); }
#line 8977 "parser_bison.c"
    break;

  case 272: /* quota_block: quota_block quota_config  */
#line 2106 "parser_bison.y"
                        {
				(yyval.obj) = (yyvsp[-1].obj);
			}
#line 8985 "parser_bison.c"
    break;

  case 273: /* quota_block: quota_block comment_spec  */
#line 2110 "parser_bison.y"
                        {
				if (already_set((yyvsp[-1].obj)->comment, &(yylsp[0]), state)) {
					xfree((yyvsp[0].string));
					YYERROR;
				}
				(yyvsp[-1].obj)->comment = (yyvsp[0].string);
			}
#line 8997 "parser_bison.c"
    break;

  case 274: /* ct_helper_block: %empty  */
#line 2119 "parser_bison.y"
                                                { (yyval.obj) = (yyvsp[(-1) - (0)].obj); }
#line 9003 "parser_bison.c"
    break;

  case 277: /* ct_helper_block: ct_helper_block ct_helper_config  */
#line 2123 "parser_bison.y"
                        {
				(yyval.obj) = (yyvsp[-1].obj);
			}
#line 9011 "parser_bison.c"
    break;

  case 278: /* ct_helper_block: ct_helper_block comment_spec  */
#line 2127 "parser_bison.y"
                        {
				if (already_set((yyvsp[-1].obj)->comment, &(yylsp[0]), state)) {
					xfree((yyvsp[0].string));
					YYERROR;
				}
				(yyvsp[-1].obj)->comment = (yyvsp[0].string);
			}
#line 9023 "parser_bison.c"
    break;

  case 279: /* ct_timeout_block: %empty  */
#line 2137 "parser_bison.y"
                        {
				(yyval.obj) = (yyvsp[(-1) - (0)].obj);
				init_list_head(&(yyval.obj)->ct_timeout.timeout_list);
			}
#line 9032 "parser_bison.c"
    break;

  case 282: /* ct_timeout_block: ct_timeout_block ct_timeout_config  */
#line 2144 "parser_bison.y"
                        {
				(yyval.obj) = (yyvsp[-1].obj);
			}
#line 9040 "parser_bison.c"
    break;

  case 283: /* ct_timeout_block: ct_timeout_block comment_spec  */
#line 2148 "parser_bison.y"
                        {
				if (already_set((yyvsp[-1].obj)->comment, &(yylsp[0]), state)) {
					xfree((yyvsp[0].string));
					YYERROR;
				}
				(yyvsp[-1].obj)->comment = (yyvsp[0].string);
			}
#line 9052 "parser_bison.c"
    break;

  case 284: /* ct_expect_block: %empty  */
#line 2157 "parser_bison.y"
                                                { (yyval.obj) = (yyvsp[(-1) - (0)].obj); }
#line 9058 "parser_bison.c"
    break;

  case 287: /* ct_expect_block: ct_expect_block ct_expect_config  */
#line 2161 "parser_bison.y"
                        {
				(yyval.obj) = (yyvsp[-1].obj);
			}
#line 9066 "parser_bison.c"
    break;

  case 288: /* ct_expect_block: ct_expect_block comment_spec  */
#line 2165 "parser_bison.y"
                        {
				if (already_set((yyvsp[-1].obj)->comment, &(yylsp[0]), state)) {
					xfree((yyvsp[0].string));
					YYERROR;
				}
				(yyvsp[-1].obj)->comment = (yyvsp[0].string);
			}
#line 9078 "parser_bison.c"
    break;

  case 289: /* limit_block: %empty  */
#line 2174 "parser_bison.y"
                                                { (yyval.obj) = (yyvsp[(-1) - (0)].obj); }
#line 9084 "parser_bison.c"
    break;

  case 292: /* limit_block: limit_block limit_config  */
#line 2178 "parser_bison.y"
                        {
				(yyval.obj) = (yyvsp[-1].obj);
			}
#line 9092 "parser_bison.c"
    break;

  case 293: /* limit_block: limit_block comment_spec  */
#line 2182 "parser_bison.y"
                        {
				if (already_set((yyvsp[-1].obj)->comment, &(yylsp[0]), state)) {
					xfree((yyvsp[0].string));
					YYERROR;
				}
				(yyvsp[-1].obj)->comment = (yyvsp[0].string);
			}
#line 9104 "parser_bison.c"
    break;

  case 294: /* secmark_block: %empty  */
#line 2191 "parser_bison.y"
                                                { (yyval.obj) = (yyvsp[(-1) - (0)].obj); }
#line 9110 "parser_bison.c"
    break;

  case 297: /* secmark_block: secmark_block secmark_config  */
#line 2195 "parser_bison.y"
                        {
				(yyval.obj) = (yyvsp[-1].obj);
			}
#line 9118 "parser_bison.c"
    break;

  case 298: /* secmark_block: secmark_block comment_spec  */
#line 2199 "parser_bison.y"
                        {
				if (already_set((yyvsp[-1].obj)->comment, &(yylsp[0]), state)) {
					xfree((yyvsp[0].string));
					YYERROR;
				}
				(yyvsp[-1].obj)->comment = (yyvsp[0].string);
			}
#line 9130 "parser_bison.c"
    break;

  case 299: /* synproxy_block: %empty  */
#line 2208 "parser_bison.y"
                                                { (yyval.obj) = (yyvsp[(-1) - (0)].obj); }
#line 9136 "parser_bison.c"
    break;

  case 302: /* synproxy_block: synproxy_block synproxy_config  */
#line 2212 "parser_bison.y"
                        {
				(yyval.obj) = (yyvsp[-1].obj);
			}
#line 9144 "parser_bison.c"
    break;

  case 303: /* synproxy_block: synproxy_block comment_spec  */
#line 2216 "parser_bison.y"
                        {
				if (already_set((yyvsp[-1].obj)->comment, &(yylsp[0]), state)) {
					xfree((yyvsp[0].string));
					YYERROR;
				}
				(yyvsp[-1].obj)->comment = (yyvsp[0].string);
			}
#line 9156 "parser_bison.c"
    break;

  case 304: /* type_identifier: "string"  */
#line 2225 "parser_bison.y"
                                        { (yyval.string) = (yyvsp[0].string); }
#line 9162 "parser_bison.c"
    break;

  case 305: /* type_identifier: "mark"  */
#line 2226 "parser_bison.y"
                                        { (yyval.string) = xstrdup("mark"); }
#line 9168 "parser_bison.c"
    break;

  case 306: /* type_identifier: "dscp"  */
#line 2227 "parser_bison.y"
                                        { (yyval.string) = xstrdup("dscp"); }
#line 9174 "parser_bison.c"
    break;

  case 307: /* type_identifier: "ecn"  */
#line 2228 "parser_bison.y"
                                        { (yyval.string) = xstrdup("ecn"); }
#line 9180 "parser_bison.c"
    break;

  case 308: /* type_identifier: "classid"  */
#line 2229 "parser_bison.y"
                                        { (yyval.string) = xstrdup("classid"); }
#line 9186 "parser_bison.c"
    break;

  case 309: /* hook_spec: "type" "string" "hook" "string" dev_spec prio_spec  */
#line 2233 "parser_bison.y"
                        {
				const char *chain_type = chain_type_name_lookup((yyvsp[-4].string));

				if (chain_type == NULL) {
					erec_queue(error(&(yylsp[-4]), "unknown chain type"),
						   state->msgs);
					xfree((yyvsp[-4].string));
					YYERROR;
				}
				(yyvsp[-6].chain)->type		= xstrdup(chain_type);
				xfree((yyvsp[-4].string));

				(yyvsp[-6].chain)->loc = (yyloc);
				(yyvsp[-6].chain)->hook.loc = (yylsp[-2]);
				(yyvsp[-6].chain)->hook.name = chain_hookname_lookup((yyvsp[-2].string));
				if ((yyvsp[-6].chain)->hook.name == NULL) {
					erec_queue(error(&(yylsp[-2]), "unknown chain hook"),
						   state->msgs);
					xfree((yyvsp[-2].string));
					YYERROR;
				}
				xfree((yyvsp[-2].string));

				(yyvsp[-6].chain)->dev_expr	= (yyvsp[-1].expr);
				(yyvsp[-6].chain)->priority	= (yyvsp[0].prio_spec);
				(yyvsp[-6].chain)->flags	|= CHAIN_F_BASECHAIN;
			}
#line 9218 "parser_bison.c"
    break;

  case 310: /* prio_spec: "priority" extended_prio_spec  */
#line 2263 "parser_bison.y"
                        {
				(yyval.prio_spec) = (yyvsp[0].prio_spec);
				(yyval.prio_spec).loc = (yyloc);
			}
#line 9227 "parser_bison.c"
    break;

  case 311: /* extended_prio_name: "out"  */
#line 2270 "parser_bison.y"
                        {
				(yyval.string) = strdup("out");
			}
#line 9235 "parser_bison.c"
    break;

  case 313: /* extended_prio_spec: int_num  */
#line 2277 "parser_bison.y"
                        {
				struct prio_spec spec = {0};

				spec.expr = constant_expr_alloc(&(yyloc), &integer_type,
								BYTEORDER_HOST_ENDIAN,
								sizeof(int) *
								BITS_PER_BYTE, &(yyvsp[0].val32));
				(yyval.prio_spec) = spec;
			}
#line 9249 "parser_bison.c"
    break;

  case 314: /* extended_prio_spec: variable_expr  */
#line 2287 "parser_bison.y"
                        {
				struct prio_spec spec = {0};

				spec.expr = (yyvsp[0].expr);
				(yyval.prio_spec) = spec;
			}
#line 9260 "parser_bison.c"
    break;

  case 315: /* extended_prio_spec: extended_prio_name  */
#line 2294 "parser_bison.y"
                        {
				struct prio_spec spec = {0};

				spec.expr = constant_expr_alloc(&(yyloc), &string_type,
								BYTEORDER_HOST_ENDIAN,
								strlen((yyvsp[0].string)) * BITS_PER_BYTE,
								(yyvsp[0].string));
				xfree((yyvsp[0].string));
				(yyval.prio_spec) = spec;
			}
#line 9275 "parser_bison.c"
    break;

  case 316: /* extended_prio_spec: extended_prio_name "+" "number"  */
#line 2305 "parser_bison.y"
                        {
				struct prio_spec spec = {0};

				char str[NFT_NAME_MAXLEN];
				snprintf(str, sizeof(str), "%s + %" PRIu64, (yyvsp[-2].string), (yyvsp[0].val));
				spec.expr = constant_expr_alloc(&(yyloc), &string_type,
								BYTEORDER_HOST_ENDIAN,
								strlen(str) * BITS_PER_BYTE,
								str);
				xfree((yyvsp[-2].string));
				(yyval.prio_spec) = spec;
			}
#line 9292 "parser_bison.c"
    break;

  case 317: /* extended_prio_spec: extended_prio_name "-" "number"  */
#line 2318 "parser_bison.y"
                        {
				struct prio_spec spec = {0};
				char str[NFT_NAME_MAXLEN];

				snprintf(str, sizeof(str), "%s - %" PRIu64, (yyvsp[-2].string), (yyvsp[0].val));
				spec.expr = constant_expr_alloc(&(yyloc), &string_type,
								BYTEORDER_HOST_ENDIAN,
								strlen(str) * BITS_PER_BYTE,
								str);
				xfree((yyvsp[-2].string));
				(yyval.prio_spec) = spec;
			}
#line 9309 "parser_bison.c"
    break;

  case 318: /* int_num: "number"  */
#line 2332 "parser_bison.y"
                                                        { (yyval.val32) = (yyvsp[0].val); }
#line 9315 "parser_bison.c"
    break;

  case 319: /* int_num: "-" "number"  */
#line 2333 "parser_bison.y"
                                                        { (yyval.val32) = -(yyvsp[0].val); }
#line 9321 "parser_bison.c"
    break;

  case 320: /* dev_spec: "device" string  */
#line 2337 "parser_bison.y"
                        {
				struct expr *expr;

				expr = constant_expr_alloc(&(yyloc), &string_type,
							   BYTEORDER_HOST_ENDIAN,
							   strlen((yyvsp[0].string)) * BITS_PER_BYTE, (yyvsp[0].string));
				xfree((yyvsp[0].string));
				(yyval.expr) = compound_expr_alloc(&(yyloc), EXPR_LIST);
				compound_expr_add((yyval.expr), expr);

			}
#line 9337 "parser_bison.c"
    break;

  case 321: /* dev_spec: "device" variable_expr  */
#line 2349 "parser_bison.y"
                        {
				datatype_set((yyvsp[0].expr)->sym->expr, &ifname_type);
				(yyval.expr) = compound_expr_alloc(&(yyloc), EXPR_LIST);
				compound_expr_add((yyval.expr), (yyvsp[0].expr));
			}
#line 9347 "parser_bison.c"
    break;

  case 322: /* dev_spec: "devices" '=' flowtable_expr  */
#line 2355 "parser_bison.y"
                        {
				(yyval.expr) = (yyvsp[0].expr);
			}
#line 9355 "parser_bison.c"
    break;

  case 323: /* dev_spec: %empty  */
#line 2358 "parser_bison.y"
                                                        { (yyval.expr) = NULL; }
#line 9361 "parser_bison.c"
    break;

  case 324: /* flags_spec: "flags" "offload"  */
#line 2362 "parser_bison.y"
                        {
				(yyvsp[-2].chain)->flags |= CHAIN_F_HW_OFFLOAD;
			}
#line 9369 "parser_bison.c"
    break;

  case 325: /* policy_spec: "policy" policy_expr  */
#line 2368 "parser_bison.y"
                        {
				if ((yyvsp[-2].chain)->policy) {
					erec_queue(error(&(yyloc), "you cannot set chain policy twice"),
						   state->msgs);
					expr_free((yyvsp[0].expr));
					YYERROR;
				}
				(yyvsp[-2].chain)->policy		= (yyvsp[0].expr);
				(yyvsp[-2].chain)->policy->location	= (yyloc);
			}
#line 9384 "parser_bison.c"
    break;

  case 326: /* policy_expr: variable_expr  */
#line 2381 "parser_bison.y"
                        {
				datatype_set((yyvsp[0].expr)->sym->expr, &policy_type);
				(yyval.expr) = (yyvsp[0].expr);
			}
#line 9393 "parser_bison.c"
    break;

  case 327: /* policy_expr: chain_policy  */
#line 2386 "parser_bison.y"
                        {
				(yyval.expr) = constant_expr_alloc(&(yyloc), &integer_type,
							 BYTEORDER_HOST_ENDIAN,
							 sizeof(int) *
							 BITS_PER_BYTE, &(yyvsp[0].val32));
			}
#line 9404 "parser_bison.c"
    break;

  case 328: /* chain_policy: "accept"  */
#line 2394 "parser_bison.y"
                                                { (yyval.val32) = NF_ACCEPT; }
#line 9410 "parser_bison.c"
    break;

  case 329: /* chain_policy: "drop"  */
#line 2395 "parser_bison.y"
                                                { (yyval.val32) = NF_DROP;   }
#line 9416 "parser_bison.c"
    break;

  case 334: /* time_spec: "string"  */
#line 2407 "parser_bison.y"
                        {
				struct error_record *erec;
				uint64_t res;

				erec = time_parse(&(yylsp[0]), (yyvsp[0].string), &res);
				xfree((yyvsp[0].string));
				if (erec != NULL) {
					erec_queue(erec, state->msgs);
					YYERROR;
				}
				(yyval.val) = res;
			}
#line 9433 "parser_bison.c"
    break;

  case 335: /* family_spec: %empty  */
#line 2421 "parser_bison.y"
                                                        { (yyval.val) = NFPROTO_IPV4; }
#line 9439 "parser_bison.c"
    break;

  case 337: /* family_spec_explicit: "ip"  */
#line 2425 "parser_bison.y"
                                                { (yyval.val) = NFPROTO_IPV4; }
#line 9445 "parser_bison.c"
    break;

  case 338: /* family_spec_explicit: "ip6"  */
#line 2426 "parser_bison.y"
                                                { (yyval.val) = NFPROTO_IPV6; }
#line 9451 "parser_bison.c"
    break;

  case 339: /* family_spec_explicit: "inet"  */
#line 2427 "parser_bison.y"
                                                { (yyval.val) = NFPROTO_INET; }
#line 9457 "parser_bison.c"
    break;

  case 340: /* family_spec_explicit: "arp"  */
#line 2428 "parser_bison.y"
                                                { (yyval.val) = NFPROTO_ARP; }
#line 9463 "parser_bison.c"
    break;

  case 341: /* family_spec_explicit: "bridge"  */
#line 2429 "parser_bison.y"
                                                { (yyval.val) = NFPROTO_BRIDGE; }
#line 9469 "parser_bison.c"
    break;

  case 342: /* family_spec_explicit: "netdev"  */
#line 2430 "parser_bison.y"
                                                { (yyval.val) = NFPROTO_NETDEV; }
#line 9475 "parser_bison.c"
    break;

  case 343: /* table_spec: family_spec identifier  */
#line 2434 "parser_bison.y"
                        {
				memset(&(yyval.handle), 0, sizeof((yyval.handle)));
				(yyval.handle).family	= (yyvsp[-1].val);
				(yyval.handle).table.location = (yylsp[0]);
				(yyval.handle).table.name	= (yyvsp[0].string);
			}
#line 9486 "parser_bison.c"
    break;

  case 344: /* tableid_spec: family_spec "handle" "number"  */
#line 2443 "parser_bison.y"
                        {
				memset(&(yyval.handle), 0, sizeof((yyval.handle)));
				(yyval.handle).family 		= (yyvsp[-2].val);
				(yyval.handle).handle.id 		= (yyvsp[0].val);
				(yyval.handle).handle.location	= (yylsp[0]);
			}
#line 9497 "parser_bison.c"
    break;

  case 345: /* chain_spec: table_spec identifier  */
#line 2452 "parser_bison.y"
                        {
				(yyval.handle)		= (yyvsp[-1].handle);
				(yyval.handle).chain.name	= (yyvsp[0].string);
				(yyval.handle).chain.location = (yylsp[0]);
			}
#line 9507 "parser_bison.c"
    break;

  case 346: /* chainid_spec: table_spec "handle" "number"  */
#line 2460 "parser_bison.y"
                        {
				(yyval.handle) 			= (yyvsp[-2].handle);
				(yyval.handle).handle.location 	= (yylsp[0]);
				(yyval.handle).handle.id 		= (yyvsp[0].val);
			}
#line 9517 "parser_bison.c"
    break;

  case 347: /* chain_identifier: identifier  */
#line 2468 "parser_bison.y"
                        {
				memset(&(yyval.handle), 0, sizeof((yyval.handle)));
				(yyval.handle).chain.name		= (yyvsp[0].string);
				(yyval.handle).chain.location	= (yylsp[0]);
			}
#line 9527 "parser_bison.c"
    break;

  case 348: /* set_spec: table_spec identifier  */
#line 2476 "parser_bison.y"
                        {
				(yyval.handle)		= (yyvsp[-1].handle);
				(yyval.handle).set.name	= (yyvsp[0].string);
				(yyval.handle).set.location	= (yylsp[0]);
			}
#line 9537 "parser_bison.c"
    break;

  case 349: /* setid_spec: table_spec "handle" "number"  */
#line 2484 "parser_bison.y"
                        {
				(yyval.handle) 			= (yyvsp[-2].handle);
				(yyval.handle).handle.location 	= (yylsp[0]);
				(yyval.handle).handle.id 		= (yyvsp[0].val);
			}
#line 9547 "parser_bison.c"
    break;

  case 350: /* set_identifier: identifier  */
#line 2492 "parser_bison.y"
                        {
				memset(&(yyval.handle), 0, sizeof((yyval.handle)));
				(yyval.handle).set.name	= (yyvsp[0].string);
				(yyval.handle).set.location	= (yylsp[0]);
			}
#line 9557 "parser_bison.c"
    break;

  case 351: /* flowtable_spec: table_spec identifier  */
#line 2500 "parser_bison.y"
                        {
				(yyval.handle)			= (yyvsp[-1].handle);
				(yyval.handle).flowtable.name	= (yyvsp[0].string);
				(yyval.handle).flowtable.location	= (yylsp[0]);
			}
#line 9567 "parser_bison.c"
    break;

  case 352: /* flowtableid_spec: table_spec "handle" "number"  */
#line 2508 "parser_bison.y"
                        {
				(yyval.handle)			= (yyvsp[-2].handle);
				(yyval.handle).handle.location	= (yylsp[0]);
				(yyval.handle).handle.id		= (yyvsp[0].val);
			}
#line 9577 "parser_bison.c"
    break;

  case 353: /* flowtable_identifier: identifier  */
#line 2516 "parser_bison.y"
                        {
				memset(&(yyval.handle), 0, sizeof((yyval.handle)));
				(yyval.handle).flowtable.name	= (yyvsp[0].string);
				(yyval.handle).flowtable.location	= (yylsp[0]);
			}
#line 9587 "parser_bison.c"
    break;

  case 354: /* obj_spec: table_spec identifier  */
#line 2524 "parser_bison.y"
                        {
				(yyval.handle)		= (yyvsp[-1].handle);
				(yyval.handle).obj.name	= (yyvsp[0].string);
				(yyval.handle).obj.location	= (yylsp[0]);
			}
#line 9597 "parser_bison.c"
    break;

  case 355: /* objid_spec: table_spec "handle" "number"  */
#line 2532 "parser_bison.y"
                        {
				(yyval.handle) 			= (yyvsp[-2].handle);
				(yyval.handle).handle.location	= (yylsp[0]);
				(yyval.handle).handle.id		= (yyvsp[0].val);
			}
#line 9607 "parser_bison.c"
    break;

  case 356: /* obj_identifier: identifier  */
#line 2540 "parser_bison.y"
                        {
				memset(&(yyval.handle), 0, sizeof((yyval.handle)));
				(yyval.handle).obj.name		= (yyvsp[0].string);
				(yyval.handle).obj.location		= (yylsp[0]);
			}
#line 9617 "parser_bison.c"
    break;

  case 357: /* handle_spec: "handle" "number"  */
#line 2548 "parser_bison.y"
                        {
				memset(&(yyval.handle), 0, sizeof((yyval.handle)));
				(yyval.handle).handle.location	= (yylsp[0]);
				(yyval.handle).handle.id		= (yyvsp[0].val);
			}
#line 9627 "parser_bison.c"
    break;

  case 358: /* position_spec: "position" "number"  */
#line 2556 "parser_bison.y"
                        {
				memset(&(yyval.handle), 0, sizeof((yyval.handle)));
				(yyval.handle).position.location	= (yyloc);
				(yyval.handle).position.id		= (yyvsp[0].val);
			}
#line 9637 "parser_bison.c"
    break;

  case 359: /* index_spec: "index" "number"  */
#line 2564 "parser_bison.y"
                        {
				memset(&(yyval.handle), 0, sizeof((yyval.handle)));
				(yyval.handle).index.location	= (yyloc);
				(yyval.handle).index.id		= (yyvsp[0].val) + 1;
			}
#line 9647 "parser_bison.c"
    break;

  case 360: /* rule_position: chain_spec  */
#line 2572 "parser_bison.y"
                        {
				(yyval.handle) = (yyvsp[0].handle);
			}
#line 9655 "parser_bison.c"
    break;

  case 361: /* rule_position: chain_spec position_spec  */
#line 2576 "parser_bison.y"
                        {
				handle_merge(&(yyvsp[-1].handle), &(yyvsp[0].handle));
				(yyval.handle) = (yyvsp[-1].handle);
			}
#line 9664 "parser_bison.c"
    break;

  case 362: /* rule_position: chain_spec handle_spec  */
#line 2581 "parser_bison.y"
                        {
				(yyvsp[0].handle).position.location = (yyvsp[0].handle).handle.location;
				(yyvsp[0].handle).position.id = (yyvsp[0].handle).handle.id;
				(yyvsp[0].handle).handle.id = 0;
				handle_merge(&(yyvsp[-1].handle), &(yyvsp[0].handle));
				(yyval.handle) = (yyvsp[-1].handle);
			}
#line 9676 "parser_bison.c"
    break;

  case 363: /* rule_position: chain_spec index_spec  */
#line 2589 "parser_bison.y"
                        {
				handle_merge(&(yyvsp[-1].handle), &(yyvsp[0].handle));
				(yyval.handle) = (yyvsp[-1].handle);
			}
#line 9685 "parser_bison.c"
    break;

  case 364: /* ruleid_spec: chain_spec handle_spec  */
#line 2596 "parser_bison.y"
                        {
				handle_merge(&(yyvsp[-1].handle), &(yyvsp[0].handle));
				(yyval.handle) = (yyvsp[-1].handle);
			}
#line 9694 "parser_bison.c"
    break;

  case 365: /* comment_spec: "comment" string  */
#line 2603 "parser_bison.y"
                        {
				if (strlen((yyvsp[0].string)) > NFTNL_UDATA_COMMENT_MAXLEN) {
					erec_queue(error(&(yylsp[0]), "comment too long, %d characters maximum allowed",
							 NFTNL_UDATA_COMMENT_MAXLEN),
						   state->msgs);
					YYERROR;
				}
				(yyval.string) = (yyvsp[0].string);
			}
#line 9708 "parser_bison.c"
    break;

  case 366: /* ruleset_spec: %empty  */
#line 2615 "parser_bison.y"
                        {
				memset(&(yyval.handle), 0, sizeof((yyval.handle)));
				(yyval.handle).family	= NFPROTO_UNSPEC;
			}
#line 9717 "parser_bison.c"
    break;

  case 367: /* ruleset_spec: family_spec_explicit  */
#line 2620 "parser_bison.y"
                        {
				memset(&(yyval.handle), 0, sizeof((yyval.handle)));
				(yyval.handle).family	= (yyvsp[0].val);
			}
#line 9726 "parser_bison.c"
    break;

  case 368: /* rule: rule_alloc  */
#line 2627 "parser_bison.y"
                        {
				(yyval.rule)->comment = NULL;
			}
#line 9734 "parser_bison.c"
    break;

  case 369: /* rule: rule_alloc comment_spec  */
#line 2631 "parser_bison.y"
                        {
				(yyval.rule)->comment = (yyvsp[0].string);
			}
#line 9742 "parser_bison.c"
    break;

  case 370: /* rule_alloc: stmt_list  */
#line 2637 "parser_bison.y"
                        {
				struct stmt *i;

				(yyval.rule) = rule_alloc(&(yyloc), NULL);
				list_for_each_entry(i, (yyvsp[0].list), list)
					(yyval.rule)->num_stmts++;
				list_splice_tail((yyvsp[0].list), &(yyval.rule)->stmts);
				xfree((yyvsp[0].list));
			}
#line 9756 "parser_bison.c"
    break;

  case 371: /* stmt_list: stmt  */
#line 2649 "parser_bison.y"
                        {
				(yyval.list) = xmalloc(sizeof(*(yyval.list)));
				init_list_head((yyval.list));
				list_add_tail(&(yyvsp[0].stmt)->list, (yyval.list));
			}
#line 9766 "parser_bison.c"
    break;

  case 372: /* stmt_list: stmt_list stmt  */
#line 2655 "parser_bison.y"
                        {
				(yyval.list) = (yyvsp[-1].list);
				list_add_tail(&(yyvsp[0].stmt)->list, (yyvsp[-1].list));
			}
#line 9775 "parser_bison.c"
    break;

  case 373: /* stateful_stmt_list: stateful_stmt  */
#line 2662 "parser_bison.y"
                        {
				(yyval.list) = xmalloc(sizeof(*(yyval.list)));
				init_list_head((yyval.list));
				list_add_tail(&(yyvsp[0].stmt)->list, (yyval.list));
			}
#line 9785 "parser_bison.c"
    break;

  case 374: /* stateful_stmt_list: stateful_stmt_list stateful_stmt  */
#line 2668 "parser_bison.y"
                        {
				(yyval.list) = (yyvsp[-1].list);
				list_add_tail(&(yyvsp[0].stmt)->list, (yyvsp[-1].list));
			}
#line 9794 "parser_bison.c"
    break;

  case 399: /* chain_stmt_type: "jump"  */
#line 2702 "parser_bison.y"
                                        { (yyval.val) = NFT_JUMP; }
#line 9800 "parser_bison.c"
    break;

  case 400: /* chain_stmt_type: "goto"  */
#line 2703 "parser_bison.y"
                                        { (yyval.val) = NFT_GOTO; }
#line 9806 "parser_bison.c"
    break;

  case 401: /* chain_stmt: chain_stmt_type chain_block_alloc '{' subchain_block '}'  */
#line 2707 "parser_bison.y"
                        {
				(yyvsp[-3].chain)->location = (yylsp[-3]);
				close_scope(state);
				(yyvsp[-1].chain)->location = (yylsp[-1]);
				(yyval.stmt) = chain_stmt_alloc(&(yyloc), (yyvsp[-1].chain), (yyvsp[-4].val));
			}
#line 9817 "parser_bison.c"
    break;

  case 402: /* verdict_stmt: verdict_expr  */
#line 2716 "parser_bison.y"
                        {
				(yyval.stmt) = verdict_stmt_alloc(&(yyloc), (yyvsp[0].expr));
			}
#line 9825 "parser_bison.c"
    break;

  case 403: /* verdict_stmt: verdict_map_stmt  */
#line 2720 "parser_bison.y"
                        {
				(yyval.stmt) = verdict_stmt_alloc(&(yyloc), (yyvsp[0].expr));
			}
#line 9833 "parser_bison.c"
    break;

  case 404: /* verdict_map_stmt: concat_expr "vmap" verdict_map_expr  */
#line 2726 "parser_bison.y"
                        {
				(yyval.expr) = map_expr_alloc(&(yyloc), (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 9841 "parser_bison.c"
    break;

  case 405: /* verdict_map_expr: '{' verdict_map_list_expr '}'  */
#line 2732 "parser_bison.y"
                        {
				(yyvsp[-1].expr)->location = (yyloc);
				(yyval.expr) = (yyvsp[-1].expr);
			}
#line 9850 "parser_bison.c"
    break;

  case 407: /* verdict_map_list_expr: verdict_map_list_member_expr  */
#line 2740 "parser_bison.y"
                        {
				(yyval.expr) = set_expr_alloc(&(yyloc), NULL);
				compound_expr_add((yyval.expr), (yyvsp[0].expr));
			}
#line 9859 "parser_bison.c"
    break;

  case 408: /* verdict_map_list_expr: verdict_map_list_expr "comma" verdict_map_list_member_expr  */
#line 2745 "parser_bison.y"
                        {
				compound_expr_add((yyvsp[-2].expr), (yyvsp[0].expr));
				(yyval.expr) = (yyvsp[-2].expr);
			}
#line 9868 "parser_bison.c"
    break;

  case 410: /* verdict_map_list_member_expr: opt_newline set_elem_expr "colon" verdict_expr opt_newline  */
#line 2753 "parser_bison.y"
                        {
				(yyval.expr) = mapping_expr_alloc(&(yyloc), (yyvsp[-3].expr), (yyvsp[-1].expr));
			}
#line 9876 "parser_bison.c"
    break;

  case 411: /* connlimit_stmt: "ct" "count" "number"  */
#line 2759 "parser_bison.y"
                        {
				(yyval.stmt) = connlimit_stmt_alloc(&(yyloc));
				(yyval.stmt)->connlimit.count	= (yyvsp[0].val);
			}
#line 9885 "parser_bison.c"
    break;

  case 412: /* connlimit_stmt: "ct" "count" "over" "number"  */
#line 2764 "parser_bison.y"
                        {
				(yyval.stmt) = connlimit_stmt_alloc(&(yyloc));
				(yyval.stmt)->connlimit.count = (yyvsp[0].val);
				(yyval.stmt)->connlimit.flags = NFT_CONNLIMIT_F_INV;
			}
#line 9895 "parser_bison.c"
    break;

  case 415: /* counter_stmt_alloc: "counter"  */
#line 2775 "parser_bison.y"
                        {
				(yyval.stmt) = counter_stmt_alloc(&(yyloc));
			}
#line 9903 "parser_bison.c"
    break;

  case 416: /* counter_stmt_alloc: "counter" "name" stmt_expr  */
#line 2779 "parser_bison.y"
                        {
				(yyval.stmt) = objref_stmt_alloc(&(yyloc));
				(yyval.stmt)->objref.type = NFT_OBJECT_COUNTER;
				(yyval.stmt)->objref.expr = (yyvsp[0].expr);
			}
#line 9913 "parser_bison.c"
    break;

  case 417: /* counter_args: counter_arg  */
#line 2787 "parser_bison.y"
                        {
				(yyval.stmt)	= (yyvsp[-1].stmt);
			}
#line 9921 "parser_bison.c"
    break;

  case 419: /* counter_arg: "packets" "number"  */
#line 2794 "parser_bison.y"
                        {
				(yyvsp[-2].stmt)->counter.packets = (yyvsp[0].val);
			}
#line 9929 "parser_bison.c"
    break;

  case 420: /* counter_arg: "bytes" "number"  */
#line 2798 "parser_bison.y"
                        {
				(yyvsp[-2].stmt)->counter.bytes	 = (yyvsp[0].val);
			}
#line 9937 "parser_bison.c"
    break;

  case 423: /* log_stmt_alloc: "log"  */
#line 2808 "parser_bison.y"
                        {
				(yyval.stmt) = log_stmt_alloc(&(yyloc));
			}
#line 9945 "parser_bison.c"
    break;

  case 424: /* log_args: log_arg  */
#line 2814 "parser_bison.y"
                        {
				(yyval.stmt)	= (yyvsp[-1].stmt);
			}
#line 9953 "parser_bison.c"
    break;

  case 426: /* log_arg: "prefix" string  */
#line 2821 "parser_bison.y"
                        {
				struct scope *scope = current_scope(state);
				bool done = false, another_var = false;
				char *start, *end, scratch = '\0';
				struct expr *expr, *item;
				struct symbol *sym;
				enum {
					PARSE_TEXT,
					PARSE_VAR,
				} prefix_state;

				/* No variables in log prefix, skip. */
				if (!strchr((yyvsp[0].string), '$')) {
					expr = constant_expr_alloc(&(yyloc), &string_type,
								   BYTEORDER_HOST_ENDIAN,
								   (strlen((yyvsp[0].string)) + 1) * BITS_PER_BYTE, (yyvsp[0].string));
					xfree((yyvsp[0].string));
					(yyvsp[-2].stmt)->log.prefix = expr;
					(yyvsp[-2].stmt)->log.flags |= STMT_LOG_PREFIX;
					break;
				}

				/* Parse variables in log prefix string using a
				 * state machine parser with two states. This
				 * parser creates list of expressions composed
				 * of constant and variable expressions.
				 */
				expr = compound_expr_alloc(&(yyloc), EXPR_LIST);

				start = (char *)(yyvsp[0].string);

				if (*start != '$') {
					prefix_state = PARSE_TEXT;
				} else {
					prefix_state = PARSE_VAR;
					start++;
				}
				end = start;

				/* Not nice, but works. */
				while (!done) {
					switch (prefix_state) {
					case PARSE_TEXT:
						while (*end != '\0' && *end != '$')
							end++;

						if (*end == '\0')
							done = true;

						*end = '\0';
						item = constant_expr_alloc(&(yyloc), &string_type,
									   BYTEORDER_HOST_ENDIAN,
									   (strlen(start) + 1) * BITS_PER_BYTE,
									   start);
						compound_expr_add(expr, item);

						if (done)
							break;

						start = end + 1;
						end = start;

						/* fall through */
					case PARSE_VAR:
						while (isalnum(*end) || *end == '_')
							end++;

						if (*end == '\0')
							done = true;
						else if (*end == '$')
							another_var = true;
						else
							scratch = *end;

						*end = '\0';

						sym = symbol_get(scope, start);
						if (!sym) {
							sym = symbol_lookup_fuzzy(scope, start);
							if (sym) {
								erec_queue(error(&(yylsp[0]), "unknown identifier '%s'; "
										 "did you mean identifier ‘%s’?",
										 start, sym->identifier),
									   state->msgs);
							} else {
								erec_queue(error(&(yylsp[0]), "unknown identifier '%s'",
										 start),
									   state->msgs);
							}
							expr_free(expr);
							xfree((yyvsp[0].string));
							YYERROR;
						}
						item = variable_expr_alloc(&(yyloc), scope, sym);
						compound_expr_add(expr, item);

						if (done)
							break;

						/* Restore original byte after
						 * symbol lookup.
						 */
						if (scratch) {
							*end = scratch;
							scratch = '\0';
						}

						start = end;
						if (another_var) {
							another_var = false;
							start++;
							prefix_state = PARSE_VAR;
						} else {
							prefix_state = PARSE_TEXT;
						}
						end = start;
						break;
					}
				}

				xfree((yyvsp[0].string));
				(yyvsp[-2].stmt)->log.prefix	 = expr;
				(yyvsp[-2].stmt)->log.flags 	|= STMT_LOG_PREFIX;
			}
#line 10082 "parser_bison.c"
    break;

  case 427: /* log_arg: "group" "number"  */
#line 2946 "parser_bison.y"
                        {
				(yyvsp[-2].stmt)->log.group	 = (yyvsp[0].val);
				(yyvsp[-2].stmt)->log.flags 	|= STMT_LOG_GROUP;
			}
#line 10091 "parser_bison.c"
    break;

  case 428: /* log_arg: "snaplen" "number"  */
#line 2951 "parser_bison.y"
                        {
				(yyvsp[-2].stmt)->log.snaplen	 = (yyvsp[0].val);
				(yyvsp[-2].stmt)->log.flags 	|= STMT_LOG_SNAPLEN;
			}
#line 10100 "parser_bison.c"
    break;

  case 429: /* log_arg: "queue-threshold" "number"  */
#line 2956 "parser_bison.y"
                        {
				(yyvsp[-2].stmt)->log.qthreshold = (yyvsp[0].val);
				(yyvsp[-2].stmt)->log.flags 	|= STMT_LOG_QTHRESHOLD;
			}
#line 10109 "parser_bison.c"
    break;

  case 430: /* log_arg: "level" level_type  */
#line 2961 "parser_bison.y"
                        {
				(yyvsp[-2].stmt)->log.level	= (yyvsp[0].val);
				(yyvsp[-2].stmt)->log.flags 	|= STMT_LOG_LEVEL;
			}
#line 10118 "parser_bison.c"
    break;

  case 431: /* log_arg: "flags" log_flags  */
#line 2966 "parser_bison.y"
                        {
				(yyvsp[-2].stmt)->log.logflags	|= (yyvsp[0].val);
			}
#line 10126 "parser_bison.c"
    break;

  case 432: /* level_type: string  */
#line 2972 "parser_bison.y"
                        {
				if (!strcmp("emerg", (yyvsp[0].string)))
					(yyval.val) = NFT_LOGLEVEL_EMERG;
				else if (!strcmp("alert", (yyvsp[0].string)))
					(yyval.val) = NFT_LOGLEVEL_ALERT;
				else if (!strcmp("crit", (yyvsp[0].string)))
					(yyval.val) = NFT_LOGLEVEL_CRIT;
				else if (!strcmp("err", (yyvsp[0].string)))
					(yyval.val) = NFT_LOGLEVEL_ERR;
				else if (!strcmp("warn", (yyvsp[0].string)))
					(yyval.val) = NFT_LOGLEVEL_WARNING;
				else if (!strcmp("notice", (yyvsp[0].string)))
					(yyval.val) = NFT_LOGLEVEL_NOTICE;
				else if (!strcmp("info", (yyvsp[0].string)))
					(yyval.val) = NFT_LOGLEVEL_INFO;
				else if (!strcmp("debug", (yyvsp[0].string)))
					(yyval.val) = NFT_LOGLEVEL_DEBUG;
				else if (!strcmp("audit", (yyvsp[0].string)))
					(yyval.val) = NFT_LOGLEVEL_AUDIT;
				else {
					erec_queue(error(&(yylsp[0]), "invalid log level"),
						   state->msgs);
					xfree((yyvsp[0].string));
					YYERROR;
				}
				xfree((yyvsp[0].string));
			}
#line 10158 "parser_bison.c"
    break;

  case 433: /* log_flags: "tcp" log_flags_tcp  */
#line 3002 "parser_bison.y"
                        {
				(yyval.val) = (yyvsp[0].val);
			}
#line 10166 "parser_bison.c"
    break;

  case 434: /* log_flags: "ip" "options"  */
#line 3006 "parser_bison.y"
                        {
				(yyval.val) = NF_LOG_IPOPT;
			}
#line 10174 "parser_bison.c"
    break;

  case 435: /* log_flags: "skuid"  */
#line 3010 "parser_bison.y"
                        {
				(yyval.val) = NF_LOG_UID;
			}
#line 10182 "parser_bison.c"
    break;

  case 436: /* log_flags: "ether"  */
#line 3014 "parser_bison.y"
                        {
				(yyval.val) = NF_LOG_MACDECODE;
			}
#line 10190 "parser_bison.c"
    break;

  case 437: /* log_flags: "all"  */
#line 3018 "parser_bison.y"
                        {
				(yyval.val) = NF_LOG_MASK;
			}
#line 10198 "parser_bison.c"
    break;

  case 438: /* log_flags_tcp: log_flags_tcp "comma" log_flag_tcp  */
#line 3024 "parser_bison.y"
                        {
				(yyval.val) = (yyvsp[-2].val) | (yyvsp[0].val);
			}
#line 10206 "parser_bison.c"
    break;

  case 440: /* log_flag_tcp: "seq"  */
#line 3031 "parser_bison.y"
                        {
				(yyval.val) = NF_LOG_TCPSEQ;
			}
#line 10214 "parser_bison.c"
    break;

  case 441: /* log_flag_tcp: "options"  */
#line 3035 "parser_bison.y"
                        {
				(yyval.val) = NF_LOG_TCPOPT;
			}
#line 10222 "parser_bison.c"
    break;

  case 442: /* limit_stmt: "limit" "rate" limit_mode "number" "/" time_unit limit_burst_pkts  */
#line 3041 "parser_bison.y"
                        {
				if ((yyvsp[0].val) == 0) {
					erec_queue(error(&(yylsp[0]), "limit burst must be > 0"),
						   state->msgs);
					YYERROR;
				}
				(yyval.stmt) = limit_stmt_alloc(&(yyloc));
				(yyval.stmt)->limit.rate	= (yyvsp[-3].val);
				(yyval.stmt)->limit.unit	= (yyvsp[-1].val);
				(yyval.stmt)->limit.burst	= (yyvsp[0].val);
				(yyval.stmt)->limit.type	= NFT_LIMIT_PKTS;
				(yyval.stmt)->limit.flags = (yyvsp[-4].val);
			}
#line 10240 "parser_bison.c"
    break;

  case 443: /* limit_stmt: "limit" "rate" limit_mode "number" "string" limit_burst_bytes  */
#line 3055 "parser_bison.y"
                        {
				struct error_record *erec;
				uint64_t rate, unit;

				if ((yyvsp[0].val) == 0) {
					erec_queue(error(&(yylsp[0]), "limit burst must be > 0"),
						   state->msgs);
					YYERROR;
				}

				erec = rate_parse(&(yyloc), (yyvsp[-1].string), &rate, &unit);
				xfree((yyvsp[-1].string));
				if (erec != NULL) {
					erec_queue(erec, state->msgs);
					YYERROR;
				}

				(yyval.stmt) = limit_stmt_alloc(&(yyloc));
				(yyval.stmt)->limit.rate	= rate * (yyvsp[-2].val);
				(yyval.stmt)->limit.unit	= unit;
				(yyval.stmt)->limit.burst	= (yyvsp[0].val);
				(yyval.stmt)->limit.type	= NFT_LIMIT_PKT_BYTES;
				(yyval.stmt)->limit.flags = (yyvsp[-3].val);
			}
#line 10269 "parser_bison.c"
    break;

  case 444: /* limit_stmt: "limit" "name" stmt_expr  */
#line 3080 "parser_bison.y"
                        {
				(yyval.stmt) = objref_stmt_alloc(&(yyloc));
				(yyval.stmt)->objref.type = NFT_OBJECT_LIMIT;
				(yyval.stmt)->objref.expr = (yyvsp[0].expr);
			}
#line 10279 "parser_bison.c"
    break;

  case 445: /* quota_mode: "over"  */
#line 3087 "parser_bison.y"
                                                { (yyval.val) = NFT_QUOTA_F_INV; }
#line 10285 "parser_bison.c"
    break;

  case 446: /* quota_mode: "until"  */
#line 3088 "parser_bison.y"
                                                { (yyval.val) = 0; }
#line 10291 "parser_bison.c"
    break;

  case 447: /* quota_mode: %empty  */
#line 3089 "parser_bison.y"
                                                { (yyval.val) = 0; }
#line 10297 "parser_bison.c"
    break;

  case 448: /* quota_unit: "bytes"  */
#line 3092 "parser_bison.y"
                                                { (yyval.string) = xstrdup("bytes"); }
#line 10303 "parser_bison.c"
    break;

  case 449: /* quota_unit: "string"  */
#line 3093 "parser_bison.y"
                                                { (yyval.string) = (yyvsp[0].string); }
#line 10309 "parser_bison.c"
    break;

  case 450: /* quota_used: %empty  */
#line 3096 "parser_bison.y"
                                                { (yyval.val) = 0; }
#line 10315 "parser_bison.c"
    break;

  case 451: /* quota_used: "used" "number" quota_unit  */
#line 3098 "parser_bison.y"
                        {
				struct error_record *erec;
				uint64_t rate;

				erec = data_unit_parse(&(yyloc), (yyvsp[0].string), &rate);
				xfree((yyvsp[0].string));
				if (erec != NULL) {
					erec_queue(erec, state->msgs);
					YYERROR;
				}
				(yyval.val) = (yyvsp[-1].val) * rate;
			}
#line 10332 "parser_bison.c"
    break;

  case 452: /* quota_stmt: "quota" quota_mode "number" quota_unit quota_used  */
#line 3113 "parser_bison.y"
                        {
				struct error_record *erec;
				uint64_t rate;

				erec = data_unit_parse(&(yyloc), (yyvsp[-1].string), &rate);
				xfree((yyvsp[-1].string));
				if (erec != NULL) {
					erec_queue(erec, state->msgs);
					YYERROR;
				}
				(yyval.stmt) = quota_stmt_alloc(&(yyloc));
				(yyval.stmt)->quota.bytes	= (yyvsp[-2].val) * rate;
				(yyval.stmt)->quota.used = (yyvsp[0].val);
				(yyval.stmt)->quota.flags	= (yyvsp[-3].val);
			}
#line 10352 "parser_bison.c"
    break;

  case 453: /* quota_stmt: "quota" "name" stmt_expr  */
#line 3129 "parser_bison.y"
                        {
				(yyval.stmt) = objref_stmt_alloc(&(yyloc));
				(yyval.stmt)->objref.type = NFT_OBJECT_QUOTA;
				(yyval.stmt)->objref.expr = (yyvsp[0].expr);
			}
#line 10362 "parser_bison.c"
    break;

  case 454: /* limit_mode: "over"  */
#line 3136 "parser_bison.y"
                                                                { (yyval.val) = NFT_LIMIT_F_INV; }
#line 10368 "parser_bison.c"
    break;

  case 455: /* limit_mode: "until"  */
#line 3137 "parser_bison.y"
                                                                { (yyval.val) = 0; }
#line 10374 "parser_bison.c"
    break;

  case 456: /* limit_mode: %empty  */
#line 3138 "parser_bison.y"
                                                                { (yyval.val) = 0; }
#line 10380 "parser_bison.c"
    break;

  case 457: /* limit_burst_pkts: %empty  */
#line 3141 "parser_bison.y"
                                                                { (yyval.val) = 5; }
#line 10386 "parser_bison.c"
    break;

  case 458: /* limit_burst_pkts: "burst" "number" "packets"  */
#line 3142 "parser_bison.y"
                                                                { (yyval.val) = (yyvsp[-1].val); }
#line 10392 "parser_bison.c"
    break;

  case 459: /* limit_burst_bytes: %empty  */
#line 3145 "parser_bison.y"
                                                                { (yyval.val) = 5; }
#line 10398 "parser_bison.c"
    break;

  case 460: /* limit_burst_bytes: "burst" "number" "bytes"  */
#line 3146 "parser_bison.y"
                                                                { (yyval.val) = (yyvsp[-1].val); }
#line 10404 "parser_bison.c"
    break;

  case 461: /* limit_burst_bytes: "burst" "number" "string"  */
#line 3148 "parser_bison.y"
                        {
				struct error_record *erec;
				uint64_t rate;

				erec = data_unit_parse(&(yyloc), (yyvsp[0].string), &rate);
				xfree((yyvsp[0].string));
				if (erec != NULL) {
					erec_queue(erec, state->msgs);
					YYERROR;
				}
				(yyval.val) = (yyvsp[-1].val) * rate;
			}
#line 10421 "parser_bison.c"
    break;

  case 462: /* time_unit: "second"  */
#line 3162 "parser_bison.y"
                                                { (yyval.val) = 1ULL; }
#line 10427 "parser_bison.c"
    break;

  case 463: /* time_unit: "minute"  */
#line 3163 "parser_bison.y"
                                                { (yyval.val) = 1ULL * 60; }
#line 10433 "parser_bison.c"
    break;

  case 464: /* time_unit: "hour"  */
#line 3164 "parser_bison.y"
                                                { (yyval.val) = 1ULL * 60 * 60; }
#line 10439 "parser_bison.c"
    break;

  case 465: /* time_unit: "day"  */
#line 3165 "parser_bison.y"
                                                { (yyval.val) = 1ULL * 60 * 60 * 24; }
#line 10445 "parser_bison.c"
    break;

  case 466: /* time_unit: "week"  */
#line 3166 "parser_bison.y"
                                                { (yyval.val) = 1ULL * 60 * 60 * 24 * 7; }
#line 10451 "parser_bison.c"
    break;

  case 468: /* reject_stmt_alloc: "reject"  */
#line 3173 "parser_bison.y"
                        {
				(yyval.stmt) = reject_stmt_alloc(&(yyloc));
			}
#line 10459 "parser_bison.c"
    break;

  case 469: /* reject_opts: %empty  */
#line 3179 "parser_bison.y"
                        {
				(yyvsp[0].stmt)->reject.type = -1;
				(yyvsp[0].stmt)->reject.icmp_code = -1;
			}
#line 10468 "parser_bison.c"
    break;

  case 470: /* reject_opts: "with" "icmp" "type" "string"  */
#line 3184 "parser_bison.y"
                        {
				(yyvsp[-4].stmt)->reject.family = NFPROTO_IPV4;
				(yyvsp[-4].stmt)->reject.type = NFT_REJECT_ICMP_UNREACH;
				(yyvsp[-4].stmt)->reject.expr =
					symbol_expr_alloc(&(yyloc), SYMBOL_VALUE,
							  current_scope(state),
							  (yyvsp[0].string));
				datatype_set((yyvsp[-4].stmt)->reject.expr, &icmp_code_type);
				xfree((yyvsp[0].string));
			}
#line 10483 "parser_bison.c"
    break;

  case 471: /* reject_opts: "with" "icmpv6" "type" "string"  */
#line 3195 "parser_bison.y"
                        {
				(yyvsp[-4].stmt)->reject.family = NFPROTO_IPV6;
				(yyvsp[-4].stmt)->reject.type = NFT_REJECT_ICMP_UNREACH;
				(yyvsp[-4].stmt)->reject.expr =
					symbol_expr_alloc(&(yyloc), SYMBOL_VALUE,
							  current_scope(state),
							  (yyvsp[0].string));
				datatype_set((yyvsp[-4].stmt)->reject.expr, &icmpv6_code_type);
				xfree((yyvsp[0].string));
			}
#line 10498 "parser_bison.c"
    break;

  case 472: /* reject_opts: "with" "icmpx" "type" "string"  */
#line 3206 "parser_bison.y"
                        {
				(yyvsp[-4].stmt)->reject.type = NFT_REJECT_ICMPX_UNREACH;
				(yyvsp[-4].stmt)->reject.expr =
					symbol_expr_alloc(&(yyloc), SYMBOL_VALUE,
							  current_scope(state),
							  (yyvsp[0].string));
				datatype_set((yyvsp[-4].stmt)->reject.expr, &icmpx_code_type);
				xfree((yyvsp[0].string));
			}
#line 10512 "parser_bison.c"
    break;

  case 473: /* reject_opts: "with" "tcp" "reset"  */
#line 3216 "parser_bison.y"
                        {
				(yyvsp[-3].stmt)->reject.type = NFT_REJECT_TCP_RST;
			}
#line 10520 "parser_bison.c"
    break;

  case 475: /* nat_stmt_alloc: "snat"  */
#line 3224 "parser_bison.y"
                                        { (yyval.stmt) = nat_stmt_alloc(&(yyloc), NFT_NAT_SNAT); }
#line 10526 "parser_bison.c"
    break;

  case 476: /* nat_stmt_alloc: "dnat"  */
#line 3225 "parser_bison.y"
                                        { (yyval.stmt) = nat_stmt_alloc(&(yyloc), NFT_NAT_DNAT); }
#line 10532 "parser_bison.c"
    break;

  case 477: /* tproxy_stmt: "tproxy" "to" stmt_expr  */
#line 3229 "parser_bison.y"
                        {
				(yyval.stmt) = tproxy_stmt_alloc(&(yyloc));
				(yyval.stmt)->tproxy.family = NFPROTO_UNSPEC;
				(yyval.stmt)->tproxy.addr = (yyvsp[0].expr);
			}
#line 10542 "parser_bison.c"
    break;

  case 478: /* tproxy_stmt: "tproxy" nf_key_proto "to" stmt_expr  */
#line 3235 "parser_bison.y"
                        {
				(yyval.stmt) = tproxy_stmt_alloc(&(yyloc));
				(yyval.stmt)->tproxy.family = (yyvsp[-2].val);
				(yyval.stmt)->tproxy.addr = (yyvsp[0].expr);
			}
#line 10552 "parser_bison.c"
    break;

  case 479: /* tproxy_stmt: "tproxy" "to" "colon" stmt_expr  */
#line 3241 "parser_bison.y"
                        {
				(yyval.stmt) = tproxy_stmt_alloc(&(yyloc));
				(yyval.stmt)->tproxy.family = NFPROTO_UNSPEC;
				(yyval.stmt)->tproxy.port = (yyvsp[0].expr);
			}
#line 10562 "parser_bison.c"
    break;

  case 480: /* tproxy_stmt: "tproxy" "to" stmt_expr "colon" stmt_expr  */
#line 3247 "parser_bison.y"
                        {
				(yyval.stmt) = tproxy_stmt_alloc(&(yyloc));
				(yyval.stmt)->tproxy.family = NFPROTO_UNSPEC;
				(yyval.stmt)->tproxy.addr = (yyvsp[-2].expr);
				(yyval.stmt)->tproxy.port = (yyvsp[0].expr);
			}
#line 10573 "parser_bison.c"
    break;

  case 481: /* tproxy_stmt: "tproxy" nf_key_proto "to" stmt_expr "colon" stmt_expr  */
#line 3254 "parser_bison.y"
                        {
				(yyval.stmt) = tproxy_stmt_alloc(&(yyloc));
				(yyval.stmt)->tproxy.family = (yyvsp[-4].val);
				(yyval.stmt)->tproxy.addr = (yyvsp[-2].expr);
				(yyval.stmt)->tproxy.port = (yyvsp[0].expr);
			}
#line 10584 "parser_bison.c"
    break;

  case 482: /* tproxy_stmt: "tproxy" nf_key_proto "to" "colon" stmt_expr  */
#line 3261 "parser_bison.y"
                        {
				(yyval.stmt) = tproxy_stmt_alloc(&(yyloc));
				(yyval.stmt)->tproxy.family = (yyvsp[-3].val);
				(yyval.stmt)->tproxy.port = (yyvsp[0].expr);
			}
#line 10594 "parser_bison.c"
    break;

  case 485: /* synproxy_stmt_alloc: "synproxy"  */
#line 3273 "parser_bison.y"
                        {
				(yyval.stmt) = synproxy_stmt_alloc(&(yyloc));
			}
#line 10602 "parser_bison.c"
    break;

  case 486: /* synproxy_stmt_alloc: "synproxy" "name" stmt_expr  */
#line 3277 "parser_bison.y"
                        {
				(yyval.stmt) = objref_stmt_alloc(&(yyloc));
				(yyval.stmt)->objref.type = NFT_OBJECT_SYNPROXY;
				(yyval.stmt)->objref.expr = (yyvsp[0].expr);
			}
#line 10612 "parser_bison.c"
    break;

  case 487: /* synproxy_args: synproxy_arg  */
#line 3285 "parser_bison.y"
                        {
				(yyval.stmt)	= (yyvsp[-1].stmt);
			}
#line 10620 "parser_bison.c"
    break;

  case 489: /* synproxy_arg: "mss" "number"  */
#line 3292 "parser_bison.y"
                        {
				(yyvsp[-2].stmt)->synproxy.mss = (yyvsp[0].val);
				(yyvsp[-2].stmt)->synproxy.flags |= NF_SYNPROXY_OPT_MSS;
			}
#line 10629 "parser_bison.c"
    break;

  case 490: /* synproxy_arg: "wscale" "number"  */
#line 3297 "parser_bison.y"
                        {
				(yyvsp[-2].stmt)->synproxy.wscale = (yyvsp[0].val);
				(yyvsp[-2].stmt)->synproxy.flags |= NF_SYNPROXY_OPT_WSCALE;
			}
#line 10638 "parser_bison.c"
    break;

  case 491: /* synproxy_arg: "timestamp"  */
#line 3302 "parser_bison.y"
                        {
				(yyvsp[-1].stmt)->synproxy.flags |= NF_SYNPROXY_OPT_TIMESTAMP;
			}
#line 10646 "parser_bison.c"
    break;

  case 492: /* synproxy_arg: "sack-permitted"  */
#line 3306 "parser_bison.y"
                        {
				(yyvsp[-1].stmt)->synproxy.flags |= NF_SYNPROXY_OPT_SACK_PERM;
			}
#line 10654 "parser_bison.c"
    break;

  case 493: /* synproxy_config: "mss" "number" "wscale" "number" synproxy_ts synproxy_sack  */
#line 3312 "parser_bison.y"
                        {
				struct synproxy *synproxy;
				uint32_t flags = 0;

				synproxy = &(yyvsp[-6].obj)->synproxy;
				synproxy->mss = (yyvsp[-4].val);
				flags |= NF_SYNPROXY_OPT_MSS;
				synproxy->wscale = (yyvsp[-2].val);
				flags |= NF_SYNPROXY_OPT_WSCALE;
				if ((yyvsp[-1].val))
					flags |= (yyvsp[-1].val);
				if ((yyvsp[0].val))
					flags |= (yyvsp[0].val);
				synproxy->flags = flags;
			}
#line 10674 "parser_bison.c"
    break;

  case 494: /* synproxy_config: "mss" "number" stmt_separator "wscale" "number" stmt_separator synproxy_ts synproxy_sack  */
#line 3328 "parser_bison.y"
                        {
				struct synproxy *synproxy;
				uint32_t flags = 0;

				synproxy = &(yyvsp[-8].obj)->synproxy;
				synproxy->mss = (yyvsp[-6].val);
				flags |= NF_SYNPROXY_OPT_MSS;
				synproxy->wscale = (yyvsp[-3].val);
				flags |= NF_SYNPROXY_OPT_WSCALE;
				if ((yyvsp[-1].val))
					flags |= (yyvsp[-1].val);
				if ((yyvsp[0].val))
					flags |= (yyvsp[0].val);
				synproxy->flags = flags;
			}
#line 10694 "parser_bison.c"
    break;

  case 495: /* synproxy_obj: %empty  */
#line 3346 "parser_bison.y"
                        {
				(yyval.obj) = obj_alloc(&(yyloc));
				(yyval.obj)->type = NFT_OBJECT_SYNPROXY;
			}
#line 10703 "parser_bison.c"
    break;

  case 496: /* synproxy_ts: %empty  */
#line 3352 "parser_bison.y"
                                                { (yyval.val) = 0; }
#line 10709 "parser_bison.c"
    break;

  case 497: /* synproxy_ts: "timestamp"  */
#line 3354 "parser_bison.y"
                        {
				(yyval.val) = NF_SYNPROXY_OPT_TIMESTAMP;
			}
#line 10717 "parser_bison.c"
    break;

  case 498: /* synproxy_sack: %empty  */
#line 3359 "parser_bison.y"
                                                { (yyval.val) = 0; }
#line 10723 "parser_bison.c"
    break;

  case 499: /* synproxy_sack: "sack-permitted"  */
#line 3361 "parser_bison.y"
                        {
				(yyval.val) = NF_SYNPROXY_OPT_SACK_PERM;
			}
#line 10731 "parser_bison.c"
    break;

  case 500: /* primary_stmt_expr: symbol_expr  */
#line 3366 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 10737 "parser_bison.c"
    break;

  case 501: /* primary_stmt_expr: integer_expr  */
#line 3367 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 10743 "parser_bison.c"
    break;

  case 502: /* primary_stmt_expr: boolean_expr  */
#line 3368 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 10749 "parser_bison.c"
    break;

  case 503: /* primary_stmt_expr: meta_expr  */
#line 3369 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 10755 "parser_bison.c"
    break;

  case 504: /* primary_stmt_expr: rt_expr  */
#line 3370 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 10761 "parser_bison.c"
    break;

  case 505: /* primary_stmt_expr: ct_expr  */
#line 3371 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 10767 "parser_bison.c"
    break;

  case 506: /* primary_stmt_expr: numgen_expr  */
#line 3372 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 10773 "parser_bison.c"
    break;

  case 507: /* primary_stmt_expr: hash_expr  */
#line 3373 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 10779 "parser_bison.c"
    break;

  case 508: /* primary_stmt_expr: payload_expr  */
#line 3374 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 10785 "parser_bison.c"
    break;

  case 509: /* primary_stmt_expr: keyword_expr  */
#line 3375 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 10791 "parser_bison.c"
    break;

  case 510: /* primary_stmt_expr: socket_expr  */
#line 3376 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 10797 "parser_bison.c"
    break;

  case 511: /* primary_stmt_expr: osf_expr  */
#line 3377 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 10803 "parser_bison.c"
    break;

  case 512: /* primary_stmt_expr: '(' basic_stmt_expr ')'  */
#line 3378 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[-1].expr); }
#line 10809 "parser_bison.c"
    break;

  case 514: /* shift_stmt_expr: shift_stmt_expr "<<" primary_stmt_expr  */
#line 3383 "parser_bison.y"
                        {
				(yyval.expr) = binop_expr_alloc(&(yyloc), OP_LSHIFT, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 10817 "parser_bison.c"
    break;

  case 515: /* shift_stmt_expr: shift_stmt_expr ">>" primary_stmt_expr  */
#line 3387 "parser_bison.y"
                        {
				(yyval.expr) = binop_expr_alloc(&(yyloc), OP_RSHIFT, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 10825 "parser_bison.c"
    break;

  case 517: /* and_stmt_expr: and_stmt_expr "&" shift_stmt_expr  */
#line 3394 "parser_bison.y"
                        {
				(yyval.expr) = binop_expr_alloc(&(yyloc), OP_AND, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 10833 "parser_bison.c"
    break;

  case 519: /* exclusive_or_stmt_expr: exclusive_or_stmt_expr "^" and_stmt_expr  */
#line 3401 "parser_bison.y"
                        {
				(yyval.expr) = binop_expr_alloc(&(yyloc), OP_XOR, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 10841 "parser_bison.c"
    break;

  case 521: /* inclusive_or_stmt_expr: inclusive_or_stmt_expr '|' exclusive_or_stmt_expr  */
#line 3408 "parser_bison.y"
                        {
				(yyval.expr) = binop_expr_alloc(&(yyloc), OP_OR, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 10849 "parser_bison.c"
    break;

  case 524: /* concat_stmt_expr: concat_stmt_expr "." primary_stmt_expr  */
#line 3418 "parser_bison.y"
                        {
				struct location rhs[] = {
					[1]	= (yylsp[-1]),
					[2]	= (yylsp[0]),
				};

				(yyval.expr) = handle_concat_expr(&(yyloc), (yyval.expr), (yyvsp[-2].expr), (yyvsp[0].expr), rhs);
			}
#line 10862 "parser_bison.c"
    break;

  case 527: /* map_stmt_expr: concat_stmt_expr "map" map_stmt_expr_set  */
#line 3433 "parser_bison.y"
                        {
				(yyval.expr) = map_expr_alloc(&(yyloc), (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 10870 "parser_bison.c"
    break;

  case 528: /* map_stmt_expr: concat_stmt_expr  */
#line 3436 "parser_bison.y"
                                                        { (yyval.expr) = (yyvsp[0].expr); }
#line 10876 "parser_bison.c"
    break;

  case 529: /* prefix_stmt_expr: basic_stmt_expr "/" "number"  */
#line 3440 "parser_bison.y"
                        {
				(yyval.expr) = prefix_expr_alloc(&(yyloc), (yyvsp[-2].expr), (yyvsp[0].val));
			}
#line 10884 "parser_bison.c"
    break;

  case 530: /* range_stmt_expr: basic_stmt_expr "-" basic_stmt_expr  */
#line 3446 "parser_bison.y"
                        {
				(yyval.expr) = range_expr_alloc(&(yyloc), (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 10892 "parser_bison.c"
    break;

  case 531: /* wildcard_expr: "*"  */
#line 3452 "parser_bison.y"
                        {
				struct expr *expr;

				expr = constant_expr_alloc(&(yyloc), &integer_type,
							   BYTEORDER_HOST_ENDIAN,
							   0, NULL);
				(yyval.expr) = prefix_expr_alloc(&(yyloc), expr, 0);
			}
#line 10905 "parser_bison.c"
    break;

  case 538: /* nat_stmt_args: stmt_expr  */
#line 3473 "parser_bison.y"
                        {
				(yyvsp[-1].stmt)->nat.addr = (yyvsp[0].expr);
			}
#line 10913 "parser_bison.c"
    break;

  case 539: /* nat_stmt_args: "to" stmt_expr  */
#line 3477 "parser_bison.y"
                        {
				(yyvsp[-2].stmt)->nat.addr = (yyvsp[0].expr);
			}
#line 10921 "parser_bison.c"
    break;

  case 540: /* nat_stmt_args: nf_key_proto "to" stmt_expr  */
#line 3481 "parser_bison.y"
                        {
				(yyvsp[-3].stmt)->nat.family = (yyvsp[-2].val);
				(yyvsp[-3].stmt)->nat.addr = (yyvsp[0].expr);
			}
#line 10930 "parser_bison.c"
    break;

  case 541: /* nat_stmt_args: stmt_expr "colon" stmt_expr  */
#line 3486 "parser_bison.y"
                        {
				(yyvsp[-3].stmt)->nat.addr = (yyvsp[-2].expr);
				(yyvsp[-3].stmt)->nat.proto = (yyvsp[0].expr);
			}
#line 10939 "parser_bison.c"
    break;

  case 542: /* nat_stmt_args: "to" stmt_expr "colon" stmt_expr  */
#line 3491 "parser_bison.y"
                        {
				(yyvsp[-4].stmt)->nat.addr = (yyvsp[-2].expr);
				(yyvsp[-4].stmt)->nat.proto = (yyvsp[0].expr);
			}
#line 10948 "parser_bison.c"
    break;

  case 543: /* nat_stmt_args: nf_key_proto "to" stmt_expr "colon" stmt_expr  */
#line 3496 "parser_bison.y"
                        {
				(yyvsp[-5].stmt)->nat.family = (yyvsp[-4].val);
				(yyvsp[-5].stmt)->nat.addr = (yyvsp[-2].expr);
				(yyvsp[-5].stmt)->nat.proto = (yyvsp[0].expr);
			}
#line 10958 "parser_bison.c"
    break;

  case 544: /* nat_stmt_args: "colon" stmt_expr  */
#line 3502 "parser_bison.y"
                        {
				(yyvsp[-2].stmt)->nat.proto = (yyvsp[0].expr);
			}
#line 10966 "parser_bison.c"
    break;

  case 545: /* nat_stmt_args: "to" "colon" stmt_expr  */
#line 3506 "parser_bison.y"
                        {
				(yyvsp[-3].stmt)->nat.proto = (yyvsp[0].expr);
			}
#line 10974 "parser_bison.c"
    break;

  case 546: /* nat_stmt_args: nat_stmt_args nf_nat_flags  */
#line 3510 "parser_bison.y"
                        {
				(yyvsp[-2].stmt)->nat.flags = (yyvsp[0].val);
			}
#line 10982 "parser_bison.c"
    break;

  case 547: /* nat_stmt_args: nf_key_proto "addr" "." "port" "to" stmt_expr  */
#line 3514 "parser_bison.y"
                        {
				(yyvsp[-6].stmt)->nat.family = (yyvsp[-5].val);
				(yyvsp[-6].stmt)->nat.addr = (yyvsp[0].expr);
				(yyvsp[-6].stmt)->nat.type_flags = STMT_NAT_F_CONCAT;
			}
#line 10992 "parser_bison.c"
    break;

  case 548: /* nat_stmt_args: nf_key_proto "interval" "to" stmt_expr  */
#line 3520 "parser_bison.y"
                        {
				(yyvsp[-4].stmt)->nat.family = (yyvsp[-3].val);
				(yyvsp[-4].stmt)->nat.addr = (yyvsp[0].expr);
				(yyvsp[-4].stmt)->nat.type_flags = STMT_NAT_F_INTERVAL;
			}
#line 11002 "parser_bison.c"
    break;

  case 549: /* nat_stmt_args: "interval" "to" stmt_expr  */
#line 3526 "parser_bison.y"
                        {
				(yyvsp[-3].stmt)->nat.addr = (yyvsp[0].expr);
				(yyvsp[-3].stmt)->nat.type_flags = STMT_NAT_F_INTERVAL;
			}
#line 11011 "parser_bison.c"
    break;

  case 550: /* nat_stmt_args: nf_key_proto "prefix" "to" stmt_expr  */
#line 3531 "parser_bison.y"
                        {
				(yyvsp[-4].stmt)->nat.family = (yyvsp[-3].val);
				(yyvsp[-4].stmt)->nat.addr = (yyvsp[0].expr);
				(yyvsp[-4].stmt)->nat.type_flags =
						STMT_NAT_F_PREFIX |
						STMT_NAT_F_INTERVAL;
				(yyvsp[-4].stmt)->nat.flags |= NF_NAT_RANGE_NETMAP;
			}
#line 11024 "parser_bison.c"
    break;

  case 551: /* nat_stmt_args: "prefix" "to" stmt_expr  */
#line 3540 "parser_bison.y"
                        {
				(yyvsp[-3].stmt)->nat.addr = (yyvsp[0].expr);
				(yyvsp[-3].stmt)->nat.type_flags =
						STMT_NAT_F_PREFIX |
						STMT_NAT_F_INTERVAL;
				(yyvsp[-3].stmt)->nat.flags |= NF_NAT_RANGE_NETMAP;
			}
#line 11036 "parser_bison.c"
    break;

  case 554: /* masq_stmt_alloc: "masquerade"  */
#line 3553 "parser_bison.y"
                                                { (yyval.stmt) = nat_stmt_alloc(&(yyloc), NFT_NAT_MASQ); }
#line 11042 "parser_bison.c"
    break;

  case 555: /* masq_stmt_args: "to" "colon" stmt_expr  */
#line 3557 "parser_bison.y"
                        {
				(yyvsp[-3].stmt)->nat.proto = (yyvsp[0].expr);
			}
#line 11050 "parser_bison.c"
    break;

  case 556: /* masq_stmt_args: "to" "colon" stmt_expr nf_nat_flags  */
#line 3561 "parser_bison.y"
                        {
				(yyvsp[-4].stmt)->nat.proto = (yyvsp[-1].expr);
				(yyvsp[-4].stmt)->nat.flags = (yyvsp[0].val);
			}
#line 11059 "parser_bison.c"
    break;

  case 557: /* masq_stmt_args: nf_nat_flags  */
#line 3566 "parser_bison.y"
                        {
				(yyvsp[-1].stmt)->nat.flags = (yyvsp[0].val);
			}
#line 11067 "parser_bison.c"
    break;

  case 560: /* redir_stmt_alloc: "redirect"  */
#line 3575 "parser_bison.y"
                                                { (yyval.stmt) = nat_stmt_alloc(&(yyloc), NFT_NAT_REDIR); }
#line 11073 "parser_bison.c"
    break;

  case 561: /* redir_stmt_arg: "to" stmt_expr  */
#line 3579 "parser_bison.y"
                        {
				(yyvsp[-2].stmt)->nat.proto = (yyvsp[0].expr);
			}
#line 11081 "parser_bison.c"
    break;

  case 562: /* redir_stmt_arg: "to" "colon" stmt_expr  */
#line 3583 "parser_bison.y"
                        {
				(yyvsp[-3].stmt)->nat.proto = (yyvsp[0].expr);
			}
#line 11089 "parser_bison.c"
    break;

  case 563: /* redir_stmt_arg: nf_nat_flags  */
#line 3587 "parser_bison.y"
                        {
				(yyvsp[-1].stmt)->nat.flags = (yyvsp[0].val);
			}
#line 11097 "parser_bison.c"
    break;

  case 564: /* redir_stmt_arg: "to" stmt_expr nf_nat_flags  */
#line 3591 "parser_bison.y"
                        {
				(yyvsp[-3].stmt)->nat.proto = (yyvsp[-1].expr);
				(yyvsp[-3].stmt)->nat.flags = (yyvsp[0].val);
			}
#line 11106 "parser_bison.c"
    break;

  case 565: /* redir_stmt_arg: "to" "colon" stmt_expr nf_nat_flags  */
#line 3596 "parser_bison.y"
                        {
				(yyvsp[-4].stmt)->nat.proto = (yyvsp[-1].expr);
				(yyvsp[-4].stmt)->nat.flags = (yyvsp[0].val);
			}
#line 11115 "parser_bison.c"
    break;

  case 566: /* dup_stmt: "dup" "to" stmt_expr  */
#line 3603 "parser_bison.y"
                        {
				(yyval.stmt) = dup_stmt_alloc(&(yyloc));
				(yyval.stmt)->dup.to = (yyvsp[0].expr);
			}
#line 11124 "parser_bison.c"
    break;

  case 567: /* dup_stmt: "dup" "to" stmt_expr "device" stmt_expr  */
#line 3608 "parser_bison.y"
                        {
				(yyval.stmt) = dup_stmt_alloc(&(yyloc));
				(yyval.stmt)->dup.to = (yyvsp[-2].expr);
				(yyval.stmt)->dup.dev = (yyvsp[0].expr);
			}
#line 11134 "parser_bison.c"
    break;

  case 568: /* fwd_stmt: "fwd" "to" stmt_expr  */
#line 3616 "parser_bison.y"
                        {
				(yyval.stmt) = fwd_stmt_alloc(&(yyloc));
				(yyval.stmt)->fwd.dev = (yyvsp[0].expr);
			}
#line 11143 "parser_bison.c"
    break;

  case 569: /* fwd_stmt: "fwd" nf_key_proto "to" stmt_expr "device" stmt_expr  */
#line 3621 "parser_bison.y"
                        {
				(yyval.stmt) = fwd_stmt_alloc(&(yyloc));
				(yyval.stmt)->fwd.family = (yyvsp[-4].val);
				(yyval.stmt)->fwd.addr = (yyvsp[-2].expr);
				(yyval.stmt)->fwd.dev = (yyvsp[0].expr);
			}
#line 11154 "parser_bison.c"
    break;

  case 571: /* nf_nat_flags: nf_nat_flags "comma" nf_nat_flag  */
#line 3631 "parser_bison.y"
                        {
				(yyval.val) = (yyvsp[-2].val) | (yyvsp[0].val);
			}
#line 11162 "parser_bison.c"
    break;

  case 572: /* nf_nat_flag: "random"  */
#line 3636 "parser_bison.y"
                                                { (yyval.val) = NF_NAT_RANGE_PROTO_RANDOM; }
#line 11168 "parser_bison.c"
    break;

  case 573: /* nf_nat_flag: "fully-random"  */
#line 3637 "parser_bison.y"
                                                { (yyval.val) = NF_NAT_RANGE_PROTO_RANDOM_FULLY; }
#line 11174 "parser_bison.c"
    break;

  case 574: /* nf_nat_flag: "persistent"  */
#line 3638 "parser_bison.y"
                                                { (yyval.val) = NF_NAT_RANGE_PERSISTENT; }
#line 11180 "parser_bison.c"
    break;

  case 577: /* queue_stmt_alloc: "queue"  */
#line 3646 "parser_bison.y"
                        {
				(yyval.stmt) = queue_stmt_alloc(&(yyloc));
			}
#line 11188 "parser_bison.c"
    break;

  case 578: /* queue_stmt_args: queue_stmt_arg  */
#line 3652 "parser_bison.y"
                        {
				(yyval.stmt)	= (yyvsp[-1].stmt);
			}
#line 11196 "parser_bison.c"
    break;

  case 580: /* queue_stmt_arg: "num" stmt_expr  */
#line 3659 "parser_bison.y"
                        {
				(yyvsp[-2].stmt)->queue.queue = (yyvsp[0].expr);
				(yyvsp[-2].stmt)->queue.queue->location = (yyloc);
			}
#line 11205 "parser_bison.c"
    break;

  case 581: /* queue_stmt_arg: queue_stmt_flags  */
#line 3664 "parser_bison.y"
                        {
				(yyvsp[-1].stmt)->queue.flags |= (yyvsp[0].val);
			}
#line 11213 "parser_bison.c"
    break;

  case 583: /* queue_stmt_flags: queue_stmt_flags "comma" queue_stmt_flag  */
#line 3671 "parser_bison.y"
                        {
				(yyval.val) = (yyvsp[-2].val) | (yyvsp[0].val);
			}
#line 11221 "parser_bison.c"
    break;

  case 584: /* queue_stmt_flag: "bypass"  */
#line 3676 "parser_bison.y"
                                        { (yyval.val) = NFT_QUEUE_FLAG_BYPASS; }
#line 11227 "parser_bison.c"
    break;

  case 585: /* queue_stmt_flag: "fanout"  */
#line 3677 "parser_bison.y"
                                        { (yyval.val) = NFT_QUEUE_FLAG_CPU_FANOUT; }
#line 11233 "parser_bison.c"
    break;

  case 588: /* set_elem_expr_stmt_alloc: concat_expr  */
#line 3685 "parser_bison.y"
                        {
				(yyval.expr) = set_elem_expr_alloc(&(yylsp[0]), (yyvsp[0].expr));
			}
#line 11241 "parser_bison.c"
    break;

  case 589: /* set_stmt: "set" set_stmt_op set_elem_expr_stmt set_ref_expr  */
#line 3691 "parser_bison.y"
                        {
				(yyval.stmt) = set_stmt_alloc(&(yyloc));
				(yyval.stmt)->set.op  = (yyvsp[-2].val);
				(yyval.stmt)->set.key = (yyvsp[-1].expr);
				(yyval.stmt)->set.set = (yyvsp[0].expr);
			}
#line 11252 "parser_bison.c"
    break;

  case 590: /* set_stmt: set_stmt_op set_ref_expr '{' set_elem_expr_stmt '}'  */
#line 3698 "parser_bison.y"
                        {
				(yyval.stmt) = set_stmt_alloc(&(yyloc));
				(yyval.stmt)->set.op  = (yyvsp[-4].val);
				(yyval.stmt)->set.key = (yyvsp[-1].expr);
				(yyval.stmt)->set.set = (yyvsp[-3].expr);
			}
#line 11263 "parser_bison.c"
    break;

  case 591: /* set_stmt: set_stmt_op set_ref_expr '{' set_elem_expr_stmt stateful_stmt_list '}'  */
#line 3705 "parser_bison.y"
                        {
				(yyval.stmt) = set_stmt_alloc(&(yyloc));
				(yyval.stmt)->set.op  = (yyvsp[-5].val);
				(yyval.stmt)->set.key = (yyvsp[-2].expr);
				(yyval.stmt)->set.set = (yyvsp[-4].expr);
				list_splice_tail((yyvsp[-1].list), &(yyval.stmt)->set.stmt_list);
				free((yyvsp[-1].list));
			}
#line 11276 "parser_bison.c"
    break;

  case 592: /* set_stmt_op: "add"  */
#line 3715 "parser_bison.y"
                                        { (yyval.val) = NFT_DYNSET_OP_ADD; }
#line 11282 "parser_bison.c"
    break;

  case 593: /* set_stmt_op: "update"  */
#line 3716 "parser_bison.y"
                                        { (yyval.val) = NFT_DYNSET_OP_UPDATE; }
#line 11288 "parser_bison.c"
    break;

  case 594: /* set_stmt_op: "delete"  */
#line 3717 "parser_bison.y"
                                        { (yyval.val) = NFT_DYNSET_OP_DELETE; }
#line 11294 "parser_bison.c"
    break;

  case 595: /* map_stmt: set_stmt_op set_ref_expr '{' set_elem_expr_stmt "colon" set_elem_expr_stmt '}'  */
#line 3721 "parser_bison.y"
                        {
				(yyval.stmt) = map_stmt_alloc(&(yyloc));
				(yyval.stmt)->map.op  = (yyvsp[-6].val);
				(yyval.stmt)->map.key = (yyvsp[-3].expr);
				(yyval.stmt)->map.data = (yyvsp[-1].expr);
				(yyval.stmt)->map.set = (yyvsp[-5].expr);
			}
#line 11306 "parser_bison.c"
    break;

  case 596: /* map_stmt: set_stmt_op set_ref_expr '{' set_elem_expr_stmt stateful_stmt_list "colon" set_elem_expr_stmt '}'  */
#line 3729 "parser_bison.y"
                        {
				(yyval.stmt) = map_stmt_alloc(&(yyloc));
				(yyval.stmt)->map.op  = (yyvsp[-7].val);
				(yyval.stmt)->map.key = (yyvsp[-4].expr);
				(yyval.stmt)->map.data = (yyvsp[-1].expr);
				(yyval.stmt)->map.set = (yyvsp[-6].expr);
				list_splice_tail((yyvsp[-3].list), &(yyval.stmt)->map.stmt_list);
				free((yyvsp[-3].list));
			}
#line 11320 "parser_bison.c"
    break;

  case 597: /* meter_stmt: flow_stmt_legacy_alloc flow_stmt_opts '{' meter_key_expr stmt '}'  */
#line 3741 "parser_bison.y"
                        {
				(yyvsp[-5].stmt)->meter.key  = (yyvsp[-2].expr);
				(yyvsp[-5].stmt)->meter.stmt = (yyvsp[-1].stmt);
				(yyval.stmt)->location  = (yyloc);
				(yyval.stmt) = (yyvsp[-5].stmt);
			}
#line 11331 "parser_bison.c"
    break;

  case 598: /* meter_stmt: meter_stmt_alloc  */
#line 3747 "parser_bison.y"
                                                                { (yyval.stmt) = (yyvsp[0].stmt); }
#line 11337 "parser_bison.c"
    break;

  case 599: /* flow_stmt_legacy_alloc: "flow"  */
#line 3751 "parser_bison.y"
                        {
				(yyval.stmt) = meter_stmt_alloc(&(yyloc));
			}
#line 11345 "parser_bison.c"
    break;

  case 600: /* flow_stmt_opts: flow_stmt_opt  */
#line 3757 "parser_bison.y"
                        {
				(yyval.stmt)	= (yyvsp[-1].stmt);
			}
#line 11353 "parser_bison.c"
    break;

  case 602: /* flow_stmt_opt: "table" identifier  */
#line 3764 "parser_bison.y"
                        {
				(yyvsp[-2].stmt)->meter.name = (yyvsp[0].string);
			}
#line 11361 "parser_bison.c"
    break;

  case 603: /* meter_stmt_alloc: "meter" identifier '{' meter_key_expr stmt '}'  */
#line 3770 "parser_bison.y"
                        {
				(yyval.stmt) = meter_stmt_alloc(&(yyloc));
				(yyval.stmt)->meter.name = (yyvsp[-4].string);
				(yyval.stmt)->meter.size = 0;
				(yyval.stmt)->meter.key  = (yyvsp[-2].expr);
				(yyval.stmt)->meter.stmt = (yyvsp[-1].stmt);
				(yyval.stmt)->location  = (yyloc);
			}
#line 11374 "parser_bison.c"
    break;

  case 604: /* meter_stmt_alloc: "meter" identifier "size" "number" '{' meter_key_expr stmt '}'  */
#line 3779 "parser_bison.y"
                        {
				(yyval.stmt) = meter_stmt_alloc(&(yyloc));
				(yyval.stmt)->meter.name = (yyvsp[-6].string);
				(yyval.stmt)->meter.size = (yyvsp[-4].val);
				(yyval.stmt)->meter.key  = (yyvsp[-2].expr);
				(yyval.stmt)->meter.stmt = (yyvsp[-1].stmt);
				(yyval.stmt)->location  = (yyloc);
			}
#line 11387 "parser_bison.c"
    break;

  case 605: /* match_stmt: relational_expr  */
#line 3790 "parser_bison.y"
                        {
				(yyval.stmt) = expr_stmt_alloc(&(yyloc), (yyvsp[0].expr));
			}
#line 11395 "parser_bison.c"
    break;

  case 606: /* variable_expr: '$' identifier  */
#line 3796 "parser_bison.y"
                        {
				struct scope *scope = current_scope(state);
				struct symbol *sym;

				sym = symbol_get(scope, (yyvsp[0].string));
				if (!sym) {
					sym = symbol_lookup_fuzzy(scope, (yyvsp[0].string));
					if (sym) {
						erec_queue(error(&(yylsp[0]), "unknown identifier '%s'; "
								      "did you mean identifier ‘%s’?",
								      (yyvsp[0].string), sym->identifier),
							   state->msgs);
					} else {
						erec_queue(error(&(yylsp[0]), "unknown identifier '%s'", (yyvsp[0].string)),
							   state->msgs);
					}
					xfree((yyvsp[0].string));
					YYERROR;
				}

				(yyval.expr) = variable_expr_alloc(&(yyloc), scope, sym);
				xfree((yyvsp[0].string));
			}
#line 11423 "parser_bison.c"
    break;

  case 608: /* symbol_expr: string  */
#line 3823 "parser_bison.y"
                        {
				(yyval.expr) = symbol_expr_alloc(&(yyloc), SYMBOL_VALUE,
						       current_scope(state),
						       (yyvsp[0].string));
				xfree((yyvsp[0].string));
			}
#line 11434 "parser_bison.c"
    break;

  case 611: /* set_ref_symbol_expr: "@" identifier  */
#line 3836 "parser_bison.y"
                        {
				(yyval.expr) = symbol_expr_alloc(&(yyloc), SYMBOL_SET,
						       current_scope(state),
						       (yyvsp[0].string));
				xfree((yyvsp[0].string));
			}
#line 11445 "parser_bison.c"
    break;

  case 612: /* integer_expr: "number"  */
#line 3845 "parser_bison.y"
                        {
				char str[64];

				snprintf(str, sizeof(str), "%" PRIu64, (yyvsp[0].val));
				(yyval.expr) = symbol_expr_alloc(&(yyloc), SYMBOL_VALUE,
						       current_scope(state),
						       str);
			}
#line 11458 "parser_bison.c"
    break;

  case 613: /* primary_expr: symbol_expr  */
#line 3855 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 11464 "parser_bison.c"
    break;

  case 614: /* primary_expr: integer_expr  */
#line 3856 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 11470 "parser_bison.c"
    break;

  case 615: /* primary_expr: payload_expr  */
#line 3857 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 11476 "parser_bison.c"
    break;

  case 616: /* primary_expr: exthdr_expr  */
#line 3858 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 11482 "parser_bison.c"
    break;

  case 617: /* primary_expr: exthdr_exists_expr  */
#line 3859 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 11488 "parser_bison.c"
    break;

  case 618: /* primary_expr: meta_expr  */
#line 3860 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 11494 "parser_bison.c"
    break;

  case 619: /* primary_expr: socket_expr  */
#line 3861 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 11500 "parser_bison.c"
    break;

  case 620: /* primary_expr: rt_expr  */
#line 3862 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 11506 "parser_bison.c"
    break;

  case 621: /* primary_expr: ct_expr  */
#line 3863 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 11512 "parser_bison.c"
    break;

  case 622: /* primary_expr: numgen_expr  */
#line 3864 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 11518 "parser_bison.c"
    break;

  case 623: /* primary_expr: hash_expr  */
#line 3865 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 11524 "parser_bison.c"
    break;

  case 624: /* primary_expr: fib_expr  */
#line 3866 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 11530 "parser_bison.c"
    break;

  case 625: /* primary_expr: osf_expr  */
#line 3867 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 11536 "parser_bison.c"
    break;

  case 626: /* primary_expr: xfrm_expr  */
#line 3868 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[0].expr); }
#line 11542 "parser_bison.c"
    break;

  case 627: /* primary_expr: '(' basic_expr ')'  */
#line 3869 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[-1].expr); }
#line 11548 "parser_bison.c"
    break;

  case 628: /* fib_expr: "fib" fib_tuple fib_result  */
#line 3873 "parser_bison.y"
                        {
				if (((yyvsp[-1].val) & (NFTA_FIB_F_SADDR|NFTA_FIB_F_DADDR)) == 0) {
					erec_queue(error(&(yylsp[-1]), "fib: need either saddr or daddr"), state->msgs);
					YYERROR;
				}

				if (((yyvsp[-1].val) & (NFTA_FIB_F_SADDR|NFTA_FIB_F_DADDR)) ==
					  (NFTA_FIB_F_SADDR|NFTA_FIB_F_DADDR)) {
					erec_queue(error(&(yylsp[-1]), "fib: saddr and daddr are mutually exclusive"), state->msgs);
					YYERROR;
				}

				if (((yyvsp[-1].val) & (NFTA_FIB_F_IIF|NFTA_FIB_F_OIF)) ==
					  (NFTA_FIB_F_IIF|NFTA_FIB_F_OIF)) {
					erec_queue(error(&(yylsp[-1]), "fib: iif and oif are mutually exclusive"), state->msgs);
					YYERROR;
				}

				(yyval.expr) = fib_expr_alloc(&(yyloc), (yyvsp[-1].val), (yyvsp[0].val));
			}
#line 11573 "parser_bison.c"
    break;

  case 629: /* fib_result: "oif"  */
#line 3895 "parser_bison.y"
                                        { (yyval.val) =NFT_FIB_RESULT_OIF; }
#line 11579 "parser_bison.c"
    break;

  case 630: /* fib_result: "oifname"  */
#line 3896 "parser_bison.y"
                                        { (yyval.val) =NFT_FIB_RESULT_OIFNAME; }
#line 11585 "parser_bison.c"
    break;

  case 631: /* fib_result: "type"  */
#line 3897 "parser_bison.y"
                                        { (yyval.val) =NFT_FIB_RESULT_ADDRTYPE; }
#line 11591 "parser_bison.c"
    break;

  case 632: /* fib_flag: "saddr"  */
#line 3900 "parser_bison.y"
                                        { (yyval.val) = NFTA_FIB_F_SADDR; }
#line 11597 "parser_bison.c"
    break;

  case 633: /* fib_flag: "daddr"  */
#line 3901 "parser_bison.y"
                                        { (yyval.val) = NFTA_FIB_F_DADDR; }
#line 11603 "parser_bison.c"
    break;

  case 634: /* fib_flag: "mark"  */
#line 3902 "parser_bison.y"
                                        { (yyval.val) = NFTA_FIB_F_MARK; }
#line 11609 "parser_bison.c"
    break;

  case 635: /* fib_flag: "iif"  */
#line 3903 "parser_bison.y"
                                        { (yyval.val) = NFTA_FIB_F_IIF; }
#line 11615 "parser_bison.c"
    break;

  case 636: /* fib_flag: "oif"  */
#line 3904 "parser_bison.y"
                                        { (yyval.val) = NFTA_FIB_F_OIF; }
#line 11621 "parser_bison.c"
    break;

  case 637: /* fib_tuple: fib_flag "." fib_tuple  */
#line 3908 "parser_bison.y"
                        {
				(yyval.val) = (yyvsp[-2].val) | (yyvsp[0].val);
			}
#line 11629 "parser_bison.c"
    break;

  case 639: /* osf_expr: "osf" osf_ttl "version"  */
#line 3915 "parser_bison.y"
                        {
				(yyval.expr) = osf_expr_alloc(&(yyloc), (yyvsp[-1].val), NFT_OSF_F_VERSION);
			}
#line 11637 "parser_bison.c"
    break;

  case 640: /* osf_expr: "osf" osf_ttl "name"  */
#line 3919 "parser_bison.y"
                        {
				(yyval.expr) = osf_expr_alloc(&(yyloc), (yyvsp[-1].val), 0);
			}
#line 11645 "parser_bison.c"
    break;

  case 641: /* osf_ttl: %empty  */
#line 3925 "parser_bison.y"
                        {
				(yyval.val) = NF_OSF_TTL_TRUE;
			}
#line 11653 "parser_bison.c"
    break;

  case 642: /* osf_ttl: "ttl" "string"  */
#line 3929 "parser_bison.y"
                        {
				if (!strcmp((yyvsp[0].string), "loose"))
					(yyval.val) = NF_OSF_TTL_LESS;
				else if (!strcmp((yyvsp[0].string), "skip"))
					(yyval.val) = NF_OSF_TTL_NOCHECK;
				else {
					erec_queue(error(&(yylsp[0]), "invalid ttl option"),
						   state->msgs);
					YYERROR;
				}
			}
#line 11669 "parser_bison.c"
    break;

  case 644: /* shift_expr: shift_expr "<<" primary_rhs_expr  */
#line 3944 "parser_bison.y"
                        {
				(yyval.expr) = binop_expr_alloc(&(yyloc), OP_LSHIFT, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 11677 "parser_bison.c"
    break;

  case 645: /* shift_expr: shift_expr ">>" primary_rhs_expr  */
#line 3948 "parser_bison.y"
                        {
				(yyval.expr) = binop_expr_alloc(&(yyloc), OP_RSHIFT, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 11685 "parser_bison.c"
    break;

  case 647: /* and_expr: and_expr "&" shift_rhs_expr  */
#line 3955 "parser_bison.y"
                        {
				(yyval.expr) = binop_expr_alloc(&(yyloc), OP_AND, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 11693 "parser_bison.c"
    break;

  case 649: /* exclusive_or_expr: exclusive_or_expr "^" and_rhs_expr  */
#line 3962 "parser_bison.y"
                        {
				(yyval.expr) = binop_expr_alloc(&(yyloc), OP_XOR, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 11701 "parser_bison.c"
    break;

  case 651: /* inclusive_or_expr: inclusive_or_expr '|' exclusive_or_rhs_expr  */
#line 3969 "parser_bison.y"
                        {
				(yyval.expr) = binop_expr_alloc(&(yyloc), OP_OR, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 11709 "parser_bison.c"
    break;

  case 654: /* concat_expr: concat_expr "." basic_expr  */
#line 3979 "parser_bison.y"
                        {
				struct location rhs[] = {
					[1]	= (yylsp[-1]),
					[2]	= (yylsp[0]),
				};

				(yyval.expr) = handle_concat_expr(&(yyloc), (yyval.expr), (yyvsp[-2].expr), (yyvsp[0].expr), rhs);
			}
#line 11722 "parser_bison.c"
    break;

  case 655: /* prefix_rhs_expr: basic_rhs_expr "/" "number"  */
#line 3990 "parser_bison.y"
                        {
				(yyval.expr) = prefix_expr_alloc(&(yyloc), (yyvsp[-2].expr), (yyvsp[0].val));
			}
#line 11730 "parser_bison.c"
    break;

  case 656: /* range_rhs_expr: basic_rhs_expr "-" basic_rhs_expr  */
#line 3996 "parser_bison.y"
                        {
				(yyval.expr) = range_expr_alloc(&(yyloc), (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 11738 "parser_bison.c"
    break;

  case 659: /* map_expr: concat_expr "map" rhs_expr  */
#line 4006 "parser_bison.y"
                        {
				(yyval.expr) = map_expr_alloc(&(yyloc), (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 11746 "parser_bison.c"
    break;

  case 663: /* set_expr: '{' set_list_expr '}'  */
#line 4017 "parser_bison.y"
                        {
				(yyvsp[-1].expr)->location = (yyloc);
				(yyval.expr) = (yyvsp[-1].expr);
			}
#line 11755 "parser_bison.c"
    break;

  case 664: /* set_list_expr: set_list_member_expr  */
#line 4024 "parser_bison.y"
                        {
				(yyval.expr) = set_expr_alloc(&(yyloc), NULL);
				compound_expr_add((yyval.expr), (yyvsp[0].expr));
			}
#line 11764 "parser_bison.c"
    break;

  case 665: /* set_list_expr: set_list_expr "comma" set_list_member_expr  */
#line 4029 "parser_bison.y"
                        {
				compound_expr_add((yyvsp[-2].expr), (yyvsp[0].expr));
				(yyval.expr) = (yyvsp[-2].expr);
			}
#line 11773 "parser_bison.c"
    break;

  case 667: /* set_list_member_expr: opt_newline set_expr opt_newline  */
#line 4037 "parser_bison.y"
                        {
				(yyval.expr) = (yyvsp[-1].expr);
			}
#line 11781 "parser_bison.c"
    break;

  case 668: /* set_list_member_expr: opt_newline set_elem_expr opt_newline  */
#line 4041 "parser_bison.y"
                        {
				(yyval.expr) = (yyvsp[-1].expr);
			}
#line 11789 "parser_bison.c"
    break;

  case 669: /* set_list_member_expr: opt_newline set_elem_expr "colon" set_rhs_expr opt_newline  */
#line 4045 "parser_bison.y"
                        {
				(yyval.expr) = mapping_expr_alloc(&(yyloc), (yyvsp[-3].expr), (yyvsp[-1].expr));
			}
#line 11797 "parser_bison.c"
    break;

  case 671: /* meter_key_expr: meter_key_expr_alloc set_elem_options  */
#line 4052 "parser_bison.y"
                        {
				(yyval.expr)->location = (yyloc);
				(yyval.expr) = (yyvsp[-1].expr);
			}
#line 11806 "parser_bison.c"
    break;

  case 672: /* meter_key_expr_alloc: concat_expr  */
#line 4059 "parser_bison.y"
                        {
				(yyval.expr) = set_elem_expr_alloc(&(yylsp[0]), (yyvsp[0].expr));
			}
#line 11814 "parser_bison.c"
    break;

  case 675: /* set_elem_expr_alloc: set_lhs_expr set_elem_stmt_list  */
#line 4069 "parser_bison.y"
                        {
				(yyval.expr) = set_elem_expr_alloc(&(yylsp[-1]), (yyvsp[-1].expr));
				list_splice_tail((yyvsp[0].list), &(yyval.expr)->stmt_list);
				xfree((yyvsp[0].list));
			}
#line 11824 "parser_bison.c"
    break;

  case 676: /* set_elem_expr_alloc: set_lhs_expr  */
#line 4075 "parser_bison.y"
                        {
				(yyval.expr) = set_elem_expr_alloc(&(yylsp[0]), (yyvsp[0].expr));
			}
#line 11832 "parser_bison.c"
    break;

  case 677: /* set_elem_options: set_elem_option  */
#line 4081 "parser_bison.y"
                        {
				(yyval.expr)	= (yyvsp[-1].expr);
			}
#line 11840 "parser_bison.c"
    break;

  case 679: /* set_elem_option: "timeout" time_spec  */
#line 4088 "parser_bison.y"
                        {
				(yyvsp[-2].expr)->timeout = (yyvsp[0].val);
			}
#line 11848 "parser_bison.c"
    break;

  case 680: /* set_elem_option: "expires" time_spec  */
#line 4092 "parser_bison.y"
                        {
				(yyvsp[-2].expr)->expiration = (yyvsp[0].val);
			}
#line 11856 "parser_bison.c"
    break;

  case 681: /* set_elem_option: comment_spec  */
#line 4096 "parser_bison.y"
                        {
				if (already_set((yyvsp[-1].expr)->comment, &(yylsp[0]), state)) {
					xfree((yyvsp[0].string));
					YYERROR;
				}
				(yyvsp[-1].expr)->comment = (yyvsp[0].string);
			}
#line 11868 "parser_bison.c"
    break;

  case 682: /* set_elem_expr_options: set_elem_expr_option  */
#line 4106 "parser_bison.y"
                        {
				(yyval.expr)	= (yyvsp[-1].expr);
			}
#line 11876 "parser_bison.c"
    break;

  case 684: /* set_elem_stmt_list: set_elem_stmt  */
#line 4113 "parser_bison.y"
                        {
				(yyval.list) = xmalloc(sizeof(*(yyval.list)));
				init_list_head((yyval.list));
				list_add_tail(&(yyvsp[0].stmt)->list, (yyval.list));
			}
#line 11886 "parser_bison.c"
    break;

  case 685: /* set_elem_stmt_list: set_elem_stmt_list set_elem_stmt  */
#line 4119 "parser_bison.y"
                        {
				(yyval.list) = (yyvsp[-1].list);
				list_add_tail(&(yyvsp[0].stmt)->list, (yyvsp[-1].list));
			}
#line 11895 "parser_bison.c"
    break;

  case 686: /* set_elem_stmt: "counter"  */
#line 4126 "parser_bison.y"
                        {
				(yyval.stmt) = counter_stmt_alloc(&(yyloc));
			}
#line 11903 "parser_bison.c"
    break;

  case 687: /* set_elem_stmt: "counter" "packets" "number" "bytes" "number"  */
#line 4130 "parser_bison.y"
                        {
				(yyval.stmt) = counter_stmt_alloc(&(yyloc));
				(yyval.stmt)->counter.packets = (yyvsp[-2].val);
				(yyval.stmt)->counter.bytes = (yyvsp[0].val);
			}
#line 11913 "parser_bison.c"
    break;

  case 688: /* set_elem_stmt: "limit" "rate" limit_mode "number" "/" time_unit limit_burst_pkts  */
#line 4136 "parser_bison.y"
                        {
				if ((yyvsp[0].val) == 0) {
					erec_queue(error(&(yylsp[0]), "limit burst must be > 0"),
						   state->msgs);
					YYERROR;
				}
				(yyval.stmt) = limit_stmt_alloc(&(yyloc));
				(yyval.stmt)->limit.rate  = (yyvsp[-3].val);
				(yyval.stmt)->limit.unit  = (yyvsp[-1].val);
				(yyval.stmt)->limit.burst = (yyvsp[0].val);
				(yyval.stmt)->limit.type  = NFT_LIMIT_PKTS;
				(yyval.stmt)->limit.flags = (yyvsp[-4].val);
			}
#line 11931 "parser_bison.c"
    break;

  case 689: /* set_elem_stmt: "limit" "rate" limit_mode "number" "string" limit_burst_bytes  */
#line 4150 "parser_bison.y"
                        {
				struct error_record *erec;
				uint64_t rate, unit;

				if ((yyvsp[0].val) == 0) {
					erec_queue(error(&(yylsp[0]), "limit burst must be > 0"),
						   state->msgs);
					YYERROR;
				}
				erec = rate_parse(&(yyloc), (yyvsp[-1].string), &rate, &unit);
				xfree((yyvsp[-1].string));
				if (erec != NULL) {
					erec_queue(erec, state->msgs);
					YYERROR;
				}

				(yyval.stmt) = limit_stmt_alloc(&(yyloc));
				(yyval.stmt)->limit.rate  = rate * (yyvsp[-2].val);
				(yyval.stmt)->limit.unit  = unit;
				(yyval.stmt)->limit.burst = (yyvsp[0].val);
				(yyval.stmt)->limit.type  = NFT_LIMIT_PKT_BYTES;
				(yyval.stmt)->limit.flags = (yyvsp[-3].val);
                        }
#line 11959 "parser_bison.c"
    break;

  case 690: /* set_elem_expr_option: "timeout" time_spec  */
#line 4176 "parser_bison.y"
                        {
				(yyvsp[-2].expr)->timeout = (yyvsp[0].val);
			}
#line 11967 "parser_bison.c"
    break;

  case 691: /* set_elem_expr_option: "expires" time_spec  */
#line 4180 "parser_bison.y"
                        {
				(yyvsp[-2].expr)->expiration = (yyvsp[0].val);
			}
#line 11975 "parser_bison.c"
    break;

  case 692: /* set_elem_expr_option: comment_spec  */
#line 4184 "parser_bison.y"
                        {
				if (already_set((yyvsp[-1].expr)->comment, &(yylsp[0]), state)) {
					xfree((yyvsp[0].string));
					YYERROR;
				}
				(yyvsp[-1].expr)->comment = (yyvsp[0].string);
			}
#line 11987 "parser_bison.c"
    break;

  case 699: /* initializer_expr: '{' '}'  */
#line 4203 "parser_bison.y"
                                                { (yyval.expr) = compound_expr_alloc(&(yyloc), EXPR_SET); }
#line 11993 "parser_bison.c"
    break;

  case 700: /* initializer_expr: "-" "number"  */
#line 4205 "parser_bison.y"
                        {
				int32_t num = -(yyvsp[0].val);

				(yyval.expr) = constant_expr_alloc(&(yyloc), &integer_type,
							 BYTEORDER_HOST_ENDIAN,
							 sizeof(num) * BITS_PER_BYTE,
							 &num);
			}
#line 12006 "parser_bison.c"
    break;

  case 701: /* counter_config: "packets" "number" "bytes" "number"  */
#line 4216 "parser_bison.y"
                        {
				struct counter *counter;

				counter = &(yyvsp[-4].obj)->counter;
				counter->packets = (yyvsp[-2].val);
				counter->bytes = (yyvsp[0].val);
			}
#line 12018 "parser_bison.c"
    break;

  case 702: /* counter_obj: %empty  */
#line 4226 "parser_bison.y"
                        {
				(yyval.obj) = obj_alloc(&(yyloc));
				(yyval.obj)->type = NFT_OBJECT_COUNTER;
			}
#line 12027 "parser_bison.c"
    break;

  case 703: /* quota_config: quota_mode "number" quota_unit quota_used  */
#line 4233 "parser_bison.y"
                        {
				struct error_record *erec;
				struct quota *quota;
				uint64_t rate;

				erec = data_unit_parse(&(yyloc), (yyvsp[-1].string), &rate);
				xfree((yyvsp[-1].string));
				if (erec != NULL) {
					erec_queue(erec, state->msgs);
					YYERROR;
				}

				quota = &(yyvsp[-4].obj)->quota;
				quota->bytes	= (yyvsp[-2].val) * rate;
				quota->used	= (yyvsp[0].val);
				quota->flags	= (yyvsp[-3].val);
			}
#line 12049 "parser_bison.c"
    break;

  case 704: /* quota_obj: %empty  */
#line 4253 "parser_bison.y"
                        {
				(yyval.obj) = obj_alloc(&(yyloc));
				(yyval.obj)->type = NFT_OBJECT_QUOTA;
			}
#line 12058 "parser_bison.c"
    break;

  case 705: /* secmark_config: string  */
#line 4260 "parser_bison.y"
                        {
				int ret;
				struct secmark *secmark;

				secmark = &(yyvsp[-1].obj)->secmark;
				ret = snprintf(secmark->ctx, sizeof(secmark->ctx), "%s", (yyvsp[0].string));
				if (ret <= 0 || ret >= (int)sizeof(secmark->ctx)) {
					erec_queue(error(&(yylsp[0]), "invalid context '%s', max length is %u\n", (yyvsp[0].string), (int)sizeof(secmark->ctx)), state->msgs);
					xfree((yyvsp[0].string));
					YYERROR;
				}
				xfree((yyvsp[0].string));
			}
#line 12076 "parser_bison.c"
    break;

  case 706: /* secmark_obj: %empty  */
#line 4276 "parser_bison.y"
                        {
				(yyval.obj) = obj_alloc(&(yyloc));
				(yyval.obj)->type = NFT_OBJECT_SECMARK;
			}
#line 12085 "parser_bison.c"
    break;

  case 707: /* ct_obj_type: "helper"  */
#line 4282 "parser_bison.y"
                                                { (yyval.val) = NFT_OBJECT_CT_HELPER; }
#line 12091 "parser_bison.c"
    break;

  case 708: /* ct_obj_type: "timeout"  */
#line 4283 "parser_bison.y"
                                                { (yyval.val) = NFT_OBJECT_CT_TIMEOUT; }
#line 12097 "parser_bison.c"
    break;

  case 709: /* ct_obj_type: "expectation"  */
#line 4284 "parser_bison.y"
                                                { (yyval.val) = NFT_OBJECT_CT_EXPECT; }
#line 12103 "parser_bison.c"
    break;

  case 710: /* ct_l4protoname: "tcp"  */
#line 4287 "parser_bison.y"
                                        { (yyval.val) = IPPROTO_TCP; }
#line 12109 "parser_bison.c"
    break;

  case 711: /* ct_l4protoname: "udp"  */
#line 4288 "parser_bison.y"
                                        { (yyval.val) = IPPROTO_UDP; }
#line 12115 "parser_bison.c"
    break;

  case 712: /* ct_helper_config: "type" "quoted string" "protocol" ct_l4protoname stmt_separator  */
#line 4292 "parser_bison.y"
                        {
				struct ct_helper *ct;
				int ret;

				ct = &(yyvsp[-5].obj)->ct_helper;

				ret = snprintf(ct->name, sizeof(ct->name), "%s", (yyvsp[-3].string));
				if (ret <= 0 || ret >= (int)sizeof(ct->name)) {
					erec_queue(error(&(yylsp[-3]), "invalid name '%s', max length is %u\n", (yyvsp[-3].string), (int)sizeof(ct->name)), state->msgs);
					YYERROR;
				}
				xfree((yyvsp[-3].string));

				ct->l4proto = (yyvsp[-1].val);
			}
#line 12135 "parser_bison.c"
    break;

  case 713: /* ct_helper_config: "l3proto" family_spec_explicit stmt_separator  */
#line 4308 "parser_bison.y"
                        {
				(yyvsp[-3].obj)->ct_helper.l3proto = (yyvsp[-1].val);
			}
#line 12143 "parser_bison.c"
    break;

  case 714: /* timeout_states: timeout_state  */
#line 4314 "parser_bison.y"
                        {
				(yyval.list) = xmalloc(sizeof(*(yyval.list)));
				init_list_head((yyval.list));
				list_add_tail((yyvsp[0].list), (yyval.list));
			}
#line 12153 "parser_bison.c"
    break;

  case 715: /* timeout_states: timeout_states "comma" timeout_state  */
#line 4320 "parser_bison.y"
                        {
				list_add_tail((yyvsp[0].list), (yyvsp[-2].list));
				(yyval.list) = (yyvsp[-2].list);
			}
#line 12162 "parser_bison.c"
    break;

  case 716: /* timeout_state: "string" "colon" "number"  */
#line 4328 "parser_bison.y"
                        {
				struct timeout_state *ts;

				ts = xzalloc(sizeof(*ts));
				ts->timeout_str = (yyvsp[-2].string);
				ts->timeout_value = (yyvsp[0].val);
				ts->location = (yylsp[-2]);
				init_list_head(&ts->head);
				(yyval.list) = &ts->head;
			}
#line 12177 "parser_bison.c"
    break;

  case 717: /* ct_timeout_config: "protocol" ct_l4protoname stmt_separator  */
#line 4341 "parser_bison.y"
                        {
				struct ct_timeout *ct;
				int l4proto = (yyvsp[-1].val);

				ct = &(yyvsp[-3].obj)->ct_timeout;
				ct->l4proto = l4proto;
			}
#line 12189 "parser_bison.c"
    break;

  case 718: /* ct_timeout_config: "policy" '=' '{' timeout_states '}' stmt_separator  */
#line 4349 "parser_bison.y"
                        {
				struct ct_timeout *ct;

				ct = &(yyvsp[-6].obj)->ct_timeout;
				list_splice_tail((yyvsp[-2].list), &ct->timeout_list);
				xfree((yyvsp[-2].list));
			}
#line 12201 "parser_bison.c"
    break;

  case 719: /* ct_timeout_config: "l3proto" family_spec_explicit stmt_separator  */
#line 4357 "parser_bison.y"
                        {
				(yyvsp[-3].obj)->ct_timeout.l3proto = (yyvsp[-1].val);
			}
#line 12209 "parser_bison.c"
    break;

  case 720: /* ct_expect_config: "protocol" ct_l4protoname stmt_separator  */
#line 4363 "parser_bison.y"
                        {
				(yyvsp[-3].obj)->ct_expect.l4proto = (yyvsp[-1].val);
			}
#line 12217 "parser_bison.c"
    break;

  case 721: /* ct_expect_config: "dport" "number" stmt_separator  */
#line 4367 "parser_bison.y"
                        {
				(yyvsp[-3].obj)->ct_expect.dport = (yyvsp[-1].val);
			}
#line 12225 "parser_bison.c"
    break;

  case 722: /* ct_expect_config: "timeout" time_spec stmt_separator  */
#line 4371 "parser_bison.y"
                        {
				(yyvsp[-3].obj)->ct_expect.timeout = (yyvsp[-1].val);
			}
#line 12233 "parser_bison.c"
    break;

  case 723: /* ct_expect_config: "size" "number" stmt_separator  */
#line 4375 "parser_bison.y"
                        {
				(yyvsp[-3].obj)->ct_expect.size = (yyvsp[-1].val);
			}
#line 12241 "parser_bison.c"
    break;

  case 724: /* ct_expect_config: "l3proto" family_spec_explicit stmt_separator  */
#line 4379 "parser_bison.y"
                        {
				(yyvsp[-3].obj)->ct_expect.l3proto = (yyvsp[-1].val);
			}
#line 12249 "parser_bison.c"
    break;

  case 725: /* ct_obj_alloc: %empty  */
#line 4385 "parser_bison.y"
                        {
				(yyval.obj) = obj_alloc(&(yyloc));
			}
#line 12257 "parser_bison.c"
    break;

  case 726: /* limit_config: "rate" limit_mode "number" "/" time_unit limit_burst_pkts  */
#line 4391 "parser_bison.y"
                        {
				struct limit *limit;

				limit = &(yyvsp[-6].obj)->limit;
				limit->rate	= (yyvsp[-3].val);
				limit->unit	= (yyvsp[-1].val);
				limit->burst	= (yyvsp[0].val);
				limit->type	= NFT_LIMIT_PKTS;
				limit->flags	= (yyvsp[-4].val);
			}
#line 12272 "parser_bison.c"
    break;

  case 727: /* limit_config: "rate" limit_mode "number" "string" limit_burst_bytes  */
#line 4402 "parser_bison.y"
                        {
				struct limit *limit;
				struct error_record *erec;
				uint64_t rate, unit;

				erec = rate_parse(&(yyloc), (yyvsp[-1].string), &rate, &unit);
				if (erec != NULL) {
					erec_queue(erec, state->msgs);
					YYERROR;
				}

				limit = &(yyvsp[-5].obj)->limit;
				limit->rate	= rate * (yyvsp[-2].val);
				limit->unit	= unit;
				limit->burst	= (yyvsp[0].val);
				limit->type	= NFT_LIMIT_PKT_BYTES;
				limit->flags	= (yyvsp[-3].val);
			}
#line 12295 "parser_bison.c"
    break;

  case 728: /* limit_obj: %empty  */
#line 4423 "parser_bison.y"
                        {
				(yyval.obj) = obj_alloc(&(yyloc));
				(yyval.obj)->type = NFT_OBJECT_LIMIT;
			}
#line 12304 "parser_bison.c"
    break;

  case 729: /* relational_expr: expr rhs_expr  */
#line 4430 "parser_bison.y"
                        {
				(yyval.expr) = relational_expr_alloc(&(yyloc), OP_IMPLICIT, (yyvsp[-1].expr), (yyvsp[0].expr));
			}
#line 12312 "parser_bison.c"
    break;

  case 730: /* relational_expr: expr list_rhs_expr  */
#line 4434 "parser_bison.y"
                        {
				(yyval.expr) = relational_expr_alloc(&(yyloc), OP_IMPLICIT, (yyvsp[-1].expr), (yyvsp[0].expr));
			}
#line 12320 "parser_bison.c"
    break;

  case 731: /* relational_expr: expr relational_op rhs_expr  */
#line 4438 "parser_bison.y"
                        {
				(yyval.expr) = relational_expr_alloc(&(yylsp[-1]), (yyvsp[-1].val), (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 12328 "parser_bison.c"
    break;

  case 732: /* list_rhs_expr: basic_rhs_expr "comma" basic_rhs_expr  */
#line 4444 "parser_bison.y"
                        {
				(yyval.expr) = list_expr_alloc(&(yyloc));
				compound_expr_add((yyval.expr), (yyvsp[-2].expr));
				compound_expr_add((yyval.expr), (yyvsp[0].expr));
			}
#line 12338 "parser_bison.c"
    break;

  case 733: /* list_rhs_expr: list_rhs_expr "comma" basic_rhs_expr  */
#line 4450 "parser_bison.y"
                        {
				(yyvsp[-2].expr)->location = (yyloc);
				compound_expr_add((yyvsp[-2].expr), (yyvsp[0].expr));
				(yyval.expr) = (yyvsp[-2].expr);
			}
#line 12348 "parser_bison.c"
    break;

  case 734: /* rhs_expr: concat_rhs_expr  */
#line 4457 "parser_bison.y"
                                                        { (yyval.expr) = (yyvsp[0].expr); }
#line 12354 "parser_bison.c"
    break;

  case 735: /* rhs_expr: wildcard_expr  */
#line 4458 "parser_bison.y"
                                                        { (yyval.expr) = (yyvsp[0].expr); }
#line 12360 "parser_bison.c"
    break;

  case 736: /* rhs_expr: set_expr  */
#line 4459 "parser_bison.y"
                                                        { (yyval.expr) = (yyvsp[0].expr); }
#line 12366 "parser_bison.c"
    break;

  case 737: /* rhs_expr: set_ref_symbol_expr  */
#line 4460 "parser_bison.y"
                                                        { (yyval.expr) = (yyvsp[0].expr); }
#line 12372 "parser_bison.c"
    break;

  case 739: /* shift_rhs_expr: shift_rhs_expr "<<" primary_rhs_expr  */
#line 4465 "parser_bison.y"
                        {
				(yyval.expr) = binop_expr_alloc(&(yyloc), OP_LSHIFT, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 12380 "parser_bison.c"
    break;

  case 740: /* shift_rhs_expr: shift_rhs_expr ">>" primary_rhs_expr  */
#line 4469 "parser_bison.y"
                        {
				(yyval.expr) = binop_expr_alloc(&(yyloc), OP_RSHIFT, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 12388 "parser_bison.c"
    break;

  case 742: /* and_rhs_expr: and_rhs_expr "&" shift_rhs_expr  */
#line 4476 "parser_bison.y"
                        {
				(yyval.expr) = binop_expr_alloc(&(yyloc), OP_AND, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 12396 "parser_bison.c"
    break;

  case 744: /* exclusive_or_rhs_expr: exclusive_or_rhs_expr "^" and_rhs_expr  */
#line 4483 "parser_bison.y"
                        {
				(yyval.expr) = binop_expr_alloc(&(yyloc), OP_XOR, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 12404 "parser_bison.c"
    break;

  case 746: /* inclusive_or_rhs_expr: inclusive_or_rhs_expr '|' exclusive_or_rhs_expr  */
#line 4490 "parser_bison.y"
                        {
				(yyval.expr) = binop_expr_alloc(&(yyloc), OP_OR, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 12412 "parser_bison.c"
    break;

  case 750: /* concat_rhs_expr: concat_rhs_expr "." multiton_rhs_expr  */
#line 4501 "parser_bison.y"
                        {
				struct location rhs[] = {
					[1]	= (yylsp[-1]),
					[2]	= (yylsp[0]),
				};

				(yyval.expr) = handle_concat_expr(&(yyloc), (yyval.expr), (yyvsp[-2].expr), (yyvsp[0].expr), rhs);
			}
#line 12425 "parser_bison.c"
    break;

  case 751: /* concat_rhs_expr: concat_rhs_expr "." basic_rhs_expr  */
#line 4510 "parser_bison.y"
                        {
				struct location rhs[] = {
					[1]	= (yylsp[-1]),
					[2]	= (yylsp[0]),
				};

				(yyval.expr) = handle_concat_expr(&(yyloc), (yyval.expr), (yyvsp[-2].expr), (yyvsp[0].expr), rhs);
			}
#line 12438 "parser_bison.c"
    break;

  case 752: /* boolean_keys: "exists"  */
#line 4520 "parser_bison.y"
                                                { (yyval.val8) = true; }
#line 12444 "parser_bison.c"
    break;

  case 753: /* boolean_keys: "missing"  */
#line 4521 "parser_bison.y"
                                                { (yyval.val8) = false; }
#line 12450 "parser_bison.c"
    break;

  case 754: /* boolean_expr: boolean_keys  */
#line 4525 "parser_bison.y"
                        {
				(yyval.expr) = constant_expr_alloc(&(yyloc), &boolean_type,
							 BYTEORDER_HOST_ENDIAN,
							 sizeof((yyvsp[0].val8)) * BITS_PER_BYTE, &(yyvsp[0].val8));
			}
#line 12460 "parser_bison.c"
    break;

  case 755: /* keyword_expr: "ether"  */
#line 4532 "parser_bison.y"
                                                        { (yyval.expr) = symbol_value(&(yyloc), "ether"); }
#line 12466 "parser_bison.c"
    break;

  case 756: /* keyword_expr: "ip"  */
#line 4533 "parser_bison.y"
                                                        { (yyval.expr) = symbol_value(&(yyloc), "ip"); }
#line 12472 "parser_bison.c"
    break;

  case 757: /* keyword_expr: "ip6"  */
#line 4534 "parser_bison.y"
                                                        { (yyval.expr) = symbol_value(&(yyloc), "ip6"); }
#line 12478 "parser_bison.c"
    break;

  case 758: /* keyword_expr: "vlan"  */
#line 4535 "parser_bison.y"
                                                        { (yyval.expr) = symbol_value(&(yyloc), "vlan"); }
#line 12484 "parser_bison.c"
    break;

  case 759: /* keyword_expr: "arp"  */
#line 4536 "parser_bison.y"
                                                        { (yyval.expr) = symbol_value(&(yyloc), "arp"); }
#line 12490 "parser_bison.c"
    break;

  case 760: /* keyword_expr: "dnat"  */
#line 4537 "parser_bison.y"
                                                        { (yyval.expr) = symbol_value(&(yyloc), "dnat"); }
#line 12496 "parser_bison.c"
    break;

  case 761: /* keyword_expr: "snat"  */
#line 4538 "parser_bison.y"
                                                        { (yyval.expr) = symbol_value(&(yyloc), "snat"); }
#line 12502 "parser_bison.c"
    break;

  case 762: /* keyword_expr: "ecn"  */
#line 4539 "parser_bison.y"
                                                        { (yyval.expr) = symbol_value(&(yyloc), "ecn"); }
#line 12508 "parser_bison.c"
    break;

  case 763: /* keyword_expr: "reset"  */
#line 4540 "parser_bison.y"
                                                        { (yyval.expr) = symbol_value(&(yyloc), "reset"); }
#line 12514 "parser_bison.c"
    break;

  case 764: /* keyword_expr: "original"  */
#line 4541 "parser_bison.y"
                                                        { (yyval.expr) = symbol_value(&(yyloc), "original"); }
#line 12520 "parser_bison.c"
    break;

  case 765: /* keyword_expr: "reply"  */
#line 4542 "parser_bison.y"
                                                        { (yyval.expr) = symbol_value(&(yyloc), "reply"); }
#line 12526 "parser_bison.c"
    break;

  case 766: /* keyword_expr: "label"  */
#line 4543 "parser_bison.y"
                                                        { (yyval.expr) = symbol_value(&(yyloc), "label"); }
#line 12532 "parser_bison.c"
    break;

  case 767: /* primary_rhs_expr: symbol_expr  */
#line 4546 "parser_bison.y"
                                                        { (yyval.expr) = (yyvsp[0].expr); }
#line 12538 "parser_bison.c"
    break;

  case 768: /* primary_rhs_expr: integer_expr  */
#line 4547 "parser_bison.y"
                                                        { (yyval.expr) = (yyvsp[0].expr); }
#line 12544 "parser_bison.c"
    break;

  case 769: /* primary_rhs_expr: boolean_expr  */
#line 4548 "parser_bison.y"
                                                        { (yyval.expr) = (yyvsp[0].expr); }
#line 12550 "parser_bison.c"
    break;

  case 770: /* primary_rhs_expr: keyword_expr  */
#line 4549 "parser_bison.y"
                                                        { (yyval.expr) = (yyvsp[0].expr); }
#line 12556 "parser_bison.c"
    break;

  case 771: /* primary_rhs_expr: "tcp"  */
#line 4551 "parser_bison.y"
                        {
				uint8_t data = IPPROTO_TCP;
				(yyval.expr) = constant_expr_alloc(&(yyloc), &inet_protocol_type,
							 BYTEORDER_HOST_ENDIAN,
							 sizeof(data) * BITS_PER_BYTE, &data);
			}
#line 12567 "parser_bison.c"
    break;

  case 772: /* primary_rhs_expr: "udp"  */
#line 4558 "parser_bison.y"
                        {
				uint8_t data = IPPROTO_UDP;
				(yyval.expr) = constant_expr_alloc(&(yyloc), &inet_protocol_type,
							 BYTEORDER_HOST_ENDIAN,
							 sizeof(data) * BITS_PER_BYTE, &data);
			}
#line 12578 "parser_bison.c"
    break;

  case 773: /* primary_rhs_expr: "udplite"  */
#line 4565 "parser_bison.y"
                        {
				uint8_t data = IPPROTO_UDPLITE;
				(yyval.expr) = constant_expr_alloc(&(yyloc), &inet_protocol_type,
							 BYTEORDER_HOST_ENDIAN,
							 sizeof(data) * BITS_PER_BYTE, &data);
			}
#line 12589 "parser_bison.c"
    break;

  case 774: /* primary_rhs_expr: "esp"  */
#line 4572 "parser_bison.y"
                        {
				uint8_t data = IPPROTO_ESP;
				(yyval.expr) = constant_expr_alloc(&(yyloc), &inet_protocol_type,
							 BYTEORDER_HOST_ENDIAN,
							 sizeof(data) * BITS_PER_BYTE, &data);
			}
#line 12600 "parser_bison.c"
    break;

  case 775: /* primary_rhs_expr: "ah"  */
#line 4579 "parser_bison.y"
                        {
				uint8_t data = IPPROTO_AH;
				(yyval.expr) = constant_expr_alloc(&(yyloc), &inet_protocol_type,
							 BYTEORDER_HOST_ENDIAN,
							 sizeof(data) * BITS_PER_BYTE, &data);
			}
#line 12611 "parser_bison.c"
    break;

  case 776: /* primary_rhs_expr: "icmp"  */
#line 4586 "parser_bison.y"
                        {
				uint8_t data = IPPROTO_ICMP;
				(yyval.expr) = constant_expr_alloc(&(yyloc), &inet_protocol_type,
							 BYTEORDER_HOST_ENDIAN,
							 sizeof(data) * BITS_PER_BYTE, &data);
			}
#line 12622 "parser_bison.c"
    break;

  case 777: /* primary_rhs_expr: "igmp"  */
#line 4593 "parser_bison.y"
                        {
				uint8_t data = IPPROTO_IGMP;
				(yyval.expr) = constant_expr_alloc(&(yyloc), &inet_protocol_type,
							 BYTEORDER_HOST_ENDIAN,
							 sizeof(data) * BITS_PER_BYTE, &data);
			}
#line 12633 "parser_bison.c"
    break;

  case 778: /* primary_rhs_expr: "icmpv6"  */
#line 4600 "parser_bison.y"
                        {
				uint8_t data = IPPROTO_ICMPV6;
				(yyval.expr) = constant_expr_alloc(&(yyloc), &inet_protocol_type,
							 BYTEORDER_HOST_ENDIAN,
							 sizeof(data) * BITS_PER_BYTE, &data);
			}
#line 12644 "parser_bison.c"
    break;

  case 779: /* primary_rhs_expr: "comp"  */
#line 4607 "parser_bison.y"
                        {
				uint8_t data = IPPROTO_COMP;
				(yyval.expr) = constant_expr_alloc(&(yyloc), &inet_protocol_type,
							 BYTEORDER_HOST_ENDIAN,
							 sizeof(data) * BITS_PER_BYTE, &data);
			}
#line 12655 "parser_bison.c"
    break;

  case 780: /* primary_rhs_expr: "dccp"  */
#line 4614 "parser_bison.y"
                        {
				uint8_t data = IPPROTO_DCCP;
				(yyval.expr) = constant_expr_alloc(&(yyloc), &inet_protocol_type,
							 BYTEORDER_HOST_ENDIAN,
							 sizeof(data) * BITS_PER_BYTE, &data);
			}
#line 12666 "parser_bison.c"
    break;

  case 781: /* primary_rhs_expr: "sctp"  */
#line 4621 "parser_bison.y"
                        {
				uint8_t data = IPPROTO_SCTP;
				(yyval.expr) = constant_expr_alloc(&(yyloc), &inet_protocol_type,
							 BYTEORDER_HOST_ENDIAN,
							 sizeof(data) * BITS_PER_BYTE, &data);
			}
#line 12677 "parser_bison.c"
    break;

  case 782: /* primary_rhs_expr: "redirect"  */
#line 4628 "parser_bison.y"
                        {
				uint8_t data = ICMP_REDIRECT;
				(yyval.expr) = constant_expr_alloc(&(yyloc), &icmp_type_type,
							 BYTEORDER_HOST_ENDIAN,
							 sizeof(data) * BITS_PER_BYTE, &data);
			}
#line 12688 "parser_bison.c"
    break;

  case 783: /* primary_rhs_expr: '(' basic_rhs_expr ')'  */
#line 4634 "parser_bison.y"
                                                                { (yyval.expr) = (yyvsp[-1].expr); }
#line 12694 "parser_bison.c"
    break;

  case 784: /* relational_op: "=="  */
#line 4637 "parser_bison.y"
                                                { (yyval.val) = OP_EQ; }
#line 12700 "parser_bison.c"
    break;

  case 785: /* relational_op: "!="  */
#line 4638 "parser_bison.y"
                                                { (yyval.val) = OP_NEQ; }
#line 12706 "parser_bison.c"
    break;

  case 786: /* relational_op: "<"  */
#line 4639 "parser_bison.y"
                                                { (yyval.val) = OP_LT; }
#line 12712 "parser_bison.c"
    break;

  case 787: /* relational_op: ">"  */
#line 4640 "parser_bison.y"
                                                { (yyval.val) = OP_GT; }
#line 12718 "parser_bison.c"
    break;

  case 788: /* relational_op: ">="  */
#line 4641 "parser_bison.y"
                                                { (yyval.val) = OP_GTE; }
#line 12724 "parser_bison.c"
    break;

  case 789: /* relational_op: "<="  */
#line 4642 "parser_bison.y"
                                                { (yyval.val) = OP_LTE; }
#line 12730 "parser_bison.c"
    break;

  case 790: /* verdict_expr: "accept"  */
#line 4646 "parser_bison.y"
                        {
				(yyval.expr) = verdict_expr_alloc(&(yyloc), NF_ACCEPT, NULL);
			}
#line 12738 "parser_bison.c"
    break;

  case 791: /* verdict_expr: "drop"  */
#line 4650 "parser_bison.y"
                        {
				(yyval.expr) = verdict_expr_alloc(&(yyloc), NF_DROP, NULL);
			}
#line 12746 "parser_bison.c"
    break;

  case 792: /* verdict_expr: "continue"  */
#line 4654 "parser_bison.y"
                        {
				(yyval.expr) = verdict_expr_alloc(&(yyloc), NFT_CONTINUE, NULL);
			}
#line 12754 "parser_bison.c"
    break;

  case 793: /* verdict_expr: "jump" chain_expr  */
#line 4658 "parser_bison.y"
                        {
				(yyval.expr) = verdict_expr_alloc(&(yyloc), NFT_JUMP, (yyvsp[0].expr));
			}
#line 12762 "parser_bison.c"
    break;

  case 794: /* verdict_expr: "goto" chain_expr  */
#line 4662 "parser_bison.y"
                        {
				(yyval.expr) = verdict_expr_alloc(&(yyloc), NFT_GOTO, (yyvsp[0].expr));
			}
#line 12770 "parser_bison.c"
    break;

  case 795: /* verdict_expr: "return"  */
#line 4666 "parser_bison.y"
                        {
				(yyval.expr) = verdict_expr_alloc(&(yyloc), NFT_RETURN, NULL);
			}
#line 12778 "parser_bison.c"
    break;

  case 797: /* chain_expr: identifier  */
#line 4673 "parser_bison.y"
                        {
				(yyval.expr) = constant_expr_alloc(&(yyloc), &string_type,
							 BYTEORDER_HOST_ENDIAN,
							 strlen((yyvsp[0].string)) * BITS_PER_BYTE,
							 (yyvsp[0].string));
				xfree((yyvsp[0].string));
			}
#line 12790 "parser_bison.c"
    break;

  case 798: /* meta_expr: "meta" meta_key  */
#line 4683 "parser_bison.y"
                        {
				(yyval.expr) = meta_expr_alloc(&(yyloc), (yyvsp[0].val));
			}
#line 12798 "parser_bison.c"
    break;

  case 799: /* meta_expr: meta_key_unqualified  */
#line 4687 "parser_bison.y"
                        {
				(yyval.expr) = meta_expr_alloc(&(yyloc), (yyvsp[0].val));
			}
#line 12806 "parser_bison.c"
    break;

  case 800: /* meta_expr: "meta" "string"  */
#line 4691 "parser_bison.y"
                        {
				struct error_record *erec;
				unsigned int key;

				erec = meta_key_parse(&(yyloc), (yyvsp[0].string), &key);
				xfree((yyvsp[0].string));
				if (erec != NULL) {
					erec_queue(erec, state->msgs);
					YYERROR;
				}

				(yyval.expr) = meta_expr_alloc(&(yyloc), key);
			}
#line 12824 "parser_bison.c"
    break;

  case 803: /* meta_key_qualified: "length"  */
#line 4710 "parser_bison.y"
                                                { (yyval.val) = NFT_META_LEN; }
#line 12830 "parser_bison.c"
    break;

  case 804: /* meta_key_qualified: "protocol"  */
#line 4711 "parser_bison.y"
                                                { (yyval.val) = NFT_META_PROTOCOL; }
#line 12836 "parser_bison.c"
    break;

  case 805: /* meta_key_qualified: "priority"  */
#line 4712 "parser_bison.y"
                                                { (yyval.val) = NFT_META_PRIORITY; }
#line 12842 "parser_bison.c"
    break;

  case 806: /* meta_key_qualified: "random"  */
#line 4713 "parser_bison.y"
                                                { (yyval.val) = NFT_META_PRANDOM; }
#line 12848 "parser_bison.c"
    break;

  case 807: /* meta_key_qualified: "secmark"  */
#line 4714 "parser_bison.y"
                                                { (yyval.val) = NFT_META_SECMARK; }
#line 12854 "parser_bison.c"
    break;

  case 808: /* meta_key_unqualified: "mark"  */
#line 4717 "parser_bison.y"
                                                { (yyval.val) = NFT_META_MARK; }
#line 12860 "parser_bison.c"
    break;

  case 809: /* meta_key_unqualified: "iif"  */
#line 4718 "parser_bison.y"
                                                { (yyval.val) = NFT_META_IIF; }
#line 12866 "parser_bison.c"
    break;

  case 810: /* meta_key_unqualified: "iifname"  */
#line 4719 "parser_bison.y"
                                                { (yyval.val) = NFT_META_IIFNAME; }
#line 12872 "parser_bison.c"
    break;

  case 811: /* meta_key_unqualified: "iiftype"  */
#line 4720 "parser_bison.y"
                                                { (yyval.val) = NFT_META_IIFTYPE; }
#line 12878 "parser_bison.c"
    break;

  case 812: /* meta_key_unqualified: "oif"  */
#line 4721 "parser_bison.y"
                                                { (yyval.val) = NFT_META_OIF; }
#line 12884 "parser_bison.c"
    break;

  case 813: /* meta_key_unqualified: "oifname"  */
#line 4722 "parser_bison.y"
                                                { (yyval.val) = NFT_META_OIFNAME; }
#line 12890 "parser_bison.c"
    break;

  case 814: /* meta_key_unqualified: "oiftype"  */
#line 4723 "parser_bison.y"
                                                { (yyval.val) = NFT_META_OIFTYPE; }
#line 12896 "parser_bison.c"
    break;

  case 815: /* meta_key_unqualified: "skuid"  */
#line 4724 "parser_bison.y"
                                                { (yyval.val) = NFT_META_SKUID; }
#line 12902 "parser_bison.c"
    break;

  case 816: /* meta_key_unqualified: "skgid"  */
#line 4725 "parser_bison.y"
                                                { (yyval.val) = NFT_META_SKGID; }
#line 12908 "parser_bison.c"
    break;

  case 817: /* meta_key_unqualified: "nftrace"  */
#line 4726 "parser_bison.y"
                                                { (yyval.val) = NFT_META_NFTRACE; }
#line 12914 "parser_bison.c"
    break;

  case 818: /* meta_key_unqualified: "rtclassid"  */
#line 4727 "parser_bison.y"
                                                { (yyval.val) = NFT_META_RTCLASSID; }
#line 12920 "parser_bison.c"
    break;

  case 819: /* meta_key_unqualified: "ibriport"  */
#line 4728 "parser_bison.y"
                                                { (yyval.val) = NFT_META_BRI_IIFNAME; }
#line 12926 "parser_bison.c"
    break;

  case 820: /* meta_key_unqualified: "obriport"  */
#line 4729 "parser_bison.y"
                                                { (yyval.val) = NFT_META_BRI_OIFNAME; }
#line 12932 "parser_bison.c"
    break;

  case 821: /* meta_key_unqualified: "ibrname"  */
#line 4730 "parser_bison.y"
                                                { (yyval.val) = NFT_META_BRI_IIFNAME; }
#line 12938 "parser_bison.c"
    break;

  case 822: /* meta_key_unqualified: "obrname"  */
#line 4731 "parser_bison.y"
                                                { (yyval.val) = NFT_META_BRI_OIFNAME; }
#line 12944 "parser_bison.c"
    break;

  case 823: /* meta_key_unqualified: "pkttype"  */
#line 4732 "parser_bison.y"
                                                { (yyval.val) = NFT_META_PKTTYPE; }
#line 12950 "parser_bison.c"
    break;

  case 824: /* meta_key_unqualified: "cpu"  */
#line 4733 "parser_bison.y"
                                                { (yyval.val) = NFT_META_CPU; }
#line 12956 "parser_bison.c"
    break;

  case 825: /* meta_key_unqualified: "iifgroup"  */
#line 4734 "parser_bison.y"
                                                { (yyval.val) = NFT_META_IIFGROUP; }
#line 12962 "parser_bison.c"
    break;

  case 826: /* meta_key_unqualified: "oifgroup"  */
#line 4735 "parser_bison.y"
                                                { (yyval.val) = NFT_META_OIFGROUP; }
#line 12968 "parser_bison.c"
    break;

  case 827: /* meta_key_unqualified: "cgroup"  */
#line 4736 "parser_bison.y"
                                                { (yyval.val) = NFT_META_CGROUP; }
#line 12974 "parser_bison.c"
    break;

  case 828: /* meta_key_unqualified: "ipsec"  */
#line 4737 "parser_bison.y"
                                                { (yyval.val) = NFT_META_SECPATH; }
#line 12980 "parser_bison.c"
    break;

  case 829: /* meta_key_unqualified: "time"  */
#line 4738 "parser_bison.y"
                                                { (yyval.val) = NFT_META_TIME_NS; }
#line 12986 "parser_bison.c"
    break;

  case 830: /* meta_key_unqualified: "day"  */
#line 4739 "parser_bison.y"
                                                { (yyval.val) = NFT_META_TIME_DAY; }
#line 12992 "parser_bison.c"
    break;

  case 831: /* meta_key_unqualified: "hour"  */
#line 4740 "parser_bison.y"
                                                { (yyval.val) = NFT_META_TIME_HOUR; }
#line 12998 "parser_bison.c"
    break;

  case 832: /* meta_stmt: "meta" meta_key "set" stmt_expr  */
#line 4744 "parser_bison.y"
                        {
				switch ((yyvsp[-2].val)) {
				case NFT_META_SECMARK:
					switch ((yyvsp[0].expr)->etype) {
					case EXPR_CT:
						(yyval.stmt) = meta_stmt_alloc(&(yyloc), (yyvsp[-2].val), (yyvsp[0].expr));
						break;
					default:
						(yyval.stmt) = objref_stmt_alloc(&(yyloc));
						(yyval.stmt)->objref.type = NFT_OBJECT_SECMARK;
						(yyval.stmt)->objref.expr = (yyvsp[0].expr);
						break;
					}
					break;
				default:
					(yyval.stmt) = meta_stmt_alloc(&(yyloc), (yyvsp[-2].val), (yyvsp[0].expr));
					break;
				}
			}
#line 13022 "parser_bison.c"
    break;

  case 833: /* meta_stmt: meta_key_unqualified "set" stmt_expr  */
#line 4764 "parser_bison.y"
                        {
				(yyval.stmt) = meta_stmt_alloc(&(yyloc), (yyvsp[-2].val), (yyvsp[0].expr));
			}
#line 13030 "parser_bison.c"
    break;

  case 834: /* meta_stmt: "meta" "string" "set" stmt_expr  */
#line 4768 "parser_bison.y"
                        {
				struct error_record *erec;
				unsigned int key;

				erec = meta_key_parse(&(yyloc), (yyvsp[-2].string), &key);
				xfree((yyvsp[-2].string));
				if (erec != NULL) {
					erec_queue(erec, state->msgs);
					YYERROR;
				}

				(yyval.stmt) = meta_stmt_alloc(&(yyloc), key, (yyvsp[0].expr));
			}
#line 13048 "parser_bison.c"
    break;

  case 835: /* meta_stmt: "notrack"  */
#line 4782 "parser_bison.y"
                        {
				(yyval.stmt) = notrack_stmt_alloc(&(yyloc));
			}
#line 13056 "parser_bison.c"
    break;

  case 836: /* meta_stmt: "flow" "offload" "@" string  */
#line 4786 "parser_bison.y"
                        {
				(yyval.stmt) = flow_offload_stmt_alloc(&(yyloc), (yyvsp[0].string));
			}
#line 13064 "parser_bison.c"
    break;

  case 837: /* meta_stmt: "flow" "add" "@" string  */
#line 4790 "parser_bison.y"
                        {
				(yyval.stmt) = flow_offload_stmt_alloc(&(yyloc), (yyvsp[0].string));
			}
#line 13072 "parser_bison.c"
    break;

  case 838: /* socket_expr: "socket" socket_key  */
#line 4796 "parser_bison.y"
                        {
				(yyval.expr) = socket_expr_alloc(&(yyloc), (yyvsp[0].val));
			}
#line 13080 "parser_bison.c"
    break;

  case 839: /* socket_key: "transparent"  */
#line 4801 "parser_bison.y"
                                                { (yyval.val) = NFT_SOCKET_TRANSPARENT; }
#line 13086 "parser_bison.c"
    break;

  case 840: /* socket_key: "mark"  */
#line 4802 "parser_bison.y"
                                                { (yyval.val) = NFT_SOCKET_MARK; }
#line 13092 "parser_bison.c"
    break;

  case 841: /* socket_key: "wildcard"  */
#line 4803 "parser_bison.y"
                                                { (yyval.val) = NFT_SOCKET_WILDCARD; }
#line 13098 "parser_bison.c"
    break;

  case 842: /* offset_opt: %empty  */
#line 4806 "parser_bison.y"
                                                { (yyval.val) = 0; }
#line 13104 "parser_bison.c"
    break;

  case 843: /* offset_opt: "offset" "number"  */
#line 4807 "parser_bison.y"
                                                { (yyval.val) = (yyvsp[0].val); }
#line 13110 "parser_bison.c"
    break;

  case 844: /* numgen_type: "inc"  */
#line 4810 "parser_bison.y"
                                                { (yyval.val) = NFT_NG_INCREMENTAL; }
#line 13116 "parser_bison.c"
    break;

  case 845: /* numgen_type: "random"  */
#line 4811 "parser_bison.y"
                                                { (yyval.val) = NFT_NG_RANDOM; }
#line 13122 "parser_bison.c"
    break;

  case 846: /* numgen_expr: "numgen" numgen_type "mod" "number" offset_opt  */
#line 4815 "parser_bison.y"
                        {
				(yyval.expr) = numgen_expr_alloc(&(yyloc), (yyvsp[-3].val), (yyvsp[-1].val), (yyvsp[0].val));
			}
#line 13130 "parser_bison.c"
    break;

  case 847: /* xfrm_spnum: "spnum" "number"  */
#line 4820 "parser_bison.y"
                                            { (yyval.val) = (yyvsp[0].val); }
#line 13136 "parser_bison.c"
    break;

  case 848: /* xfrm_spnum: %empty  */
#line 4821 "parser_bison.y"
                                            { (yyval.val) = 0; }
#line 13142 "parser_bison.c"
    break;

  case 849: /* xfrm_dir: "in"  */
#line 4824 "parser_bison.y"
                                        { (yyval.val) = XFRM_POLICY_IN; }
#line 13148 "parser_bison.c"
    break;

  case 850: /* xfrm_dir: "out"  */
#line 4825 "parser_bison.y"
                                        { (yyval.val) = XFRM_POLICY_OUT; }
#line 13154 "parser_bison.c"
    break;

  case 851: /* xfrm_state_key: "spi"  */
#line 4828 "parser_bison.y"
                                    { (yyval.val) = NFT_XFRM_KEY_SPI; }
#line 13160 "parser_bison.c"
    break;

  case 852: /* xfrm_state_key: "reqid"  */
#line 4829 "parser_bison.y"
                                      { (yyval.val) = NFT_XFRM_KEY_REQID; }
#line 13166 "parser_bison.c"
    break;

  case 853: /* xfrm_state_proto_key: "daddr"  */
#line 4832 "parser_bison.y"
                                                { (yyval.val) = NFT_XFRM_KEY_DADDR_IP4; }
#line 13172 "parser_bison.c"
    break;

  case 854: /* xfrm_state_proto_key: "saddr"  */
#line 4833 "parser_bison.y"
                                                { (yyval.val) = NFT_XFRM_KEY_SADDR_IP4; }
#line 13178 "parser_bison.c"
    break;

  case 855: /* xfrm_expr: "ipsec" xfrm_dir xfrm_spnum xfrm_state_key  */
#line 4837 "parser_bison.y"
                        {
				if ((yyvsp[-1].val) > 255) {
					erec_queue(error(&(yylsp[-1]), "value too large"), state->msgs);
					YYERROR;
				}
				(yyval.expr) = xfrm_expr_alloc(&(yyloc), (yyvsp[-2].val), (yyvsp[-1].val), (yyvsp[0].val));
			}
#line 13190 "parser_bison.c"
    break;

  case 856: /* xfrm_expr: "ipsec" xfrm_dir xfrm_spnum nf_key_proto xfrm_state_proto_key  */
#line 4845 "parser_bison.y"
                        {
				enum nft_xfrm_keys xfrmk = (yyvsp[0].val);

				switch ((yyvsp[-1].val)) {
				case NFPROTO_IPV4:
					break;
				case NFPROTO_IPV6:
					if ((yyvsp[0].val) == NFT_XFRM_KEY_SADDR_IP4)
						xfrmk = NFT_XFRM_KEY_SADDR_IP6;
					else if ((yyvsp[0].val) == NFT_XFRM_KEY_DADDR_IP4)
						xfrmk = NFT_XFRM_KEY_DADDR_IP6;
					break;
				default:
					YYERROR;
					break;
				}

				if ((yyvsp[-2].val) > 255) {
					erec_queue(error(&(yylsp[-2]), "value too large"), state->msgs);
					YYERROR;
				}

				(yyval.expr) = xfrm_expr_alloc(&(yyloc), (yyvsp[-3].val), (yyvsp[-2].val), xfrmk);
			}
#line 13219 "parser_bison.c"
    break;

  case 857: /* hash_expr: "jhash" expr "mod" "number" "seed" "number" offset_opt  */
#line 4872 "parser_bison.y"
                        {
				(yyval.expr) = hash_expr_alloc(&(yyloc), (yyvsp[-3].val), true, (yyvsp[-1].val), (yyvsp[0].val), NFT_HASH_JENKINS);
				(yyval.expr)->hash.expr = (yyvsp[-5].expr);
			}
#line 13228 "parser_bison.c"
    break;

  case 858: /* hash_expr: "jhash" expr "mod" "number" offset_opt  */
#line 4877 "parser_bison.y"
                        {
				(yyval.expr) = hash_expr_alloc(&(yyloc), (yyvsp[-1].val), false, 0, (yyvsp[0].val), NFT_HASH_JENKINS);
				(yyval.expr)->hash.expr = (yyvsp[-3].expr);
			}
#line 13237 "parser_bison.c"
    break;

  case 859: /* hash_expr: "symhash" "mod" "number" offset_opt  */
#line 4882 "parser_bison.y"
                        {
				(yyval.expr) = hash_expr_alloc(&(yyloc), (yyvsp[-1].val), false, 0, (yyvsp[0].val), NFT_HASH_SYM);
			}
#line 13245 "parser_bison.c"
    break;

  case 860: /* nf_key_proto: "ip"  */
#line 4887 "parser_bison.y"
                                                { (yyval.val) = NFPROTO_IPV4; }
#line 13251 "parser_bison.c"
    break;

  case 861: /* nf_key_proto: "ip6"  */
#line 4888 "parser_bison.y"
                                                { (yyval.val) = NFPROTO_IPV6; }
#line 13257 "parser_bison.c"
    break;

  case 862: /* rt_expr: "rt" rt_key  */
#line 4892 "parser_bison.y"
                        {
				(yyval.expr) = rt_expr_alloc(&(yyloc), (yyvsp[0].val), true);
			}
#line 13265 "parser_bison.c"
    break;

  case 863: /* rt_expr: "rt" nf_key_proto rt_key  */
#line 4896 "parser_bison.y"
                        {
				enum nft_rt_keys rtk = (yyvsp[0].val);

				switch ((yyvsp[-1].val)) {
				case NFPROTO_IPV4:
					break;
				case NFPROTO_IPV6:
					if ((yyvsp[0].val) == NFT_RT_NEXTHOP4)
						rtk = NFT_RT_NEXTHOP6;
					break;
				default:
					YYERROR;
					break;
				}

				(yyval.expr) = rt_expr_alloc(&(yyloc), rtk, false);
			}
#line 13287 "parser_bison.c"
    break;

  case 864: /* rt_key: "classid"  */
#line 4915 "parser_bison.y"
                                                { (yyval.val) = NFT_RT_CLASSID; }
#line 13293 "parser_bison.c"
    break;

  case 865: /* rt_key: "nexthop"  */
#line 4916 "parser_bison.y"
                                                { (yyval.val) = NFT_RT_NEXTHOP4; }
#line 13299 "parser_bison.c"
    break;

  case 866: /* rt_key: "mtu"  */
#line 4917 "parser_bison.y"
                                                { (yyval.val) = NFT_RT_TCPMSS; }
#line 13305 "parser_bison.c"
    break;

  case 867: /* rt_key: "ipsec"  */
#line 4918 "parser_bison.y"
                                                { (yyval.val) = NFT_RT_XFRM; }
#line 13311 "parser_bison.c"
    break;

  case 868: /* ct_expr: "ct" ct_key  */
#line 4922 "parser_bison.y"
                        {
				(yyval.expr) = ct_expr_alloc(&(yyloc), (yyvsp[0].val), -1);
			}
#line 13319 "parser_bison.c"
    break;

  case 869: /* ct_expr: "ct" ct_dir ct_key_dir  */
#line 4926 "parser_bison.y"
                        {
				(yyval.expr) = ct_expr_alloc(&(yyloc), (yyvsp[0].val), (yyvsp[-1].val));
			}
#line 13327 "parser_bison.c"
    break;

  case 870: /* ct_expr: "ct" ct_dir ct_key_proto_field  */
#line 4930 "parser_bison.y"
                        {
				(yyval.expr) = ct_expr_alloc(&(yyloc), (yyvsp[0].val), (yyvsp[-1].val));
			}
#line 13335 "parser_bison.c"
    break;

  case 871: /* ct_dir: "original"  */
#line 4935 "parser_bison.y"
                                                { (yyval.val) = IP_CT_DIR_ORIGINAL; }
#line 13341 "parser_bison.c"
    break;

  case 872: /* ct_dir: "reply"  */
#line 4936 "parser_bison.y"
                                                { (yyval.val) = IP_CT_DIR_REPLY; }
#line 13347 "parser_bison.c"
    break;

  case 873: /* ct_key: "l3proto"  */
#line 4939 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_L3PROTOCOL; }
#line 13353 "parser_bison.c"
    break;

  case 874: /* ct_key: "protocol"  */
#line 4940 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_PROTOCOL; }
#line 13359 "parser_bison.c"
    break;

  case 875: /* ct_key: "mark"  */
#line 4941 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_MARK; }
#line 13365 "parser_bison.c"
    break;

  case 876: /* ct_key: "state"  */
#line 4942 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_STATE; }
#line 13371 "parser_bison.c"
    break;

  case 877: /* ct_key: "direction"  */
#line 4943 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_DIRECTION; }
#line 13377 "parser_bison.c"
    break;

  case 878: /* ct_key: "status"  */
#line 4944 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_STATUS; }
#line 13383 "parser_bison.c"
    break;

  case 879: /* ct_key: "expiration"  */
#line 4945 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_EXPIRATION; }
#line 13389 "parser_bison.c"
    break;

  case 880: /* ct_key: "helper"  */
#line 4946 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_HELPER; }
#line 13395 "parser_bison.c"
    break;

  case 881: /* ct_key: "saddr"  */
#line 4947 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_SRC; }
#line 13401 "parser_bison.c"
    break;

  case 882: /* ct_key: "daddr"  */
#line 4948 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_DST; }
#line 13407 "parser_bison.c"
    break;

  case 883: /* ct_key: "proto-src"  */
#line 4949 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_PROTO_SRC; }
#line 13413 "parser_bison.c"
    break;

  case 884: /* ct_key: "proto-dst"  */
#line 4950 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_PROTO_DST; }
#line 13419 "parser_bison.c"
    break;

  case 885: /* ct_key: "label"  */
#line 4951 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_LABELS; }
#line 13425 "parser_bison.c"
    break;

  case 886: /* ct_key: "event"  */
#line 4952 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_EVENTMASK; }
#line 13431 "parser_bison.c"
    break;

  case 887: /* ct_key: "secmark"  */
#line 4953 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_SECMARK; }
#line 13437 "parser_bison.c"
    break;

  case 888: /* ct_key: "id"  */
#line 4954 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_ID; }
#line 13443 "parser_bison.c"
    break;

  case 890: /* ct_key_dir: "saddr"  */
#line 4958 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_SRC; }
#line 13449 "parser_bison.c"
    break;

  case 891: /* ct_key_dir: "daddr"  */
#line 4959 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_DST; }
#line 13455 "parser_bison.c"
    break;

  case 892: /* ct_key_dir: "l3proto"  */
#line 4960 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_L3PROTOCOL; }
#line 13461 "parser_bison.c"
    break;

  case 893: /* ct_key_dir: "protocol"  */
#line 4961 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_PROTOCOL; }
#line 13467 "parser_bison.c"
    break;

  case 894: /* ct_key_dir: "proto-src"  */
#line 4962 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_PROTO_SRC; }
#line 13473 "parser_bison.c"
    break;

  case 895: /* ct_key_dir: "proto-dst"  */
#line 4963 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_PROTO_DST; }
#line 13479 "parser_bison.c"
    break;

  case 897: /* ct_key_proto_field: "ip" "saddr"  */
#line 4967 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_SRC_IP; }
#line 13485 "parser_bison.c"
    break;

  case 898: /* ct_key_proto_field: "ip" "daddr"  */
#line 4968 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_DST_IP; }
#line 13491 "parser_bison.c"
    break;

  case 899: /* ct_key_proto_field: "ip6" "saddr"  */
#line 4969 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_SRC_IP6; }
#line 13497 "parser_bison.c"
    break;

  case 900: /* ct_key_proto_field: "ip6" "daddr"  */
#line 4970 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_DST_IP6; }
#line 13503 "parser_bison.c"
    break;

  case 901: /* ct_key_dir_optional: "bytes"  */
#line 4973 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_BYTES; }
#line 13509 "parser_bison.c"
    break;

  case 902: /* ct_key_dir_optional: "packets"  */
#line 4974 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_PKTS; }
#line 13515 "parser_bison.c"
    break;

  case 903: /* ct_key_dir_optional: "avgpkt"  */
#line 4975 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_AVGPKT; }
#line 13521 "parser_bison.c"
    break;

  case 904: /* ct_key_dir_optional: "zone"  */
#line 4976 "parser_bison.y"
                                                { (yyval.val) = NFT_CT_ZONE; }
#line 13527 "parser_bison.c"
    break;

  case 907: /* list_stmt_expr: symbol_stmt_expr "comma" symbol_stmt_expr  */
#line 4984 "parser_bison.y"
                        {
				(yyval.expr) = list_expr_alloc(&(yyloc));
				compound_expr_add((yyval.expr), (yyvsp[-2].expr));
				compound_expr_add((yyval.expr), (yyvsp[0].expr));
			}
#line 13537 "parser_bison.c"
    break;

  case 908: /* list_stmt_expr: list_stmt_expr "comma" symbol_stmt_expr  */
#line 4990 "parser_bison.y"
                        {
				(yyvsp[-2].expr)->location = (yyloc);
				compound_expr_add((yyvsp[-2].expr), (yyvsp[0].expr));
				(yyval.expr) = (yyvsp[-2].expr);
			}
#line 13547 "parser_bison.c"
    break;

  case 909: /* ct_stmt: "ct" ct_key "set" stmt_expr  */
#line 4998 "parser_bison.y"
                        {
				switch ((yyvsp[-2].val)) {
				case NFT_CT_HELPER:
					(yyval.stmt) = objref_stmt_alloc(&(yyloc));
					(yyval.stmt)->objref.type = NFT_OBJECT_CT_HELPER;
					(yyval.stmt)->objref.expr = (yyvsp[0].expr);
					break;
				default:
					(yyval.stmt) = ct_stmt_alloc(&(yyloc), (yyvsp[-2].val), -1, (yyvsp[0].expr));
					break;
				}
			}
#line 13564 "parser_bison.c"
    break;

  case 910: /* ct_stmt: "ct" "timeout" "set" stmt_expr  */
#line 5011 "parser_bison.y"
                        {
				(yyval.stmt) = objref_stmt_alloc(&(yyloc));
				(yyval.stmt)->objref.type = NFT_OBJECT_CT_TIMEOUT;
				(yyval.stmt)->objref.expr = (yyvsp[0].expr);

			}
#line 13575 "parser_bison.c"
    break;

  case 911: /* ct_stmt: "ct" "expectation" "set" stmt_expr  */
#line 5018 "parser_bison.y"
                        {
				(yyval.stmt) = objref_stmt_alloc(&(yyloc));
				(yyval.stmt)->objref.type = NFT_OBJECT_CT_EXPECT;
				(yyval.stmt)->objref.expr = (yyvsp[0].expr);
			}
#line 13585 "parser_bison.c"
    break;

  case 912: /* ct_stmt: "ct" ct_dir ct_key_dir_optional "set" stmt_expr  */
#line 5024 "parser_bison.y"
                        {
				(yyval.stmt) = ct_stmt_alloc(&(yyloc), (yyvsp[-2].val), (yyvsp[-3].val), (yyvsp[0].expr));
			}
#line 13593 "parser_bison.c"
    break;

  case 913: /* payload_stmt: payload_expr "set" stmt_expr  */
#line 5030 "parser_bison.y"
                        {
				if ((yyvsp[-2].expr)->etype == EXPR_EXTHDR)
					(yyval.stmt) = exthdr_stmt_alloc(&(yyloc), (yyvsp[-2].expr), (yyvsp[0].expr));
				else
					(yyval.stmt) = payload_stmt_alloc(&(yyloc), (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 13604 "parser_bison.c"
    break;

  case 932: /* payload_raw_expr: "@" payload_base_spec "comma" "number" "comma" "number"  */
#line 5059 "parser_bison.y"
                        {
				(yyval.expr) = payload_expr_alloc(&(yyloc), NULL, 0);
				payload_init_raw((yyval.expr), (yyvsp[-4].val), (yyvsp[-2].val), (yyvsp[0].val));
				(yyval.expr)->byteorder		= BYTEORDER_BIG_ENDIAN;
				(yyval.expr)->payload.is_raw	= true;
			}
#line 13615 "parser_bison.c"
    break;

  case 933: /* payload_base_spec: "ll"  */
#line 5067 "parser_bison.y"
                                                { (yyval.val) = PROTO_BASE_LL_HDR; }
#line 13621 "parser_bison.c"
    break;

  case 934: /* payload_base_spec: "nh"  */
#line 5068 "parser_bison.y"
                                                { (yyval.val) = PROTO_BASE_NETWORK_HDR; }
#line 13627 "parser_bison.c"
    break;

  case 935: /* payload_base_spec: "th"  */
#line 5069 "parser_bison.y"
                                                { (yyval.val) = PROTO_BASE_TRANSPORT_HDR; }
#line 13633 "parser_bison.c"
    break;

  case 936: /* eth_hdr_expr: "ether" eth_hdr_field  */
#line 5073 "parser_bison.y"
                        {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_eth, (yyvsp[0].val));
			}
#line 13641 "parser_bison.c"
    break;

  case 937: /* eth_hdr_field: "saddr"  */
#line 5078 "parser_bison.y"
                                                { (yyval.val) = ETHHDR_SADDR; }
#line 13647 "parser_bison.c"
    break;

  case 938: /* eth_hdr_field: "daddr"  */
#line 5079 "parser_bison.y"
                                                { (yyval.val) = ETHHDR_DADDR; }
#line 13653 "parser_bison.c"
    break;

  case 939: /* eth_hdr_field: "type"  */
#line 5080 "parser_bison.y"
                                                { (yyval.val) = ETHHDR_TYPE; }
#line 13659 "parser_bison.c"
    break;

  case 940: /* vlan_hdr_expr: "vlan" vlan_hdr_field  */
#line 5084 "parser_bison.y"
                        {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_vlan, (yyvsp[0].val));
			}
#line 13667 "parser_bison.c"
    break;

  case 941: /* vlan_hdr_field: "id"  */
#line 5089 "parser_bison.y"
                                                { (yyval.val) = VLANHDR_VID; }
#line 13673 "parser_bison.c"
    break;

  case 942: /* vlan_hdr_field: "cfi"  */
#line 5090 "parser_bison.y"
                                                { (yyval.val) = VLANHDR_CFI; }
#line 13679 "parser_bison.c"
    break;

  case 943: /* vlan_hdr_field: "pcp"  */
#line 5091 "parser_bison.y"
                                                { (yyval.val) = VLANHDR_PCP; }
#line 13685 "parser_bison.c"
    break;

  case 944: /* vlan_hdr_field: "type"  */
#line 5092 "parser_bison.y"
                                                { (yyval.val) = VLANHDR_TYPE; }
#line 13691 "parser_bison.c"
    break;

  case 945: /* arp_hdr_expr: "arp" arp_hdr_field  */
#line 5096 "parser_bison.y"
                        {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_arp, (yyvsp[0].val));
			}
#line 13699 "parser_bison.c"
    break;

  case 946: /* arp_hdr_field: "htype"  */
#line 5101 "parser_bison.y"
                                                { (yyval.val) = ARPHDR_HRD; }
#line 13705 "parser_bison.c"
    break;

  case 947: /* arp_hdr_field: "ptype"  */
#line 5102 "parser_bison.y"
                                                { (yyval.val) = ARPHDR_PRO; }
#line 13711 "parser_bison.c"
    break;

  case 948: /* arp_hdr_field: "hlen"  */
#line 5103 "parser_bison.y"
                                                { (yyval.val) = ARPHDR_HLN; }
#line 13717 "parser_bison.c"
    break;

  case 949: /* arp_hdr_field: "plen"  */
#line 5104 "parser_bison.y"
                                                { (yyval.val) = ARPHDR_PLN; }
#line 13723 "parser_bison.c"
    break;

  case 950: /* arp_hdr_field: "operation"  */
#line 5105 "parser_bison.y"
                                                { (yyval.val) = ARPHDR_OP; }
#line 13729 "parser_bison.c"
    break;

  case 951: /* arp_hdr_field: "saddr" "ether"  */
#line 5106 "parser_bison.y"
                                                { (yyval.val) = ARPHDR_SADDR_ETHER; }
#line 13735 "parser_bison.c"
    break;

  case 952: /* arp_hdr_field: "daddr" "ether"  */
#line 5107 "parser_bison.y"
                                                { (yyval.val) = ARPHDR_DADDR_ETHER; }
#line 13741 "parser_bison.c"
    break;

  case 953: /* arp_hdr_field: "saddr" "ip"  */
#line 5108 "parser_bison.y"
                                                { (yyval.val) = ARPHDR_SADDR_IP; }
#line 13747 "parser_bison.c"
    break;

  case 954: /* arp_hdr_field: "daddr" "ip"  */
#line 5109 "parser_bison.y"
                                                { (yyval.val) = ARPHDR_DADDR_IP; }
#line 13753 "parser_bison.c"
    break;

  case 955: /* ip_hdr_expr: "ip" ip_hdr_field  */
#line 5113 "parser_bison.y"
                        {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_ip, (yyvsp[0].val));
			}
#line 13761 "parser_bison.c"
    break;

  case 956: /* ip_hdr_expr: "ip" "option" ip_option_type ip_option_field  */
#line 5117 "parser_bison.y"
                        {
				(yyval.expr) = ipopt_expr_alloc(&(yyloc), (yyvsp[-1].val), (yyvsp[0].val), 0);
			}
#line 13769 "parser_bison.c"
    break;

  case 957: /* ip_hdr_expr: "ip" "option" ip_option_type  */
#line 5121 "parser_bison.y"
                        {
				(yyval.expr) = ipopt_expr_alloc(&(yyloc), (yyvsp[0].val), IPOPT_FIELD_TYPE, 0);
				(yyval.expr)->exthdr.flags = NFT_EXTHDR_F_PRESENT;
			}
#line 13778 "parser_bison.c"
    break;

  case 958: /* ip_hdr_field: "version"  */
#line 5127 "parser_bison.y"
                                                { (yyval.val) = IPHDR_VERSION; }
#line 13784 "parser_bison.c"
    break;

  case 959: /* ip_hdr_field: "hdrlength"  */
#line 5128 "parser_bison.y"
                                                { (yyval.val) = IPHDR_HDRLENGTH; }
#line 13790 "parser_bison.c"
    break;

  case 960: /* ip_hdr_field: "dscp"  */
#line 5129 "parser_bison.y"
                                                { (yyval.val) = IPHDR_DSCP; }
#line 13796 "parser_bison.c"
    break;

  case 961: /* ip_hdr_field: "ecn"  */
#line 5130 "parser_bison.y"
                                                { (yyval.val) = IPHDR_ECN; }
#line 13802 "parser_bison.c"
    break;

  case 962: /* ip_hdr_field: "length"  */
#line 5131 "parser_bison.y"
                                                { (yyval.val) = IPHDR_LENGTH; }
#line 13808 "parser_bison.c"
    break;

  case 963: /* ip_hdr_field: "id"  */
#line 5132 "parser_bison.y"
                                                { (yyval.val) = IPHDR_ID; }
#line 13814 "parser_bison.c"
    break;

  case 964: /* ip_hdr_field: "frag-off"  */
#line 5133 "parser_bison.y"
                                                { (yyval.val) = IPHDR_FRAG_OFF; }
#line 13820 "parser_bison.c"
    break;

  case 965: /* ip_hdr_field: "ttl"  */
#line 5134 "parser_bison.y"
                                                { (yyval.val) = IPHDR_TTL; }
#line 13826 "parser_bison.c"
    break;

  case 966: /* ip_hdr_field: "protocol"  */
#line 5135 "parser_bison.y"
                                                { (yyval.val) = IPHDR_PROTOCOL; }
#line 13832 "parser_bison.c"
    break;

  case 967: /* ip_hdr_field: "checksum"  */
#line 5136 "parser_bison.y"
                                                { (yyval.val) = IPHDR_CHECKSUM; }
#line 13838 "parser_bison.c"
    break;

  case 968: /* ip_hdr_field: "saddr"  */
#line 5137 "parser_bison.y"
                                                { (yyval.val) = IPHDR_SADDR; }
#line 13844 "parser_bison.c"
    break;

  case 969: /* ip_hdr_field: "daddr"  */
#line 5138 "parser_bison.y"
                                                { (yyval.val) = IPHDR_DADDR; }
#line 13850 "parser_bison.c"
    break;

  case 970: /* ip_option_type: "lsrr"  */
#line 5141 "parser_bison.y"
                                                { (yyval.val) = IPOPT_LSRR; }
#line 13856 "parser_bison.c"
    break;

  case 971: /* ip_option_type: "rr"  */
#line 5142 "parser_bison.y"
                                                { (yyval.val) = IPOPT_RR; }
#line 13862 "parser_bison.c"
    break;

  case 972: /* ip_option_type: "ssrr"  */
#line 5143 "parser_bison.y"
                                                { (yyval.val) = IPOPT_SSRR; }
#line 13868 "parser_bison.c"
    break;

  case 973: /* ip_option_type: "ra"  */
#line 5144 "parser_bison.y"
                                                { (yyval.val) = IPOPT_RA; }
#line 13874 "parser_bison.c"
    break;

  case 974: /* ip_option_field: "type"  */
#line 5147 "parser_bison.y"
                                                { (yyval.val) = IPOPT_FIELD_TYPE; }
#line 13880 "parser_bison.c"
    break;

  case 975: /* ip_option_field: "length"  */
#line 5148 "parser_bison.y"
                                                { (yyval.val) = IPOPT_FIELD_LENGTH; }
#line 13886 "parser_bison.c"
    break;

  case 976: /* ip_option_field: "value"  */
#line 5149 "parser_bison.y"
                                                { (yyval.val) = IPOPT_FIELD_VALUE; }
#line 13892 "parser_bison.c"
    break;

  case 977: /* ip_option_field: "ptr"  */
#line 5150 "parser_bison.y"
                                                { (yyval.val) = IPOPT_FIELD_PTR; }
#line 13898 "parser_bison.c"
    break;

  case 978: /* ip_option_field: "addr"  */
#line 5151 "parser_bison.y"
                                                { (yyval.val) = IPOPT_FIELD_ADDR_0; }
#line 13904 "parser_bison.c"
    break;

  case 979: /* icmp_hdr_expr: "icmp" icmp_hdr_field  */
#line 5155 "parser_bison.y"
                        {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_icmp, (yyvsp[0].val));
			}
#line 13912 "parser_bison.c"
    break;

  case 980: /* icmp_hdr_field: "type"  */
#line 5160 "parser_bison.y"
                                                { (yyval.val) = ICMPHDR_TYPE; }
#line 13918 "parser_bison.c"
    break;

  case 981: /* icmp_hdr_field: "code"  */
#line 5161 "parser_bison.y"
                                                { (yyval.val) = ICMPHDR_CODE; }
#line 13924 "parser_bison.c"
    break;

  case 982: /* icmp_hdr_field: "checksum"  */
#line 5162 "parser_bison.y"
                                                { (yyval.val) = ICMPHDR_CHECKSUM; }
#line 13930 "parser_bison.c"
    break;

  case 983: /* icmp_hdr_field: "id"  */
#line 5163 "parser_bison.y"
                                                { (yyval.val) = ICMPHDR_ID; }
#line 13936 "parser_bison.c"
    break;

  case 984: /* icmp_hdr_field: "seq"  */
#line 5164 "parser_bison.y"
                                                { (yyval.val) = ICMPHDR_SEQ; }
#line 13942 "parser_bison.c"
    break;

  case 985: /* icmp_hdr_field: "gateway"  */
#line 5165 "parser_bison.y"
                                                { (yyval.val) = ICMPHDR_GATEWAY; }
#line 13948 "parser_bison.c"
    break;

  case 986: /* icmp_hdr_field: "mtu"  */
#line 5166 "parser_bison.y"
                                                { (yyval.val) = ICMPHDR_MTU; }
#line 13954 "parser_bison.c"
    break;

  case 987: /* igmp_hdr_expr: "igmp" igmp_hdr_field  */
#line 5170 "parser_bison.y"
                        {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_igmp, (yyvsp[0].val));
			}
#line 13962 "parser_bison.c"
    break;

  case 988: /* igmp_hdr_field: "type"  */
#line 5175 "parser_bison.y"
                                                { (yyval.val) = IGMPHDR_TYPE; }
#line 13968 "parser_bison.c"
    break;

  case 989: /* igmp_hdr_field: "checksum"  */
#line 5176 "parser_bison.y"
                                                { (yyval.val) = IGMPHDR_CHECKSUM; }
#line 13974 "parser_bison.c"
    break;

  case 990: /* igmp_hdr_field: "mrt"  */
#line 5177 "parser_bison.y"
                                                { (yyval.val) = IGMPHDR_MRT; }
#line 13980 "parser_bison.c"
    break;

  case 991: /* igmp_hdr_field: "group"  */
#line 5178 "parser_bison.y"
                                                { (yyval.val) = IGMPHDR_GROUP; }
#line 13986 "parser_bison.c"
    break;

  case 992: /* ip6_hdr_expr: "ip6" ip6_hdr_field  */
#line 5182 "parser_bison.y"
                        {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_ip6, (yyvsp[0].val));
			}
#line 13994 "parser_bison.c"
    break;

  case 993: /* ip6_hdr_field: "version"  */
#line 5187 "parser_bison.y"
                                                { (yyval.val) = IP6HDR_VERSION; }
#line 14000 "parser_bison.c"
    break;

  case 994: /* ip6_hdr_field: "dscp"  */
#line 5188 "parser_bison.y"
                                                { (yyval.val) = IP6HDR_DSCP; }
#line 14006 "parser_bison.c"
    break;

  case 995: /* ip6_hdr_field: "ecn"  */
#line 5189 "parser_bison.y"
                                                { (yyval.val) = IP6HDR_ECN; }
#line 14012 "parser_bison.c"
    break;

  case 996: /* ip6_hdr_field: "flowlabel"  */
#line 5190 "parser_bison.y"
                                                { (yyval.val) = IP6HDR_FLOWLABEL; }
#line 14018 "parser_bison.c"
    break;

  case 997: /* ip6_hdr_field: "length"  */
#line 5191 "parser_bison.y"
                                                { (yyval.val) = IP6HDR_LENGTH; }
#line 14024 "parser_bison.c"
    break;

  case 998: /* ip6_hdr_field: "nexthdr"  */
#line 5192 "parser_bison.y"
                                                { (yyval.val) = IP6HDR_NEXTHDR; }
#line 14030 "parser_bison.c"
    break;

  case 999: /* ip6_hdr_field: "hoplimit"  */
#line 5193 "parser_bison.y"
                                                { (yyval.val) = IP6HDR_HOPLIMIT; }
#line 14036 "parser_bison.c"
    break;

  case 1000: /* ip6_hdr_field: "saddr"  */
#line 5194 "parser_bison.y"
                                                { (yyval.val) = IP6HDR_SADDR; }
#line 14042 "parser_bison.c"
    break;

  case 1001: /* ip6_hdr_field: "daddr"  */
#line 5195 "parser_bison.y"
                                                { (yyval.val) = IP6HDR_DADDR; }
#line 14048 "parser_bison.c"
    break;

  case 1002: /* icmp6_hdr_expr: "icmpv6" icmp6_hdr_field  */
#line 5198 "parser_bison.y"
                        {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_icmp6, (yyvsp[0].val));
			}
#line 14056 "parser_bison.c"
    break;

  case 1003: /* icmp6_hdr_field: "type"  */
#line 5203 "parser_bison.y"
                                                { (yyval.val) = ICMP6HDR_TYPE; }
#line 14062 "parser_bison.c"
    break;

  case 1004: /* icmp6_hdr_field: "code"  */
#line 5204 "parser_bison.y"
                                                { (yyval.val) = ICMP6HDR_CODE; }
#line 14068 "parser_bison.c"
    break;

  case 1005: /* icmp6_hdr_field: "checksum"  */
#line 5205 "parser_bison.y"
                                                { (yyval.val) = ICMP6HDR_CHECKSUM; }
#line 14074 "parser_bison.c"
    break;

  case 1006: /* icmp6_hdr_field: "param-problem"  */
#line 5206 "parser_bison.y"
                                                { (yyval.val) = ICMP6HDR_PPTR; }
#line 14080 "parser_bison.c"
    break;

  case 1007: /* icmp6_hdr_field: "mtu"  */
#line 5207 "parser_bison.y"
                                                { (yyval.val) = ICMP6HDR_MTU; }
#line 14086 "parser_bison.c"
    break;

  case 1008: /* icmp6_hdr_field: "id"  */
#line 5208 "parser_bison.y"
                                                { (yyval.val) = ICMP6HDR_ID; }
#line 14092 "parser_bison.c"
    break;

  case 1009: /* icmp6_hdr_field: "seq"  */
#line 5209 "parser_bison.y"
                                                { (yyval.val) = ICMP6HDR_SEQ; }
#line 14098 "parser_bison.c"
    break;

  case 1010: /* icmp6_hdr_field: "max-delay"  */
#line 5210 "parser_bison.y"
                                                { (yyval.val) = ICMP6HDR_MAXDELAY; }
#line 14104 "parser_bison.c"
    break;

  case 1011: /* auth_hdr_expr: "ah" auth_hdr_field  */
#line 5214 "parser_bison.y"
                        {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_ah, (yyvsp[0].val));
			}
#line 14112 "parser_bison.c"
    break;

  case 1012: /* auth_hdr_field: "nexthdr"  */
#line 5219 "parser_bison.y"
                                                { (yyval.val) = AHHDR_NEXTHDR; }
#line 14118 "parser_bison.c"
    break;

  case 1013: /* auth_hdr_field: "hdrlength"  */
#line 5220 "parser_bison.y"
                                                { (yyval.val) = AHHDR_HDRLENGTH; }
#line 14124 "parser_bison.c"
    break;

  case 1014: /* auth_hdr_field: "reserved"  */
#line 5221 "parser_bison.y"
                                                { (yyval.val) = AHHDR_RESERVED; }
#line 14130 "parser_bison.c"
    break;

  case 1015: /* auth_hdr_field: "spi"  */
#line 5222 "parser_bison.y"
                                                { (yyval.val) = AHHDR_SPI; }
#line 14136 "parser_bison.c"
    break;

  case 1016: /* auth_hdr_field: "seq"  */
#line 5223 "parser_bison.y"
                                                { (yyval.val) = AHHDR_SEQUENCE; }
#line 14142 "parser_bison.c"
    break;

  case 1017: /* esp_hdr_expr: "esp" esp_hdr_field  */
#line 5227 "parser_bison.y"
                        {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_esp, (yyvsp[0].val));
			}
#line 14150 "parser_bison.c"
    break;

  case 1018: /* esp_hdr_field: "spi"  */
#line 5232 "parser_bison.y"
                                                { (yyval.val) = ESPHDR_SPI; }
#line 14156 "parser_bison.c"
    break;

  case 1019: /* esp_hdr_field: "seq"  */
#line 5233 "parser_bison.y"
                                                { (yyval.val) = ESPHDR_SEQUENCE; }
#line 14162 "parser_bison.c"
    break;

  case 1020: /* comp_hdr_expr: "comp" comp_hdr_field  */
#line 5237 "parser_bison.y"
                        {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_comp, (yyvsp[0].val));
			}
#line 14170 "parser_bison.c"
    break;

  case 1021: /* comp_hdr_field: "nexthdr"  */
#line 5242 "parser_bison.y"
                                                { (yyval.val) = COMPHDR_NEXTHDR; }
#line 14176 "parser_bison.c"
    break;

  case 1022: /* comp_hdr_field: "flags"  */
#line 5243 "parser_bison.y"
                                                { (yyval.val) = COMPHDR_FLAGS; }
#line 14182 "parser_bison.c"
    break;

  case 1023: /* comp_hdr_field: "cpi"  */
#line 5244 "parser_bison.y"
                                                { (yyval.val) = COMPHDR_CPI; }
#line 14188 "parser_bison.c"
    break;

  case 1024: /* udp_hdr_expr: "udp" udp_hdr_field  */
#line 5248 "parser_bison.y"
                        {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_udp, (yyvsp[0].val));
			}
#line 14196 "parser_bison.c"
    break;

  case 1025: /* udp_hdr_field: "sport"  */
#line 5253 "parser_bison.y"
                                                { (yyval.val) = UDPHDR_SPORT; }
#line 14202 "parser_bison.c"
    break;

  case 1026: /* udp_hdr_field: "dport"  */
#line 5254 "parser_bison.y"
                                                { (yyval.val) = UDPHDR_DPORT; }
#line 14208 "parser_bison.c"
    break;

  case 1027: /* udp_hdr_field: "length"  */
#line 5255 "parser_bison.y"
                                                { (yyval.val) = UDPHDR_LENGTH; }
#line 14214 "parser_bison.c"
    break;

  case 1028: /* udp_hdr_field: "checksum"  */
#line 5256 "parser_bison.y"
                                                { (yyval.val) = UDPHDR_CHECKSUM; }
#line 14220 "parser_bison.c"
    break;

  case 1029: /* udplite_hdr_expr: "udplite" udplite_hdr_field  */
#line 5260 "parser_bison.y"
                        {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_udplite, (yyvsp[0].val));
			}
#line 14228 "parser_bison.c"
    break;

  case 1030: /* udplite_hdr_field: "sport"  */
#line 5265 "parser_bison.y"
                                                { (yyval.val) = UDPHDR_SPORT; }
#line 14234 "parser_bison.c"
    break;

  case 1031: /* udplite_hdr_field: "dport"  */
#line 5266 "parser_bison.y"
                                                { (yyval.val) = UDPHDR_DPORT; }
#line 14240 "parser_bison.c"
    break;

  case 1032: /* udplite_hdr_field: "csumcov"  */
#line 5267 "parser_bison.y"
                                                { (yyval.val) = UDPHDR_LENGTH; }
#line 14246 "parser_bison.c"
    break;

  case 1033: /* udplite_hdr_field: "checksum"  */
#line 5268 "parser_bison.y"
                                                { (yyval.val) = UDPHDR_CHECKSUM; }
#line 14252 "parser_bison.c"
    break;

  case 1034: /* tcp_hdr_expr: "tcp" tcp_hdr_field  */
#line 5272 "parser_bison.y"
                        {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_tcp, (yyvsp[0].val));
			}
#line 14260 "parser_bison.c"
    break;

  case 1035: /* tcp_hdr_expr: "tcp" "option" tcp_hdr_option_type tcp_hdr_option_field  */
#line 5276 "parser_bison.y"
                        {
				(yyval.expr) = tcpopt_expr_alloc(&(yyloc), (yyvsp[-1].val), (yyvsp[0].val));
			}
#line 14268 "parser_bison.c"
    break;

  case 1036: /* tcp_hdr_expr: "tcp" "option" tcp_hdr_option_type  */
#line 5280 "parser_bison.y"
                        {
				(yyval.expr) = tcpopt_expr_alloc(&(yyloc), (yyvsp[0].val), TCPOPT_COMMON_KIND);
				(yyval.expr)->exthdr.flags = NFT_EXTHDR_F_PRESENT;
			}
#line 14277 "parser_bison.c"
    break;

  case 1037: /* tcp_hdr_expr: "tcp" "option" "@" tcp_hdr_option_type "comma" "number" "comma" "number"  */
#line 5285 "parser_bison.y"
                        {
				(yyval.expr) = tcpopt_expr_alloc(&(yyloc), (yyvsp[-4].val), 0);
				tcpopt_init_raw((yyval.expr), (yyvsp[-4].val), (yyvsp[-2].val), (yyvsp[0].val), 0);
			}
#line 14286 "parser_bison.c"
    break;

  case 1038: /* tcp_hdr_field: "sport"  */
#line 5291 "parser_bison.y"
                                                { (yyval.val) = TCPHDR_SPORT; }
#line 14292 "parser_bison.c"
    break;

  case 1039: /* tcp_hdr_field: "dport"  */
#line 5292 "parser_bison.y"
                                                { (yyval.val) = TCPHDR_DPORT; }
#line 14298 "parser_bison.c"
    break;

  case 1040: /* tcp_hdr_field: "seq"  */
#line 5293 "parser_bison.y"
                                                { (yyval.val) = TCPHDR_SEQ; }
#line 14304 "parser_bison.c"
    break;

  case 1041: /* tcp_hdr_field: "ackseq"  */
#line 5294 "parser_bison.y"
                                                { (yyval.val) = TCPHDR_ACKSEQ; }
#line 14310 "parser_bison.c"
    break;

  case 1042: /* tcp_hdr_field: "doff"  */
#line 5295 "parser_bison.y"
                                                { (yyval.val) = TCPHDR_DOFF; }
#line 14316 "parser_bison.c"
    break;

  case 1043: /* tcp_hdr_field: "reserved"  */
#line 5296 "parser_bison.y"
                                                { (yyval.val) = TCPHDR_RESERVED; }
#line 14322 "parser_bison.c"
    break;

  case 1044: /* tcp_hdr_field: "flags"  */
#line 5297 "parser_bison.y"
                                                { (yyval.val) = TCPHDR_FLAGS; }
#line 14328 "parser_bison.c"
    break;

  case 1045: /* tcp_hdr_field: "window"  */
#line 5298 "parser_bison.y"
                                                { (yyval.val) = TCPHDR_WINDOW; }
#line 14334 "parser_bison.c"
    break;

  case 1046: /* tcp_hdr_field: "checksum"  */
#line 5299 "parser_bison.y"
                                                { (yyval.val) = TCPHDR_CHECKSUM; }
#line 14340 "parser_bison.c"
    break;

  case 1047: /* tcp_hdr_field: "urgptr"  */
#line 5300 "parser_bison.y"
                                                { (yyval.val) = TCPHDR_URGPTR; }
#line 14346 "parser_bison.c"
    break;

  case 1048: /* tcp_hdr_option_type: "eol"  */
#line 5303 "parser_bison.y"
                                                { (yyval.val) = TCPOPT_KIND_EOL; }
#line 14352 "parser_bison.c"
    break;

  case 1049: /* tcp_hdr_option_type: "nop"  */
#line 5304 "parser_bison.y"
                                                { (yyval.val) = TCPOPT_KIND_NOP; }
#line 14358 "parser_bison.c"
    break;

  case 1050: /* tcp_hdr_option_type: "mss"  */
#line 5305 "parser_bison.y"
                                                { (yyval.val) = TCPOPT_KIND_MAXSEG; }
#line 14364 "parser_bison.c"
    break;

  case 1051: /* tcp_hdr_option_type: "window"  */
#line 5306 "parser_bison.y"
                                                { (yyval.val) = TCPOPT_KIND_WINDOW; }
#line 14370 "parser_bison.c"
    break;

  case 1052: /* tcp_hdr_option_type: "sack-permitted"  */
#line 5307 "parser_bison.y"
                                                { (yyval.val) = TCPOPT_KIND_SACK_PERMITTED; }
#line 14376 "parser_bison.c"
    break;

  case 1053: /* tcp_hdr_option_type: "sack"  */
#line 5308 "parser_bison.y"
                                                { (yyval.val) = TCPOPT_KIND_SACK; }
#line 14382 "parser_bison.c"
    break;

  case 1054: /* tcp_hdr_option_type: "sack0"  */
#line 5309 "parser_bison.y"
                                                { (yyval.val) = TCPOPT_KIND_SACK; }
#line 14388 "parser_bison.c"
    break;

  case 1055: /* tcp_hdr_option_type: "sack1"  */
#line 5310 "parser_bison.y"
                                                { (yyval.val) = TCPOPT_KIND_SACK1; }
#line 14394 "parser_bison.c"
    break;

  case 1056: /* tcp_hdr_option_type: "sack2"  */
#line 5311 "parser_bison.y"
                                                { (yyval.val) = TCPOPT_KIND_SACK2; }
#line 14400 "parser_bison.c"
    break;

  case 1057: /* tcp_hdr_option_type: "sack3"  */
#line 5312 "parser_bison.y"
                                                { (yyval.val) = TCPOPT_KIND_SACK3; }
#line 14406 "parser_bison.c"
    break;

  case 1058: /* tcp_hdr_option_type: "echo"  */
#line 5313 "parser_bison.y"
                                                { (yyval.val) = TCPOPT_KIND_ECHO; }
#line 14412 "parser_bison.c"
    break;

  case 1059: /* tcp_hdr_option_type: "timestamp"  */
#line 5314 "parser_bison.y"
                                                { (yyval.val) = TCPOPT_KIND_TIMESTAMP; }
#line 14418 "parser_bison.c"
    break;

  case 1060: /* tcp_hdr_option_type: "number"  */
#line 5315 "parser_bison.y"
                                                {
				if ((yyvsp[0].val) > 255) {
					erec_queue(error(&(yylsp[0]), "value too large"), state->msgs);
					YYERROR;
				}
				(yyval.val) = (yyvsp[0].val);
			}
#line 14430 "parser_bison.c"
    break;

  case 1061: /* tcp_hdr_option_field: "kind"  */
#line 5324 "parser_bison.y"
                                                { (yyval.val) = TCPOPT_COMMON_KIND; }
#line 14436 "parser_bison.c"
    break;

  case 1062: /* tcp_hdr_option_field: "length"  */
#line 5325 "parser_bison.y"
                                                { (yyval.val) = TCPOPT_COMMON_LENGTH; }
#line 14442 "parser_bison.c"
    break;

  case 1063: /* tcp_hdr_option_field: "size"  */
#line 5326 "parser_bison.y"
                                                { (yyval.val) = TCPOPT_MAXSEG_SIZE; }
#line 14448 "parser_bison.c"
    break;

  case 1064: /* tcp_hdr_option_field: "count"  */
#line 5327 "parser_bison.y"
                                                { (yyval.val) = TCPOPT_WINDOW_COUNT; }
#line 14454 "parser_bison.c"
    break;

  case 1065: /* tcp_hdr_option_field: "left"  */
#line 5328 "parser_bison.y"
                                                { (yyval.val) = TCPOPT_SACK_LEFT; }
#line 14460 "parser_bison.c"
    break;

  case 1066: /* tcp_hdr_option_field: "right"  */
#line 5329 "parser_bison.y"
                                                { (yyval.val) = TCPOPT_SACK_RIGHT; }
#line 14466 "parser_bison.c"
    break;

  case 1067: /* tcp_hdr_option_field: "tsval"  */
#line 5330 "parser_bison.y"
                                                { (yyval.val) = TCPOPT_TS_TSVAL; }
#line 14472 "parser_bison.c"
    break;

  case 1068: /* tcp_hdr_option_field: "tsecr"  */
#line 5331 "parser_bison.y"
                                                { (yyval.val) = TCPOPT_TS_TSECR; }
#line 14478 "parser_bison.c"
    break;

  case 1069: /* dccp_hdr_expr: "dccp" dccp_hdr_field  */
#line 5335 "parser_bison.y"
                        {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_dccp, (yyvsp[0].val));
			}
#line 14486 "parser_bison.c"
    break;

  case 1070: /* dccp_hdr_field: "sport"  */
#line 5340 "parser_bison.y"
                                                { (yyval.val) = DCCPHDR_SPORT; }
#line 14492 "parser_bison.c"
    break;

  case 1071: /* dccp_hdr_field: "dport"  */
#line 5341 "parser_bison.y"
                                                { (yyval.val) = DCCPHDR_DPORT; }
#line 14498 "parser_bison.c"
    break;

  case 1072: /* dccp_hdr_field: "type"  */
#line 5342 "parser_bison.y"
                                                { (yyval.val) = DCCPHDR_TYPE; }
#line 14504 "parser_bison.c"
    break;

  case 1073: /* sctp_hdr_expr: "sctp" sctp_hdr_field  */
#line 5346 "parser_bison.y"
                        {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_sctp, (yyvsp[0].val));
			}
#line 14512 "parser_bison.c"
    break;

  case 1074: /* sctp_hdr_field: "sport"  */
#line 5351 "parser_bison.y"
                                                { (yyval.val) = SCTPHDR_SPORT; }
#line 14518 "parser_bison.c"
    break;

  case 1075: /* sctp_hdr_field: "dport"  */
#line 5352 "parser_bison.y"
                                                { (yyval.val) = SCTPHDR_DPORT; }
#line 14524 "parser_bison.c"
    break;

  case 1076: /* sctp_hdr_field: "vtag"  */
#line 5353 "parser_bison.y"
                                                { (yyval.val) = SCTPHDR_VTAG; }
#line 14530 "parser_bison.c"
    break;

  case 1077: /* sctp_hdr_field: "checksum"  */
#line 5354 "parser_bison.y"
                                                { (yyval.val) = SCTPHDR_CHECKSUM; }
#line 14536 "parser_bison.c"
    break;

  case 1078: /* th_hdr_expr: "th" th_hdr_field  */
#line 5358 "parser_bison.y"
                        {
				(yyval.expr) = payload_expr_alloc(&(yyloc), &proto_th, (yyvsp[0].val));
				if ((yyval.expr))
					(yyval.expr)->payload.is_raw = true;
			}
#line 14546 "parser_bison.c"
    break;

  case 1079: /* th_hdr_field: "sport"  */
#line 5365 "parser_bison.y"
                                                { (yyval.val) = THDR_SPORT; }
#line 14552 "parser_bison.c"
    break;

  case 1080: /* th_hdr_field: "dport"  */
#line 5366 "parser_bison.y"
                                                { (yyval.val) = THDR_DPORT; }
#line 14558 "parser_bison.c"
    break;

  case 1089: /* hbh_hdr_expr: "hbh" hbh_hdr_field  */
#line 5380 "parser_bison.y"
                        {
				(yyval.expr) = exthdr_expr_alloc(&(yyloc), &exthdr_hbh, (yyvsp[0].val));
			}
#line 14566 "parser_bison.c"
    break;

  case 1090: /* hbh_hdr_field: "nexthdr"  */
#line 5385 "parser_bison.y"
                                                { (yyval.val) = HBHHDR_NEXTHDR; }
#line 14572 "parser_bison.c"
    break;

  case 1091: /* hbh_hdr_field: "hdrlength"  */
#line 5386 "parser_bison.y"
                                                { (yyval.val) = HBHHDR_HDRLENGTH; }
#line 14578 "parser_bison.c"
    break;

  case 1092: /* rt_hdr_expr: "rt" rt_hdr_field  */
#line 5390 "parser_bison.y"
                        {
				(yyval.expr) = exthdr_expr_alloc(&(yyloc), &exthdr_rt, (yyvsp[0].val));
			}
#line 14586 "parser_bison.c"
    break;

  case 1093: /* rt_hdr_field: "nexthdr"  */
#line 5395 "parser_bison.y"
                                                { (yyval.val) = RTHDR_NEXTHDR; }
#line 14592 "parser_bison.c"
    break;

  case 1094: /* rt_hdr_field: "hdrlength"  */
#line 5396 "parser_bison.y"
                                                { (yyval.val) = RTHDR_HDRLENGTH; }
#line 14598 "parser_bison.c"
    break;

  case 1095: /* rt_hdr_field: "type"  */
#line 5397 "parser_bison.y"
                                                { (yyval.val) = RTHDR_TYPE; }
#line 14604 "parser_bison.c"
    break;

  case 1096: /* rt_hdr_field: "seg-left"  */
#line 5398 "parser_bison.y"
                                                { (yyval.val) = RTHDR_SEG_LEFT; }
#line 14610 "parser_bison.c"
    break;

  case 1097: /* rt0_hdr_expr: "rt0" rt0_hdr_field  */
#line 5402 "parser_bison.y"
                        {
				(yyval.expr) = exthdr_expr_alloc(&(yyloc), &exthdr_rt0, (yyvsp[0].val));
			}
#line 14618 "parser_bison.c"
    break;

  case 1098: /* rt0_hdr_field: "addr" '[' "number" ']'  */
#line 5408 "parser_bison.y"
                        {
				(yyval.val) = RT0HDR_ADDR_1 + (yyvsp[-1].val) - 1;
			}
#line 14626 "parser_bison.c"
    break;

  case 1099: /* rt2_hdr_expr: "rt2" rt2_hdr_field  */
#line 5414 "parser_bison.y"
                        {
				(yyval.expr) = exthdr_expr_alloc(&(yyloc), &exthdr_rt2, (yyvsp[0].val));
			}
#line 14634 "parser_bison.c"
    break;

  case 1100: /* rt2_hdr_field: "addr"  */
#line 5419 "parser_bison.y"
                                                { (yyval.val) = RT2HDR_ADDR; }
#line 14640 "parser_bison.c"
    break;

  case 1101: /* rt4_hdr_expr: "srh" rt4_hdr_field  */
#line 5423 "parser_bison.y"
                        {
				(yyval.expr) = exthdr_expr_alloc(&(yyloc), &exthdr_rt4, (yyvsp[0].val));
			}
#line 14648 "parser_bison.c"
    break;

  case 1102: /* rt4_hdr_field: "last-entry"  */
#line 5428 "parser_bison.y"
                                                { (yyval.val) = RT4HDR_LASTENT; }
#line 14654 "parser_bison.c"
    break;

  case 1103: /* rt4_hdr_field: "flags"  */
#line 5429 "parser_bison.y"
                                                { (yyval.val) = RT4HDR_FLAGS; }
#line 14660 "parser_bison.c"
    break;

  case 1104: /* rt4_hdr_field: "tag"  */
#line 5430 "parser_bison.y"
                                                { (yyval.val) = RT4HDR_TAG; }
#line 14666 "parser_bison.c"
    break;

  case 1105: /* rt4_hdr_field: "sid" '[' "number" ']'  */
#line 5432 "parser_bison.y"
                        {
				(yyval.val) = RT4HDR_SID_1 + (yyvsp[-1].val) - 1;
			}
#line 14674 "parser_bison.c"
    break;

  case 1106: /* frag_hdr_expr: "frag" frag_hdr_field  */
#line 5438 "parser_bison.y"
                        {
				(yyval.expr) = exthdr_expr_alloc(&(yyloc), &exthdr_frag, (yyvsp[0].val));
			}
#line 14682 "parser_bison.c"
    break;

  case 1107: /* frag_hdr_field: "nexthdr"  */
#line 5443 "parser_bison.y"
                                                { (yyval.val) = FRAGHDR_NEXTHDR; }
#line 14688 "parser_bison.c"
    break;

  case 1108: /* frag_hdr_field: "reserved"  */
#line 5444 "parser_bison.y"
                                                { (yyval.val) = FRAGHDR_RESERVED; }
#line 14694 "parser_bison.c"
    break;

  case 1109: /* frag_hdr_field: "frag-off"  */
#line 5445 "parser_bison.y"
                                                { (yyval.val) = FRAGHDR_FRAG_OFF; }
#line 14700 "parser_bison.c"
    break;

  case 1110: /* frag_hdr_field: "reserved2"  */
#line 5446 "parser_bison.y"
                                                { (yyval.val) = FRAGHDR_RESERVED2; }
#line 14706 "parser_bison.c"
    break;

  case 1111: /* frag_hdr_field: "more-fragments"  */
#line 5447 "parser_bison.y"
                                                { (yyval.val) = FRAGHDR_MFRAGS; }
#line 14712 "parser_bison.c"
    break;

  case 1112: /* frag_hdr_field: "id"  */
#line 5448 "parser_bison.y"
                                                { (yyval.val) = FRAGHDR_ID; }
#line 14718 "parser_bison.c"
    break;

  case 1113: /* dst_hdr_expr: "dst" dst_hdr_field  */
#line 5452 "parser_bison.y"
                        {
				(yyval.expr) = exthdr_expr_alloc(&(yyloc), &exthdr_dst, (yyvsp[0].val));
			}
#line 14726 "parser_bison.c"
    break;

  case 1114: /* dst_hdr_field: "nexthdr"  */
#line 5457 "parser_bison.y"
                                                { (yyval.val) = DSTHDR_NEXTHDR; }
#line 14732 "parser_bison.c"
    break;

  case 1115: /* dst_hdr_field: "hdrlength"  */
#line 5458 "parser_bison.y"
                                                { (yyval.val) = DSTHDR_HDRLENGTH; }
#line 14738 "parser_bison.c"
    break;

  case 1116: /* mh_hdr_expr: "mh" mh_hdr_field  */
#line 5462 "parser_bison.y"
                        {
				(yyval.expr) = exthdr_expr_alloc(&(yyloc), &exthdr_mh, (yyvsp[0].val));
			}
#line 14746 "parser_bison.c"
    break;

  case 1117: /* mh_hdr_field: "nexthdr"  */
#line 5467 "parser_bison.y"
                                                { (yyval.val) = MHHDR_NEXTHDR; }
#line 14752 "parser_bison.c"
    break;

  case 1118: /* mh_hdr_field: "hdrlength"  */
#line 5468 "parser_bison.y"
                                                { (yyval.val) = MHHDR_HDRLENGTH; }
#line 14758 "parser_bison.c"
    break;

  case 1119: /* mh_hdr_field: "type"  */
#line 5469 "parser_bison.y"
                                                { (yyval.val) = MHHDR_TYPE; }
#line 14764 "parser_bison.c"
    break;

  case 1120: /* mh_hdr_field: "reserved"  */
#line 5470 "parser_bison.y"
                                                { (yyval.val) = MHHDR_RESERVED; }
#line 14770 "parser_bison.c"
    break;

  case 1121: /* mh_hdr_field: "checksum"  */
#line 5471 "parser_bison.y"
                                                { (yyval.val) = MHHDR_CHECKSUM; }
#line 14776 "parser_bison.c"
    break;

  case 1122: /* exthdr_exists_expr: "exthdr" exthdr_key  */
#line 5475 "parser_bison.y"
                        {
				const struct exthdr_desc *desc;

				desc = exthdr_find_proto((yyvsp[0].val));

				/* Assume that NEXTHDR template is always
				 * the fist one in list of templates.
				 */
				(yyval.expr) = exthdr_expr_alloc(&(yyloc), desc, 1);
				(yyval.expr)->exthdr.flags = NFT_EXTHDR_F_PRESENT;
			}
#line 14792 "parser_bison.c"
    break;

  case 1123: /* exthdr_key: "hbh"  */
#line 5488 "parser_bison.y"
                                        { (yyval.val) = IPPROTO_HOPOPTS; }
#line 14798 "parser_bison.c"
    break;

  case 1124: /* exthdr_key: "rt"  */
#line 5489 "parser_bison.y"
                                        { (yyval.val) = IPPROTO_ROUTING; }
#line 14804 "parser_bison.c"
    break;

  case 1125: /* exthdr_key: "frag"  */
#line 5490 "parser_bison.y"
                                        { (yyval.val) = IPPROTO_FRAGMENT; }
#line 14810 "parser_bison.c"
    break;

  case 1126: /* exthdr_key: "dst"  */
#line 5491 "parser_bison.y"
                                        { (yyval.val) = IPPROTO_DSTOPTS; }
#line 14816 "parser_bison.c"
    break;

  case 1127: /* exthdr_key: "mh"  */
#line 5492 "parser_bison.y"
                                        { (yyval.val) = IPPROTO_MH; }
#line 14822 "parser_bison.c"
    break;


#line 14826 "parser_bison.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      {
        yypcontext_t yyctx
          = {yyssp, yytoken, &yylloc};
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == -1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *,
                             YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (yymsg)
              {
                yysyntax_error_status
                  = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
                yymsgp = yymsg;
              }
            else
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = YYENOMEM;
              }
          }
        yyerror (&yylloc, nft, scanner, state, yymsgp);
        if (yysyntax_error_status == YYENOMEM)
          goto yyexhaustedlab;
      }
    }

  yyerror_range[1] = yylloc;
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= TOKEN_EOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == TOKEN_EOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc, nft, scanner, state);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, yylsp, nft, scanner, state);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  ++yylsp;
  YYLLOC_DEFAULT (*yylsp, yyerror_range, 2);

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if 1
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (&yylloc, nft, scanner, state, YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturn;
#endif


/*-------------------------------------------------------.
| yyreturn -- parsing is finished, clean up and return.  |
`-------------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc, nft, scanner, state);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, yylsp, nft, scanner, state);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
  return yyresult;
}

#line 5495 "parser_bison.y"

